#include <inrimage/image.h>
#include <stdio.h>

static char Ucmd[]=
"{-sob | -kir | -lap | -hue r1 r2 | -wal} [image-in] [image-out]";
static char Udetail[]=
"\tdetection de contour avec algorithmes :\n\
\tsobel (-sob), kirsh (-kir), laplace (-lap), wallis (-wal) ou\n\
\thueckel avec seuil de luminance r1 et produit scalaire >r2";

static char Ucmd0[]= "-sob [image-in] [image-out]";
static char Ucmd1[]= "-kir [image-in] [image-out]";
static char Ucmd2[]= "-lap [image-in] [image-out]";
static char Ucmd3[]= "-hue r1 r2 [image-in] [image-out]";
static char Ucmd4[]= "-wal [image-in] [image-out]";

static struct multi_cmd cmds[] = {
	"-sob",Ucmd0,Udetail,	/*  1 */
	"-kir",Ucmd1,Udetail,	/* 2 */
	"-lap",Ucmd2,Udetail,	/*  3 */
	"-hue",Ucmd3,Udetail,	/*  4 */
	"-wal",Ucmd4,Udetail,	/*  5 */
	"",Ucmd,Udetail,
	0,0,0,
};

extern debug_;

fcmain_()
{
	char *s0;
	char inname[128],outname[128];
	Fort_int seuil;
	int dummy;
	float pscal;
	Fort_int choix = -1 ;
	
	choix = inr_initm(0,0,"2.1",cmds);

	if(choix < 0) {
		fprintf(stderr,"Il faut l'une des options -sob -kir -lap -hue -wal\n");
		iusage_(Ucmd,Udetail);
	}
	s0 = xargv[0];
	if(choix == 3) {
		if(!igetopt(cmds[choix].name,"",0,"%d",&dummy,"%f",&pscal))
			iusage_(Ucmd,Udetail);
		else
		  seuil = dummy;
		if(debug_)
			fprintf(stderr,"%s:hueckel seuil %l scal %f\n",s0,dummy,pscal);
	} else {
		if(!igetopt(cmds[choix].name,"",0,"",0,"",0))
			iusage_(Ucmd,Udetail);
		if(debug_) {
			switch(choix) {
			case 0:
				fprintf(stderr,"%s:sobel\n",s0);
				break;
			case 1:
				fprintf(stderr,"%s:kirsh\n",s0);
				break;
			case 2:
				fprintf(stderr,"%s:laplace\n",s0);
				break;
			case 4:
				fprintf(stderr,"%s:wallis\n",s0);
				break;
			}
		}
	}
	choix++;
	fileopt(inname,"i");
	fileopt(outname,"o");
	if ( tstopts())
		iusage_(Ucmd,Udetail);

	sedged_(inname,outname,&choix,&seuil,&pscal);
	return 0;

}
