#include <inrimage/image.h>
#include <stdio.h>

#include "fcmain.h"

static char Ucmdg[]=
"[image-in] [-noct] [-ix nn] [-iy nn] [-iz nn] [-iv nn][-xpas nn][-ypas nn][-zpas nn][-vpas nn] [image-out] [options-de-dim.]";
static char Ucmd0[]=
"[-I] [image-in] [-noct] [-ix nn] [-iy nn] [-iz nn] [image-out] [options-de-dim.]";

static char Udetailg[]=
"    Extraction d'une sous-image quelconque\n\
\t -I : tous les parametres sont demandes en interactif\n\
\t -noct : ne pas copier la 'color table'\n\
\t -ix, -iy, -iz, -iv : origine (>= 1) de la fenetre dans 'image-in'\n\
\t   ix : 1..NDIMX, iy : 1..NDIMY, iz : 1..NDIMZ, iv : 1..NDIMV\n\
\t -xpas, -ypas, -zpas, -vpas : pas d'echantillonage (>= 1) \n\
\t donner les dimensions de 'image-out' si elle n'existe pas\n\
\t   (format demande en interactif si pas d'options -x, -y, -z, -v)";

static char Udetail0[]=
"     Extraction d'une sous-image (inadapte aux image vectorielles : utiliser extg)\n\
\t -I : tous les parametres sont demandes en interactif\n\
\t -noct : ne pas copier la 'color table'\n\
\t -ix, -iy, -iz: origine (>= 1) de la fenetre dans 'image-in' \n\
\t   ix : 1..DIMX, iy : 1..NDIMY, iz : 1..NDIMZ\n\
\t donner les dimensions de 'image-out' si elle n'existe pas\n\
\t   (format demande en interactif si pas d'options -x, -y, -z, -v)";

static struct multi_cmd cmds[] = {
  "ext",Ucmd0,Udetail0,	/*  0 */
  "extg",Ucmdg,Udetailg,	/*  1 */
  "lt-extg",Ucmdg,Udetailg,	/*  2 : pour que cela marche avec les libraires partages 
				 *      (on utilse extg pour construire les fontes avant installation) */
  0,0,0,
};

main(argc,argv)
int argc;
char *argv[];
{
	char inname[128],outname[128];
	int verbose = 1;
	Fort_int first_pt[4], pas_echan[4];
	struct multi_cmd *ppcmd;
	int i, dummy;
	Fort_int fl_noct;
	Fort_int choix= 0, flag_extend= 0;

	if((choix = inr_initm(argc,argv,"2.3",cmds)) > 0) flag_extend= 1;
	ppcmd = &cmds[choix];

#ifndef NONINTERACTIF
	if(! flag_extend) {
	  if((verbose = igetopt("-I","",0,"",0,"",0))) {
	    if(tstopts())
	      iusage_(ppcmd->ucmd,ppcmd->udetail);
	    kextim_();
	    return 1;
	  }
	}
#endif
	infileopt(inname);
	outfileopt(outname);

	fl_noct = igetopt("-noct","",0  ,"",0  ,"",0);
	for(i=0;i<4;i++) {
	  first_pt[i] = 1;
	  pas_echan[i] = 1;
	}
	if( igetopt1("-ix","%d",&dummy)) first_pt[0] = dummy;       
	if( igetopt1("-iy","%d",&dummy))  first_pt[1] = dummy;       
	if( igetopt1("-iz","%d",&dummy)) first_pt[2] = dummy;       
	if(flag_extend) {
	  if( igetopt1("-iv","%d",&dummy))  first_pt[3] = dummy;       
	  if( igetopt1("-xpas","%d",&dummy)) pas_echan[0] = dummy;
	  if( igetopt1("-ypas","%d",&dummy)) pas_echan[1] = dummy;
	  if( igetopt1("-zpas","%d",&dummy)) pas_echan[2] = dummy;
	  if( igetopt1("-vpas","%d",&dummy)) pas_echan[3] = dummy;
	}
	if(gtstopts(0,1,0) > 0) iusage_(ppcmd->ucmd,ppcmd->udetail);
	sextim_(inname,outname,first_pt,pas_echan,&fl_noct,&flag_extend);
	return 0;
}
