
#include <stdio.h>
#include <inrimage/inrfile.h>

static char Ucmd[]=
"[[-x newdimx] [-y newdimy] | [-sc n | -nx n | -ny n]] [-nc][-f] [image_in | -] [image_out]";
static char Udetail[]=
"\t-sc n : facteur d'agrandissement (reduction si 0.<n<1., image inchangee si n<=0)\n\
\t -nx, -ny : changer la taille pour amener dimx ou dimy a n (-sc -nx -ny exclusifs)\n\
\t-f : fast mode, sans interpolation\n\
\t-nc : no center (garder les valeurs aux extremites des lignes)\n";

static int Xmag= 0, Ymag= 0;
static int nxc= 0, nyc= 0;
float Coef= 0.;
Fort_int lfmt[9], lfmto[9];
extern errno;
extern int koctet_, debug_;
#define DEFK 500

extern int IM_nbmin_hdr;

main(argc,argv)
int argc;
char **argv;
{
	char in[80], out[80];
	char tabr[256], tabg[256], tabb[256];
	int i0, nbc;
	struct image *nfi, *nfo;
	register i;
	int flg_center= 1;
	int flg_fast = 0;

	inr_init(argc,argv,"2.1",Ucmd,Udetail);

	if(igetopt("-sc","",0,"%f",&Coef,"",0)) {
		if(Coef < 0.) Coef = 0.;
	} else if(igetopt("-nx","",0,"%d",&nxc,"",0)) {
		if(nxc < 0) nxc = 0;
	} else if(igetopt("-ny","",0,"%d",&nyc,"",0)) {
		if(nyc < 0) nyc = 0;
	} else {
		igetopt("-x","",0,"%d",&Xmag,"",0);
		igetopt("-y","",0,"%d",&Ymag,"",0);
	}
	if(igetopt("-nc","",0,"",0,"",0))
		flg_center = 0;
	if(igetopt("-f","",0,"",0,"",0))
		flg_fast = 1;
	if ( !igetopt("","%s",in,"",0,"",0) ) { /* stdin par defaut */
		in[0] = '<';
		in[1] = 0;
	} else {
		if(in[0] == '-' && in[1] == 0)
			in[0] = '<';  /* stdin */
	}
	if ( !igetopt("","%s",out,"",0,"",0) ) { /* stdout par defaut */
		out[0] = '>';
		out[1] = 0;
	}
	if(tstopts()) iusage_(Ucmd,Udetail);
	nfi = image_(in,"e","",lfmt);
#if 0
	if(NDIMV > 1 && !flg_fast)
		imerror(6,"images vectorielles non traites \n");
#endif
	if(nxc > 0)
		Coef = (float)nxc / (float)NDIMX;
	else if(nyc > 0)
		Coef = (float)nyc / (float)NDIMY;
	if(Coef > 0.) {
		Xmag = (int)(NDIMX * Coef + .5);
		Ymag = (int)(NDIMY * Coef + .5);
	}
	if(Xmag == 0) Xmag = NDIMX;
	if(Ymag == 0) Ymag = NDIMY;
	if(flg_fast) {
		if(Xmag < NDIMX) {
			Xmag = (int)((float)NDIMX / (float)Xmag + .5);
			lfmto[I_NDIMX] = ((NDIMX -1) / Xmag) + 1;
		} else {
			Xmag = -(int)((float)Xmag / (float)NDIMX + .5);
			lfmto[I_NDIMX] = NDIMX * (-Xmag);
		}
		if(Ymag < NDIMY) {
			Ymag = (int)((float)NDIMY / (float)Ymag + .5);
			lfmto[I_NDIMY] = ((NDIMY -1) / Ymag) + 1;
		} else {
			Ymag = -(int)((float)Ymag / (float)NDIMY + .5);
			lfmto[I_NDIMY] = NDIMY * (-Ymag);
		}
	} else {
		lfmto[I_NDIMX] = Xmag;
		lfmto[I_NDIMY] = Ymag;
	}
	lfmto[I_NDIMZ] = NDIMZ;
	lfmto[I_NDIMV] = NDIMV;
	lfmto[I_DIMX] = lfmto[I_NDIMX] * NDIMV;
	lfmto[I_DIMY] = lfmto[I_NDIMY] * NDIMZ;
	lfmto[I_BSIZE] = BSIZE;
	lfmto[I_TYPE] = TYPE;
	lfmto[I_EXP] = EXP;
	if(TYPE != FIXE || BSIZE != 1)
		imerror(9,"sorry! For now, I only accept 8 bits pixels\n");
	if(flg_fast) {
		IM_nbmin_hdr = nfi->desc_size / FILE_HEADER_LEN;
		flg_center = -1;
	}
	nfo = image_(out,"s","a",lfmto);
	if(flg_fast)
		icop_ct(nfi,nfo);
	if(koctet_ == 0)
		koctet_ = DEFK;
	sizoom(&nfi,&nfo,lfmt,lfmto,Xmag,Ymag,flg_center);
	return 0;

}
