#include <inrimage/image.h>
#include <stdio.h>

static char Ucmd0[]= "-et [image1-in | -] [image2-in | -] [image-out]";
static char Ucmd1[]= "-ou [image1-in | -] [image2-in | -] [image-out]";
static char Ucmd2[]= "-xou [image1-in | -] [image2-in | -] [image-out]";
static char Ucmd3[]= "-ma hh [image-in | -] [image-out]";
static char Ucmd4[]= "-fo hh [image-in | -] [image-out]";
static char Ucmd5[]= "-co hh [image-in | -] [image-out]";
static char Ucmd6[]= "-inv [image-in | -] [image-out]";

static char Udetail0[]= "\t'et' logique entre image1-in image2-in\n";
static char Udetail1[]= "\t'ou' logique entre image1-in image2-in\n";
static char Udetail2[]= "\t'ou_exclusif' entre image1-in image2-in\n";
static char Udetail3[]= "\t'et' logique entre image-in la constante hexa hh\n";
static char Udetail4[]= "\t'ou' logique entre image-in la constante hexa hh\n";
static char Udetail5[]= "\t'ou_exclusif' entre image-in la constante hexa hh\n";
static char Udetail6[]= "\t'inversion' des bits de image-in\n";

static char Ucmd[]=
"\n   [-et image1-in image2-in [image-out]]\n\
   [-ou image1-in image2-in [image-out]]\n\
   [-xou image1-in image2-in [image-out]]\n\
   [-ma hh image-in [image-out]]\n\
   [-fo hh image-in [image-out]]\n\
   [-co hh image-in [image-out]]\n\
   [-inv image-in [image-out]]";
static char Udetail[]=
"\t -ma, -fo, -co = 'et', 'ou' et 'ou exclusif' entre 'image-in' et la\n\
\t\t  constante hexadecimale hh";

static struct multi_cmd cmds[] = {
		"-et",Ucmd0,Udetail0,	/*  1 */
		"-ou",Ucmd1,Udetail1,	/*  2 */
		"-xou",Ucmd2,Udetail2,	/*  3 */
		"-ma",Ucmd3,Udetail3,	/*  4 */
		"-fo",Ucmd4,Udetail4,	/*  5 */
		"-co",Ucmd5,Udetail5,	/*  6 */
		"-inv",Ucmd6,Udetail6,	/*  7 */
		"",Ucmd,Udetail,	/*  default */
		0,0,0,
		};

main(argc,argv)
int argc;
char *argv[];
{
	char in1[80],in2[80],out[80];
	int choix ,ival;
	register i1, i2;

	choix = inr_initm(argc,argv,"2.1",cmds);
	if(choix < 0) {
		fprintf(stderr,"Il faut l'une des options -et -ou -xou -ma -fo -co -inv\n");
		iusage_(Ucmd,Udetail);
	}
	if((choix > 2) && (choix < 6)) {
		if(!igetopt(cmds[choix].name,"",0,"%x",&ival,"",0))
			iusage_(Ucmd,Udetail);
	} else if(!igetopt(cmds[choix].name,"",0,"",0,"",0))
		iusage_(Ucmd,Udetail);
	choix++;
	if ( choix < 4 ) { /* fonctions a 2 images d'entree */
		i1 = fileopt(in1,"i");
		i2 = fileopt(in2,"i");
		if((i1 == 0) && (i2 == 0))
			imerror(9,"2 images d'entree obligatoires\n");
	} else {       /* fonctions a une image d'entree */
		fileopt(in1,"i");
	}

	fileopt(out,"o");
	if(tstopts())
		iusage_(Ucmd,Udetail);
	slogic_(in1,in2,out,&choix,&ival);
	return 0;

}



