/* modification de format d'image
*/
#include <inrimage/image.h>
#include <inrimage/error.h>
#include <stdio.h>

extern debug_,koctet_;

static char Ucmd[]=
"[-cp [-hdr=size]] [-F=version] [-V] [options_de_format] [-hist=string] [-com=string] [-key=string] [-setct ct_file-in  | -getct ct_file-out | -copct proto_image][-i0 nn] [image .... image]";
static char Udetail[]=
"\t-cp : copie image sur stdout\n\
\t-V : entree interactive des options de format\n\
\t-F= : choix du Format de header\n\
\t-hist= : 'history-message'\n\
\t-com= : ecriture d'un commentaire\n\
\t-key= : definition de variable de la forme 'var=valeur'\n\
\t-setct : inscrit les tables couleurs a partir du fichier ct_file (DIMY= 1 ou 3, DIMX <= 256)\n\
\t\t-i0 nn : 1er pixel de la table (avec -setct)\n\
\t-coptct : copie les T.C. de proto_image dans les images\n\
\t-getct : ecrit la table couleur de la 1ere image dans ct_file (dimx <=256, dimz= 1 ou 3)";

static struct nf_fmt gfmt;
static struct nf_fmt gfmt0= {
	{0},{0},-1,0.,0.};

static Fort_int iopt= 0xf;
static struct image *nf, *nfo;

#define MAXCOL 256

static fl_h=0, fl_com= 0, fl_k=0;
static int fl_ct= 0, i0_ct= -1, nb_ct;
#define GETCT 1
#define SETCT 2
#define COPCT 3
struct image *nf_ct;
static struct nf_fmt fmt_ct= {MAXCOL,1,1,0,MAXCOL,MAXCOL,1,1,200,0,0,0,0,0,0};

static bldgfm();
static char *chkk();
static char bufct[3*MAXCOL];
static char *bufr, *bufg, *bufb;

#define BUFR &bufct[0]
#define BUFG &bufct[MAXCOL]
#define BUFB &bufct[2 * MAXCOL]
extern int khoros_mode;

main(argc,argv)
int argc;
char *argv[];
{
	register next, ier;
	register format;
	register char *pk;
	char in[256],out[256];
	char ctfile[MAXCOL];
	char bufh[256], bufc[256], bufk[256], bufkk[80];
	register n;
	int version;
	register flg_wr; /* pour savoir si on a des modifs */
	inr_init(argc,argv,"2.1",Ucmd,Udetail);

	out[0] = '\0';
	out[1] = '\0';
	in[1] = '\0';
	flg_wr = 0;
	if ( igetopt("-cp","",0,"",0,"",0) ) {
		if(khoros_mode)
			imerror(9,"-cp option not allowed in KHOROS mode\n");
		out[0] = '>'; /* standart output */
		flg_wr = 1;
	}

	if(igetopt("-V","",0,"",0,"",0)) {
		rdfmg_(&gfmt0,&iopt);
		format = 0xffffff;  /* tout est a modifier */
	} else {
		format = opt_modfmt(&gfmt0,(int)iopt);
	}
	fl_h = igetopt("-hist=","%[^\177]",bufh,"",0,"",0);
	fl_com = igetopt("-com=","%[^\177]",bufc,"",0,"",0);
	if((fl_k = igetopt("-key=","%[^\177]",bufk,"",0,"",0))) {
		if((pk = chkk(bufkk,bufk)) == (char *) 0)
			iusage_(Ucmd,Udetail);
	}
	if(igetopt("-setct","",0,"%s",ctfile,"",0)) {
		fl_ct = SETCT;
	} else if(igetopt("-getct","",0,"%s",ctfile,"",0))
		fl_ct = GETCT;
	else if(igetopt("-copct","",0,"%s",ctfile,"",0)) {
		fl_ct = COPCT;
	} if(igetopt("-i0","",0,"%d",&i0_ct,"",0)) {
		if(fl_ct != SETCT) 
			imerror(9,"option -i0 only allowed with -setct");
		if(i0_ct > 255)
			iusage_(Ucmd,Udetail);
	}
	if(fl_ct) {
		bufr = BUFR;
		bufg = BUFG;
		bufb = BUFB;
	}
	if((fl_ct == SETCT) || (fl_ct == COPCT)) {
		flg_wr = 1;
		nf_ct = imagex_(ctfile,"ex","t",&fmt_ct);
		if(fl_ct == SETCT) {
#if 0
			if((fmt_ct.DIMX > MAXCOL) || ((fmt_ct.DIMY != 1) && (fmt_ct.DIMY != 3)))
				imerror(9,"%s: format incorrect\n",ctfile);
			if(i0_ct < 0)
				i0_ct = fmt_ct.offsets[0];
			nb_ct = fmt_ct.DIMX;
			if((nb_ct + i0_ct) > MAXCOL)
				i0_ct = MAXCOL - nb_ct;
			fillbuf(bufct,fmt_ct.DIMY * MAXCOL,0);
			c_lect(nf_ct,1,bufr + i0_ct);
			if(fmt_ct.DIMY == 1) {
				bufg = bufr;bufb = bufr;
			} else {
				c_lect(nf_ct,1,bufg + i0_ct);
				c_lect(nf_ct,1,bufb + i0_ct);
			}
#endif
			ird_ctfile(nf_ct,&i0_ct,&nb_ct,bufr,bufg,bufb,MAXCOL);
			fermnf_(&nf_ct);
		} else {
			if(ird_ctrgb(nf_ct,&i0_ct,&nb_ct,bufr,bufg,bufb,MAXCOL) <= 0) {
				fl_ct = 0;
				fprintf(stderr,"Warning!! No color table in %s\n",ctfile);
			}
		}
	}		
	fileopt(in,"i");
	if(tstoptm()) iusage_(Ucmd,Udetail);  /* il reste des options */
	flg_wr |= fl_h | fl_com | fl_k | format;
	version = get_vers_opt();
	silent_err();
	next = 1;
	while (next) {
		c_erreur(ier);
		if(ier == 0) {
			nf=imagex_(in,"ex","",&gfmt);
			bldgfm(&gfmt0,&gfmt,format);
			if(out[0] != 0) /* filtre */
				nfo = imagex_(out,"sx","ax",&gfmt);
			else
				nfo = nf;
			if(fl_h)
				c_iwrhis(nfo,bufh);
			if(fl_com)
				c_iwrcom(nfo,bufc);
			if(fl_k)
				irephline(nfo,bufkk,0,pk);
			if(fl_ct == GETCT) {  /* read C.T. from file */
				if((n = ird_ctrgb(nf,&i0_ct,&nb_ct,bufr,bufg,bufb,MAXCOL)) <= 0) {
					fl_ct = 0;
					fprintf(stderr,"Warning!! No color table in %s\n",in);
				} else {
					fmt_ct.DIMX = fmt_ct.NDIMX = nb_ct;
					fmt_ct.DIMY = fmt_ct.NDIMY = n == 1 ? 1 : 3;
					fmt_ct.offsets[0] = i0_ct;
					nf_ct = imagex_(ctfile,"sx","ax",&fmt_ct);
					c_ecr(nf_ct,1,bufr + i0_ct);
					if(n > 1) {
						c_ecr(nf_ct,1,bufg + i0_ct);
						c_ecr(nf_ct,1,bufb + i0_ct);
					}
					fermnf_(&nf_ct);
				}
			} else if(fl_ct) {  /* SET or COP */
				iwr_ctrgb(nfo,i0_ct,nb_ct,bufr,bufg,bufb);
			}
			if(flg_wr || (version && (version != nf->i_version))) { /* write only if necessary*/
				smdfmt_(&nf,&nfo,&gfmt);
			}
		}
		next = xfileopt(in,"i",0);
		if(fl_ct == GETCT)
			fl_ct = 0;
	}
	return 0;

}

static bldgfm(gfmti,gfmto,format)
register struct nf_fmt *gfmti, *gfmto;
register format;
{
	register i, k;
	k = 4;
	for(i=2;i<9;i++) {
		if(format & k)
			gfmto->lfmt[i] = gfmti->lfmt[i];
		k <<= 1;
	}
	gfmto->DIMX = gfmto->NDIMX * gfmto->NDIMV;
	gfmto->DIMY = gfmto->NDIMY * gfmto->NDIMZ;
	for(i=0;i<3;i++) {
		if(format & k)
			gfmto->offsets[i] = gfmti->offsets[i];
		k <<= 1;
	}
	if(format & k)
		gfmto->maille = gfmti->maille;
	k <<= 1;
	if(format & k)
		gfmto->bias = gfmti->bias;
	k <<= 1;
	if(format & k)
		if((gfmto->scale = gfmti->scale) != 0.) {
			if(gfmto->EXP < 0)
				gfmto->EXP = -200;
			else
				gfmto->EXP = 200;
			}
	ver_gfmt(gfmto,(Fort_int)3);   /* verif du format modifie */
}

static char *chkk(key,buf)
register char *buf, *key;
{
	register i, c;
	register char *p;
	p = buf;
	if(*p == '#') return (char *)0;
	for(i=0;i<79;i++) {
		if((c = *p++) == '=') {
			key[i++] = c;
			key[i] = 0;
			return ( i > 0 ? p : (char *) 0);
		}
		if(c == 0) break;
		key[i] = c;
	}
	return (char *) 0;
}
