#include <stdio.h>
#include <math.h>
#include <inrimage/inrfile.h>

static char Ucmd[]=
"-a angle[-f] [-xc xc][-yc yc][-tx xtrans] [-ty ytrans][-ixi n][-iyi n][-dxi n][-dyi n][-nw | -fv fill_values] [image_in | -][image_out]";
static char Udetail[]=
"    Rotation (2D) d'une sous-image 8 bits autour d'un point (centre par defaut) + translation\n\
	-a : angle (float) de rotation en degres\n\
	-f : (fast) sans interpolation (choisit le point le plus pres)\n\
	-xc, -yc : nbs flottants, pixel centre de rotation : 0 = centre image\n\
	        point haut gauche= 1.,1.\n\
	-tx, -ty : translation a appliquer apres la rotation\n\
	-ixi, -iyi : indices (>=1) 1e pixel dans image source\n\
	-dxi, -dyi : taille fenetre dans image source\n\
	-nw : ne modifier dans image_out que ce qui correspond a la fenetre source\n\
	-fv : liste (<= NDIMV) de valeurs (n,n,...) pour completer image_out\n\
	image_in : image source (stdin par def)\n\
	image_out : resultat (stdout par def), taille qque, mais meme NDIMV, NDIMZ que image_in\n\
\n";

extern errno;
extern int koctet_, debug_;

extern int IM_nbmin_hdr;
Fort_int lfmti[9]= {1,1,1,0,1,1,1,1,0};
Fort_int lfmto[9]= {1,1,1,0,1,1,1,1,0};
static int ixi= 1, iyi= 1;
static int dxi= 0, dyi= 0;
static float ixc= 0., iyc= 0., tx= 0., ty= 0.;
#define ARRONDI(x) (x < 0 ? (int)(x - .5) : (int)(x + .5))
static int flg_keep;
static int *fill_vals;
extern int IM_nbmin_hdr;
extern char * index();

main(argc,argv)
int argc;
char **argv;
{
	int i, n;
	float ang, angle;

	char in[256], out[256];
	struct image *nfi, *nfo;
	double sina, cosa;
	char *bufi, *bufo, fvbuf[256];
	int flg_fast, flg_fv;
	int y, nbv;
	int lfv;

	inr_init(argc,argv,"2.2",Ucmd,Udetail);

	flg_fv = 0;
	if(! igetopt1("-a","%f",&angle)) iusage_(Ucmd,Udetail);
	igetopt1("-xc","%f",&ixc);
	igetopt1("-yc","%f",&iyc);
	igetopt1("-tx","%f",&tx);
	igetopt1("-ty","%f",&ty);
	igetopt1("-dxi","%d",&dxi);
	igetopt1("-dyi","%d",&dyi);
	igetopt1("-ixi","%d",&ixi);
	igetopt1("-iyi","%d",&iyi);
	if( ! (flg_keep = igetopt0("-nw")))
		flg_fv = igetopt1("-fv","%s",fvbuf);
	flg_fast = igetopt0("-f");
	infileopt(in);
	outfileopt(out);
	nfi = image_(in,"e","t",lfmti);
	if(flg_fast)  /* place pour copier la table couleur */
		IM_nbmin_hdr = nfi->desc_size / FILE_HEADER_LEN;
	if(flg_keep)
		nfo = image_(out,"e","t",lfmto);
	else
		nfo = image_(out,"s","t",lfmto);
	if(tstopts()) iusage_(Ucmd,Udetail);
	if((lfmti[I_NDIMV] != lfmto[I_NDIMV]) || (lfmti[I_NDIMZ] != lfmto[I_NDIMZ]))
		imerror(9," les images doivent avoir meme ndimz et ndimv\n");
	if(! flg_keep) {
		if((nbv = lfmti[I_NDIMV]) == 1) fill_vals = &lfv;
		else
			fill_vals = (int *)i_malloc(nbv* sizeof(int));
		if(flg_fv) {
			bufi = fvbuf;
			for(i=0;i<nbv;i++) {
				sscanf(bufi,"%d",fill_vals +i);
				if((bufi = index(bufi,',')) == NULL) break;
				bufi++;
			}
			if(i < nbv) n = *(fill_vals + i);
		} else {
			i=0;
			n=0;
		}
		for(;i<nbv;i++)
		  *(fill_vals + i) = n;
	}

	n = lfmti[I_DIMX] * lfmti[I_NDIMY];
	bufi = (char *)i_malloc(n);
	n = lfmto[I_DIMX] * lfmto[I_NDIMY];
	bufo = (char *)i_malloc(n);
	
	if(flg_fast) {  /* copier la table couleur */
		icop_ct(nfi,nfo);
	}
/* les parametres de la transformation */
	if((angle < -360.) || (angle > 360.))
	  imerror(9,"angle incorrect : ]-360.,360.[)\n");
	ang = ((double) angle) * 3.14159 / 180.;
	cosa = cos(ang);
	sina = sin(ang);

	if(ixi > 0) ixi--;
	else ixi = 0;
	if((dxi <= 0) || (dxi > (lfmti[I_NDIMX] - ixi)))
		dxi = lfmti[I_NDIMX] - ixi;
	if(ixc == 0.)
		ixc = ixi + dxi / 2.;
	else if(ixc > 0.) ixc -= 1.;

	if(iyi > 0) iyi--;
	else iyi = 0;
	if((dyi <= 0) || (dyi > (lfmti[I_NDIMY] - iyi)))
		dyi = lfmti[I_NDIMY] - iyi;
	if(iyc == 0.)
		iyc = iyi + dyi / 2.;
	else if(iyc > 0.) iyc -= 1.;
	
	for(i=0;i<lfmti[I_NDIMZ];i++) {
 		c_lect(nfi,lfmti[I_NDIMY],(unsigned char *)bufi);
		if(flg_keep) {
			y = c_lptget(nfo);
			c_lect(nfo,lfmto[I_NDIMY],(unsigned char *)bufo);
			c_lptset(nfo,y);
		}
		if(flg_fast)
			fbufrot(bufi,bufo,sina,cosa);
		else
			bufrot(bufi,bufo,sina,cosa,ixc,iyc);
		c_ecr(nfo,lfmto[I_NDIMY],(unsigned char *)bufo);
	}
	fermnf_(&nfi);
	fermnf_(&nfo);
	return 0;
}


fbufrot(ppi,po,sina,cosa)
register unsigned char *ppi, *po;
register double sina, cosa;
{
	int nv, nxo, nyo, nxi, nyi;
	register xi, yi;
	register x, y, i, lgl;
	register unsigned char *pi;
	float dx, dy;
	float dycos, dysin, v;
	register float xc, yc;
	xc = ixc;
	yc = iyc;
	nxo = lfmto[I_NDIMX];
	nyo = lfmto[I_NDIMY];
	nxi = ixi + dxi - 1;
	nyi = dyi + iyi - 1;
	nv = lfmto[I_NDIMV];
	lgl = lfmti[I_DIMX];
	for(y=0;y<nyo;y++) {
		/* calcul y origine . ATTENTION a origine en y / ind. lignr*/
		dy = yc - y + ty;
		dysin = dy * sina;
		dycos = dy * cosa;
		for(x=0;x<nxo;x++) {
			/* on calcule le pt origine */
			dx = x -xc -tx;
			v = yc - (dycos - dx * sina);
			yi = ARRONDI(v);
			if((yi < iyi) || (yi > nyi)) {
				if(! flg_keep) {
					for(i=0;i<nv;i++) *po++ = fill_vals[i];
				} else po += nv;
				continue;
			}
			v = xc + (dx * cosa + dysin);
			xi = ARRONDI(v);
			if((xi < ixi) || (xi > nxi)) {
				if(! flg_keep) {
					for(i=0;i<nv;i++) *po++ = fill_vals[i];
				} else po += nv;
				continue;
			}
			pi = ppi + (yi * lgl) + xi * nv;
			for(i=0;i<nv;i++)
				*po++ = *pi++;
		}
	}
}


bufrot(ppi,po,sina,cosa)
register unsigned char *ppi, *po;
register double sina, cosa;
{
	int nv, nxo, nyo, nxi, nyi;
	int xi, yi;
	register x, y, i, lgl, lgl1;
	register unsigned char *pi;
	float dx, dy;
	float dycos, dysin, v;
	float xc, yc, kx, ky;
	xc = ixc;
	yc = iyc;
	nxo = lfmto[I_NDIMX];
	nyo = lfmto[I_NDIMY];
	nxi = ixi + dxi - 1;
	nyi = dyi + iyi - 1;
	nv = lfmto[I_NDIMV];
	lgl = lfmti[I_DIMX];
	lgl1 = lgl + nv;
	for(y=0;y<nyo;y++) {
		/* calcul y origine . ATTENTION a origine en y / ind. lignr*/
		dy = yc - y + ty;
		dysin = dy * sina;
		dycos = dy * cosa;
		for(x=0;x<nxo;x++) {
			/* on calcule le pt origine */
			dx = x -xc -tx;
			v = yc - (dycos - dx * sina);
			yi = ARRONDI(v);
			if((yi < iyi) || (yi > nyi)) {
				if(! flg_keep) {
					for(i=0;i<nv;i++) *po++ = fill_vals[i];
				} else po += nv;
				continue;
			}
			ky = v - (float)yi;
			if(ky < 0) ky = -ky;
			v = xc + (dx * cosa + dysin);
			xi = ARRONDI(v);
			if((xi < ixi) || (xi > nxi)) {
				if(! flg_keep) {
					for(i=0;i<nv;i++) *po++ = fill_vals[i];
				} else po += nv;
				continue;
			}
			kx = v - (float)xi;
			if(kx < 0) kx = -kx;
			pi = ppi + (yi * lgl) + xi * nv;
			for(i=0;i<nv;i++) {
				v = (1. - ky) * ( (float)*pi * (1 - kx) + *(pi+1) * kx);
				v += ky * ( (float)*(pi + lgl) * (1 - kx) + *(pi + lgl1) * kx);
				*po++ = ARRONDI(v);
				pi++;
			}
		}
	}
}


