#include <inrimage/image.h>

struct plig {
float *data;
int y;
};
static struct plig alig1, alig2;
static int *ixtab, *iytab;
static float *Alpha, *beta;  /* Note : sur dec alpha est predefini */
static float xscale, yscale;
static int init_tables(), fast_fzoom();
static int tab_init= 0;
static void mkbuflig();
static int nlig1, nlig2, ilig0;
static int flg_center, flg_fast;
extern int koctet_;
static int nbytes;
static int Xmag, Ymag;

extern char *i_malloc(), *i_calloc();

/*change la taille d'une image par interpolation
nfi, nfo : images in/out
xmag, ymag = nouvelles dim en X et Y (ndimx, ndimy) d'un plan (mode interpol.)
      pas d'echantillonage ou -facteur de duplication (fast mode)
option : 
      1 (center) => garder le centre, sinon garder les extremites
      -1 (fast) : dupliquer ou supprimer des pixels
*/
sfzoom(nfi,nfo,lfmt,lfmto,xmag,ymag,option)
struct image **nfi, **nfo;
Fort_int lfmt[], lfmto[];
int xmag,ymag,option;
{
	register i;
	unsigned char *buf_in, *buf_out;
	int lglig;
	flg_center = option > 0 ? 1 : 0;
	flg_fast = option < 0 ? 1 : 0;
	Xmag = xmag;Ymag = ymag;
	if(flg_fast) {
		fast_fzoom(nfi,nfo,lfmt,lfmto);
		return 1 /* makes c99 happy */;
	}
	imerror(9,"Sorry! only fast mode (-f) is implemented\n");
	nbytes = koctet_ * 1024;
	i = DIMX * NDIMY;
	if(nbytes < i) i = nbytes;
	buf_in = (unsigned char *)i_calloc(i,1);
	nlig1 = i / DIMX;
	if(Xmag == NDIMX && Ymag == NDIMY) {  /* simple copie */
		i = DIMY;
		while(i > 0) {
			if(nlig1 > i) nlig1 = i;
			c_lect(*nfi,nlig1,buf_in);
			c_ecr(*nfo,nlig1,buf_in);
			i -= nlig1;
		}
		return 1 /* makes c99 happy */;
	}
	lglig = Xmag * NDIMV;
	i = lglig * Ymag;
	if(nbytes < i) i = nbytes;
	buf_out = (unsigned char *)i_calloc(i,1);
	nlig2 = i / lglig;
	for(i=0;i<NDIMZ;i++) {
		ilig0 = -nlig1;
		fzoom_plan(buf_in,buf_out,*nfi,*nfo,NDIMX,NDIMY,NDIMV,Xmag,Ymag);
	}
	fermnf_(nfi);
	fermnf_(nfo);
}

fzoom_plan(bufin,bufo,nfi,nfo,odimx,odimy,ndimv,newdimx,newdimy)
int odimx, odimy,newdimx,newdimy, ndimv;
unsigned char *bufin, *bufo;
struct image *nfi, *nfo;
{
	float b, b1;
	float *p1, *p2;
	struct plig *plig1, *plig2, *p0;
	unsigned char *bufout;
	register j;
	register i, i0;
	register nl;
	int nl0;
	init_tables(odimx,odimy,ndimv,newdimx,newdimy);
	plig1 = &alig1;
	plig2 = &alig2;
	bufout = bufo;
	nl0 = nlig2;
	nl = nl0;
	for(i=0;i<newdimy;i++) {
		nl--;
		i0 = iytab[i];
		b = beta[i];
		if(plig1->y != i0) {
			if(plig2->y == i0) {
				p0 = plig2;
				plig2 = plig1;
				plig1 = p0;
			} else {
				mkbuflig(nfi,odimy,bufin,odimx,newdimx,ndimv,i0,plig1);
			}
		}
		if(plig2->y != (i0 + 1)) {
			if(i0 == (odimy -1)) {
				p2 = plig1->data;
			} else {
				mkbuflig(nfi,odimy,bufin,odimx,newdimx,ndimv,i0+1,plig2);
				p2 = plig2->data;
			}
		} else
			p2 = plig2->data;
		p1 = plig1->data;
		b1 = 1. - b;
		if(!flg_center && (i == 0 || i == (newdimy -1))) {
			for(j = 0;j<(newdimx * ndimv);j++)
				*bufout++ = *p1++;
		} else {
			for(j=0;j<(newdimx * ndimv);j++)
				*bufout++ = (char)(b * *p1++ + b1 * *p2++ + .5);
		}
		if(nl <= 0) {
			c_ecr(nfo,nl0,bufo);
			bufout = bufo;
			if(nl0 >= (newdimy -i))
				nl0 = newdimy -i -1;
			nl = nl0;
		}
	}
}

/* interpolation sur 1 ligne */
static void mkbuflig(nf,odimy,bufin,odimx,newdimx,ndimv,y0,plig1)
unsigned char *bufin;
struct plig *plig1;
int odimx, newdimx, y0, odimy, ndimv;
struct image *nf;
{
	register unsigned char *buf;
	register float *pf;
	register i, i0, i01, k;
	register int lglig, olglig;
	register float a, a1;
	if(y0 < ilig0)
		imerror(9,"Bad call to mkbuflig");
	if(y0 >= (ilig0 + nlig1)) {
		i = nlig1;
		ilig0 += nlig1;
		if((ilig0 + i) > odimy)
			i = odimy - ilig0;
		c_lect(nf,i,bufin);
	}
	olglig = odimx * ndimv;
	buf = bufin + (y0 - ilig0) * olglig;
	plig1->y = y0;
	pf = plig1->data;
	if(ndimv > 1) {
		for(i=0;i<newdimx;i++) {
			i0 = ixtab[i];
			i01 = i0 + ndimv;
			a = Alpha[i];
			a1 = 1. - a;
			for(k=0;k<ndimv;k++)
				*pf++ = *(buf+i0 + k) * a + a1 * *(buf + i01 + k);
		}
		if(!flg_center) {
			lglig = (newdimx - 1) * ndimv ;
			olglig -= ndimv;
			for(k=0;k<ndimv;k++) {
				*(plig1->data + k) = *(buf + k);
				*(plig1->data + lglig + k) = *(buf + olglig + k);
			}
		}
	} else {
		for(i=0;i<newdimx;i++) {
			i0 = ixtab[i];
			a = Alpha[i];
			a1 = 1. - a;
			*pf++ = *(buf+i0) * a + a1 * *(buf + i0 + 1);
		}
		if(!flg_center) {
			*(plig1->data) = *buf;
			*(plig1->data + newdimx -1) = *(buf + odimx -1);
		}
	}
}

static float *blig1, *blig2;
static int init_tables(odimx,odimy,ndimv,newdimx,newdimy)
int odimx, odimy,newdimx,newdimy, ndimv;
{
	register float dx, dy;
	register i, i0;
	if(!tab_init) {
		blig1 = (float *)i_calloc(sizeof(float), newdimx * ndimv);
		blig2 = (float *)i_calloc(sizeof(float), newdimx * ndimv);
		iytab = (int *) i_malloc(newdimy * sizeof(int));
		beta = (float *) i_malloc(newdimy * sizeof(float));
		ixtab = (int *) i_malloc(newdimx * sizeof(int));
		Alpha = (float *) i_malloc(newdimx * sizeof(float));
		tab_init = 1;
	}
	alig1.y = alig2.y = -1;
	alig1.data = blig1;
	alig2.data = blig2;
	if(newdimy == 1 || odimy == 1)
		yscale = (float)newdimy / (float)odimy;
	else
		yscale = (float)(newdimy -1) / (float)(odimy -1);
	if(newdimx == 1 || odimx == 1)
		xscale = (float)newdimx / (float)odimx;
	else
		xscale = (float)(newdimx -1) / (float)(odimx - 1);
	if(flg_center) {
		dy = ((newdimy -1) - yscale * (odimy -1)) / 2.;
		if(dy < 0.) dy = -dy;
		dx = ((newdimx -1) - xscale * (odimx -1)) / 2.;
		if(dx < 0.) dx = -dx;
	} else {
		dx = 0.;
		dy = 0.;
	}
	for(i=0;i<newdimy;i++) {
		iytab[i] = i0 = (int)((i + dy) / yscale);
		beta[i] = (float)(1 + i0) - ((i + dy) / yscale);
	}
	for(i=0;i<newdimx;i++) {
		i0 = (int)((i + dx) / xscale);
		ixtab[i] = i0 * ndimv;
		Alpha[i] = (float)(1 + i0) - ((i + dx) / xscale);
	}
}
#if 0
reduc2(buf_ima,dimx,dimy)
register char *buf_ima;
int dimx, dimy;
{
	register x, y;
	register xx, xm, ym;
	xx = 0; xm = 0; ym = dimx;
	for(y = 0; y < (dimx * dimy / 4); y++) {
		x = buf_ima[xm++] + buf_ima[ym++];
		x = x + buf_ima[xm++] + buf_ima[ym++];
		buf_ima[y] = x / 4;
		xx++;
		if(xx >= (dimx / 2)) {
			xx = 0;
			xm += dimx;
			ym += dimx;
		}
	}
}
#endif

static int fast_fzoom(nfi,nfo,lfmt,lfmto)
struct image **nfi, **nfo;
Fort_int lfmt[], lfmto[];
{
	register i;
	float *bufi, *bufo;
	register nbl, nbli, nblo;
	register n, ny, ntot;
	register nblig;
	int ny0;
	int bsize;
	int incxi, incxo;
	nbytes = koctet_ * 1024;
	ny = lfmt[I_NDIMY] > lfmto[I_NDIMY] ? NDIMY : lfmto[I_NDIMY];
	bsize = lfmt[I_BSIZE];
	n = (DIMX + lfmto[I_DIMX]) * BSIZE;
	if(Ymag < 0) { /* zoom */
		ny = NDIMY;
		ny0 = 1 -Ymag;
	} else { /* reduc */
		ny = lfmto[I_NDIMY];
		ny0 = 1 + Ymag;
	}
	n *= ny0;
	nbl = (nbytes -4) / n;
	if(nbl > ny)
		nbl = ny;
	i = nbl * n;
	bufi = (float *)i_malloc(i);
	for(i=0;i<NDIMZ;i++) {
		if(Ymag > 0) { /* reduction */
			nblo = nbl;
			nbli = (nbl - 1) * Ymag + 1;
			incxi = DIMX * (Ymag -1);
			incxo = 0;
		} else {  /* zoom */
			nbli = nbl;
			nblo = -(nbl * Ymag);
			incxo = - lfmto[I_DIMX] * (1 + Ymag);
			incxi = 0;
		}
		bufo = (float *)((((long)bufi + nbli * DIMX * bsize) + 3) & ~3);
		nblig = nbl;
		ntot = ny;
		while(ntot > 0) {
			if(nblig > ntot) {
				nblig = ntot;
				if(Ymag > 0) {
					nblo = nblig;
					nbli = nblig * Ymag;
				} else {
					nbli = nblig;
					nblo = -(nblig * Ymag);
				}
			}
			ntot -= nblig;
			c_lect(*nfi,nbli,bufi);
			if(Xmag < 0) {
				duppix(bufi,bufo,nbl,NDIMX,NDIMV,-Xmag,incxi,incxo);
			} else {
				reducpix(bufi,bufo,nbl,lfmto[I_NDIMX],NDIMV,Xmag,incxi,incxo);
			}
			if(Ymag < -1) { /* repeat lines */
				duplig(bufo,nbl,lfmto[I_DIMX],-Ymag);
			}
			c_ecr(*nfo,nblo,bufo);
		}
	}
		
	fermnf_(nfi);
	fermnf_(nfo);
}

duppix(bufi, bufo,nbl,ndimx,ndimv,idxi,incxi,incxo)
register float *bufi, *bufo;
register nbl,ndimx, ndimv, idxi, incxi, incxo;
{
	register i, j, k, nv;
	register float v;
	register float *po;
	for(j=0;j<nbl;j++) {
		for(i=0;i<ndimx;i++) {
			if(ndimv > 1) {
				for(nv=0;nv<ndimv;nv++) {
					v = *bufi++;
					po = bufo++;
					for(k=0;k<idxi;k++) {
						*po = v;
						po += ndimv;
					}
				}
				bufo = po - ndimv + 1;
			} else {
				v = *bufi++;
				for(k=0;k<idxi;k++) {
					*bufo++ = v;
				}
			}
		}
		bufi += incxi;
		bufo += incxo;
	}
}

reducpix(bufi,bufo,nbl,ndimx, ndimv,idxi,incxi,incxo)
register float *bufi, *bufo;
register nbl, ndimv,ndimx, idxi, incxi, incxo;
{
	register i, j, nv;
	register float v;
	if(ndimv > 1)
		idxi = (idxi - 1) * ndimv;
	for(j=0;j<nbl;j++) {
		if(ndimv > 1) {
			for(i=0;i<ndimx;i++) {
				for(nv=0;nv<ndimv;nv++)
					*bufo++ = *bufi++;
				bufi += idxi;
			}
		} else {
			for(i=0;i<ndimx;i++) {
				*bufo++ = *bufi;
				bufi += idxi;
			}
		}
		bufi += incxi;
		bufo += incxo;
	}
}

/* repete les lignes */
duplig(buf,nbl,dimx,nb)
float *buf;
int nb;
register dimx, nbl;
{
	register i, j, n;
	register float *pi, *po;
	n = dimx * (nb -1);
	po = buf;
	for(i=0;i<nbl;i++) {
		pi = po;
		po += dimx;
		for(j=0;j<n;j++)
			*po++ = *pi++;
	}
}
