/* SHISTO
	SUBROUTINE SHISTO(inname,outname,icd)

calcule histogramme ou fonction de repartition d'une image
inname, outname : nom fichiers in et out
icd : -1 => histogramme normalise (fraction de pts / niveau),
       0 = histo simple (nb pts / niveau)
       1 = fonct. de repartition (fraction de pts de val <= niveau)
*/

#include <inrimage/image.h>
static struct image *nfi, *nfo, *nft;
static  Fort_int ier, zero= 0, un= 1, ndimf, n;
static Fort_int lfmt2[9]= {256,1,4,1,256,1,1,1,0};

extern void calparg_(), histog_();

#define SEP_V 1
#define SEP_Z 2

void shisto_(in,out,icd,isep)
char *in, *out;
Fort_int *icd, *isep;
{
	char temp[80];
	Fort_int isf;
	Fort_int lfmt[9];
	int i;
	float min, max, moy;
	nfi = image_(in,"e","",lfmt);
	if((*icd == -2) && (NDIMV != 3)) 
		imerror(9,"Images couleur avec NDIMV==3 seulement (utiliser cnvcol -cv)");
	ndimf= 256;
	if(*isep & SEP_V) {
		ndimf *= NDIMV;
		lfmt2[I_NDIMV] = NDIMV;
		lfmt2[I_DIMX] = ndimf;
	}
	if(*isep & SEP_Z) {
		ndimf *= NDIMZ;
		lfmt2[I_NDIMZ] = NDIMZ;
		lfmt2[I_DIMY] = NDIMZ;
	}
	if(*icd == -2) { /* histo couleur normalise 4x4x4 */
		ndimf = 64;
		lfmt2[I_DIMX] = 64;
		lfmt2[I_NDIMX] = 64;
		lfmt2[I_NDIMY] = 1;
		lfmt2[I_DIMY] = 1;
		lfmt2[I_NDIMZ] = 1;
		lfmt2[I_NDIMV] = 1;
	}
	nfo = image_(out,"s","a",lfmt2);
	n= 1;
	if(lfmt[I_BSIZE] == 1) {
		exec_(&ier,&un,&ndimf,&un,&n,histog_,&nfi,&nfo,icd,isep,&min,&max,&ier);
		imperr_(&ier);
		fpanic_();
		return ;
	}

	if(ispipe_(&nfi)) {
		nft = image_(temp,"t","a",lfmt);
	} else {
		nft = nfi;
	}
	n=1;
	exec_(&ier,&zero,&zero,&un,&n,calparg_,&nfi,&nft,&zero,&min,&max,&moy,&ier);
	c_lptset(nft,1);
	n=1;
	exec_(&ier,&un,&ndimf,&un,&n,histog_,&nft,&nfo,icd,isep,&min,&max,&ier);
	imperr_(&ier);
	if(nft != nfi) rmnf_(&nft);
	fpanic_();
}


