/*  c_apolygd
	apolygd(A,B,ndim,ct_in,ct_out,nmx,eps,iopfr)
 effectue l'approximation polygonale sur les contours d'un fichier
  de contours "ouvert" par IOUVCT (parametre ct_in)
et range le resultat dans un 2e fichier (parametre ct_out)
 A et B sont 2 tableaux de travail (donnees et resultats pour chaque cont.)
   ndim contient les dimension de A et B
  nmx est le numero maximum de contour
  eps est la marge d'erreur pour l'approximation (en nombre de pas x, y)
   iopfr=1 si les contours sont fermes (on relie 1er et dernier points)
   et iopfr=0 sinon
*/

#include <stdio.h>
#include <inrimage/image.h>
#include <inrimage/contour.h>

void apolyg1_(a,b,ndim,ct_in,ct_out,nmx,eps,iopfr)
short *a, *b;
struct fc_cont *ct_in, *ct_out;
Fort_int *ndim, *nmx, *iopfr;
float *eps;
{
	register int lgra, lgrn, i;
	Fort_int n;
	Fort_int ipar[2];
	Fort_int sens, ext, np;
	int ndm;
	ndm = *ndim * (sizeof (t_aligned)/ sizeof (int4));
	lgra = lgrn = 0;
	for(i=0;i<=*nmx;i++) {
		if((n = c_ircttb(ct_in,i,a,ndm)) <= 0) {
			if(n < 0)
				imerror(8,"pas assez de place pour les contours\n");
			continue;
		}
		c_irctpa(ct_in,i,&sens,&ext,&n,ipar,1,&np);
		lgra += n;   /* calcul ancienne longueur totale */
		if(*iopfr > 0) {  /* ferme */
			polyg_(a,b,&n,eps);
		} else { /* non ferme */
			polygn_(a,b,&n,eps);
		}
		lgrn += n;
		c_wrctev(ct_out,i,ext);
		c_wrctpa(ct_out,i,ipar,np);
		c_wrcttb(ct_out,i,b,n);
	}
	fprintf(stderr,"taille passee de %d a %d\n",lgra,lgrn);
}
