#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>

/* c_chrseg(buf,ii0,pseg,plseg,nmax)

*  buf: buffer image
* ii0 : indice du 1e point de la ligne courante
*  nmax: taille de pseg (nbstruct iseg)
*Retour:
*  pseg tableau des segments noirs
*  plseg lgr de pseg (en nb elements)
*NB:
*  2 struct iseg par segments : x0,n0,x1,n1
*n0,n1 num chaines sont mis a 0
*  erreur 8 si nmax insuffisant
****************
*/

void c_chrseg(buf,ii0,pseg,plseg,nmax)
unsigned char *buf;
int ii0, nmax;
int *plseg;
struct iseg *pseg;
{
	int ix, iop, j, k, v;
	int vmin, vmax, jprec, nseg, xend;
	nmax &= ~1;   /* il faut un nb pair */
	nmax -= 2;
	ix = anac_info.x0;
	/* iop = 0 si 1 octet, 1 si 1 bit A 0, 2 si 1 bit a 1 */
	if(anac_info.flg_1bit) {
		iop = (anac_info.vmin == 0) ? 1 : 2;
	} else {
		iop = 0;
		vmin = anac_info.vmin;
		vmax = anac_info.vmax;
	}
	jprec = 1;  /* int pt precedent = fond */
	xend = ix + anac_info.dx;
	nseg = 0;
	while(ix < xend) {
		if(! iop) { /* image 1 octet */
			v = *(buf + ii0++);
			if((v < vmin) || (v > vmax)) {  /* fond */
				j = 1;
			} else {
				j = 0;   /* objet */
			}
		} else {  /* image 1 bit */
			v = *(buf + (ii0 / 8));
			k = 0x80 >> (ii0 % 8);
			ii0++;
			if(iop > 1) {  /* objet a 1 */
				j = (v & k) ? 0 : 1;
			} else {
				j = (v & k) ? 1 : 0;
			}
		}
		if(j) { /* fond */
			if(! jprec) { /* transition */
				(pseg+1)->x = ix -1;
				(pseg+1)->idesc = 0;
				pseg += 2;
				nseg += 2;
			}
		} else {   /* objet */
			if(jprec) { /* transition */
				if(nseg >= nmax)
					imerror(8,"pas assez de place pour les segmants\n");
				pseg->x = ix;
				pseg->idesc = 0;
			}
		}
		jprec = j;
		ix++;
		continue;
	}
	if(! jprec) { /* on etait dans de l'objet */
		(pseg+1)->x = ix-1;
		(pseg+1)->idesc = 0;
		pseg += 2;
		nseg += 2;
	}
	*plseg = nseg;
}
