C* ECDKCG
	SUBROUTINE ECDKCG(NF,IOPT,NUM,IEXT,NPAR,IPAR,NMOT,J,ICHN)
C  ECRITURE DE FICHIERS DE CONTOURS
C NF=NUMERO DU FICHIER ( 1 A 3)
C  IOPT=OPTION 0=INIT POUR ECRITURE, 1=ECRITURE PARAMETRES + POINTS D'UN
C     CONTOUR, 2=ECRITURE IEXT SEUL, -1=FERMETURE FICHIER
C IOPT=0 OUVERTURE DU FICHIER : CREATION SECTEUR 0 ET INIT PTRS
C    NUM=U.L.  ET ICHN=TABLEAU CONTENANT UN COMM. TERMINE PAR 1/2 MOT NU
C IOPT=-1 "FERMETURE" DU FICHIER (SANS FERMETURE D'U.L.) : INDISPENSABLE
C      ECRITURE DES DERNIERS BLOC D'INDEX ET DE DATA ET DU SECT. 0
C   RETOUR : NUM=NUMERO MAX DE CONTOUR, IEXT=NB EFFECTIF DE CONTOURS,
C    NPAR=NB TOTAL DE SECTEURS DATA+INDEX, IPAR=SURF TOTALE NOIRE
C       (SOMME ALGEBRIQUE DU 1ER PARAM DES CHN),  NMOT= SOMME DES
C       SURF DES CONTOURS EXTERIEURS
C     (SOMME DES 1ER PARAM. DES CONTOUR A NUM. D'ENVELOPPE NUL).
C     ICHN= NB MAX DE PARAMETRES PAR CONTOUR.
C IOPT=1 ECRITURE DU CONTOUR NUM CONTENU DANS LE TABLEAU ICHN(J)
C  IEXT EST LE NUMERO DE L'ENVELOPPE (IEXT ET NUM ENTRE 1 ET 32767)
C  IPAR EST UN TABLEAU DE NPAR PARAMETRES ASSOCIES AU CONTOUR
C  LE TABLEAU ICHN EST DECOUPE EN MOTS DE NMOT+1 MOTS, CHAINES PAR
C   LE 2EME 1/2 MOT. LE 1ER 1/2 MOT DE ICHN(J) CONTIENT LA LONGUEUR
C   DU CONTOUR EN NB DE MOTS DE DONNEES (LES MOTS NULS SONT IGNORES)
C IOPT=2  REECRITURE DU PARAMETRE IEXT SEUL (SUR CONTOUR NUM)
	DIMENSION IB0(64,3),IBI(64,3),IBD(64,3),ICHN(1),IPAR(1)
	INTEGER*2 IBC(2)
	INTEGER LU(3),INDX(3),INDXN(3),IDCR(3)
	EQUIVALENCE (IBC(1),ITR)
	DATA LU/0,0,0/,KRD/0/,KWR/1/
C  STRUCTURE SECT 0 :
C    1=NUMERO CONTOUR MAX, 2=NB EFFECTIF DE CONTOURS, 3=NB DE SECT. INDX
C    4=NB TOTAL SECT. INDEX+DATA, 5=ADRESSE 1ER SECT. INDEX
C    6=ADRESSE DERNIER SECT IND., 7=PTR DE LA 1ERE DONNEE (2*256+2)
C    8=PTR DU PROCHAIN MOT LIBRE POUR LES DONNEES
C    9=FLAG INDIQUANT SI LE FICHIER EST OUVERT EN ECRITURE (VAL 2)
C    10=SURFACE TOTALE D'OBJET (SOMME ALGEBRIQUES DES 1ER PARAM. DES CON
C    11=SURF. TOTALE DES CONT. "EXTERIEURS" (SOMME DES VAL. ABS. DES
C       1ERS PARAM. DES CONTOURS)
C    12=NB MAX DE PARAMETRES POUR UN CONTOUR DONNE
C    33 A 64 : COMMENTAIRE TERMINE PAR 1/2 MOT NUL.
C
C STRUCTURE SECT INDEX : 1 PTR VEC SECT. IND. PRECEDENT, 1 PTR VERS SUIV
C    62 PTRS VERS DATAS DU CONTOUR (PTR NUM. N POUR CONTOUR N) :
C       VALEUR 256*K+L OU K=NUM SECT ET L=INDICE DE MOT DANS SECT
C
C STRUCTURE SECTEUR DATA : 1 PTR VERS SECT SUIVANT, 63 MOTS DE DATA.
C   LES CONTOURS SONT RANGES CONSECUTIVEMENT :
C     1/2 MOT=LGR EFFECTIVE, 1/2 MOT NUM. ENVELOPPE
C      1/2 MOT NB DE PARAM, 1/2 MOT INDICATEUR DE CHAINAGE (0 SI DATAS
C       CONSECUTIVES, +N SI N MOTS CONSECUTIFS PAS TOUS OCCUPES, -N
C       SI N-1 MOTS CONSECUTIFS SUIVIS D'UN PTR VERS LA SUITE  DANS CE
C        CAS LA SUITE COMMENCE PAR UN MOT INDICATEUR DE CHAINAGE)
C    K MOTS PARAMETRES
C     MOTS DE DONNEES
C
	IF((IOPT.LT.-1).OR.(IOPT.GT.2))GOTO 200
	IF(NF.LT.1.OR.NF.GT.3) CALL ERMESF(9)
	IF(IOPT)100,10,20
C INITIALISATION ECRITURE
C  NUM=UNITE LOGIQUE
C  ICHN=COMMENTAIRE
10    IF(LU(NF).NE.0)GOTO 201
	LU(NF)=NUM
	DO 11 I=1,64
	IB0(I,NF)=0
	IBI(I,NF)=0
11    IBD(I,NF)=0
	IB0(3,NF)=1
	IB0(4,NF)=2
	IB0(5,NF)=1
	IB0(6,NF)=1
	IB0(7,NF)=514
	IB0(8,NF)=514
	IB0(9,NF)=2
	INDX(NF)=1
	INDXN(NF)=1
	IDCR(NF)=2
	DO 12 I=1,32
	ITR=ICHN(I)
	IB0(I+32,NF)=ITR
	IF(IBC(1).EQ.0.OR.IBC(2).EQ.0) GOTO 15
12    CONTINUE
C  CREATION SECT 0, ET 1ERS SECT DATA ET INDEX
15    CALL IOSECT(IB0(1,NF),0,LU(NF),KWR)
	CALL IOSECT(IBI(1,NF),1,LU(NF),KWR)
	CALL IOSECT(IBD(1,NF),2,LU(NF),KWR)
	RETURN
C  FIN ECRITURE,FERMETURE FICHIER
100   IF(IB0(9,NF).NE.2)RETURN
	IB0(9,NF)=0
	IF(IB0(12,NF).EQ.0) IB0(12,NF)=-1
	CALL IOSECT(IB0(1,NF),0,LU(NF),KWR)
	CALL IOSECT(IBI(1,NF),INDX(NF),LU(NF),KWR)
	CALL IOSECT(IBD(1,NF),IDCR(NF),LU(NF),KWR)
	NUM=IB0(1,NF)
	IEXT=IB0(2,NF)
	NPAR=IB0(4,NF)
	IPAR(1)=IB0(10,NF)
	NMOT=IB0(11,NF)
	ICHN(1)=IB0(12,NF)
	LU(NF)=0
	RETURN
C ECRITURE 1 CHAINE
20    IF(LU(NF).LE.0)GOTO 201
	IF(IB0(9,NF).NE.2)GOTO 201
	N=(NUM+61)/62
	K=N-IB0(3,NF)
	IF(K.LE.0)GOTO 60
C CREER NOUVEAUX SECT INDEX
	IF(IOPT.EQ.2)GOTO 200
	DO 30 L=1,K
30    CALL NWSIND(IBI(1,NF),IB0(3,NF),IB0(4,NF),IB0(6,NF),INDX(NF),
     #INDXN(NF),LU(NF))
	GOTO 65
C RECHERCHE SECTEUR DU POINTEUR
60    IF(N.EQ.INDXN(NF))GOTO 65
	CALL IOSECT(IBI(1,NF),INDX(NF),LU(NF),KWR)
	CALL GTSIND(IBI(1,NF),N,IB0(5,NF),IB0(6,NF),IB0(3,NF),INDX(NF),
     #INDXN(NF),LU(NF))
65    K=NUM-(N-1)*62+2
	I0=ISHFT(IB0(8,NF),-8)
	IF(IOPT.EQ.2)GOTO 80
	IF(IB0(1,NF).LT.NUM)IB0(1,NF)=NUM
	IB0(2,NF)=IB0(2,NF)+1
	JJ=J
	ITR=ICHN(JJ)
	LGR=IBC(1)
	II=IBC(2)
	IBC(2)=IEXT
	IF(IDCR(NF).EQ.I0)GOTO 66
	CALL IOSECT(IBD(1,NF),IDCR(NF),LU(NF),KWR)
	CALL IOSECT(IBD(1,NF),I0,LU(NF),KRD)
66    CALL ECDKMO(ITR,IBD(1,NF),IB0(4,NF),IB0(8,NF),LU(NF))
	IBI(K,NF)=IB0(8,NF)-1
	IBC(1)=NPAR
	IBC(2)=0
	CALL ECDKMO(ITR,IBD(1,NF),IB0(4,NF),IB0(8,NF),LU(NF))
	IF(NPAR.LE.0) GOTO 69
	IF(IB0(12,NF).LT.NPAR) IB0(12,NF)=NPAR
	IB0(10,NF)=IB0(10,NF)+IPAR(1)
	IF(IEXT.NE.0)GOTO 68
	IB0(11,NF)=IB0(11,NF)+IPAR(1)
68    DO 67 L=1,NPAR
	CALL ECDKMO(IPAR(L),IBD(1,NF),IB0(4,NF),IB0(8,NF),LU(NF))
67    CONTINUE
69    DO 70 L=1,NMOT
	IJ=JJ+L
	IF(ICHN(IJ).EQ.0)GOTO 70
	CALL ECDKMO(ICHN(IJ),IBD(1,NF),IB0(4,NF),IB0(8,NF),LU(NF))
70    CONTINUE
	IF(II.EQ.0)GOTO 71
	JJ=II
	ITR=ICHN(JJ)
	II=IBC(2)
	GOTO 69
71    IDCR(NF)=IB0(8,NF)/256
	RETURN
C IOPT=2 : REECRITURE IEXT SEUL
80    IPT=IBI(K,NF)
	IF(IPT.EQ.0)GOTO 200
	IFL=1
	CALL LEDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFL)
	IBC(2)=IEXT
	IPT=IPT-1
	CALL MDDKMG(ITR,IBD(1,NF),IPT,IDCR(NF),LU(NF),IFL)
	RETURN
200   CALL ERMESF(9)
201   CALL ERMESF(15)
	END
