#include "imext.h"

#define get_int(x,p) (x = *p++,x |= (*p++ << 8),x |= (*p++ << 16),x |= (*p++ << 24))

#define get_short(x,p) (x = *p++, x |= (*p++ << 8))

#define put_int(x,p) (*p++ = x,*p++ = (x >> 8),*p++ = (x >> 16),*p++ = (x >> 24))

#define put_short(x,p) (*p++ = x, *p++ = (x >> 8))

/* structure bmp
* 2 bytes : BM
* 4 bytes : file size
* 4 bytes reserved
* 4 bytes : offset for begining of data
    end of file header / start of info header
* 4 bytes : size of info header (40 ou 64)
* 4 bytes :width
* 4 bytes : height
* 2 bytes : nb plans (1)
* 2 bytes : nb bits/pixel (1, 4,8,24)
* 4 bytes : compression ( 
* 4 bytes : size of image = height * ((width * nbits +31)/32 * 4)
* 4 bytes : pixels/ metre en X
* 4 bytes : pixels/ metre en Y
* 4 bytes : nb de couleurs dans cmap
* 4 bytes : nb de couleurs importantes dans la color map
*
* dans certains 4 seuls les 5 1ers parametres d'info sont donnes
*/

struct bmp_info {
	int fsize;  /* file size */
	int off_data;
	int info_size;
	int width, height;
	int nbits;
	int lgline;  /* taille ligne arrondi a multiple de 4 octets */
	int inrline;  /* taille ligne arrondi a nb entier octets */
	int bmp_size;   /* size of raw bmp image : lgline * ndimy */
	int ncol_imp;  /* nb couleurs importantes */
	int cur_pos;   /* nb octets deja lus */
	char comp_type;
	
};

#define COMP_RLE8 1
#define COMP_RLE4 2

#define INFO_SIZE 40
