#include <stdio.h>
#include <string.h>
#include <inrimage/image.h>
#include "bmp.h"

extern errno;
extern debug_;

extern int imext_read1();
extern struct extimage *openimext();

static int col_dup(buf,ppnf,nbc,incb)
struct extimage **ppnf;
register char *buf;
register nbc, incb;
{
	register struct extimage *pnf;
	register n, i, j;
	register cr, cg, cb;
	n = 256 / nbc;
	pnf = *ppnf;
	i = 0;
	while(nbc-- > 0) {
		j = n;
		cb = *buf++;
		cg = *buf++;
		cr = *buf++;
		buf += incb;
		while(j-- > 0) {
			pnf->bbuf[i] = cb;
			pnf->gbuf[i] = cg;
			pnf->rbuf[i++] = cr;
		}
	}
	
}
static int rdcmap (pnf)
register struct extimage **pnf;
{
	char tmp[4*256];
	register numcols, n, i, incb;
	register struct bmp_info *pb;
	if(debug_)
		fprintf(stderr,"read BMP colormap (%d colors)\n",numcols);
	if(! (numcols = (*pnf)->numcols)) {
		numcols = 1 << (*pnf)->nbits;
		(*pnf)->numcols = numcols;
	}
	pb = (struct bmp_info *)(*pnf)->x_params;
	if(pb->info_size == 12) { /* old style */
		incb = 0;
		n = 3 * numcols;
	} else {
		incb = 1;
		n = 4 * numcols;
	}
	if(imext_read1(pnf,tmp,n) != n)
		imext_err(pnf,9,"could not read BMP colormap\n");
	pb->cur_pos += n;
	n = 0;
	if((numcols == 2) || (numcols == 16)) {
		(*pnf)->numcols = 256;
		col_dup(tmp,pnf,numcols,incb);
		return 0;
	}
	if(numcols && (numcols != 256)) {
		fprintf(stderr,"Warning! unexpected nb of colors %d\n",numcols);
	}
	for(i=0;i<numcols;i++) {
		(*pnf)->bbuf[i] = tmp[n++];
		(*pnf)->gbuf[i] = tmp[n++];
		(*pnf)->rbuf[i] = tmp[n++];
		n += incb;
	}

}

struct extimage *openbmp(name)
char *name;
{
	unsigned char tmp[64];
	FILE *f;
	register x, n;
	register unsigned char *pc;
	register struct bmp_info *pb;
	struct extimage *nfext;
	nfext = openimext(name,0);
	pb = (struct bmp_info *)i_calloc(1,sizeof(struct bmp_info));
	nfext->x_params = (void *)pb;
	n = 0;
	/* read 1st part of header */
	if(imext_read1(&nfext,tmp,18) != 18)
		n = -1;
	else if(strncmp(tmp,"BM",2) != 0)
		n = -1;
	if(n) {
		imext_err(&nfext,9,"%s: not a BMP file\n",name);
	}
	pc = &tmp[2];
	get_int(x,pc);
	pb->fsize = x;
	pc += 4;   /* 4 bytes ignored */
	get_int(x,pc);
	pb->off_data = x;
	get_int(x,pc);
	pb->info_size = x;
	if(x > 64 || x < 12) imext_err(&nfext,9,"incorrect header size for BMP file %s\n",name);
	
	/* read bmp header */
	x -= 4;
	if(imext_read1(&nfext,tmp,x) != x) 
		imext_err(&nfext,9,"incorrect BMP file %s\n",name);
	pc = tmp;
	get_int(x,pc);
	nfext->ndimx = x;
	get_int(x,pc);
	nfext->ndimy = x;
	nfext->ndimz = 1;
	nfext->ndimv = 1;
	get_short(x,pc);
	if(x != 1) 
	  /* imext_err(&nfext,9,"incorrect BMP file %s\n",name); */
	  fprintf( stderr, "warning: incorrect BMP file header %s (ndimz=%d but should be 1)\n", name, x);
	get_short(x,pc);
	pb->nbits = x;
	if(x != 1 && x != 4 && x != 8 && x != 24)
	  imext_err(&nfext,9,"incorrect BMP file %s (nbits=%d)\n",name, x);
	if(x == 24) {
		nfext->nbits = 8;
		nfext->ndimv = 3;
	} else {
		nfext->nbits = x;
	}
	pb->inrline = ((nfext->ndimx * nfext->nbits * nfext->ndimv) + 7) / 8;
	nfext->size = pb->inrline * nfext->ndimy;
	if(pb->info_size >= 40) {
		get_int(x,pc);
		pb->comp_type = x;
		get_int(x,pc);  /* image size */
		pc += 8;  /* pixels / metre en x et y */
		get_int(x,pc);
		nfext->numcols = x;
		get_int(x,pc);
		pb->ncol_imp = x;
	} else {
		pb->comp_type = 0;
	}
	x = (nfext->ndimx * nfext->nbits * nfext->ndimv);
	if(pb->comp_type == COMP_RLE4)
		x *= 2;
	pb->lgline = 4 * ((x + 31) / 32);
	pb->bmp_size = pb->lgline * nfext->ndimy;
	pb->cur_pos = 14 + pb->info_size;
	if(nfext->ndimv != 3)
		rdcmap(&nfext);
	/* skip to begening of data */
	x = pb->off_data - pb->cur_pos;
	n = 64;
	while(x > 0) {
		if(n > x) n = x;
		imext_read1(&nfext,tmp,n);
		x -= n;
	}
	/* alloc data buffers */
	nfext->data = (unsigned char *)i_malloc(nfext->size + 4);
	nfext->cindex = (unsigned char *)i_malloc(pb->lgline);
	if(debug_) {
		fprintf(stderr,"open BMP file %s,%d x %d (%d bits), comp %d\n",
			nfext->name,nfext->ndimx,nfext->ndimy,pb->nbits,pb->comp_type);
	}
	return nfext;
}


/* read data */
readbmp(ppnf)
struct extimage **ppnf;
{
	register struct extimage *pnf;
	register struct bmp_info *pb;
	register unsigned char *buf, *tbuf, *pc, *p2;
	register n, i, v;
	pnf = *ppnf;
	pb = (struct bmp_info *)pnf->x_params;
/*	if(pnf->nbits == 1) { */
	if( pb->comp_type) {
		if((pb->comp_type == COMP_RLE8) && (pb->nbits == 8)) {
			return readbmp8_rle(ppnf);
		}
		if((pb->comp_type == COMP_RLE4) && (pb->nbits == 4)) {
			return readbmp4_rle(ppnf);
		}
		
		imext_err(ppnf,9,"bmp compression (%d) not valid for %d bits\n",pb->comp_type,pb->nbits);
	}
	n = pnf->ndimy;
	buf = pnf->data + pnf->size;
	tbuf = pnf->cindex;
	if(pb->inrline == pb->lgline) {
		while (n-- > 0) {
			buf -= pb->inrline;
			imext_read1(ppnf,buf,pb->lgline);
			if(pnf->ndimv == 3) {
				pc = buf;
				i = pnf->ndimx;
				while(i-- > 0) {
					v = *pc;
					*pc = *(pc+2);
					pc += 2;
					*pc++ = v;
				}
			}
		}
		return 0;
	}
	
	while (n-- > 0) {
		buf -= pb->inrline;
		imext_read1(ppnf,tbuf,pb->lgline);
		if(pnf->ndimv == 3) {
			pc = tbuf;
			p2 = buf;
			i = pnf->ndimx;
			while(i-- > 0) {
				*(p2+2) = *pc++;
				*(p2+1) = *pc++;
				*p2 = *pc++;
				p2 += 3;
			}
		} else {
			memcpy(buf,tbuf,pb->inrline);
		}
		
	}
	return 0;
}

readbmp8_rle(ppnf)
struct extimage **ppnf;
{
	register struct extimage *pnf;
	register struct bmp_info *pb;
	register unsigned char *buf, *tbuf, *pc;
	register n, i, v;
	int dx;
	pnf = *ppnf;
	pb = (struct bmp_info *)pnf->x_params;
	n = pnf->ndimy;
	buf = pnf->data + pnf->size;
	tbuf = pnf->cindex;
	dx = 0;
	while(n-- > 0) {
		buf -= pb->inrline;
		i = read_rlel8(ppnf,tbuf,pb->lgline,&dx);
		c_pckbt(tbuf,buf,pnf->ndimx,4);
		if(i > n) imext_err(ppnf,9,"BMP pb de nb lignes\n");
		if(i < 0) i = n;  /* jusqu'a la fin de l'image */
		if(i > 0) {
			v = i * pb->inrline;
			buf -= v;
			pc = buf;
			n -= i;
			for(i=0;i<v;i++)
				*pc++ = 0;
		}
	}
}

readbmp4_rle(ppnf)
struct extimage **ppnf;
{
	register struct extimage *pnf;
	register struct bmp_info *pb;
	register unsigned char *buf, *tbuf, *pc;
	int dx;
	register n, i, v;
	pnf = *ppnf;
	pb = (struct bmp_info *)pnf->x_params;
	n = pnf->ndimy;
	buf = pnf->data + pnf->size;
	tbuf = pnf->cindex;
	dx = 0;
	while(n-- > 0) {
		buf -= pb->inrline;
		i = read_rlel4(ppnf,tbuf,pb->lgline,&dx);
		c_pckbt(tbuf,buf,pnf->ndimx,4);
		if(i > n) imext_err(ppnf,9,"BMP pb de nb lignes\n");
		if(i < 0) i = n;  /* jusqu'a la fin de l'image */
		if(i > 0) {
			v = i * pb->inrline;
			buf -= v;
			pc = buf;
			n -= i;
			for(i=0;i<v;i++)
				*pc++ = 0;
		}
	}
}

/* retour : 0 si ligne lue, -1 si fin de fichier,
nb lignes a sauter sinon
*/
read_rlel4(ppnf,buf,lgl,pdx)
struct extimage **ppnf;
register unsigned char *buf;
int lgl;
int *pdx;
{
	register struct extimage *pnf;
	register c, v, i, j, v2;
	register FILE *f;
	pnf = *ppnf;
	f = pnf->file;
	j = *pdx;
	for(i=0;i<j;i++)
		*buf++ = 0;
	*pdx = 0;
	while((c = getc(f)) != EOF) {
		if(c) { /* repetition */
			v2 = getc(f);
			v = (v2 & 0xf0) >> 4;
			v2 &= 0xf;
			for(i=0;i<c;i += 2) {
				*buf++ = v;
				*buf++ = v2;
			}
			j += c;
			if(c &= 1) buf--;
			if(j > lgl) imext_err(ppnf,9,"ERR\n");
			continue;
		}
		/* c == 0 : escapes */
		if((c = getc(f)) == EOF) break;
		if((c == 0) || (c == 1)) {  /* fin de ligne  ou de fichier */
			if(j > lgl) imext_err(ppnf,9,"ERR\n");
			for(;j<lgl;j++) {
				*buf++ = 0;
			}
			return (c ? -1 : 0);
		}
		if(c == 2) {  /* deplacement en x et y */
			if(j > lgl) imext_err(ppnf,9,"ERR\n");
			for(;j<lgl;j++) {  /* completer ligne */
				*buf++ = 0;
			}
			*pdx = getc(f);  /* delta x */
			v = getc(f);  /* delta y */
			return v;
		}
		for(i=0;i<c;i += 2) {
			v = getc(f);
			*buf++ = (v & 0xf0) >> 4;
			*buf++ = v & 0xf;
			j += 2;
		}
		if(c & 1) {
			j--;
			buf--;
		}
		if(j > lgl) imext_err(ppnf,9,"ERR\n");
		c &= 3;
		if(c == 2 || c == 1)
			getc(f);  /* nb pair octets */
	}
	imext_err(ppnf,9,"RLE coding err\n");
}

/* retour : 0 si ligne lue, -1 si fin de fichier,
nb lignes a sauter sinon
*/
read_rlel8(ppnf,buf,lgl,pdx)
struct extimage **ppnf;
register unsigned char *buf;
int lgl;
int *pdx;
{
	register struct extimage *pnf;
	register c, v, i, j;
	register FILE *f;
	pnf = *ppnf;
	f = pnf->file;
	j = *pdx;
	for(i=0;i<j;i++)
		*buf++ = 0;
	*pdx = 0;
	while((c = getc(f)) != EOF) {
		if(c) { /* repetition */
			v = getc(f);
			for(i=0;i<c;i++)
				*buf++ = v;
			j += c;
			if(j > lgl) imext_err(ppnf,9,"ERR\n");
			continue;
		}
		/* c == 0 : escapes */
		if((c = getc(f)) == EOF) break;
		if((c == 0) || (c == 1)) {  /* fin de ligne  ou de fichier */
			if(j > lgl) imext_err(ppnf,9,"ERR\n");
			for(;j<lgl;j++) {
				*buf++ = 0;
			}
			return (c ? -1 : 0);
		}
		if(c == 2) {  /* deplacement en x et y */
			if(j > lgl) imext_err(ppnf,9,"ERR\n");
			for(;j<lgl;j++) {  /* completer ligne */
				*buf++ = 0;
			}
			*pdx = getc(f);  /* delta x */
			v = getc(f);  /* delta y */
			return v;
		}
		v = 0;
			
		for(i=0;i<c;i++) {
			*buf++ = getc(f);
			j++;
		}
		if(j > lgl) imext_err(ppnf,9,"ERR\n");
		if(c & 1) getc(f);  /* nb pair octets */
	}
	imext_err(ppnf,9,"RLE coding err\n");
}
