#include <stdio.h>
#include <inrimage/image.h>
#include "imext.h"

static char version[]= "2.3";

static char Ucmd[]= 
"[-cv | -ct colortb_file_out|-xct][-z n] [input-file | -] [out-image]\n";
static char Udetail[]= 
"  Converts gif file (normal or animation) to inrimage\n\
\t-ct : write cmap in specified file instead of image header\n\
\t-cv : convert to true color (apply color map)\n\
\t     may be necessary if mutiple images with different cmap\n\
\t-z : extract n planes (0 = all images of the animation (default : only &st image)\n\
";
static Fort_int lfmt[9]= {0,0,1,0,0,0,1,1,200};
struct image *nf, *nft;

extern int IM_nbmin_hdr;

char in[256], out[256], tcn[256];

extern int debug_;

Fort_int lfmt1[9]= {256,3,1,0,256,3,1,1,200};
static int flgc, flg_cv;
static int nbz;
struct extimage *nfgif;
extern struct extimage *opengif();

char *cmd;
main(argc,argv)
int argc;
char **argv;
{
	register i, n;
	inr_init(argc,argv,version,Ucmd,Udetail);
	cmd = argv[0];
	if(! (flg_cv = igetopt0("-cv")))
		flgc = igetopt1("-ct","%s",tcn);
	nbz = 1;
	if(igetopt1("-z","%d",&nbz)) {
		if(nbz <= 0) nbz = 0xffff;
	}
	fileopt(in,"i");
	fileopt(out,"o");
	if(tstopts())
		iusage_(Ucmd,Udetail);
	nfgif = opengif(in,flg_cv);
	if(nfgif->nbits > 8) {
		BSIZE = (nfgif->nbits + 7) / 8;
	}
	NDIMX = nfgif->ndimx;
	NDIMY = nfgif->ndimy;
	NDIMV = nfgif->ndimv;
	DIMX = NDIMX * NDIMV;
	if(!flgc && !flg_cv) {  /* set correct size of header */
		IM_nbmin_hdr = 8;
	}
	for(i=0;i<nbz;i++) {
		readgif(&nfgif);
		if(init_gifimage(&nfgif)) break;
	}
	DIMY = nfgif->ndimy * nfgif->ndimz;
	NDIMZ = nfgif->ndimz;
	nf = image_(out,"s","a",lfmt);
	if(flgc) {
		nft = image_(tcn,"s","a",lfmt1);
		c_ecr(nft,1,nfgif->rbuf);
		c_ecr(nft,1,nfgif->gbuf);
		c_ecr(nft,1,nfgif->bbuf);
		fermnf_(&nft);
	} else if(! flg_cv) {
		iwr_ctrgb(nf,0,nfgif->numcols,nfgif->rbuf,nfgif->gbuf,nfgif->bbuf);
	}
	gif_ecrinr(nf,&nfgif);
	fermnf_(&nf);
	/*	init_gifimage(&nfgif); */
	fermimext(&nfgif);
	return 0;
}

