#include <stdio.h>
#include <inrimage/image.h>
#include "bmp.h"

char in[256], out[256], tcn[256];
static char version[]= "2.1";
static char Ucmd[]= 
"[-ct colortb_file_in] [-C][-rle] [input-image | -] [out-bmp_file]\n";
static char Udetail[]= 
"\t-ct : read cmap from specified file instead of image header\n\
\t-C : true color (if NDIMV==3 or NDIMZ==3)\n\
\t-rle : use rle compression\n";
static Fort_int lfmt[9]= {0,0,1,0,0,0,1,1,200};
struct image *nf, *nft;
unsigned char *pic, *pic2;
/* int conv24= CONV24_SLOW; */
int noqcheck= 0;/* true if we should NOT do QuickCheck */
int nbcol= 256;
unsigned char r[256],g[256],b[256];

static void z3_to_v3();

extern int debug_;

int numcols;
int true_color, flg_rle;
static int i0;
Fort_int lfmt1[9]= {256,3,1,0,256,3,1,1,200};
int flgc;

FILE *fp;
extern int errno;

struct extimage *nfext;
extern struct extimage *createbmp();

char *cmd;
main(argc,argv)
int argc;
char **argv;
{
	register i, n;
	int width, height, nbits;
	int flgx;
	inr_init(argc,argv,version,Ucmd,Udetail);
	cmd = argv[0];
	flgc = igetopt1("-ct","%s",tcn);
	igetopt1("-nc","%d",&nbcol);
	if (igetopt0("-C")) {
		true_color = 1;
	}
	flg_rle = igetopt0("-rle");
	fileopt(in,"i");
	fileopt(out,"o");
	if(tstopts())
		iusage_(Ucmd,Udetail);
	nf = image_(in,"e","",lfmt);
	if(NDIMV != 3 && NDIMZ != 3)
		true_color = 0;
	if(true_color) {
		if(NDIMV == 3) {
			width = NDIMX;
			height = DIMY;
		} else {
			true_color = 2;
			width = DIMX;
			height = NDIMY;
		}
	} else {
		width = DIMX;
		height = DIMY;
	}
	if(flgc) {
		nft = image_(tcn,"s","a",lfmt1);
		c_lect(nft,1,r);
		c_lect(nft,1,g);
		c_lect(nft,1,b);
		fermnf_(&nft);
		numcols = 256;
#if 0
		r[255] = r[0] ^ 255;
		g[255] = g[0] ^ 255;
		b[255] = b[0] ^ 255;
#endif
	} else {
		ird_ctrgb(nf,&i0,&numcols,r,g,b,256);
	}
	n = DIMY * DIMX;
	i = BSIZE > 0 ? BSIZE : ((-BSIZE + 7) / 8);
	pic = (unsigned char *)i_malloc(n * i);
	flgx = 0;
	if(true_color) {
		nbits = 24;
		numcols = nbcol;
		if(true_color > 1)
			pic2 = (unsigned char *)i_malloc(n * i);
	} else if((TYPE == PACKEE) && ((BSIZE == -1) || (BSIZE == -4))) {
		nbits = -BSIZE;
		flgx = 1;
	} else {
		nbits = 8;
	}
	c_xlect(nf,DIMY,pic,flgx);
	fermnf_(&nf);
	if(! flgx)
		c_cnvvis(pic,pic,DIMY,lfmt,0,0,0,1);
	if(true_color > 1) { /* 3 plans -> 3 RGB / pixel */
		z3_to_v3();
		i_Free(&pic);
		pic = pic2;
	}
	nfext = createbmp(out,pic,width,height,nbits,flg_rle,numcols,r,g,b);

	writebmp(&nfext);
	return 0;
}

static void z3_to_v3()
{
	register unsigned char *po, *pr, *pg, *pb;
	register n;
	n = NDIMX * NDIMY;
	po = pic2;
	pr = pic;
	pg = pr + n;
	pb = pg + n;
	while(n-- > 0) {
		*po++ = *pr++;
		*po++ = *pg++;
		*po++ = *pb++;
	}
}
