#include <stdio.h>
#include <inrimage/image.h>
#include "imext.h"

char in[256], out[256], tcn[256];
static char version[]= "2.5";
static char Ucmd[]= 
"[-ct colortb_file_in] [-C | -Cn][-t pix | -gif87][-nc nbcol][-nd][-anim [-delay n][-loop n]] [input-image | -] [out-gif_file]\n";
static char Udetail[]= 
"   Convert inrimage format to GIF89\n\
\t-ct : read cmap from specified file instead of image header\n\
\t-C : true color (if NDIMV==3 or NDIMZ==3)\n\
\t-Cn : true color, but don't check if nb colors <= 256\n\
\t-t: set transparence for pixel pix\n\
\t-gif87 : GIF87 format instead of GIF89\n\
\t-nc: nb de couleur a conserver (2-256)\n\
\t-nd: no dithering\n\
\t-anim : make a GIF89 animation if NDIMZ > 1\n\
\t   -delay : delay (1/100sec) for each frame (def 50)\n\
\t   -loop : nb of loops (netscape) -1 = no (def), 0=ever\n\
";
static Fort_int lfmt[9]= {0,0,1,0,0,0,1,1,200};
struct image *nf, *nft;
unsigned char *pic, *pic2;
/* int conv24= CONV24_SLOW; */
int noqcheck= 0;/* true if we should NOT do QuickCheck */
int nbcol= 256;
unsigned char r[256],g[256],b[256];

static void z3_to_v3();

extern int debug_;
static int delay= 50, nbloop= -1;

int numcols;
int true_color, graphic_ext= -1, flg_Cn= 0;
static int i0;
Fort_int lfmt1[9]= {256,3,1,0,256,3,1,1,200};
int flgc;

FILE *fp;
extern int errno;
static int flg_gif87;
static int flg_nd = 0, flg_anim= 0;

struct extimage *nfgif;
extern struct extimage *creategif();

char *cmd;
main(argc,argv)
int argc;
char **argv;
{
	register i, n;
	int width, height, nbanim;
	char comment[256];
	inr_init(argc,argv,version,Ucmd,Udetail);
	cmd = argv[0];
	flgc = igetopt1("-ct","%s",tcn);
	igetopt1("-nc","%d",&nbcol);
	if (igetopt0("-C")) {
		flg_Cn = 0;
		true_color = 1;
	} else if (igetopt0("-Cn")) {
		flg_Cn = 1;
		true_color = 1;
	}
	flg_nd = igetopt0("-nd");
	if(! (flg_gif87 = igetopt0("-gif87"))) {
		igetopt1("-t","%d",&graphic_ext);
		if(flg_anim = igetopt0("-anim")) {
			igetopt1("-delay","%d",&delay);
			igetopt1("-loop","%d",&nbloop);
		}
	}
	fileopt(in,"i");
	fileopt(out,"o");
	if(tstopts())
		iusage_(Ucmd,Udetail);
	nf = image_(in,"e","",lfmt);
	if(NDIMV != 3 && NDIMZ != 3)
		true_color = 0;
	nbanim= 0;
	if(true_color) {
		if(NDIMV == 3) {
			width = NDIMX;
			if(flg_anim) {
				nbanim = NDIMZ;
				height = NDIMY;
			} else
				height = DIMY;
		} else {
			true_color = 2;
			width = DIMX;
			height = NDIMY;
		}
	} else {
		width = DIMX;
		if(flg_anim) {
			nbanim = NDIMZ;
			height = NDIMY;
		} else
			height = DIMY;
	}
	if(flgc) {
		nft = image_(tcn,"s","a",lfmt1);
		c_lect(nft,1,r);
		c_lect(nft,1,g);
		c_lect(nft,1,b);
		fermnf_(&nft);
#if 0
		r[255] = r[0] ^ 255;
		g[255] = g[0] ^ 255;
		b[255] = b[0] ^ 255;
#endif
	} else {
		ird_ctrgb(nf,&i0,&numcols,r,g,b,256);
	}
	numcols = 256; /* on force numcols a 256 */
	n = DIMY * DIMX;
	i = BSIZE > 0 ? BSIZE : ((-BSIZE + 7) / 8);
	pic = (unsigned char *)i_malloc(n * i);
	if(true_color) {
		numcols = nbcol;
		if(true_color > 1)
			pic2 = (unsigned char *)i_malloc(n * i);
	}
	c_lect(nf,DIMY,pic);
	fermnf_(&nf);
	c_cnvvis(pic,pic,DIMY,lfmt,0,0,0,1);
	if(flg_gif87)
		comment[0] = 0;
	else
		sprintf(comment,"inr2gif %s",in);
	if(true_color > 1) { /* 3 plans -> 3 RGB / pixel */
		z3_to_v3();
		i_Free((char **)&pic);
		pic = pic2;
	}
	if(flg_Cn)
		true_color = -true_color;
	nfgif = creategif(out,pic,width,height,nbanim,true_color,flg_nd,numcols,comment,r,g,b);

	writegif(&nfgif,graphic_ext,delay,nbloop);
	return 0;
}

static void z3_to_v3()
{
	register unsigned char *po, *pr, *pg, *pb;
	register n;
	n = NDIMX * NDIMY;
	po = pic2;
	pr = pic;
	pg = pr + n;
	pb = pg + n;
	while(n-- > 0) {
		*po++ = *pr++;
		*po++ = *pg++;
		*po++ = *pb++;
	}
}
