#include <stdio.h>
#include <inrimage/image.h>

static char Ucmd[]= 
"[-im [-i3[rgb]] | -vol ] [-a color_file] [image-in | - | image-R image-G image-B] [image-out]";
static char Udetail[]=
"\t-im : sortie image AVS\n\
\t-vol : sortie volume AVS (max 256x256x256)\n\
\t-a : appliquer table du fichier color_file (DIMY= 1 or 3)\n\
\t-i3 : input en 3 fichiers (ordre par def. rgb)\n";

#define O_BW 0
#define O_C8 1
#define O_C24 2
#define O_IMAGE O_C24
#define O_VOLUME O_BW

static int flg_out;

extern int errno;

struct image *nfi[3], *nf_ct;
int fd_out;
long lfmt[9]= {0,0,1,0,0,0,0,0,200};  /* images virg. fixe 1 octet */
static long lfmt2[9];

static int zero= 0, ier;
extern int sim2avs();

static int set_file_order();
static char col_in[3]= {0,1,2}, col_out[3]= {0,1,2};
static char tc_ordre[32];

main(argc,argv)
int argc;
char **argv;
{
	char in[256], out[256], ctfile[256];
	int nzi, nzo;
	int nbi, nbo;
	int tabv, ntabv;
	char *verif;
	register i;
	initopts(argc,argv);
	kdopts_();
	flg_out = O_VOLUME;
	nzo = 1;
	nbi = 1;
	nbo = 1;
	if(igetopt("-vol","",0,"",0,"",0))
		flg_out = O_VOLUME;
	else if(igetopt("-im","",0,"",0,"",0)) {
		flg_out = O_IMAGE;
	}
	if(igetopt("-i3","",0,"",0,"",0)) {
		nbi = 3;
	} else if(igetopt("-i3","%s",tc_ordre,"",0,"",0)) {
		if(set_file_order(tc_ordre,col_in))
			iusage_(Ucmd,Udetail);
		nbi = 3;
	}
	nf_ct = NULL;
	if(igetopt("-a","",0,"%s",ctfile,"",0))
		nf_ct = image_(ctfile,"e","",lfmt2);

	if(tstoptm()) iusage_(Ucmd,Udetail);
	verif = "t";
	for(i=0;i<nbi;i++) {
		if ( !igetopt("","%s",in,"",0,"",0) ) { /* stdin par defaut */
			if(i > 1)
				iusage_(Ucmd,Udetail);
			in[0] = '<';
			in[1] = 0;
		} else {
			if(in[0] == '-' && in[1] == 0)
				in[0] = '<';  /* stdin */
		}
		nfi[col_in[i]] = image_(in,"e",verif,lfmt);
		verif = "a";
	}
	verif = "t";
	nzi = NDIMZ;
	DIMY = NDIMY * NDIMZ;
	if(flg_out == O_IMAGE) {
		if(nzi != 1 && nzi != 3)
			imerror(9,"l'image d'entree ne peut avoir que 1 ou 3 plans!\n");
	}
	if ( !igetopt("","%s",out,"",0,"",0) ) { /* stdout par defaut */
		fd_out = 1;
	} else {
		if((fd_out = creat(out,0644)) <= 0) 
			imerror(1,"output file open error %d\n",errno);
	}
	if(nbi == 1) {
		nfi[2] = nfi[1] = nfi[0];
	}
	if(tstopts()) iusage_(Ucmd,Udetail);
	tabv = 1;
	ntabv = 1;
		exec_(&ier,&zero,&zero,&ntabv,&tabv,sim2avs,nfi,&fd_out,&nf_ct,&nzi,lfmt,&flg_out,&ier);
}

static int set_file_order(txt,tab)
unsigned char *txt, *tab;
{
	register i, c;
	tab[0] = 0xff;
	tab[1] = 0xff;
	tab[2] = 0xff;
	for(i=0;i<3;i++) {
		c = *txt++ | 0x20;
		switch (c) {
		case 'r':
			tab[i] = 0;
			break;
		case 'v':
		case 'g':
			tab[i] = 1;
			break;
		case 'b':
			tab[i] = 2;
			break;
		}
	}
	if(*txt != 0)
		return -1;
	if(tab[0] == 0xff || tab[1] == 0xff || tab[2] == 0xff)
		return -1;
	return 0;
}

