C* CONVTB
	SUBROUTINE CONVTB(A,B,NDIM,BSI,TYPI,BSO,TYPO)
C  !!!ne convient que pour des flottants sur 4 octets !!!
C
C EFFECTUE LA CONVERSION DE A (NDIM POINTS DE BYTE SIZE BSI,
C  ET DE TYPE TYPI) EN B (BYTE SIZE BSO, TYPE TYPO)
C TYPE 0=ENTIER 1=FLOTTANT, -1=ENTIER BIT SIZE
C TYPE=-1 SIGNIFIE QUE BSI OU BSO CONTIENT LA BIT SIZE AU LIEU
C  DE LA BYTE SIZE (NB DE BITS AU LIEU DE NB OCTETS)
C POUR TYPE ENTIER, LES BITS SONT CADRES A GAUCHE ET LES NB SANS SIGNE
C 1 FLOTTANT CORRESPOND A UN ENTIER AVEC TOUS LES BITS A 1 (2**N-1)
C **************************
C  ERREUR 9 (NIVEAU 2) SI BYTE SIZE OU TYPE INCORRECTS
C TYPE 1 ET B.S. NON 4 INTERDIT (PAS DE DBLE PRECISION
C *************
C LES NOMBRES REELS EN DEHORS DE (0,1) SONT FORCES A 0 OU 1
C  POUR CONVERSION EN ENTIER
	INTEGER ADRESS,BSI,BSO,TYPI,TYPO
	INTEGER A(1),B(1)
	DOUBLE PRECISION R,RO,RI,DERR,DERR2
	EQUIVALENCE (IW,X)
	D31=2.**31
	D32=2.*D31
	JA=ADRESS(A)
	JB=ADRESS(B)
	IF(TYPI) 1,2,4
1     IBITI=BSI
	IBYTI=(IBITI+7)/8
	GOTO 3
2     IBYTI=BSI
	IBITI=8*IBYTI
3     IBSI=IBYTI
	ITPI=0
	IF(IBYTI.LE.0.OR.IBYTI.GT.4) GOTO 211
	GOTO 5
4     IBYTI=5
	IBSI=4
	ITPI=1
	IBITI=0
	IF(BSI.NE.4) GOTO 211
5     IF(TYPO) 10,11,13
10    IBITO=BSO
	IBYTO=(IBITO+7)/8
	GOTO 12
11    IBYTO=BSO
	IBITO=8*IBYTO
12    IBSO=IBYTO
	ITPO=0
	IF(IBYTO.LE.0.OR.IBYTO.GT.4) GOTO 211
	GOTO 15
13    IBYTO=5
	ITPO=1
	IBITO=0
	IBSO=4
	IF(BSO.NE.4) GOTO 211
15    LGA=IBSI*NDIM
	LGB=IBSO*NDIM
	IF(IBITO.NE.IBITI) GOTO 14
	IF(JA.EQ.JB) RETURN
C  TRANSFERT SIMPLE
	CALL MVBYTE(A,B,1,1,LGA)
	RETURN
14    JFA=JA+LGA
	JFB=JB+LGB
	IF(IBSI.GE.IBSO) GOTO 25
C  CONVERSION AVEC EXPANSION
	IF(JFA.GE.JFB) GOTO 30
C COMMENCER PAR LA FIN
20    INCA=-IBSI-IBSI
	INCB=-IBSO-IBSO
	IA=LGA-IBSI
	IB=LGB-IBSO
	GOTO 40
25    IF(JA.LT.JB) GOTO 20
C  COMMENCER PAR LE DEBUT
30    INCA=0
	INCB=0
	IA=0
	IB=0
40    RO=2.D0**IBITO-1.D0
	RI=(2.D0**IBITI-1.D0)*2.D0**(8*IBSI-IBITI)
	IF(IBYTI.EQ.5) GOTO 50
	IF(IBYTO.EQ.5) GOTO 60
C  CONVERSION ENTIER-ENTIER
	DERR=0.
	IF(IBITI.GT.IBITO) GOTO 35
	DERR=.5
	DERR2=2.*DERR
35    IDEC2=8*IBSO-IBITO
	GOTO 70
C  FLOTTANT-ENTIER
50    DERR=1.-2.D0**(-IBITO-1)
	DERR2=1.
	IA=IA/4+1
	INCA=1
	IF(IA.NE.1) INCA=-1
	GOTO 35
C  ENTIER-FLOTTANT
60    DERR=0.
	IB=IB/4+1
	INCB=1
	IF(IB.NE.1) INCB=-1
70    IV=0
C  BOUCLE DE CONVERSION
	DO 100 L=1,NDIM
	IVI0=4-IBSI
	IVO0=4-IBSO
	IF(TYPI.EQ.1) GOTO 101
C CHARGEMENT NB ENTIER
	IVI=IVI0
	DO 102 K=1,IBSI
	CALL ILBYTE(J,A,IA)
	IA=IA+1
	CALL ISBYTE(J,IV,IVI)
102   IVI=IVI+1
	R=DFLOAT(IV)
	IF(IV.LT.0) R=D32+R
	IF(TYPO.EQ.1) GOTO 111
C  ENTIER-ENTIER
	R=(R*RO)/RI+DERR
	GOTO 112
C  ENTIER-FLOTTANT
111   R=R/RI+DERR
	GOTO 104
C  CHARGEMENT NB REEL
101   IW=A(IA)
	IF(X.LT.0.) X=0.
	IF(X.GT.1.) X=1.
	R=X*RO+DERR
C  SORTIE ENTIER
112   IF(R.GE.D32) GOTO 120
	IF(R.GE.D31) R=-D32+R-DERR2
	IW=R
121   IW=ISHFT(IW,IDEC2)
	IVO=IVO0
	DO 105 K=1,IBSO
	CALL ILBYTE(J,IW,IVO)
	IVO=IVO+1
	CALL ISBYTE(J,B,IB)
105   IB=IB+1
	GOTO 106
120   IW=-1
	GOTO 121
C  SORTIE FLOAT
104   X=R
	B(IB)=IW
106   IA=IA+INCA
100   IB=IB+INCB
	RETURN
211   CALL ERMESF(9)
	END
