/* EXTIM
	extimgv_(a,ndim,nfi,nfo,first_pt,pas_echan)
   extrait, a l'aide du tableau a de ndim mots, un sous-ensemble
 de l'image nfi, commencant au point first_pt (ix,iy,iz,iv) , et le transfere
  sur l'image nfo
 la taille de l'extraction est celle de l'image de sortie
 pas_echan : pas d'echantillonnage en x y z v
 les 2 images doivent etre de type identique et de dim. compatibles
  tous les types sont acceptes
  Les images packee sont depackees puis repackee
*/
#include <inrimage/image.h>
static Fort_int un= 1;
static Fort_int lfmti[9], lfmto[9];
extimgv_(a,ndim,nfi,nfo,first_pt,pas_echan)
unsigned char *a;
struct image **nfi, **nfo;
Fort_int *ndim, *first_pt, *pas_echan;
{
	register n, i;
	int ibs, nb;
	int lgl, nlig, nl, nlo, nlmax;
	int ixi, iyi, izi, ivi;
	int deltaz, zpas, ypas;
	register ay;
	c_getgfm(*nfi,lfmti,0);
	c_getgfm(*nfo,lfmto,0);
	ixi = (int)*first_pt;
	iyi = (int)*(first_pt+1);
	izi = (int)*(first_pt+2);
	ivi = (int)*(first_pt+3);
	if((pas_echan[0] < 1) || (pas_echan[0] > lfmti[I_NDIMX])) 
	  imerror(9,"pas d'echantillonnage en X incorrect\n");
	ypas = pas_echan[1];
	if((ypas < 1) || (ypas > lfmti[I_NDIMY])) 
	  imerror(9,"pas d'echantillonnage en Y incorrect\n");
	if((pas_echan[3] < 1) || (pas_echan[3] > lfmti[I_NDIMV])) 
	  imerror(9,"pas d'echantillonnage en V incorrect\n");
	zpas = pas_echan[2];
	if((zpas < 1) || (zpas > lfmti[I_NDIMZ])) 
	  imerror(9,"pas d'echantillonnage en Z incorrect\n");

	if((ixi <= 0) || (iyi <= 0) || (izi <= 0) || (ivi <= 0))
		imerror(9,"window origin coord. must be >= 1\n");
	if(ixi + (lfmto[I_NDIMX] -1)* pas_echan[0] > lfmti[I_NDIMX]
	   || iyi + (lfmto[I_NDIMY] -1) * ypas > lfmti[I_NDIMY]
	   || izi + (lfmto[I_NDIMZ] -1) * zpas > lfmti[I_NDIMZ]
	   || ivi + (lfmto[I_NDIMV] -1) * pas_echan[3] > lfmti[I_NDIMV])
		imerror(7,"dimensions des images incompatibles\n");
	if(lfmti[I_TYPE] != lfmto[I_TYPE] || lfmti[I_BSIZE] != lfmto[I_BSIZE])
		imerror(6,"codages des images incompatibles\n");
	ibs = lfmti[I_BSIZE];
	if(ibs < 0) { /* nb de bits pour format unpacked */
		ibs = -ibs;
		ibs = 8 * ((ibs + 7) / 8);
	} else
		ibs *= 8;
	lgl = ibs * lfmti[I_DIMX];
	nlig = ((8 * *ndim * sizeof(t_aligned)) / (lgl * ypas)) * ypas; /* multiple de ypas lignes */
	if(nlig <= 0)
		imerror(8,"pas assez de memoire : utiliser option -k\n");
	nlmax = 1 + (lfmto[I_NDIMY] -1) * pas_echan[1];
	if(nlig > nlmax)
		nlig = nlmax;
	ay = iyi  + (izi - 1) * lfmti[I_NDIMY];
	c_lptset(*nfo,1);
	deltaz = zpas * lfmti[I_NDIMY];
	for(i=0;i<lfmto[I_NDIMZ];i++) {
		c_lptset(*nfi,ay);
		ay += deltaz;
		n = nlmax;
		nl = nlig;
		nlo = 1 + (nl - 1) / ypas;
		while(n > 0) {
			if(nl > n) {
			  nl = n;
			  nlo = 1 + (nl - 1) / ypas;
			}
			c_lect(*nfi,nl,a);
			if(lfmti[I_TYPE] == PACKEE) {
			  nb = nl * lfmti[I_DIMX];
			  c_unpkbt(a,a,nb,-lfmti[I_BSIZE]);
			}
			vect_extract(a,lfmti,a,lfmto,ixi,ivi,nl,pas_echan);
			if(lfmti[I_TYPE] == PACKEE) {
			  nb = nl * lfmto[I_DIMX];
			  c_pckbt(a,a,nb,-lfmti[I_BSIZE]);
			}
			c_ecr(*nfo,nlo,a);
			n -= nl;
		}
	}
}

vect_extract(in,lfmti,out,lfmto,ixi,ivi,nl,pas_echan)
char *in, *out;
Fort_int *lfmti, *lfmto, *pas_echan;
int nl, ixi, ivi;
{
  int ix, iv, nxi, nxo, nvo, nbytes, inc_bytes, first_byte, lgl;
  char *inl, *pi;
  int xpas, ypas, vpas, vdelta, k;
  ;
  ixi--;
  ivi--;
  nxi= lfmti[I_NDIMX];
  nxo = lfmto[I_NDIMX];
  nvo = lfmto[I_NDIMV];
  xpas = pas_echan[0];
  ypas = pas_echan[1];
  vpas = pas_echan[3];

  nbytes = lfmti[I_BSIZE];
  if(nbytes < 0) nbytes = (7 - nbytes) / 8;
  first_byte = (ixi * lfmti[I_NDIMV] + ivi) * nbytes; /* 1e octet dans chaque ligne */
  lgl = lfmti[I_DIMX] * nbytes * ypas;
  if(xpas == 1 && vpas == 1) { /* on simplifie un peu */
    inc_bytes = (lfmti[I_NDIMV] - nvo) * nbytes;
    nbytes = nvo * nbytes;
    while((nl -= ypas) >= 0) {
      inl= in + first_byte;
      in += lgl;
      for(ix=0;ix < nxo;ix++) {
	for(k=0;k<nbytes;k++) {
	  *out++ = *inl++;
	}
	inl += inc_bytes;
      }
    }
  } else {
    lgl = lfmti[I_DIMX] * nbytes * ypas;
    inc_bytes = lfmti[I_NDIMV] * nbytes * xpas;
    vdelta = nbytes * (vpas -1);
    while((nl -= ypas) >= 0) {
      inl= in + first_byte;
      in += lgl;
      for(ix=0;ix < nxo;ix++) {
	pi = inl;
	for(iv=0;iv < nvo;iv++) {
	  for(k=0;k<nbytes;k++) {
	    *out++ = *pi++;
	  }
	  pi += vdelta;
	}
	inl += inc_bytes;
      }
    }
  }
}
