C*FMOY
C===============================================================+
C								!
C	Giraudon   -   SOPHIA      :     16/11/84		!
C								!
C===============================================================+
C								!
C	Calcul d'une image moyennee sur une fenetre de 		!
C	dimension quelconque (idim, kdim)			!
C	L'image de sortie est ecrite avec la routine "ecrflt"	!
C								!
C	Parametres d'entree :					!
C	--------------------					!
C	- SCOL     :  vecteur reel de la taille d'une ligne     !
C		      image					!
C	- IPSE     :  vecteur poids qui donne la taille de scol !
C	- BUFF     :  buffer reel d'entree 			!
C	- SORTI    :  buffer reel de sortie			!
C	- IPOIDS   :  poids des deux buffer (1-1)		!
C	- NF       :  pointeur de l'image d'entree		!
C	- IFMT     :  format de l'image d'entree		!
C	- NF1      :  pointeur de l'image de sortie (l'image de !
C		      sortie est forcement reelle)		!
C	- IDIM     :  nombre de lignes du filtre		!
C	- KDIM     :  nombre de colonnes du filtre		!
C								!
C	Parametres de sortie					!
C	--------------------					!
C	- L'image ecrite sur disque (NF1) suivant le format	!
C	  indique par nf1					!
C								!
C===============================================================+
C-
	subroutine fmoy(scol,ipse,buff,sorti,ipoids,nf,nf1,ifmt,idim,
     c   kdim)
	dimension buff(1),sorti(1),scol(1),ipse(1),ifmt(1),ipoids(1)
	long=ipoids(1)
	lun=0
	lun1=5
	call getbof(ifmt,long,idim,nlign,nrest,ntour,nlit)
C	write(lun,8600) nlign,nrest,ntour,nlit
C8600	format(/'  nlign,nrest,ntour,nlit : ',4(4x,i6))

	ninf=1
	call lptset(nf,ninf)
C -- ninf = 1 parce que on commence a la ligne numero 1 (on n'est pas oblige
	mcolo=ifmt(1)
	do 30 i=1,mcolo
30	scol(i)=0.
C
	carre=idim*kdim
	necco=nlign-idim+ninf
	kdim2=kdim/2
	idim2=idim/2
	
	do 40 i=1,(idim2)
40	call ecrflt(nf1,1,scol)
C -- on ecrit idim/2 lignes nulles au debut de l'image de sortie

	nmot = mcolo * (idim - 1)
	indexd = nmot + 1
	indexf = mcolo * nlit + 1

C------------------------------------------------------+
C------ Debut de la boucle de calcul ------------------!
C------------------------------------------------------+
	do 70 i=1,ntour
C	write(lun,8700) i,ninf,necco
C8700	format(/'i   ninf   necco  : ',3(2x,i6))
	if (i.ne.ntour) goto 200
			 if (nrest.eq.0) goto 70
			 nlign=nrest
			 nlit=nlign-idim+1
200	if (i.eq.1) then
			call lecflt(nf,nlign,buff)
		    else
			call lecflt(nf,nlit,buff(indexd))
		    end if
C
C-- mise a zero des lignes non traitees par le filtrage
	call zerfil(sorti,mcolo,nlign,kdim2)

	call bcfmoy(buff,sorti,scol,nlit,nlign,mcolo,idim,kdim,carre)
	
	if (i.ne.ntour) goto 450
			nm=nlit*mcolo + 1 
			call finfi2(sorti,nm,ifmt,(idim2+1))
			nlit=nlign - idim2 
450	call ecrflt(nf1,nlit,sorti)

	if (i.ne.ntour) call mvmots(buff(indexf),buff(1),nmot)
C -- copie des idim-1 dernieres lignes en debut de buffer de maniere
C -- a permettre a l'executable d'etre pipable en entree . Sinon
C -- lors de l'utilisation de fichier contigu , utiliser necco ...
C	ninf=necco+1
C	necco=ninf+nlign-idim
C	call lptset(nf,ninf)

70	continue

	return
	end


C*GETBOF
C===============================================================!
C								!
C	Giraudon  -  SOPHIA     :      3/05/84			!
C								!
C===============================================================!
C								!
C	Routine qui calcule le nombre de lignes maximum pouvant !
C	etre lue a la fois, en fonction du format de l'image    !
C	et de la taille du buffer lorsque l'on veut filtrer une !
C	image par bout (probleme du recouvrement)		!
C								!
C	Les parametres d'entrees sont :				!
C	- IFMT   :  format de l'image				!
C	- LONG   :  taille du buffer de stockage		!
C	- IDIM   :  dimension du filtre				!
C								!
C	Les parametres de sorties sont :			!
C	- NLIGN  : nombre de lignes images pouvant etre lues	!
C		   a la fois					!
C	- NREST  : nombre de lignes a lire au dernier coup	!
C	- NTOUR  : nombre de tour pour lire toute l'image       !
C	- NDIMA  : le nombre exact de lignes utiles		!
C								!
C===============================================================!
C-
	subroutine getbof(ifmt,long,idim,nlign,nrest,ntour,ndima)
	dimension ifmt(1)
	index=0
	inf=1
	nlign=long/ifmt(1)
	max=nlign
	do 5 i=1,600
	index=index+1
	if (max.ge.ifmt(2)) goto 200
	inf=max-idim+2
	max=inf+nlign-1
5	continue
200	nrest=nlign-(max-ifmt(2))
	if (nlign.ge.ifmt(2)) nlign=ifmt(2)
	ntour=index
	ndima=nlign-idim+1
	return
	end



C*FINFI2
C===============================================================+
C								!
C	Giraudon     -     INRIA - SOPHIA     :    6/06/84 	!
C								!
C===============================================================+
C								!
C	Cette routine permet de mettre des zeros dans les 	!
C	dernieres lignes lorsque un filtrage est effectue.	!
C								!
C	Les parametres sont :					!
C	- A      = buffer de reel dans lequel on met les zeros  !
C		   a partir de l'indice  index+1		!
C								!
C	- INDEX  = index vectoriel du dernier pixel filtre	!
C								!
C	- IFMT   = format de l'image caracterise par 'a'	!
C		   ne sert que pour avoir la dimension de 	!
C		   l'image (eventuellement donc, format d'une	!
C		   image entiere de meme taille)		!
C								!
C	- IDIM   = dimension du filtre utilise			!
C								!
C===============================================================+
C-
	subroutine finfi2(a,index,ifmt,idim)
	dimension a(1),ifmt(1)
	do 10 i=1,((idim-1)*ifmt(1))
	index=index+1
	a(index)=0.
10	continue
	return
	end
