/*
assignation de la sortie graphique (tektro)
le nom du terminal est dans TEK_nom et peut etre modifie (voir CHGTEK)
la variable globale TEK_typ contient 1 si le terminal graphique est aussi
la console (mis par CHGTEK) et 0 dans les autres cas
si TEK_select est a 0, on cherche la variable d'environnement "TEK_NOM"
      qui permettra de faire appel a CHGTEK ('0' =/dev/tek '1'=/dev/tty , '>'=stdout,
     '<'=stdin,  '%'=stdout PostScript
	1er car. alphabetique= nom de fichier, autre=ignore)
   TEK_select est mis a 1 par CHGTEK et asstek
le file descriptor attribue est mis dans les mots 17 et 28 du COMMON /UNITES/
	le mot 28 ne devant servir que pour les entrees. il contiendra
	0 (stdin) dans le cas de la console (TEK_typ = 1)

*/

#include <stdio.h>
#ifndef NONINTERACTIF
#ifdef TERMIOS
#include <termios.h>
#include <unistd.h>
#else
#include <sgtty.h>
static struct sgttyb sgtty;
#endif
#endif
#include <ctype.h>
#include <inrimage/image.h>

#include <string.h>
#include <stdlib.h>

extern struct unites unites_;
extern struct tktrnx tktrnx_;

extern debug_;
char TEK_nom[]= "/dev/tek\0            ";   /* doit avoir 20 char. */
int TEK_typ= 0;
int TEK_select= 0;
#define NT 1	/* num device tek sans /UNITES/ */

char atek[]= "TEK_NOM";
static int flg_PS= 0;
FILE *inr_PSFILE= NULL; 

asstek_()
{
	static char tkn[]= "/dev/tek\0";
	register char *pc;
	Fort_int flag, retry=0, n=NT;
	unites_.ivt[0] = 960 ;  /* vitesse de la ligne 9600 bauds */
	tktrnx_.tk_psmode = 0;  /* mode tektro */
	tktrnx_.tk_page = 0;  /* empty page */
	tktrnx_.tk_path = 0;  /* empty path */
	tktrnx_.tk_text = 0;  /* empty text */
	if(inr_PSFILE == NULL) 
	  inr_PSFILE = stdout; /* FILE for ps output, default stdout */
	if(TEK_select == 0) {
		if((pc = getenv(atek)) != NULL)
			tek_select(pc);
		TEK_select = 1;
	}
	if( strcmp(TEK_nom,tkn) == 0) flag = 1;
	else flag = 0;
	if(flg_PS)  {
		tktrnx_.tk_psmode = 1 ;  /* mode PostScript*/
		ouvdev_(">",&n,&flag,&retry);
	} else
		ouvdev_(TEK_nom,&n,&flag,&retry);
#ifndef NONINTERACTIF
#ifndef TERMIOS
	if(flag) {	/* faire le bon stty */
		gtty(unites_.lutek,&sgtty);
		sgtty.sg_ispeed = sgtty.sg_ospeed = B9600;
		sgtty.sg_flags = (sgtty.sg_flags & ~(ECHO | CBREAK | CRMOD | TANDEM)) | RAW;
		stty(unites_.lutek,&sgtty);
	}
#endif
#endif
	if(TEK_typ == 1) 
		unites_.tekin = 0;
	else
		unites_.tekin = unites_.lutek;
}

struct {
	int itbb;
	union {
		int itc[20];
		char itcc[80];
	} uc;
} itb;

tek_select(pc)
register char *pc;
{
	itb.uc.itcc[20] = itb.uc.itcc[0] = 0;
	flg_PS = 0;
	switch (*pc) {
	case '0' :
		itb.itbb = 0;
		break;
	case '1' :
		itb.itbb = 1;
		break;
	case '%':
		flg_PS = 1;
		inr_PSFILE = stdout;
	case '>' :
		itb.itbb = 3;
		break;
	case '<' :
		itb.itbb = 2;
		break;
	default :
	     if(!(isalpha(*pc)) && *pc != '/') return 1 /* makes c99 happy */; 
		itb.itbb = -1;
		strncat(itb.uc.itcc,pc,20);
	}
	chgtek_(&itb.itbb);
}

