/*
  integer function chkgfm(nf,gfmt,iopt)
  int c_chkgfm(nf,gfmt,iopt)
  struct image *nf; struct nf_fmt *gfmt;int iopt;
compare les parametres donnes par gfmt a ceux de nf

  iopt indique les parametres qu'on doit verifier
  iopt=1 si codage a verifier (lfmt(3),lfmt(4) et lfmt(9) doivent
   avoir une signification)
  iopt=2 si dimensions a verifier, iopt=3 si tout a verifier,
    iopt=0 si rien a verifier
  iopt=4 si maille, x0, y0, z0 a verifier
  iopt=8 si bias et scale a verifier

retour: 0 si ok, >0 si diff. (=parties de iopt correspondantes)
*/

#include <inrimage/image.h>

Fort_int chkgfm_(nf,gfmt,iopt)
struct image **nf;
struct nf_fmt *gfmt;
Fort_int *iopt;
{
	return (Fort_int)c_chkgfm(*nf,gfmt,(int)*iopt);
}

int c_chkgfm(nf,gfmt,iopt)
register struct image *nf;
register struct nf_fmt *gfmt;
int iopt;
{
	register ist;
	ist = 0;
	if(iopt & VER_COD) { /* verif codage */
		if(gfmt->lfmt[2] != nf->lfmt[2] ||
		   gfmt->lfmt[3] != nf->lfmt[3])
			ist |= VER_COD;
		if(nf->TYPE == REELLE) { /* il faut type de machine courante */
			if(nf->flt_conv > 0) 
				ist |= VER_COD;
		} else {
			if(gfmt->EXP == 0) gfmt->EXP = 200;
			if(gfmt->EXP != nf->EXP)
				ist |= VER_COD;
		}
	}
	if(iopt & VER_DIM) { /* verif dim */
		if(gfmt->lfmt[4] != nf->lfmt[4] || gfmt->lfmt[5] != nf->lfmt[5] ||
		   gfmt->lfmt[6] != nf->lfmt[6] || gfmt->lfmt[7] != nf->lfmt[7])
			ist |= VER_DIM;
	}
	if(iopt & VER_OFF) {
		if(gfmt->maille != nf->maille || gfmt->offsets[0] != nf->offsets[0] ||
		   gfmt->offsets[1] != nf->offsets[1] ||gfmt->offsets[2] != nf->offsets[2])
			ist |= VER_OFF;
	}
	if(iopt & VER_XCOD) {
		if(gfmt->bias != nf->bias || gfmt->scale != nf->scale)
			ist |= VER_XCOD;
	}
	return ist;
}
