/*
void decode_pixel(val,pix,nv,is_float,endc,sep)
decode une chaine de car contenant les valeurs des composantes d'un pixel.
Si is_float != 0 : on decode en %f, sinon en 0x%x ou %d
nv : taille pixel
val : cahine de caracteres terminee par 0 ou un des car. de endc
	les composantes sont separees par sep. Les composantes
	manquantes sont obtenues par repetition de la der. composante donnee
pix : tableau resultat int ou float (selon is_float) de nv valeurs 
*/
/* int ipix_interval(val,itvl,ndimv)
   remplit itvl (int *) avec les valeurs des 2 pixels extremes, de taille ndimv,
   et renvoie un flag decrivant l'intervalle
   (existe bornes inf/sup, fermeture inf/sup,negation;
     voir itvl_* dans image.h)
   val de la forme a1/.../an,b1/.../bn, eventeullement entre []
   (ouverture, fermeture) et precede de ~ (negation)
   */
/* int fpix_interval(val,itvl,ndimv)
   idem ipix_interval, mais pour des pixels float
   */
#include <stdio.h>
#include <string.h>
#include <inrimage/image.h>
   
#define MAXLGR 80
void decode_pixel(val,pix,nv,is_float,endc,sep)
register char *val;
int nv, is_float;
char sep;
char *endc;
register int *pix;
{
  char tmp[MAXLGR+4];
  register i, j, c, c1;
  char *pc;
  int v= 0, v1=0;
  float fv= 0.;
  float *fpix;
  i = 0;
  tmp[0]= '/';  /* pour verifier la syntaxe des nb */
  j = 1;
  if(is_float) fpix = (float *) pix;
  while(val && i < nv) {
    while(c = *val) {
      val++;
      if(c == sep) break;
      pc = endc;
      while(c1 = *pc++) {
	if(c == c1) break;
      }
      if(c == c1) {
	c = 0;
	break;
      }
      if(j >= MAXLGR) 
	imerror(9,"decode_pixel : erreur de syntaxe de nombre\n");
      tmp[j++] = c;
    }
    tmp[j++] = '/';
    tmp[j++] = '0';
    tmp[j] = 0;
    if(is_float) {
      if( sscanf(tmp,"/%f/%d",&fv,&v1) != 2)
	imerror(9,"erreur de syntaxe de nombre\n");
      *(fpix+i) = fv;
      i++;

    } else {
      if(sscanf(tmp,"/0x%x/%d",&v,&v1) != 2) {
	if(sscanf(tmp,"/%d/%d",&v,&v1) != 2)
	  imerror(9,"decode_pixel: erreur de syntaxe de nombre\n");
      }
      *(pix+i) = v;
      i++;
    }
    j = 1;
    if(! c) val = (char *) 0;
  }
  if(is_float) {
    while(i < nv) *(fpix+i++) = fv;   /* on complete */
  } else {
    while(i < nv) *(pix+i++) = v;   /* on complete */
  }
}


/* calcul des intervalles */
/* les bornes pour le float */
#define FLOAT_INF -1.e30
#define FLOAT_SUP 1.e30
#define FLOAT_EPS 5.e-7
extern char *index();

static int mkitvl(val,msk,nv,is_float)
char *val;
int is_float, nv, *msk;
{
  register char *p1, *p0;
  register float *pf;
  register type, i;
  type = ITVL_INF_CLOSED | ITVL_SUP_CLOSED;
  if(*(val + strlen(val) - 1) == '[') type &= ~ITVL_SUP_CLOSED;
  if(*val == '~') {
    val++;
    type |= ITVL_NEGATE;
  }
  if(*val == '[') {
    val++;
  } else if(*val == ']') {
    val++;
    type &= ~ITVL_INF_CLOSED;
  }
  if(p1 = index(val,',')) {
    type |= ITVL_B_SUP;
    if(val != p1) type |= ITVL_B_INF;
    p1++;
  } else type |= ITVL_B_INF;
  if(is_float) {
    /* cas float */
    pf = (float *)msk;
    if(type & ITVL_B_INF) decode_pixel(val,(int *)pf,nv,is_float,",",'/');
    if(type & ITVL_B_SUP) decode_pixel(p1,(int *)(pf+nv),nv,is_float,",[]",'/');
    /* on met les bornes manquantes et on se ramene a des intervalles fermes */
    if(! (type & ITVL_B_INF)) {
      for(i=0;i<nv;i++)
	*(pf+i) = FLOAT_INF;
    }
    if(! (type & ITVL_INF_CLOSED)) { /* +eps pour garder test >= */
      for(i=0;i<nv;i++)
	if(! *(pf+i)) *(pf+i) = 1. / FLOAT_SUP;
	else *(pf+i) -= (*(pf+i) * FLOAT_EPS);
    }
    if(! (type & ITVL_B_SUP)) {
      for(i=nv;i<2*nv;i++)
	*(pf+i) = FLOAT_SUP;
    }
    if(! (type & ITVL_SUP_CLOSED)) {/* -1 pour garder <= */
      for(i=nv;i<2*nv;i++)
	if(! *(pf+i)) *(pf+i) = 1. / FLOAT_SUP;
	else *(pf+i) -= (*(pf+i) * FLOAT_EPS);
    }
    return type;
  }

  /* cas int */
  if(type & ITVL_B_INF) decode_pixel(val,msk,nv,is_float,",",'/');
  if(type & ITVL_B_SUP) decode_pixel(p1,msk+nv,nv,is_float,",[]",'/');
  /* on met les bornes manquantes et on se ramene a des intervalles fermes */
  if(! (type & ITVL_B_INF)) {
    for(i=0;i<nv;i++)
      *(msk+i) = -256;
  }
  if(! (type & ITVL_INF_CLOSED)) { /* +1 pour garder test >= */
    for(i=0;i<nv;i++)
      *(msk+i) += 1;
  }
  if(! (type & ITVL_B_SUP)) {
    for(i=nv;i<2*nv;i++)
      *(msk+i) = 255;
    }
  if(! (type & ITVL_SUP_CLOSED)) {/* -1 pour garder <= */
    for(i=nv;i<2*nv;i++)
      *(msk+i) -= 1;
  }
  return type;
}

int ipix_interval(val,itvl,ndimv)
char *val;
int *itvl, ndimv;
{
  return mkitvl(val,itvl,ndimv,0);
}
int fpix_interval(val,itvl,ndimv)
char *val;
float *itvl;
int ndimv;
{
  return mkitvl(val,itvl,ndimv,1);
}
