/* ecrpl
  SUBROUTINE ECRPL(NF,IY,IZ,NPL,NLIG,A)
  c_ecrpl(nf,iy,iz,npl,nlig,a)
 ecrit NLIG lignes dans NPL plans de l'image NF,
 en commencant au plan IZ (>=1) et a la ligne IY(>=1) de chaque plan

  c_pecrpl(nf,iy,iz,npl,nlig,a,lock)
  idem. lock >0 si on veut un mutex_lock

*/
#include <inrimage/image.h>


ecrpl_(nf,iy,iz,npl,nlig,a)

struct image **nf;
Fort_int *iy,*iz,*npl,*nlig;
CHAR *a;
{
	c_pecrpl(*nf,(int)*iy,(int)*iz,(int)*npl,(int)*nlig,a,0);
}

c_ecrpl(nf,iy,iz,npl,nlig,a)
struct image *nf;
int iy,iz,npl,nlig;
void *a;
{
	c_pecrpl(nf,iy,iz,npl,nlig,a,0);
}

c_pecrpl(nf,iy,iz,npl,nlig,a,lock)
struct image *nf;
int iy,iz,npl,nlig;
void *a;
int lock;
{
	register incr, ilig, k;
	struct nf_fmt gfmt;
	Fort_int ibs;
	c_getgfm(nf,&gfmt,0);
	if(iy < 1 || iz < 1)
		imerror(9,"lectpl: bad line or plane number\n");
	if((nlig + iy - 1) > gfmt.NDIMY)
		imerror(9,"lectpl: too many lines\n");
	ilig = (iz -1 ) * gfmt.NDIMY + iy;
	k = ligbit_((Fort_int *)&gfmt,&ibs) / 8;
	incr = (((nlig * k) + sizeof(t_aligned) - 1) / sizeof(t_aligned)) * sizeof(t_aligned);
#ifdef HAS_PTHREADS
	if(lock > 0)
		pthread_mutex_lock(&nf->nf_lock);
#endif
	if((nlig == gfmt.NDIMY) && (incr == k)) { /* 1 seul transfert ? */
		c_lptset(nf,ilig);
		nlig *= npl;
		c_ecr(nf,nlig,a);
	} else {
		while(npl-- > 0) {
			c_lptset(nf,ilig);
			c_ecr(nf,nlig,a);
			a += incr;
			ilig += gfmt.NDIMY;
		}
	}
#ifdef HAS_PTHREADS
	if(lock > 0)
		pthread_mutex_unlock(&nf->nf_lock);
#endif
}


