/* 	FERMNF(NF)
	c_fermnf(nf)
 fermeture de l'image nf  :
 close file and free tables et struct
  et met a 0 le pointeur nf

	nf_alloc(filename)
alloue et initialise a 0 la structure image
  met -1 dans ->fd, et filename dans nf->nom (max 80 car. )
*/
#include <signal.h>
#include <sys/wait.h>
#include <inrimage/image.h>
#define NFMAX 32
#define NFNULL ((struct image *) 0)
static struct image *nftab[NFMAX]= {NFNULL};
	
extern char *inr_mycalloc();

#include <string.h>
#include <stdlib.h>

/**
 * @brief Verification d'un pointeur vers structure image
 *
 * nf_valid s'assure que la structure image n'a pas ete deja liberee
 * en verifiant sa presence dans la table nftab
 *
 * @sa image(), Intro
 */
int nf_valid(nf)
struct image *nf;
{
  int i;
  if (nf == NFNULL)
    return 0;
  for(i=0;i<NFMAX;i++)
    if(nftab[i] == nf)
      return 1;
  return 0;
}

/**
 * @brief Liberation d'une structure image.
 *
 * Fermnf libere la structure image pointee par nf et remet ce pointeur a zero.
 * Toute la memoire utilisee est liberee (par appel a free, et le file descriptor 
 * associe au fichier est ferme.
 *
 * @sa image(), Intro
 */
fermnf_(anf)
struct image **anf;
{
  struct image *nf;
  int status;
  if((nf = *anf) == (struct image *) 0) return 0;
  *anf = NFNULL;
  if(! nf_valid(nf)) return 0;  // deja liberee
  if(nf->x_active != NF_ACTIVE) return 0;
  wr_imdesc(nf);
  if(nf->f_type & FL_SUBPROC) {
    /*		kill(SIGQUIT,nf->pid); */
    close(nf->fd);
#ifdef sun5
    waitpid(0,&status,WNOHANG);
#else
    wait3(&status,WNOHANG,NULL);
#endif
  } else if(nf->fd > 0 && !(nf->f_type & FL_STDIO)) close(nf->fd);
  if(nf->hdr_data != 0) free(nf->hdr_data);
  if(nf->nom != NULL) free(nf->nom);
  if(nf->hdr_lines != 0) free(nf->hdr_lines);
  if(nftab[nf->x_nftab] == nf)
    nftab[nf->x_nftab] = NFNULL;
  nf->x_active = 0;
  free(nf);
  return 0;
}

struct image *nf_alloc(filename)
char *filename;
{
	register struct image *nf;
	register i;
	if((nf = (struct image *) calloc(1,sizeof(struct image))) == (struct image *)0) return (struct image *)0;
	nf->fd = -1;
	i = strlen(filename) + 1;
	if(i < 16) i = 16;
	nf->nom = (char *)inr_mymalloc(i,"nf_alloc:");
	strcpy(nf->nom,filename);

	for(i=0;i<NFMAX;i++)
		if(nftab[i] == NFNULL) {
			nftab[i] = nf;
			nf->x_nftab = i;
			break;
		}
	nf->x_active = NF_ACTIVE;
#ifdef HAS_PTHREADS
	if(pthread_mutex_init(&nf->nf_lock, pthread_mutexattr_default))
		imerror(1,"Fatal error %d : cannot init I/O lock\n",errno);
#endif
	return nf;
}

close_allnf()
{
	register i;
	register struct image *nf;
	for(i=0;i<NFMAX;i++)
		if((nf = nftab[i]) != NFNULL) {
			if(i == nf->x_nftab)
				fermnf_(&nftab[i]);
/*			nftab[i] = NFNULL;    deja fait par fermnf_ */
		}
}
