#include <stdio.h>
/* #include <inrimage/image.h> */

/*
   hsvtorgb8(n,Hbuf,Sbuf,Vbuf,inchsv,Hmax,rbuf,gbuf,bbuf,incrgb)
*/

#define CNV8(x) ((int)((255. * x) + .5))
/*
   hsvtorgb8(n,Hbuf,Sbuf,Vbuf,inchsv,Hmax,rbuf,gbuf,bbuf,incrgb)
   convertit les n donne'es hsv (flottants) en rbg 8 bits
   Les pointeur Sbuf et Vbuf peuvent etre nuls (=> S ou V = 1)
   Hbuf peut etre nul : => H undefined, S ignore' et r,g,b = V
   inchsv : increment dans les buffer HSV (cas d'images vectorielles)
   Hmax : valeur limite pour H,  (normalement 1 ou 360)
   incrgb : increment dans les buffer RGB (cas d'images vectorielles)
*/
/*
hsvtorgb8(n,Hbuf,Sbuf,Vbuf,inchsv,Hmax,rbuf,gbuf,bbuf,incrgb)
register int n, inchsv, incrgb;
register float *Hbuf, *Sbuf, *Vbuf, Hmax;
register unsigned char *rbuf, *gbuf, *bbuf; */
void hsvtorgb8( register int n, register float *Hbuf, register float *Sbuf, register float *Vbuf, int inchsv, float Hmax,
		register unsigned char *rbuf, register unsigned char *gbuf, register unsigned char *bbuf, int incrgb)
{
	register i;
	register float H, S, V;
	register float p, q, t, f;
	register float coef;

	if(Hbuf == NULL) {
		if(Vbuf == NULL) 
			imerror(9,"hsvtorgb8: Hbuf et Vbuf ne peuvent etre tous 2 nuls\n");
		while(n-- > 0) {
			i = (int)((255. * *Vbuf) + .5);
			*rbuf = i;
			*gbuf = i;
			*bbuf = i;
			Vbuf += inchsv;
			rbuf += incrgb;
			gbuf += incrgb;
			bbuf += incrgb;
		}
		return;
	}
	coef = 6. / Hmax;
	while(n-- > 0) {
		if(Sbuf == NULL)
			S = 1.;
		else {
			S = *Sbuf;
			Sbuf += inchsv;
		}
		if(Vbuf == NULL)
			V = 1.;
		else {
			V = *Vbuf;
			Vbuf += inchsv;
		}
		if(S == 0) {  /* ignorer H */
			Hbuf += inchsv;
			i = CNV8(V);
			*rbuf = i;
			*gbuf = i;
			*bbuf = i;
			rbuf += incrgb;
			gbuf += incrgb;
			bbuf += incrgb;
			continue;
		}
		H = *Hbuf;
		Hbuf += inchsv;
#if 0
		if(H >= 360.) H = 0;
		H /= 60.;
#else
		H *= coef;
#endif
		i = (int)H;
		f = H - i;
		switch (i) {
		case 1:
			p = V * (1. - S);
			q = V * (1. - (S * f));
			*rbuf = CNV8(q);
			*gbuf = CNV8(V);
			*bbuf = CNV8(p);
			break;
		case 2:
			p = V * (1. - S);
			t = V * (1. - (S * (1. - f)));
			*rbuf = CNV8(p);
			*gbuf = CNV8(V);
			*bbuf = CNV8(t);
			break;
		case 3:
			p = V * (1. - S);
			q = V * (1. - (S * f));
			*rbuf = CNV8(p);
			*gbuf = CNV8(q);
			*bbuf = CNV8(V);
			break;
		case 4:
			p = V * (1. - S);
			t = V * (1. - (S * (1. - f)));
			*rbuf = CNV8(t);
			*gbuf = CNV8(p);
			*bbuf = CNV8(V);
			break;
		case 5:
			p = V * (1. - S);
			q = V * (1. - (S * f));
			*rbuf = CNV8(V);
			*gbuf = CNV8(p);
			*bbuf = CNV8(q);
			break;
		default:  /* case 0 et 6 */
			p = V * (1. - S);
			t = V * (1. - (S * (1. - f)));
			*rbuf = CNV8(V);
			*gbuf = CNV8(t);
			*bbuf = CNV8(p);
			break;
		}
		rbuf += incrgb;
		gbuf += incrgb;
		bbuf += incrgb;

	}
}
