/*
	FUNCTION ICPGFM(GFMT1,GFMT2)
	Fort_int icpgfm_(gfmt1,gfmt2)
	struct nf_fmt *gfmt1, *gfmt2;

 comapraison de 2 tableaux format generalises
 retourne :
  0 si tout different
  +1 si types et b.s. egaux,
  +2 si dim egales
  +4 si maille + offsets egaux
  +8 si biais et scale egaux (force si image reelle)
*/

#include <inrimage/image.h>

#define EQ_COD 1
#define EQ_DIM 2
#define EQ_XCOD 8
#define EQ_OFF 4


Fort_int icpgfm_(gfmt1,gfmt2)
register struct nf_fmt *gfmt1, *gfmt2;
{
	register code, i;
	code = 0;
	for(i=4;i<8;i++)
		if(gfmt1->lfmt[i] != gfmt2->lfmt[i]) break;
	if(i < 8)
		code |= EQ_DIM;
	if(gfmt1->TYPE == gfmt2->TYPE && gfmt1->BSIZE == gfmt2->BSIZE &&
	   gfmt1->EXP == gfmt2->EXP)
		code |= EQ_COD;
	for(i=0;i<3;i++)
		if(gfmt1->offsets[i] != gfmt2->offsets[i]) break;
	if(i < 3) {
		if(gfmt1->maille == gfmt2->maille)
			code |= EQ_OFF;
	}
	if(gfmt1->bias == gfmt2->bias && gfmt1->scale == gfmt2->scale)
		code |= EQ_XCOD;
	return code;
}
