/* IMOUVG
	SUBROUTINE IMOUVG(NVOL,NFIC,NF,ISF,GFMT,IOPT)
	struct image *c_imouv(nfic,gfmt,iopt)
  ouverture non interactive de l'image de nom nfic
  retour : nf
  iopt indique les parametres qu'on doit verifier si l'image existe :
  iopt=1 si codage a verifier (lfmt(3),lfmt(4) et lfmt(9) doivent
   avoir une signification)
  iopt=2 si dimensions a verifier, iopt=3 si tout a verifier,
    iopt=0 si rien a verifier
  iopt=4 si maille, x0, y0, z0 a verifier
  iopt=8 si bias et scale a verifier
  iopt=16 si gfmt est de type struct nf_fmt (force si iopt & 4 ou iopt & 8)
  si l'image n'existe pas, on la cree apres avoir demande les
  parametres non verifies.

 modif unix : la taille du tableau nfic est mise a 20 mots ( 80 cars )

*/

#include <inrimage/image.h>
#include <stdlib.h>
struct image *c_imouv(), *c_ouvimf();


imouvg_(nvol,nfic,nf,isf,gfmt,iopt)
Fort_int *nvol, *isf, *iopt;
struct nf_fmt *gfmt;
char *nfic;
struct image **nf;
{
	*nf = c_imouv(nfic,gfmt,(int)*iopt);
}

struct image *c_imouv(nfic,gfmt,iopt)
char *nfic;
register struct nf_fmt *gfmt;
register int iopt;
{
	register struct image *nf;
	struct nf_fmt gfmt1;
	Fort_int dummy, jopt;
	register iage, len;
	register long i;
	i = ifsize_(nfic);
	if(i > 0)
		iage = 1;
	else iage = i < 0 ? 0 : 2;  /* 2 == existe mais vide */
/*!!	iage = iexst_(&dummy,nfic,&dummy) == 1 ? 0 : 1; */
	if(iopt & VER_XMASK) {
		iage |= VER_EXTEND;
		len = sizeof(struct nf_fmt);
		jopt = (Fort_int)((iopt & VER_MASK) ^ VER_MASK);
	} else {
		jopt = (Fort_int)((iopt & VER_MINMASK) ^ VER_MINMASK);
		len =  9 * sizeof(Fort_int);
	}
	if((iage & 1) == 0) { /* fichier a creer ou vide */
		rdfmg_(gfmt,&jopt);
		c_mvbyte((CHAR *)gfmt,(CHAR *)&gfmt1,len);
	}
	if((nf = c_ouvimf(nfic,&gfmt1,iage)) == 0) {
		imerror(10,"%s: erreur d'ouverture d'image (imouvg)\n",xargv[0]);
		exit(1);
	}
	if(iage & 1) { /* image qui existe */
		i = c_chkgfm(nf,gfmt,iopt);
		if(i & VER_COD) { /* erreur verif codage */
			imerror(6,"%s : codage non acceptable\n",nf->nom);
		}
		if(i & VER_DIM) { /* err verif dim */
			imerror(7,"%s : dimensions non acceptables\n",nf->nom);
		}
		if(i & VER_XCOD) { /* erreur verif bias ou scale */
			imerror(6,"%s : biais ou facteur d'echelle non acceptable\n",nf->nom);
		}
		if(i & VER_OFF) { /* err verif maille et offsets */
			imerror(7,"%s : maille ou offsets non acceptables\n",nf->nom);
		}
		
		c_mvbyte((CHAR *)&gfmt1,(CHAR *)gfmt,len);
		return nf;
	}
	gfmt->lfmt[0] = gfmt1.lfmt[0];
	gfmt->lfmt[1] = gfmt1.lfmt[1];
	return nf;
}
