/* traitement du header inrimage Version 3 (anciens formats) */

#include <stdio.h>
#include <inrimage/inrfile.h>
#include <inrimage/flt_type.h>

#define ABS(x) ( x < 0 ? -x : x)

/* 
procedure de decodage du format depuis le descripteur 
retour : 0 si ok, 1 si pas image
*/

extern char *realloc();
extern char **hdrl_alloc();

static i3read_hdr(nf)
register struct image *nf;
{
	register char *file_header;
	register n;
	register len;
	if( nf->desc_size == DESC) return 0;
	if((nf->desc_size % DESC) != 0) return 1;
	file_header = nf->hdr_data;
	file_header = (char *) realloc(file_header,nf->desc_size*sizeof(char));
	n = nf->desc_size - DESC;
	if ( file_header == NULL ) {
		perror("realloc");
		fprintf(stderr,"Could'nt realloc %d chars\n",nf->desc_size);
		return(1);
	}
	if ( (len = read_all(nf->fd,file_header+DESC,n)) < 0) { 
		perror("read");
		return(-1);
	}
	nf->hdr_data = file_header;
	nf->byte_pnt += len;
	if(n != len)
		return -1;
	return 0;
	
}

i3desc_fmt(nf)
register struct image *nf;
{
	register struct descripteur *pi;
	register n;
	if((n = i3read_hdr(nf)) != 0) return n;
	pi = (struct descripteur *) nf->hdr_data;
	nf->DIMX = pi->dimx ;
	nf->DIMY = pi->ndimy * pi->ndimz ;
	nf->BSIZE = ( pi->flag & BITS ? -(pi->bsize) : pi->bsize );
	nf->TYPE = ( pi->flag & FLOAT ? 1 :
				( pi->flag & PACKED ? -1 : 0 ) ) ;
	nf->float_typ = pi->float_typ;
	nf->data_msbfirst = chk_msbfirst(nf->float_typ);
	if(nf->TYPE == REELLE) {
		if(nf->float_typ <= 0)
			nf->flt_conv = -1;
		else if(nf->float_typ != fl_type())
				nf->flt_conv = 1;
		nf->bits_lig = nf->DIMX * nf->BSIZE * 8;
		nf->EXP = nf->float_typ;
	} else {
		if((n = nf->BSIZE) < 0) {
			n = -n;
			if(nf->TYPE == FIXE) n = 8 * ((n + 7) / 8);
		} else
			n *= 8;   /* nb bits */
		/* check if swap needed on fix type : not packed and coded on 2 or 4 bytes */
		if((nf->TYPE != PACKEE) && (n > 8)) { 
			if(nf->data_msbfirst < 0)
				nf->swap_needed = -1;
			else if(nf->data_msbfirst != ismsbfirst())
				nf->swap_needed = (n <= 16) ? 1 : ((n > 24) ? 2 : -1);
		}
		nf->bits_lig = nf->DIMX * n;
		nf->EXP = pi->exposant ;
		if(nf->EXP == 0)
			nf->EXP = 200;
	}
	nf->NDIMX = pi->ndimx ;
	nf->NDIMY = pi->ndimy ;
	nf->NDIMV = pi->ndimv ;
	nf->NDIMZ = pi->ndimz ;
	/* convert float parts of header if possible */
	if(nf->data_msbfirst >= 0) {
		c_cnvflt(&pi->maximum,3,nf->float_typ);
		c_cnvflt(&pi->bias,2,nf->float_typ);
	}
	if(nf->i_version == IV_INR3) {
		nf->X_OFFSET = pi->x_off;
		nf->Y_OFFSET = pi->y_off;
		nf->Z_OFFSET = pi->z_off;
		nf->maille = pi->maille;
		nf->bias = pi->bias;
		nf->scale = pi->scale;
	} else {
		nf->maille = I_RECTA;
	}
	nf->hors_tout = (nf->bits_lig + 7) / 8;  /* nb d'octets par ligne sur le fichier */
	return bld_hdrl3(nf);
}
	
bld_hdrl3(nf)
register struct image *nf;
{
	register struct descripteur *pi;
	register n, i;
	register char *pc;
	pi = (struct descripteur *) nf->hdr_data;
	if((n = bld_hdrl(nf,pi->comment)) != 0) return n;
	n = 0;
	i = nf->hdr_nlines -1;
	pc = nf->hdr_lines[i];
	if (pc < (nf->hdr_data + nf->desc_size)) 
		if(*pc != 0 && *pc != '\n')
			n = 1;
	if(nf->hdr_nlines >= nf->hdrl_size-n)
		if(hdrl_alloc(nf) == 0) return 1;
	if(n)
		nf->hdr_lines[nf->hdr_nlines++] = nf->hdr_data + nf->desc_size;
	nf->hdr_lines[nf->hdr_nlines++] = nf->hdr_data + nf->desc_size;
	return 0;
}

fmt_i3desc(nf)
register struct image *nf;
{
	register struct descripteur *pi;
	register n;
	pi = (struct descripteur *) nf->hdr_data;
	pi->desc_ext = nf->desc_size - DESC;
	pi->dimx = nf->DIMX ;
	pi->flag = ( nf->TYPE == REELLE ? FLOAT :
				( nf->TYPE == FIXE ? 0 : PACKED ) );
	pi->flag |= ( nf->BSIZE < 0 ? BITS : 0 ); 
	pi->bsize = ABS(nf->BSIZE);
	pi->ndimx = nf->NDIMX ;
	pi->ndimy = nf->NDIMY ;
	pi->ndimv = nf->NDIMV ;
	pi->ndimz = nf->NDIMZ ;
	pi->im_magic = IM3_MAGIC;
	/* determination type de cpu */
	if(nf->float_typ == 0) {
		nf->float_typ  = fl_type();
		nf->data_msbfirst = ismsbfirst();
	}
	pi->float_typ = nf->float_typ;
	if(nf->TYPE != REELLE) {
		if((pi->scale = nf->scale) != 0.)
			pi->exposant = ( nf->EXP < 0 ? -200 : 200 );
		else
			pi->exposant = ( nf->EXP == 0 ? 200 : nf->EXP );
		pi->bias = nf->bias;
	}
	if((n = nf->BSIZE) < 0) {
		n = -n;
		if(nf->TYPE != PACKEE)
			n = 8 * ((n + 7) /8);
	} else
		n *= 8;
	nf->bits_lig = nf->DIMX * n;
	nf->hors_tout = (nf->bits_lig + 7) / 8;
	pi->maille = nf->maille;
	pi->x_off = nf->X_OFFSET;
	pi->y_off = nf->Y_OFFSET;
	pi->z_off = nf->Z_OFFSET;
	if(!nf->data_msbfirst)
		swapdesc(pi);
	if(nf->hdr_lines != (char **) 0)  /* c'est une mise a jour */
		return 0;
	if(hdrl_alloc(nf) != 0) {
		nf->hdr_lines[0] = pi->comment;
		nf->hdr_lines[1] = nf->hdr_data + nf->desc_size;
		nf->hdr_nlines = 2;
	}
	return 0;
}
