#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <inrimage/inrfile.h>


extern struct hdr_keys hdr_keys[];

// extern char *calloc(), *realloc();
extern char **hdrl_alloc();

static char t_unsign[]= S_UNSIGN;
static char t_sign[]= S_SIGN;
static char t_bits[]= S_BITS;
static char t_fixed[]= S_FIX;
static char t_packed[]= S_PACK;
static char t_float[]= S_REELLE;
static char t_rect[]= S_RECTA;
static char t_hexa[]= S_HEXA;

#define KeyVal(i,x,y) {if((i = hdr_keys[x].key_val) != 0) {\
		nf->y = c_idonne((char *)i,0,lgrword((char *)i)-1,&ier);\
		if(ier != 0) return 1;}}

/* remplit nf a partir du header inrimage Version 4 (ascii)
le 1er bloc est deja en memoire, on lit les blocs suivants eventuels
retour : 0 si ok, -1 si read pb, 1 si autre pb
*/
i4desc_fmt(nf)
register struct image *nf;
{
	register long ist, i, n, nbit;
	char *p;
	Fort_int ier;
	char buftyp[32];
	init_hdrkeys();
	if((ist = i4read_hdr(nf,1)) != 0) return ist;
	for(i=0;i<HDR_NB_MIN;i++)
		hdr_keys[i].key_val = 0;
	p = nf->hdr_lines[0];
	if(chkword(hdr_keys[IS_HEADER].key,p) < 0)
		return 1;
	n = nf->hdr_nlines - 2;
/*	if(n > HDR_NB_MIN) n = HDR_NB_MIN; il faut tout explorer!! */
	for(i=1;i<= n;i++) {
		p = nf->hdr_lines[i];
		if(*p == '\n' || *p == '#' || *p == 0) continue;  /* ignorer lignes vides et comment. */
		if((ist = chk_hdrkey(&p)) < 0) break;
		hdr_keys[ist].key_val = (long)p;
	}
	/* on reporte dans nf */
/*
	if((i = hdr_keys[IS_NDIMX].key_val) != 0) {
		nf->NDIMX = c_idonne(i,0,lgrword(i)-1,&ier);
		if(ier != 0) return 1;
	}
*/
	KeyVal(i,IS_NDIMX,NDIMX);
	KeyVal(i,IS_NDIMY,NDIMY);
	KeyVal(i,IS_NDIMZ,NDIMZ);
	KeyVal(i,IS_NDIMV,NDIMV);
	KeyVal(i,IS_XOFF,X_OFFSET);
	KeyVal(i,IS_YOFF,Y_OFFSET);
	KeyVal(i,IS_ZOFF,Z_OFFSET);

	if(nf->NDIMX == 0) nf->NDIMX = 1;
	if(nf->NDIMY == 0) nf->NDIMY = 1;
	if(nf->NDIMV == 0) nf->NDIMV = 1;
	if(nf->NDIMZ == 0) nf->NDIMZ = 1;
	nf->DIMX = nf->NDIMX * nf->NDIMV;
	nf->DIMY = nf->NDIMY * nf->NDIMZ;
	if((p = (char *)hdr_keys[IS_MAILLE].key_val) != (char *)0) {
		if(*p == t_rect[0]) {
			if(chkword(t_rect,p) < 0) return 1;
			nf->maille = I_RECTA;
		} else {
			if(chkword(t_hexa,p) < 0) return 1;
			nf->maille = I_HEXAG;
		}
	}
	if((p = (char *)hdr_keys[IS_BSIZE].key_val) == (char *)0) return 1;
	i = lgrword(p);
	if(chkword(t_bits,p+i) < 0) return 1;
	nf->BSIZE = c_idonne(p,0,i-1,&ier);
	if(ier != 0) return 1;
	nf->EXP = 200;
	if((p = (char *)hdr_keys[IS_SCALE].key_val) != 0) {
		if(*p == '2' && *(p+1) == '*' && *(p+2) == '*') {
			i = c_idonne(p,3,lgrline(p)-1,&ier);
			if(ier != 0) return 1;
			nf->EXP = 200 + i;
		} else
			sscanf(p,"%f",&nf->scale);
	}
	/* get cpu type */
	if((p = (char *)hdr_keys[IS_CPU].key_val) != 0) {
		i = move_line(p,buftyp,30);
		buftyp[i-1] = 0;
		nf->float_typ = chk_flname(buftyp);
	}
	nf->data_msbfirst = chk_msbfirst(nf->float_typ);
	if((p = (char *)hdr_keys[IS_TYPE].key_val) == (char *)0)
		return 1;
	nbit = nf->BSIZE;
	if(*p == t_float[0]) {
		if(chkword(t_float,p) < 0) return 1;
		nf->TYPE = REELLE;
/*!!		if(nf->BSIZE != 32 && nf->BSIZE != 64) return 1; */
		nf->BSIZE /= 8;
		nf->flt_conv = -1;
		if(nf->float_typ > 0) {
			if(nf->float_typ != fl_type())
				nf->flt_conv = 1;
			else
				nf->flt_conv = 0;
		}
		nf->EXP = nf->float_typ;
	} else {
		if((i = chkword(t_sign,p)) < 0) {
			if((i = chkword(t_unsign,p)) < 0) return 1;
		} else nf->EXP = -nf->EXP;
		p += i;
		if(chkword(t_fixed,p) >= 0) {
			nf->TYPE = FIXE;
			if(nf->BSIZE & 7) {
				nbit = 8 * ((nbit + 7) / 8);
				nf->BSIZE = -nf->BSIZE;  /* unpacked */
			} else
				nf->BSIZE /= 8;   /* normal */
		} else {
			if(chkword(t_packed,p) < 0) return 1;
			nf->BSIZE = -nf->BSIZE;
			nf->TYPE = PACKEE;
		}
		/* check if swap needed on fix type */
		if((nf->TYPE != PACKEE) && (nbit > 8)) { 
			if(nf->data_msbfirst < 0)
				nf->swap_needed = -1;
			else if(nf->data_msbfirst != ismsbfirst())
				nf->swap_needed = (nbit <= 16) ? 1 : ((nbit > 24) ? 2 : -1);
		}
		if((p = (char *)hdr_keys[IS_BIAS].key_val) != 0)
			sscanf(p,"%f",&nf->bias);
	}
	nf->bits_lig = nf->DIMX * nbit;
	nf->hors_tout = (nf->bits_lig + 7) / 8;
	return 0;
}

/* return 0 if ok, 1 or -1 else */
i4read_hdr(nf,firstblk)
register struct image *nf;
int firstblk;   /* si >0, le 1er bloc a deja ete lu */
{
	register char *file_header, *p;
	register n;
	register file_header_len;

	if(firstblk == 0) {
		if ( (file_header = (char *) calloc(FILE_HEADER_LEN,sizeof(char))) == NULL ) {
			perror("calloc");
			fprintf(stderr,"Can't calloc %d chars\n",FILE_HEADER_LEN);
			return(1);
		}
		nf->desc_size = file_header_len = FILE_HEADER_LEN;
	} else {
		if((file_header_len = nf->desc_size) != FILE_HEADER_LEN) return 1;
		file_header = nf->hdr_data;
	}
	p = file_header;
/*	file_header_len = FILE_HEADER_LEN; */
	while (1) {
		if(strncmp(p + FILE_HEADER_LEN - END_SIZE +1,MAGIC_END,END_SIZE-1) == 0) break;
		file_header_len += FILE_HEADER_LEN;
		file_header = (char *) realloc(file_header,file_header_len*sizeof(char));
		p = file_header + file_header_len - FILE_HEADER_LEN;
		if ( file_header == NULL ) {
			perror("realloc");
			fprintf(stderr,"Could'nt realloc %d chars\n",file_header_len);
			return(1);
		}
		if ( (n = read_all(nf->fd,p,FILE_HEADER_LEN)) < 0) { 
			perror("read");
			return(-1);
		}
		nf->byte_pnt += n;
		if(n != FILE_HEADER_LEN )
			return -1;

	}
	
	
	*(file_header + file_header_len - 1) = '\n'; /* on borne par un \n */
	nf->hdr_data = file_header;
	nf->desc_size = file_header_len;
	return bld_hdrl4(nf); /* liste des pointeurs de lignes du header */
}

bld_hdrl4(nf)
register struct image *nf;
{
	register n,i;
	register char *pc;
	if((n = bld_hdrl(nf,nf->hdr_data)) != 0) return n;;
	i = nf->hdr_nlines -2;
	pc = nf->hdr_lines[i];
	if(*pc != '\n') {
		if(nf->hdr_nlines >= nf->hdrl_size)
			if(hdrl_alloc(nf) == 0) return 1;
		nf->hdr_lines[nf->hdr_nlines++] = nf->hdr_lines[i+1];
	}
	return n;
}


static len, f_hdrl;
static char *f_hdr;
/* genere la partie min. du header d'une image inrimage format ascii,
a partir de la structure image (nf) : (lfmt, f_type,
i_version, desc_size, hdr_data.
Le 1er bloc du header est deja alloue.
met a jour les champs bits_lig, hors_tout, float_typ, flt_conv, hdrl et hdr_lines.
retourne 0 si ok, 1 si alloc err.
*/
fmt_i4desc(nf)
register struct image *nf;
{
	register n, nbit, exp;
	char buftyp[20], bufsiz[16], bufexp[16], bufbias[16], bufmail[20];

	/* on remplit le buffer */
	init_hdrkeys();
	hdr_keys[IS_SCALE].key_val = 0;
	hdr_keys[IS_BIAS].key_val = 0;
	hdr_keys[IS_CPU].key_val = 0;
	hdr_keys[IS_MAILLE].key_val = 0;
	hdr_keys[IS_XOFF].key_val = nf->X_OFFSET;
	hdr_keys[IS_YOFF].key_val = nf->Y_OFFSET;
	hdr_keys[IS_ZOFF].key_val = nf->Z_OFFSET;
	hdr_keys[IS_NDIMX].key_val = nf->NDIMX;
	hdr_keys[IS_NDIMY].key_val = nf->NDIMY;
	hdr_keys[IS_NDIMV].key_val = nf->NDIMV;
	hdr_keys[IS_NDIMZ].key_val = nf->NDIMZ;
	if(nf->maille == I_HEXAG) {
		strcpy(bufmail,t_hexa);
		hdr_keys[IS_MAILLE].key_val = (long)bufmail;
	}
	/* determination type de cpu */
	if(nf->float_typ == 0) {
		nf->float_typ  = fl_type();
		nf->data_msbfirst = ismsbfirst();
	}
	hdr_keys[IS_CPU].key_val = (long) get_flname(nf->float_typ);
	n = nf->BSIZE;
	if(nf->TYPE == REELLE) {
		strcpy(buftyp,t_float);
		n = nbit = 8 * n;
	} else {
		if(nf->EXP < 0) {
			exp = -nf->EXP - 200;
			strcpy(buftyp,t_sign);
		} else {
			exp = nf->EXP - 200;
			strcpy(buftyp,t_unsign);
		}
		strcat(buftyp," ");
		if(nf->TYPE == FIXE) {
			strcat(buftyp,t_fixed);
			n = n < 0 ? -n : 8*n;
			nbit = 8 * ((n + 7) / 8);
		} else {
			strcat(buftyp,t_packed);
			nbit = -n;
			n = nbit;
		}
		if(nf->scale == 0)
			sprintf(bufexp,"2**%d",exp);
		else
			sprintf(bufexp,"%f",nf->scale);
		hdr_keys[IS_SCALE].key_val = (long)bufexp;
		if(nf->bias != 0) {
			sprintf(bufbias,"%f",nf->bias);
			hdr_keys[IS_BIAS].key_val = (long)bufbias;
		}
	}
	sprintf(bufsiz,"%d ",n);
	strcat(bufsiz,t_bits);
	nf->bits_lig = nf->DIMX * nbit;
	nf->hors_tout = (nf->bits_lig + 7) / 8;
	hdr_keys[IS_TYPE].key_val = (long) buftyp;
	hdr_keys[IS_BSIZE].key_val = (long) bufsiz;
	if(nf->hdr_lines == (char **) 0) {  /* new header */
		if((n = set_hdrl(nf)) != 0) return n;
		if((n = bld_hdrl4(nf)) != 0) return n;
		return 0;
	} else /* mise a jour d'un haeder */
		return mod_hdrl(nf);
}

set_hdrl(nf)
register struct image *nf;
{
	register i, k;
	f_hdr = nf->hdr_data;
	f_hdrl = nf->desc_size;
	len = 0;
	if((i = hdrl_add1(&hdr_keys[IS_HEADER])) != 0) return i;
	for(k=0;k<HDR_NB_MIN;k++)
		if((i = hdrl_add1(&hdr_keys[k])) != 0) return i;
	/* on ajoute le message de fin */
	k = f_hdrl - hdr_keys[IS_END].key_length - 1;
	if(len <= k)
		len = k;
	else
		len = f_hdrl;
	if((i = hdrl_add1(&hdr_keys[IS_END])) != 0) return i;
	nf->hdr_data = f_hdr;
	nf->desc_size = f_hdrl;
	return 0;
}

mod_hdrl(nf)
register struct image *nf;
{
	register n, k;
	register struct hdr_keys *pk;
	register char *p2;
	char buff[20];
	pk = hdr_keys;
	for(k=0;k<HDR_NB_MIN;k++) {
		if(pk->key_val == 0){
			pk++;
			continue;
		}
		switch(pk->key_type) {
		case K_DECIMAL:
			sprintf(buff,"%d ",pk->key_val);
			p2 = buff;
			break;
		case K_STRING:
			p2 = (char *) pk->key_val;
			break;
		default:
			return 1;
		}
		if((n = irephline(nf,pk->key,0,p2)) < 0)
			return 1;
		pk++;
	}
	return 0;
}

hdrl_add1(pk)
register struct hdr_keys *pk;
{
	register char *p, *p2;
	register n, n2, l;
	char buff[20];
	p = f_hdr + f_hdrl - FILE_HEADER_LEN;
	l = f_hdrl - len;
	if(pk->key_val == 0) return 0;
/*!!!	if(len == 0)
		fillbuf(f_hdr,f_hdrl,'\n'); !!!*/
	n = pk->key_length;
	switch(pk->key_type) {
	case K_DECIMAL:
		sprintf(buff,"%d ",pk->key_val);
		p2 = buff;
		break;
	case K_STRING:
		p2 = (char *) pk->key_val;
		break;
	default:
		return 1;
	}
	n2 = strlen(p2);
	while((n + n2 + 1) > l) {
		f_hdrl += FILE_HEADER_LEN;
		if((f_hdr = (char *)realloc(f_hdr,f_hdrl*sizeof(char))) == NULL) {
			fprintf(stderr,"header alloc err\n");
			return 1;
		}
		p = f_hdr + f_hdrl - FILE_HEADER_LEN;
		fillbuf(p,FILE_HEADER_LEN,'\n');
		l += FILE_HEADER_LEN;
	}
	p = f_hdr + len;
	strncpy(p,pk->key,n);
	strncpy(p+n,p2,n2);
	len += n + n2 + 1;
	return 0;
}


	
