#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <inrimage/image.h>
#include <inrimage/inrlocal.h>

int xargc;
char **xargv;
extern char **inr_xargv;
extern int inr_xargc;

char *inr_Ucmd= NULL, *inr_Udetail= NULL;
char inr_force_ext[64]= {0};

/* pour DEC station : histoire de se distinguer en Fortran! */
int f77argc;
char **f77argv;
/* pour alpha station : histoire de se distinguer en Fortran! */
int for__l_argc;
char **for__a_argv;
/* pour sun f77 1.4 */
int __xargc;
char **__xargv;

extern char *inr_progvers;


/* inr_init(argc,argv,progversion,ucmd,udetail)
  initialisations diverses :
     si un arg est nul, il est ignore'
  progversion: string contenant la version du prog. si non nulle
  ucmd, udetail : arguments pour appel iusage_ 
      (messages "help" du programme)

      appelle:
      		initopts(argc,argv)
		kdopts_()  (options -k, -D, -vers, -.)
		cherche l'option -help et appelle iusage_
*/

static int kdopts_called= 0;  /* pour ne pas appeler kdopts_ 2 fois */
static int initop_called= 0;  /* pour ne pas appeler initopts_ 2 fois */
int khoros_mode= 0;   /* use khoros options if > 0 
		       overwrite output files if == 2*/
#ifdef INR_KHOROS
static int khoros_inb= 0;   /* current num of -i option */
static int khoros_onb= 0;   /* current num of -o option */
#endif
inr_init(argc,argv,progversion,ucmd,udetail)
int argc;
char **argv;
char *progversion, *ucmd, *udetail;
{
	if(argc && (argv != NULL))
		initopts(argc,argv);
	if(progversion != NULL)
		inr_progvers = progversion;
	kdopts_();
	if(ucmd != NULL)
		hlpopt_(ucmd,udetail);
}
/* tbcmd contient une table de noms, avec ucmd et udetail associes
si le nom commence par '-', c'est une option.
  le programme doit etre appele avec 1 seule option de la liste
si le nom ne commence pas par '-' c'est une variante du nom de la commande.
Si la table contient des options elle ne doit contenir
qu'une entree sans '-', qui est l'entree par defaut.
Retour : numero (>=0) du nom de commande ou de l'option
    -1 si nom de commande ou option non trouvee
L'entree par defaut contient un nom vide; si elle existe ce  doit etre la derniere
*/

int inr_initm(argc,argv,progversion,tbcmd0)
int argc;
char **argv;
char *progversion;
struct multi_cmd *tbcmd0;
{
	register struct multi_cmd *tbcmd, *pm;
	register char *pc, *pd, *cmd;
	register found;
	register nbm, i0m, nbcmd;
	if(argc && (argv != NULL))
		initopts(argc,argv);
	if(progversion != NULL)
		inr_progvers = progversion;
	inr_setopts();
	/* test de commande */
	found = 0;
	nbm = 0;
	i0m = -1;
	nbcmd=0;
	tbcmd = tbcmd0;
	cmd = inr_basename(inr_xargv[0]);
	while(tbcmd->name != NULL) {
		nbcmd++;
		if(*tbcmd->name == '-') {
			nbm++;
			if(iverifopt(tbcmd->name)) {
				if(i0m < 0) {
					i0m = nbcmd -1;
					pm = tbcmd;
					found = 1;
				}
#if 0
				else
					imerror(9,"option %s incompatible with %s\n",tbcmd->name,(tbcmd0+i0m)->name);
#endif
			}
		} else if(*tbcmd->name == 0) {  /* default */
			if(!found) {
				found = 1;
				pm = tbcmd;
			}
			break;
		} else {
			if(found) {
				tbcmd++;
				continue;
			}
			if ( strcmp(cmd,tbcmd->name) == 0 ) {
				if(i0m >= 0)
					imerror(9,"inr_initm: table d'options inconsistante\n");
				found = 1;
				pm = tbcmd;
				if(nbm == 0)
					i0m = nbcmd - 1;
			}
		}
		tbcmd++;
	}
	if((nbm > 0) && (nbm < (nbcmd-1)))
		imerror(9,"inr_initm: table d'options inconsistante\n");
	if(!found) 
		imerror(9,"fonction inconnue (%s)!!\n",cmd);
	kdopts_();
	if(pm->ucmd != NULL)
		hlpopt_(pm->ucmd,pm->udetail);
	return i0m;
}

initopts(argc,argv)
int argc;
char **argv;
{
	if(initop_called)
		return 1 /* makes c99 happy */; 
	initop_called = 1;
	xargc = argc;
	xargv = argv;
}

/*
	SUBROUTINE KDOPTS
prend en compte les options "-k octets" et -D
*/

extern debug_,koctet_;
kdopts_()
{
	register i;
	int val;
	if(kdopts_called)
		return 1 /* makes c99 happy */; 
	kdopts_called = 1;
	khoros_mode = 0;
#ifdef INR_KHOROS
	if(igetopt("-khoros","",0,"%d",&val,"",0)) {
		khoros_mode = (val == 1) ? 2 : 1;
	}
	if(khoros_mode)
		if(igetopt("-V","",0,"",0,"",0))
			print_version();
#endif
	if(igetopt("-vers","",0,"",0,"",0))
		print_version();
	igetopt("-k","",0    ,"%d",&koctet_  ,"",0);
	if(koctet_ <= 0)
	  get_defkoctet ();
	debug_ = igetopt("-D","",0   ,"",0    ,"",0);
	if(igetopt("-.","%s",&inr_force_ext[1],"",0,"",0))
		inr_force_ext[0] = '.';
}

/* on cherche les options -help et -Help
et on imprime les messages
*/

hlpopt_(ucmd,udetail)
char *ucmd, *udetail;
{
	register char *p1;
	inr_Ucmd = ucmd;
	inr_Udetail = udetail;
#ifdef INR_KHOROS
	if(khoros_mode)
		if(igetopt("-help","",0,"",0,"",0))
			iusage_(ucmd,udetail);
#endif
	if(igetopt("-help","",0,"",0,"",0))
		iusage_(ucmd,udetail);
	else if(igetopt("-Help","",0,"",0,"",0))
		iusage_(ucmd,NULL);
}

clearopts()
{
	if(inr_xargv == (char **)0) return 0;
	free(inr_xargv);
	inr_xargv = (char **)0;
	inr_xargc = 0;
	kdopts_called = 0;
	initop_called = 0;
#ifdef INR_KHOROS
	khoros_inb= 0;   /* current num of -i option */
	khoros_onb= 0;   /* current num of -o option */
	khoros_mode = 0;
#endif
	return 1;
}

/**
 * experimental !
 */
inr_exit() {
  clearopts();
  inr_myfree( get_inr_home());
  inr_myfree( get_user_home());
  inr_myfree( get_inr_extfile());
}

/* 
   xfileoptg(name,lg_name,opt_name,required)
   name : buffer pour le nom, de taille lg_name (0 si taille inconnue)
   opt_name : "i" pour input, "o" pour output
   retourne 1 si vrai nom, 0 si stdin/stdout
   erreur en mode khoros si stdin ou stdout et required != 0
   Si lg_name >0 : on utilise %nc au lieu de %s pour accepter les noms avec espaces
*/

#define FMT_SIZE 20
int xfileoptg(name,lg_name,opt_name,required)
char *name, *opt_name;
int required;
{
	register true_file;
	register flg_io, n;  /* 0= input, 1= output */
	char fmt[FMT_SIZE];
	if(strcmp(opt_name,"i") == 0)
		flg_io = 0;
	else if(strcmp(opt_name,"o") == 0)
		flg_io = 1;
	else
		imerror(9,"fileopt: bad option type\n");
#ifdef INR_KHOROS
	if(khoros_mode) {
		if(flg_io == 0) {
			sprintf(fmt,"-i%d",++khoros_inb);
			n = khoros_inb;
		} else {
			sprintf(fmt,"-o%d",++khoros_onb);
			n = khoros_onb;
		}
		if(!igetopt(fmt,"",0,"%s",name,"",0)) {
			if(!required)
				return 0;
			imerror(9,"%s option required\n",fmt);
		}
		if(strcmp(name,"pipe=-") == 0) {
			name[1] = 0;
			name[0] = flg_io == 0 ? '<' : '>';
			return 0;
		}
		return 1;
	}
#endif
	if(lg_name > 0) {
	  for(n = 0;n <lg_name;n++) 
	    *(name+n) = 0;
	  sprintf(fmt,"%%%dc",lg_name - 1);
	} else {
	  strcpy(fmt,"%s");
	}
	if(flg_io == 0) { /* input */
		if (!igetopt("",fmt,name,"",0,"",0) || ! strcmp("-",name)) {
			strcpy(name,"<"); /* standart input */
			return 0;
		}
	} else {
		if (!igetopt("",fmt,name,"",0,"",0) || ! strcmp("-",name)) {
			strcpy(name,">"); /* standart input */
			return 0;
		}
	}
	return 1;
}

/* infileopt(buff), outfileopt(buff) :
cherchent nom de fichier dans args, resp. pour input et output
renvoient le nom dans buff, mettent "<" ou ">" si "-" ou pas d'arg
retour 1 si OK, 0 si pas d'option ou "-"
*/

infileopt(name)
char *name;
{
	return xfileopt(name,"i",1);
}

outfileopt(name)
char *name;
{
	return xfileopt(name,"o",1);
}

/* fileopt
   fileopt(name,opt_name)
   cherche nom de fichier dans liste d'options et le
      renvoie dans name
   opt_name doit etre "i" ou "o"
      en mode khoros on cherche -in ou -on, avec n >=1 et incremente
      automatiquement a chaque appel
   retourne 1 si vrai nom, 0 si stdin/stdout
   erreur en mode khoros si stdin ou stdout
*/

int fileopt(name,opt_name)
char *name, *opt_name;
{
	return xfileopt(name,opt_name,1);
}
/* fileoptg
   fileoptg(name,lg_name,opt_name)
   cherche nom de fichier dans liste d'options et le
      renvoie dans name (max lg_name)
   opt_name doit etre "i" ou "o"
      en mode khoros on cherche -in ou -on, avec n >=1 et incremente
      automatiquement a chaque appel
   retourne 1 si vrai nom, 0 si stdin/stdout
   erreur en mode khoros si stdin ou stdout
*/

int fileoptg(name,lg_name,opt_name)
char *name, *opt_name;
{
  return xfileoptg(name,lg_name,opt_name,1);
}

/* xfileopt
   fileopt(name,opt_name,required)
   retourne 1 si vrai nom, 0 si stdin/stdout
   erreur en mode khoros si stdin ou stdout et required != 0
*/

int xfileopt(name,opt_name,required)
char *name, *opt_name;
int required;
{
  return xfileoptg(name,0,opt_name,required);
}


/*
  FILE *asciifileopt(opt,type)
opt= nom de l'option, type = 0 pour read ,1 pour wr
si type > 0: on teste les noms particuliers stdout et stderr
             on ouvre en mode append si le nom commence par >>
retourne NULL si pas d'option
*/
FILE *asciifileopt(opt,type)
char *opt;
register type;
{
	FILE *file;
	char name[256];
	register char *pc, *mod;

	if( opt[strlen(opt)-1] == '=') {
	  if(!igetopt(opt,"%s",name,"",0,"",0))
	    return NULL;
	} else
	  if(!igetopt(opt,"",0,"%s",name,"",0))
	    return NULL;

	if(type == 0) {
		if((file = fopen(name,"r")) == NULL)
			imerror(1,"asciifileopt: open err %d on %s\n",errno,name);
		return file;
	}
	/* fichier de sortie */
	if(strcmp(name,"stderr") == 0)
		return stderr;
	if(strcmp(name,"stdout") == 0)
		return stdout;
	pc = name;
	mod = "w";
	if(*pc == '>') {
		pc++;
		if(*pc == '>') {
			pc++;
			mod = "a";
		}
	}
	if((file = fopen(pc,mod)) == NULL)
		imerror(1,"asciifileopt: open err %d for %s\n",errno,pc);
	return file;
}
