/* mvbits
	subroutine movbts(a,b,ia,ib,nbits)
	c_mvbits(a,b,ia,ib,nbits)
		char *a, *b; int ia,ib,nbits;
 transfere une suite de nbits bits, de a dans b :
 on commence au bit ia de a et ib de b (comptes a partir de 1)
 en fonction des positions relatives des chaines, on commence
 par le debut ou la fin
 on  appelle mvbvte quand c'est possible
*/
#include <stdio.h>
#include <inrimage/image.h>



/* deplacement d'une chaine de bits */
/* on ne fait pas d'hypothese sur la place des bytes dans un mot */


movbts_(in,out,i_in,i_out,nbits)
CHAR *in, *out;
Fort_int *i_in, *i_out, *nbits;
{
	c_mvbits(in,out,(int)*i_in,(int)*i_out,(int)*nbits);
}

c_mvbits(in,out,i_in,i_out,nb_bits)
register CHAR *in, *out;
int i_in, i_out;
register int nb_bits;
{
	register fb_in,fb_out;
	fb_in = i_in - 1; /* l'appellant compte a partir de 1 */
	fb_out = i_out - 1;
	in += fb_in / 8;  /* on pointe sur le 1er octet concerne */
	out += fb_out / 8;
	fb_in &= 7;
	fb_out &= 7;
	if ( ( in == out ) && ( fb_in == fb_out ) ) return 1 /* makes c99 happy */;  /* rien a faire */
	/* on appelle mvbyte si possible */
	if(fb_in == 0 && fb_out == 0 && (nb_bits & 7) == 0) {
		c_mvbyte(in,out,nb_bits/8);
		return 1 /* makes c99 happy */; 
	}
	if ( in < out || (( in == out ) && ( fb_in < fb_out )))
		{	/* on commence par la fin */

		mvb_fin(in,out,fb_in,fb_out,nb_bits);

		}
	else
		{	/* on commence par le debut */

		mvb_debut(in,out,fb_in,fb_out,nb_bits);

		}
}

/* deplacement en commencant par la fin */

mvb_fin(in,out,fb_in,fb_out,nb_bits)
CHAR *in, *out;
int fb_in,fb_out,nb_bits;
{
	register CHAR *r_in,*r_out,*last_out;
	register int gauche,droite;
	int i,rst_p,rst_d,byte_in,byte_out,nb_bytes;
	Fort_int bit_in,bit_out;
	/* on traite le dernier champ */

	rst_d = ( fb_out + nb_bits ) % 8 ;
	rst_d = ( rst_d < nb_bits ? rst_d : nb_bits );

	bit_in = fb_in + nb_bits - 1;
	bit_out = fb_out + nb_bits - 1;

	for ( i=0 ; i<rst_d ; i++ )
		{

		if ( btest_(in,&bit_in) )
			bset_(out,&bit_out);
		else
			bclr_(out,&bit_out);

		bit_in--;
		bit_out--;
		}

	if ( (nb_bits -= rst_d) == 0 ) return 1 /* makes c99 happy */;  /* c'est deja fini ! */

	/* rang du dernier bit a traiter sur out et de son pote sur in */

	bit_out = fb_out + nb_bits - 1;
	bit_in =  fb_in  + nb_bits - 1;

	/* evaluation des decalages */

	droite = 7 - (bit_in % 8);
	gauche = 8 - droite;

	/* bornes sur in et out */

	last_out = out + (fb_out+7)/8 - 1;
	r_out = out + bit_out/8;
	r_in = in + bit_in/8;

	/* on deplace */

	if ( droite != 0 )
			/* les 2 zones n'ont pas le meme alignement */
		while ( r_out > last_out )
			{
			*(r_out--) = (*(r_in-1) << gauche) |
					(*(r_in) >> droite);
			r_in--;
			}
	else
		{	/* les 2 zones ont le meme alignement -> mvbyte */

		byte_in = (fb_in+7)/8;
		byte_out = (fb_out+7)/8;

		nb_bytes = (fb_in + nb_bits)/8 -byte_in;
		c_mvbyte(in + byte_in,out + byte_out,nb_bytes);

		}


	/* on traite le premier champ */

	rst_p = nb_bits - (out + bit_out/8 - last_out) * 8;

	bit_in = fb_in + rst_p - 1;
	bit_out = fb_out + rst_p - 1;

	for ( i=0 ; i<rst_p ; i++ )
		{

		if ( btest_(in,&bit_in) )
			bset_(out,&bit_out);
		else
			bclr_(out,&bit_out);

		bit_in--;
		bit_out--;
		}
}


/* deplacement en commencant par le debut */

mvb_debut(in,out,fb_in,fb_out,nb_bits)
CHAR *in, *out;
int fb_in,fb_out,nb_bits;
{
	register CHAR *r_in,*r_out,*last_out;
	register int gauche,droite;
	int i,rst_p,rst_d,byte_in,byte_out,nb_bytes;
	Fort_int bit_in,bit_out;
	/* on traite le premier champ */

	rst_p = 8 - (fb_out%8) ;
	rst_p = ( rst_p < nb_bits ? rst_p : nb_bits );

	bit_in = fb_in;
	bit_out = fb_out;

	for ( i=0 ; i<rst_p ; i++ )
		{

		if ( btest_(in,&bit_in))
			bset_(out,&bit_out);
		else
			bclr_(out,&bit_out);

		bit_in++;
		bit_out++;
		}

	if ( (nb_bits -= rst_p) == 0 ) return 1 /* makes c99 happy */;  /* c'est deja fini */

	fb_in += rst_p ;
	fb_out += rst_p;

	/* evaluation des decalages */

	gauche = fb_in % 8 ;
	droite = 8 - gauche;

	/* rang du dernier bit a traiter sur out */

	bit_out = fb_out + nb_bits - 1 ;

	/* bornes sur out */

	last_out = out + (bit_out-7)/8 + 1;
	r_out = out + fb_out/8 ;

	/* borne sur in */

	r_in = in + fb_in/8;

	/* on deplace */

	if ( gauche != 0 )
		while ( r_out < last_out )
			{	/* les 2 zones n'ont pas meme alignement */
			*(r_out++) = ( *r_in << gauche ) |
						( *(r_in+1) >> droite );
			r_in++;
			}
	else
		{	/* les 2 zones ont meme alignement -> mvbyte */
		byte_in = (fb_in+7)/8;
		byte_out = (fb_out+7)/8;

		nb_bytes = ( fb_in + nb_bits ) / 8 - byte_in;
		c_mvbyte(in + byte_in,out + byte_out,nb_bytes);
		}

	/* on traite le dernier champ */

	rst_d = nb_bits - ( last_out - out - fb_out/8 ) * 8;

	bit_in = fb_in + nb_bits - rst_d ;
	bit_out = fb_out + nb_bits - rst_d ;

	for ( i=0 ; i<rst_d ; i++ )
		{
		if ( btest_(in,&bit_in) )
			bset_(out,&bit_out);
		else
			bclr_(out,&bit_out);

		bit_in++;
		bit_out++;
		}
}

