/* open_image(nf,mode)
  procedure d'ouverture d'une image
La structure image (nf) doit avoir ete creee et initialisee a 0.


mode= 1 si write only, 2 si RW, 0 si RO, 6 si create RW
   on traite de facon particuliere les fichiers de nom "<" et ">"
   "<" indique standart input
   ">" ---------------- output
Dans une version precedente,
   dans ces 2 cas on a le dup de 0(resp. 1) dans nom[1] et on ferme 0(resp. 1)
   pour empecher tout acces parasite sur 0 ou 1.
retour : 0 si ok, -1 si pb d'acces au fichier, 1 si ce n'est pas une image
*/
   
#include <stdio.h>
#include <sys/types.h>
#include <inrimage/inrfile.h>
extern debug_;	/* debug */
int inr_stdin_used= 0;
#include <stdlib.h>

#include <sys/types.h> /* for off_t */
#include <unistd.h>    /* for lseek */


open_image(nf,mode)
struct image *nf;
int mode;
{
	register rw;
	char *p,*index();
	register char c, c1;
	// On veut accepter des noms de fichiers avec des espaces
	//	if ( p = index(nf->nom,' ') ) *p = '\0'; /* on borne le nom par \0 */

	rw = -1;
	c = nf->nom[0];
	c1 = nf->nom[1];
	if(nf->f_type & FL_SUBPROC) {
		c = '<';
		c1 = 0;
	}
	switch ( c ) {
	case '<' :	/* stdin */
		if(c1 != 0)
			imerror(9,"bad filename %s\n",nf->nom);
		if ( mode == IM_RONLY ) {/* ouverture en input seulement */
#if 0
			nf->fd = dup(0);
			close(0); /* on ferme 0 pour eviter
				     tout acces parasite sur stdin */
			if ( open("/dev/null",0) == -1 ) {
				/* et on le remplace par /dev/null */
				fprintf(stderr,"%s open_image Warning: open erreur %d avec /dev/null\n",
					xargv[0],errno);
			/*!!!	exit(1);  on continue quand meme */
			}
#else
			if(nf->f_type & FL_SUBPROC) {
				nf->fd = inr_startsubproc(nf->nom,nf->cnv_ovf);
				nf->cnv_ovf = 0;
				nf->f_type |= FL_STDIO | FL_PIPE;
			} else
				nf->fd = 0;
#endif
			inr_stdin_used= 1;
		} else {
			nf->fd = -1;
		}
		break;
	case '>' :
		/* stdout */
		if(nf->nom[1] != 0)
			imerror(9,"bad filename %s\n",nf->nom);
		if ( mode == IM_WONLY ) {/* ouverture en output seulement */
#if 0
			nf->fd = dup(1);
			close(1); /* on ferme 1 pour eviter
				     tout acces parasite sur stdout */
			if ( open("/dev/null",1) == -1 ) {
				/* et on le remplace par /dev/null */
				fprintf(stderr,"%s open_image Warning: open erreur %d avec /dev/null\n",
					xargv[0],errno);
				/*!!	exit(-1); */
			}
#else
			nf->fd = 1;
#endif
		} else {
			nf->fd = -1;
		}
		break;

	default:
		/* c'est un fichier classique */

			nf->fd = open(nf->nom,mode);
			break;
		}


	if ( nf->fd != -1)
	  if((rw = init_nf(nf,mode)) < 0) {
	    close(nf->fd);
	    nf->fd = -1;
	  }


	if (debug_) fprintf(stderr,"%s open_image %s mode %d fd %d\n",xargv[0],nf->nom,mode,nf->fd);

	return rw;
}

/* pour essayer de savoir si c'est un pipe (ou une tty !) */
#define ispipe(fd) (lseek(fd,(off_t)0,1) < 0)
/* retourne 0 si ok, 1 si pas image, -1 si pb d'acces */
init_nf(nf,mode)
struct image *nf;
int mode;
{
	register rw;
	if(nf->nom[0] == '<' || nf->nom[0] == '>') {
		nf->f_type = FL_STDIO;
		if(ispipe(nf->fd)) nf->f_type |= FL_PIPE;
	}
	switch ( mode ) {
	case IM_RONLY : 
	case IM_RW :
		if(mode == IM_RONLY)
			nf->f_type |= FL_READ;
		else
			nf->f_type |= FL_RDWR;
		rw = rd_imdesc(nf);
		break;
	case IM_CRW :
		nf->f_type |= FL_READ;
	case IM_WONLY :
		nf->f_type |= FL_WR;
		rw =bld_imdesc(nf);
		break;
	}
	nf->no_ligne = 1;
	return rw;
}

/* read image descriptor 
retourne 0 si OK ( et initialise le reste de la structure nf
-1 si pb de read,  1 si autre pb
*/
rd_imdesc(nf)
register struct image *nf;
{
	register ist, n;
	register struct descripteur *pi;
	register struct vlg_desc *pv;
	register char *file_header;
	if((file_header = (char *)calloc(FILE_HEADER_LEN,sizeof(char))) == NULL) {
		fprintf(stderr,"%s open_image: file header alloc err\n",xargv[0]);
		return(1);
	}
	nf->hdr_data = file_header;
	pv = (struct vlg_desc *) file_header;
	pi = (struct descripteur *) file_header;
	if(read_all(nf->fd,file_header,VDESC) != VDESC) return -1; /* descripteur */
	nf->byte_pnt = VDESC;
	if(pv->i_magic == V_SWMAGIC) {
		swapvdesc(pv);
	}
	if(pv->i_magic == V_MAGIC) {
		nf->i_version = IV_VLOG;
		if((n = pv->hdr_usr) > 0) {
			if(n > (DESC - VDESC))
				n = DESC - VDESC;
			if(read_all(nf->fd,file_header + VDESC,n) != n) return -1;
			nf->byte_pnt += n;
		}
		nf->desc_size = pv->hdr_data;
		if(debug_)
			fprintf(stderr,"%s is of type Visilog\n",nf->nom);
		return desc_fmt(nf);
	}
	n = DESC - VDESC;
	if(read_all(nf->fd,file_header + VDESC,n) != n) return -1;
	nf->desc_size = nf->byte_pnt = DESC;
	if(pi->im_magic == IM3_SWMAGIC) { /* from vax : swap! */
		if(debug_)
			fprintf(stderr,"%s is of type Inrimage swapped\n",nf->nom);
		swapdesc(pi);
	}
	if(pi->im_magic == IM3_MAGIC) {
		nf->i_version = IV_INR3;
		if(debug_)
			fprintf(stderr,"%s is of type Inrimage-R3\n",nf->nom);
		if((pi->desc_ext % DESC) == 0) 
			nf->desc_size += pi->desc_ext;
		return desc_fmt(nf);
	}
	if(chkword(MAGIC_HEADER,file_header) >= 0) {
		nf->i_version = IV_INR4;
		if(debug_)
			fprintf(stderr,"%s is of type Inrimage\n",nf->nom);
	} else {
		if(!(nf->f_type & FL_PIPE)) {
			n = lseek(nf->fd,(off_t)0,2);  /* sizeof file */
			lseek(nf->fd,(off_t)DESC,0); /* reset ptr */
		} else n = 0;
		if(i3desc_test((struct descripteur *)file_header,n) != 0) {
			if(debug_)
				fprintf(stderr,"%s is not an image\n",nf->nom);
			return 1;
		}
		nf->i_version = IV_OLD;
		if(debug_)
			fprintf(stderr,"%s is of old type Inrimage\n",nf->nom);
	}
	ist = desc_fmt(nf); /* decodage du format */
	return ist;
}
/* prepare le header image
retourne 0 si OK 
  1 si  pb
*/
bld_imdesc(nf)
register struct image *nf;
{
	register version, hdrl;
	if((version = get_version()) == IV_VLOG) {
		hdrl = FILE_HEADER_LEN * get_hdrVblk();
		nf->desc_size = hdrl > VDESC ? hdrl : VDESC;
		nf->i_version = IV_VLOG;
		if(hdrl == 0) hdrl = VDESC;
		if(debug_)
			fprintf(stderr,"creating Visilog descriptor for %s\n",nf->nom);
	} else if (version == IV_INR3){
		hdrl = FILE_HEADER_LEN * get_hdr3blk();
		nf->desc_size = hdrl;
		nf->i_version = IV_INR3;
		if(debug_)
			fprintf(stderr,"creating Inrimage-R3 descriptor for %s\n",nf->nom);
	} else {
		/* nouvelle version */
		hdrl = FILE_HEADER_LEN * get_hdr4blk();
		nf->desc_size = hdrl;
		nf->i_version = IV_INR4;
		if(debug_)
			fprintf(stderr,"creating Inrimage descriptor for %s\n",nf->nom);
	}
	return init_hdr(nf,hdrl);
}

/* alloc et init du header de taille hdrl pour nf */
init_hdr(nf,hdrl)
register struct image *nf;
register hdrl;
{
	register char *file_header;
	if((file_header = (char *)calloc(hdrl,sizeof(char))) == NULL) {
		fprintf(stderr,"%s open_image: file header alloc err\n",xargv[0]);
		return (1);
	}
	if(nf->i_version == IV_INR4)
		fillbuf(file_header,hdrl,'\n');
	else
		fillbuf(file_header,hdrl,0);
	nf->hdr_data = file_header;
	return fmt_desc(nf); /* codage du format */
}

 /* ecriture effective du descripteur */
wr_imdesc(nf)
register struct image *nf;
{
	register n;
	if(!(nf->hdr_stat & HST_TOMOD)) return 0;
	if(nf->hdr_data == NULL || nf->x_active != NF_ACTIVE) return 0; 
	if(get_hist() > 0) {
		auto_history(nf);
	}
	nf->hdr_stat &= ~HST_HIST2SET;
	if(!(nf->hdr_stat & HST_TOWRITE)) return 0;
	if((n = nf->byte_pnt) > 0) {  /* revenir au debut */
		if(lseek(nf->fd,(off_t)0,0) < 0) {
			imerror(1,"%s : seek error on %s\n",xargv[0],nf->nom);
			exit(1);
		}
	}
/*	if(nf->i_version == IV_INR3) {
		pi = (struct descripteur *) nf->hdr_data;
		pi->flag |= COMMENT;
	} !!*/
	if(write(nf->fd,nf->hdr_data,nf->desc_size) != nf->desc_size) {
		imerror(1,"%s : error when writing header of %s\n",
			xargv[0],nf->nom);
		exit(1);
	}
	nf->hdr_stat &= ~HST_TOWRITE;
	if(n == 0) {
		nf->byte_pnt = nf->desc_size;
		return 0;
	}
	lseek(nf->fd,(off_t)n,0);
	return 0;
}

#define swp2(x,y) { x = y; y = ((x >> 8) & 0xff) | (x << 8); }
#define swp4(x,y) { x = y;\
y = (x << 24) | ((x & 0xff00) << 8) | ((x >> 8) & 0xff00) | ((x >> 24) & 0xff);}

/* swap le short et int d'un header image Inr3 :
 les float  (min, max, moy, bias, scale) doivent etre traites a part
 */
swapdesc(pi)
register struct descripteur *pi;
{
register unsigned short r2;
register long rl;
	swp2(r2,pi->dimx)
	swp2(r2,pi->ndimy)
	swp2(r2,pi->ndimx)
	swp2(r2,pi->ndimz)
	swp2(r2,pi->ndimv)
	swp2(r2,pi->exposant)
	swp2(r2,pi->float_typ)
	swp4(rl,pi->im_magic)
	swp4(rl,pi->desc_ext)
	swp4(rl,pi->x_off)
	swp4(rl,pi->y_off)
	swp4(rl,pi->z_off)
	swp4(rl,pi->maille)
}
swapvdesc(pv)
register struct vlg_desc *pv;
{
	register long rl;
	register long *pl;
	pl = (long *)pv;
	while(pl <= (long *) &pv->hdr_data) {
		swp4(rl,*pl);
		pl++;
	}
}

/*
 * procedure de lecture (utilisee pour les lectures ds un pipe)
 * permet de satisfaire une lecture de longueur precise
 * la valeur retournee est le nombre d'octets lus ou le code d'erreur
 */

read_all(fd,buf,len)
register int fd;
register int len;
char *buf;
{
	register int n;
	register char *p = buf;
	
	while ( len > 0 ) {
		if ( (n = read(fd,p,len)) > 0 ) {
			len -= n;
			p += n;      /* on avance */
		} else {
			if ( n < 0 )
				return(n);   /* erreur de lecture */
			else
				return(p - buf); /* fin de fichier */
		}
	}
	
	return(p - buf); /* on retourne le compte d'octets */
}

