/*
C*OUVDEV
	SUBROUTINE OUVDEV(NOM,N,IFLAG,NRETRY)
C  ASSIGNATION d'un device reserve (tek, cit, vicom, etc)
	NOM= nom device termine par 0
	     (met le fd 1 (stdout) si NOM == ">" et le fd 0 si NOM == '<')
	N = num. du dev. = indice de 1 a 12 dans 2e partie de /UNITES/
	IFLAG =1 si exclusivite demandee
	IFLAG = 2 si lock demande (ce flag n'est utilise
	que par une commande specialisee)
	NRETRY= nb de retry (toutes les secondes) si pb assign
  si IFLAG=1 on ecrit dans un fichier (s'il existe) le numero utilisateur
   (fichier /usr/spool/devlck/nom pour device /dev/nom)
 NB : si le fichier lock existe, on teste son proprietaire :
	si c'est l'utilisateur, on accepte l'assignation,
	mais non exclusive (plusieurs taches possibles)
*/

#include <stdio.h>
#include <string.h>
#if (! defined NONINTERACTIF && ! defined TERMIOS)
#include <sgtty.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <inrimage/image.h>
#define WAIT 1	/* attente de 1 sec entre 2 retry */

#define OK 0
#define EXCL 1
#define LOCK 2
#define ERR -1

extern Fort_int unites_[28];

extern debug_;

static char nlk[]="/usr/spool/devlck/xxxxxxxxxx";
static char lock[]="/usr/spool/devlck/LCK..xxxxxxxxxx";
static Fort_int blck[2];	/* uid et creat time du fichier lock */
#define LCK 18	/* numero du 1e car. a remplacer */
#define LCK2 23
ouvdev_(nom,n,iflag,nretry)
char nom[];
Fort_int *n, *iflag, *nretry;
{
	Fort_int is1 = 2, is2;
	int ISATTY;
	Fort_int  icrlf=1, er9= 9, icrl0= 0;
	int lnum;
	register k, flag, retry, st;
	struct stat buf;
#ifndef NONINTERACTIF
	ISATTY = isatty(0); /* si stdin=tty on pourra repeter open */
#else
	ISATTY = 0;
#endif
	lnum = *n +15;
	if(lnum <16 || lnum >27) ermesf_(&er9);
	if ( unites_[lnum] > 0) return 1 /* makes c99 happy */;  /* deja assigne */
	if(strcmp(nom,">") == 0) {
		unites_[lnum] = 1;
		return 1 /* makes c99 happy */; 
	}
	if(strcmp(nom,"<") == 0) {
		unites_[lnum] = 0;
		return 1 /* makes c99 happy */; 
	}
	flag = *iflag;
	/* preparer le nom du fichier lock */
	if(nom[0] == '/' && nom[4] == '/' &&
	  nom[1] == 'd' && nom[2] == 'e' && nom[3] == 'v') {
		strncpy(&nlk[LCK],&nom[5],10);
		strncpy(&lock[LCK2],&nom[5],10);
		flag += 8;
	}
	if (ISATTY) {
#ifndef NONINTERACTIF
		while ((st=assdev0(lnum,nom,flag)) != OK) {
			outstr_(&icrl0,nom);
			switch (st) {
			case EXCL :
				outstr_(&icrlf,": OCCUPE. $");
				if((k=open(nlk,0)) > 0 && 
				  read(k,blck,4) >= 4 && blck[0] >= 0) {
					fstat(k,&buf);
					close(k);
					outstr_(&icrl0,"dernier utilisateur connu : $");
					blck[1] = buf.st_mtime;
					prtlck_(blck);
				}
				break;
			case ERR :
				outstr_(&icrlf,": err $");
				break;
			case LOCK :
				outstr_(&icrlf,": RESERVE. $");
				outstr_(&icrl0,"Par : $");
				stat(lock,&buf);
				blck[0] = buf.st_uid;
				blck[1] = buf.st_ctime;
				prtlck_(blck);
			}
			if(iask_(&icrl0," On recommence ? $") != 1) {
				is2 = (Fort_int)errno;
				ermess_(&is1,&is2);
			}
		}
#else
		;
#endif
	} else {
		retry = *nretry;
		while (assdev0(lnum,nom,flag) != OK) {
			if( --retry <= 0) {
			  fprintf(stderr,"%s ouvdev:probleme avec %s\n",xargv[0],nom);
			  ermess_(&is1,&is2);
			}
			sleep(WAIT);
		}
	}
}

assdev0(k,name,flg)
char *name;
int flg, k;
{
register fd, fdl, fl;
int i, uid;
	uid = getuid();
	fl = flg &0x7;
	if (flg & 8) {
		if((i=chklck(lock,uid,blck)) == 0) return LOCK;
		if (i == 2 && fl == 1) fl = 0;
	}
	if ( (fd = open(name,2)) == -1) {
err0:		if(debug_) 
		  fprintf(stderr,"%s assdev0:probleme avec %s\n",xargv[0],name);
		if(errno == EBUSY) return EXCL;
		else return ERR;
	}
	/* assignation exclusive flag 1 ou 2 */
#ifdef TIOCEXCL
	if( fl >= 1 &&
		ioctl(fd,TIOCEXCL,NULL) == -1) goto err0;
#endif
	if( debug_ ) printf("assdev0: lu=%d\n",fd);
	if( debug_) printf("assdev0: nom= %s\n",name);
#ifdef TIOCFLUSH
 	ioctl(fd,TIOCFLUSH,NULL); 
#endif
	unites_[k] = fd;
	if (fl == 0) return OK;
	if (flg & 8 && (fdl = open(nlk,2)) > 0) {
		if(fl == 2) 
			i = -1;
		else {
			i = uid;
			if (debug_) fprintf(stderr,"flag file %s\n",nlk);
		}
		write(fdl,&i,4);
		close(fdl);
	}
	if(fl != 2 || !(flg & 8)) return OK;
	if((fdl = creat(lock,0666)) <= 0) {
		if(debug_) fprintf(stderr,"%s : creat err %d\n",lock,errno);
		return ERR;
	} else {
		if(debug_) fprintf(stderr,"lock file cree : %s\n",lock);
		close(fdl);
		return OK;
	}
}


