/*
  define le format de l'image nf a partir de donnees utilisateur
  put_gfmt(nf,gfmt,type)
  gfmt est lfmt[9] si type == 0
          struct nf_fmt si type == 1
  recalcule lfmt[0] et lfmt[1] a partir de lfmt[4..7]
verifie la coherence du format
*/
#include <inrimage/image.h>


put_gfmt(nf,gfmt,type)
register struct image *nf;
register struct nf_fmt *gfmt;
int type;
{
	register i;
	gfmt->DIMX = gfmt->NDIMX * gfmt->NDIMV;
	gfmt->DIMY = gfmt->NDIMY * gfmt->NDIMZ;
	if(gfmt->EXP == 0)
		gfmt->EXP = 200;
	if((gfmt->TYPE != REELLE)) {
		if((gfmt->EXP < -300) || (gfmt->EXP > 300) || 
		   ((gfmt->EXP < 100) && (gfmt->EXP > -100)))
			imerror(6,"exposant incorrect pour %s\n",nf->nom);
	}
	if(gfmt->BSIZE == 0)
		imerror(6,"byte/bit size incorrecte pour %s\n",nf->nom);
	if(gfmt->TYPE == FIXE)  {
		if(gfmt->BSIZE < -32 || gfmt->BSIZE > 4)
			imerror(6,"byte/bit size incorrecte pour %s\n",nf->nom);
	} else if(gfmt->TYPE == PACKEE) {
		if(gfmt->BSIZE < -32 || gfmt->BSIZE > 0)
			imerror(6,"bit size incorrecte pour %s\n",nf->nom);
	} else if(gfmt->TYPE == REELLE) {
		if(gfmt->BSIZE != sizeof(float) && gfmt->BSIZE != sizeof(double))
			imerror(6,"byte size incorrecte pour %s\n",nf->nom);
	} else
		imerror(6,"type incorrect pour %s\n",nf->nom);
	for(i=0;i<9;i++)
		nf->lfmt[i] = gfmt->lfmt[i];
	if(type != 1) return 1 /* makes c99 happy */; 
	for(i=0;i<3;i++)
		nf->offsets[i] = gfmt->offsets[i];
	nf->maille = gfmt->maille;
	nf->bias = gfmt->bias;
	nf->scale = gfmt->scale;
}
