/*
C*RDFMG
	SUBROUTINE RDFMG(GFMT,IOPT)
	rdfmg_(gfmt,iopt)
	struct nf_fmt *gfmt; Fort_int *iopt;
 renvoie  un format generalise d'image :
 cherche dans la liste des options (par optfmt); s'il ne trouve aucune
   option, demande des valeurs sur stdin
      options de taille si 'iopt & 2', de codage si 'iopt & 1'
      ( les 2 si iopt == 3)
      maille + offsets si iopt & 4
      bias + offset si iopt & 8 (images virg. fixe)
C NB : L'EXPOSANT EST LAISSE INCHANGE
*/

#include <inrimage/image.h>
#define X_COD 1
#define X_DIM 2
#define X_OFF 4
#define X_XCOD 8
extern float c_realgt();
extern int khoros_mode;

rdfmg_(gfmt,iopt)
register struct nf_fmt *gfmt;
register Fort_int *iopt;
{
	register ibs, i, isig;
	register iexp;
	if(*iopt <= 0) return 1 /* makes c99 happy */; 
	if(optfmt_(gfmt,iopt) != 0) return 1 /* makes c99 happy */; 
#ifdef NONINTERACTIF
	imerror(9,"vous devez donner des options de format\n");
#else
	if(khoros_mode)
		imerror(9,"missing image format options\n");
	if(*iopt & X_DIM) {  /* dimensions */
		c_intch(0,"dimx, dimy, dimv, dimz (0 eq 1) ",1,4,&gfmt->NDIMX);
		for(i=4;i<8;i++) {
			if(gfmt->lfmt[i] == 0)
				gfmt->lfmt[i] = 1;
		}
		gfmt->DIMX = gfmt->NDIMX * gfmt->NDIMV;
		gfmt->DIMY = gfmt->NDIMY * gfmt->NDIMZ;
	}
	if(*iopt & X_OFF) {  /* offsets et maille */
		c_intch(0,"X0, Y0, Z0 ",1,3,gfmt->offsets);
		gfmt->maille = c_intchk(0,"type de maille (1 = hexa) ",0,1);
	}
	if(*iopt & X_COD) {  /* codage et type */
		i = c_intchk(0,"type: -1(fix packed), 0(fix), 1(float) ",-1,1);
		if(i == REELLE) {  /* flottant */
			ibs = c_intget(0,"byte size (float ou double, 0 eq float) ");
			if(ibs == 0) ibs = sizeof(float);
			if(ibs != sizeof(float) && ibs != sizeof(double))
				imerror(9,"rdfmg: byte size incorrecte\n");
			gfmt->EXP = fl_type();
		} else {
			if(i == PACKEE) {
				/* bit size packed */
				ibs = c_intchk(0,"bit size (-32..-1) ",-32,-1);
			} else {
				/* byte size ou bit size unpacked */
				ibs = c_intchk(0,"byte size(1..4) ou bit size(-1..-32) ",-32,4);
				if(ibs == 0) ibs = 1;
			}
			isig = c_intchk(0,"avec(=1) ou sans(=0) signe ? ",0,1);
			iexp = c_intchk(1,"exposant 2**n: donner n (-100..+100) ",-100,100);
			iexp += 200;
			if(isig) iexp = -iexp;
			gfmt->EXP = iexp;
		}
		gfmt->TYPE =i;
		gfmt->BSIZE = ibs;
	}
	if(*iopt & X_XCOD && gfmt->TYPE != REELLE) {
		/* demander bias et scale */
		gfmt->bias = c_realgt(0,"biais (flottant) ");
		gfmt->scale = c_realgt(0,"facteur d'echelle (flottant, si non 0 remplace l'exposant) ");
	}
#endif /* NONINTERACTIF */
}

c_rdfmg(struct nf_fmt *gfmt, Fort_int iopt) {
  rdfmg_(gfmt,&iopt);
}
 
