/*  trtblb
	SUBROUTINE TRTBLB(A,NDIMA,IXA,B,NDIMB,IXB,NPOIN,NLIG,IBS)
	trtblb_(a,ndima,ixa,b,ndimb,ixb,npoin,nlig,ibs)
	c_trtblb(a,ndima,ixa,b,ndimb,ixb,npoin,nlig,ibs)

  transfere une fenetre du tableau A dans une fenetre de B

 IBS= bit size (nb bits pour stocker 1 point)
 NDIMA et NDIMB = longueur des lignes (nb de points) de A et B.
 IXA et IXB= indices (>= 1) du premier point de la fenetre dans A et B
 NPOIN=nb points/lignes fenetre
 NLIG=nb lignes fenetre.
*/
#include <inrimage/image.h>

trtblb_(a,ndima,ixa,b,ndimb,ixb,npoin,nlig,ibs)
char *a, *b;
Fort_int *ndima, *ixa, *ndimb, *ixb, *npoin, *nlig, *ibs;
{
	c_trtblb(a,(int)*ndima,(int)*ixa,b,(int)*ndimb,(int)*ixb,(int)*npoin,(int)*nlig,(int)*ibs);
}

c_trtblb(in,ndimi,ixi,out,ndimo,ixo,npoin,nlig,ibs)
unsigned char *in, *out;
int ndimi, ixi, ndimo, ixo, npoin, nlig, ibs;
{
	register unsigned int *pli, *plo;
	char *p1, *p2;
	register jxi, jxo, ipa, ipb, id;
	register i, j;
	int nbit;
	/* ramener a partir de 0 */
	ixi--;
	ixo--;
	p1 = (char *)in + ((ixi * ibs + 7) / 8);
	p2 = (char *)out + ((ixo * ibs + 7) / 8);
	if(ibs <= 0 || (ibs > 32 && ibs != 64))
		imerror(9,"trtblb: bad bit size (%d)\n",ibs);
	if(ibs >= 32) {  /* 32 or 64 bits */
		ipa = ndimi - npoin;
		ipb = ndimo - npoin;
		if(p1 >= p2) { /* commencer par le debut */
			jxi = ixi;
			jxo = ixo;
			id = 1;
		} else {  /* par la fin */
			jxi = ixi + (nlig -1) * ndimi + npoin -1;
			jxo = ixo + (nlig -1) * ndimo + npoin -1;
			id = -1;
			ipa = -ipa;
			ipb = -ipb;
		}
		if(ibs == 64) {
			npoin *= 2;
			jxi = 2 * jxi + 1;
			jxo = 2 * jxo + 1;
			ipa *= 2;
			ipb *= 2;
		}
		pli = (unsigned int *)in + jxi;
		plo = (unsigned int *)out + jxo;
		for(i=0;i<nlig;i++) {
			for(j=0;j<npoin;j++) {
				*plo = *pli;
				plo += id;
				pli += id;
			}
			plo += ipb;
			pli += ipa;
		}
		return 1 /* makes c99 happy */; 
	}
	/* cas general */
	nbit = npoin * ibs;
	jxi = ixi * ibs;
	jxo = ixo * ibs;
	ipa = ndimi * ibs;
	ipb = ndimo * ibs;
	if(p1 < p2) { /* commencer par la fin */
		i = (nlig -1) * ibs;
		jxi += i * ndimi;
		jxo += i * ndimo;
		ipa = -ipa;
		ipb = -ipb;
	}
	for(i=0;i<nlig;i++) {
		c_mvbits(in,out,jxi+1,jxo+1,nbit);
		jxi += ipa;
		jxo += ipb;
	}
	return 1 /* makes c99 happy */; 
}
