/*
  int tstopts()
  int tstoptm()
  int tstnbopts()
  int testopt()
  int gtstopts(ign_imag,ign_dim,ign_cod);
  extern char *inr_erropts;
  
  toutes ces fonctions  ignorent les options '-F=' et '-hdr='

  tstopts : retourne 1 si reste des options non utilisees, 0 sinon
  tstoptm ne teste que les options qui ne sont pas des noms (commencant par - ou un chiffre)
  tstnbopts() renvoie le nb d'options non reconnues
  testopt : idem tstopts, mais renvoie 0 s'il reste des options , 1 sinon
  gtstopts : renvoie le nb options non utilisee en ignorant
    les options indiquees par les flags
   On trouvera dans inr_erropts un message avec la liste des options non
   reconnues.
*/
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <inrimage/image.h>
#include <inrimage/inrlocal.h>

extern debug_;
extern int inr_xargc;
extern char **inr_xargv;
extern int khoros_mode;

#define LG_ERR 512
static char erropts[LG_ERR];
char *inr_erropts= erropts;
static int lg_erropts;

struct tb_opts {
	char *name;
	int lg_op;  /* lgr option si arg colle' */
	int nbsubop; /* nb options a suivre */
};
static struct tb_opts dim_opts[]= {
	{"-x",0,1},
	{"-y",0,1},
	{"-v",0,1},
	{"-z",0,1},
	{"-m=",3,1},
	{"-x0",0,1},
	{"-y0",0,1},
	{"-z0",0,1},
};
static struct tb_opts cod_opts[]= {
	{"-f",0,0},
	{"-p",0,0},
	{"-r",0,0},
	{"-s",0,0},
	{"-o",0,1},
	{"-b",0,1},
	{"-e",0,1},
	{"-imbi",0,1},
	{"-imsc",0,1},
};
static struct tb_opts khcod_opts[]= {
	{"-codtyp",0,1},
	{"-s",0,0},
	{"-o",0,1},
	{"-b",0,1},
	{"-e",0,1},
	{"-imbi",0,1},
	{"-imsc",0,1},
};
#define NB_CODOPT (sizeof(cod_opts) / sizeof(struct tb_opts))
static short nb_codopts[NB_CODOPT];
#define NB_KHCODOPT (sizeof(khcod_opts) / sizeof(struct tb_opts))
static short nb_khcodopts[NB_KHCODOPT];
#define NB_DIMOPT (sizeof(dim_opts) / sizeof(struct tb_opts))
static short nb_dimopts[NB_DIMOPT];

static int chk_dim_cod();

int tstopts()
{
	if(gtstopts(0,0,0))
		return 1;
	return 0;
}

int tstoptm()
{
	if(gtstopts(1,0,0))
		return 1;
	return 0;
}

int tstnbopts()
{
	return gtstopts(0,0,0);
}

int testopt()
{
	if(gtstopts(0,0,0))
		return 0;
	return 1;
}

#if 0
/* ne teste pas les noms d'images si all == 0
renvoie le nb d'options restantes si all < 0
*/
static int chk_opts(all)
register all;
{
	register i, ist;
	register char *p;
	ist = 0;
	for(i=1;i<inr_xargc;i++) {
		if((p = inr_xargv[i]) != (char *)0)  {
			if(*p++ == '-') {
				if(*p == 0) {
					if(all == 0)
						continue;
					ist++;
					if(all > 0)
						break;
					continue;
				}
				if(*p == 'F') {
					if(*(p+1) != '=') {
						ist++;
						if(all < 0)
							continue;
						break;
					} else if(khoros_mode){
						/* sauter arg suivant si khoros*/
						i++;
					}

					continue;
				}
#ifdef INR_KHOROS
				if(khoros_mode && (all == 0)) {
					if((*p == 'i') || (*p == 'o')) {
						if(isdigit(*(p+1))) {
							i++;
							continue;
						}
					}
				}
#endif
				if(*p++ != 'h') {
					ist++;
					if(all < 0)
						continue;
					break;
				}
				if(*p != 'd' || *(p+1) != 'r' || *(p+2) != '=') {
					ist++;
					if(all < 0)
						continue;
					break;
				}
				continue;
			} else if(all == 0) {
				if(!(isdigit(*(p-1))))
					continue;
			}
			ist++;
			if(all < 0)
				continue;
			break;
		}
	}
	if(ist && debug_) {
		if(all >= 0)
			fprintf(stderr,"%s:%s option non reconnue\n",inr_xargv[0],inr_xargv[i]);
		else
			fprintf(stderr,"%s: reste %d option(s)\n",inr_xargv[0],ist);
	}
	return ist;
}

#endif
/* i = indice dans xargv, n = nb arg supplementaires */
static int add_erropt(i,n)
register i, n;
{
	register lg;
	register j;
	register char *p;
	if(n < 0) {
		n = 0;
	} else if(khoros_mode) {
		n = 1;
	}
	while (n-- >= 0) {
		if((p = inr_xargv[i++]) == NULL) continue;
		lg = strlen(p);
		if((lg + lg_erropts) >= (LG_ERR -2)) return -1;
		erropts[lg_erropts++] = ' ';
		strcpy(&erropts[lg_erropts],p);
		lg_erropts += lg;
		erropts[lg_erropts] = 0;
		if(i >= inr_xargc) break;
	}
	return 0;
}

/* renvoie nb options non utilisees.
 compose un message d'erreur dans le tableau pointe par inr_erropts
ign_file != 0 : ignore les options ne commencant ni par - ni par chiffre 
ign_dim != 0 : ignore les options de dimension
ign_cod != 0 : ignore les options de codage
Ignorent les options '-F=' et '-hdr='
*/

int gtstopts(ign_file,ign_dim,ign_cod)
register ign_file, ign_dim, ign_cod;
{
	register ist, i, n, j;
	register char *p;
	int nbF, nbh;
	ist = 0;
	lg_erropts = 0;
	erropts[0] = 0;
	nbF = 0; nbh = 0;
	for(i=1;i<inr_xargc;i++) {
		if((p = inr_xargv[i]) != (char *)0)  {
			/* ignore -F et -hdr */
			if(strncmp(p,"-F=",3) == 0) {
				if(nbF) {
					ist++;
					add_erropt(i,0);
				}
				nbF++;
				if(khoros_mode) i++;  /* sauter arg suivant */
				continue;
			}
			if(strncmp(p,"-hdr=",5) == 0) {
				if(nbh) {  /* 1 seule option */
					ist++;
					add_erropt(i,0);
				}
				nbh++;
				if(khoros_mode) i++;  /* sauter arg suivant */
				continue;
			}
			if(ign_file) {
				if(!khoros_mode && (*p == '-') && (*(p+1) == 0))
					continue;
				if(khoros_mode) {
					if((*p == '-') && ((*(p+1) == 'i') || (*(p+1) == 'o'))) {
						if(isdigit(*(p+2))) {
							i++;
							continue;
						}
					}
				} else if((*p != '-') && !isdigit(*p)) 
					continue;

			}
			if(*p != '-') {
				ist++;
				add_erropt(i,-1);
				continue;
			}
			j = 0;
			if(ign_dim) {
				if((j = chk_dim_cod(dim_opts,nb_dimopts,NB_DIMOPT,i))) {
					if(j < 0) {
						ist++;
						j = -j;
					}
					i += j - 1;
					continue;
				}
			}
			if(ign_cod && !j) {
				if(khoros_mode)
					j = chk_dim_cod(khcod_opts,nb_khcodopts,NB_KHCODOPT,i);
				else
					j = chk_dim_cod(cod_opts,nb_codopts,NB_CODOPT,i);
				if(j) {
					if(j < 0) {
						ist++;
						j = -j;
					}
					i += j - 1;
					continue;
				}
			}
			ist++;
			add_erropt(i,-1);
		}
	}
	return ist;
}

/* retour 0 si pas trouve,
+n si trouve et sauter n-1 arg
-n si trouve 2e fois et sauter -n -1 arg.
*/
static int chk_dim_cod(ptb,pnb,n,ixarg)
register struct tb_opts *ptb;
register n;
int ixarg;
register short *pnb;
{
	register j, lg, stat, i;
	register res;
	res = 0;
	i = ixarg;
	for(j=0;j<n;j++) {
		lg = ptb->lg_op;
		if(!khoros_mode && (lg > 0))
			stat = strncmp(ptb->name,inr_xargv[i],lg);
		else
			stat = strcmp(ptb->name,inr_xargv[i]);
		if(stat == 0) {
			if(*pnb) {
				res = -1;
			} else {
				*pnb += 1;
				res = 1;
			}
			break;
		}
		ptb++;
		pnb++;
	}
	if(res == 0) return 0;
	lg = khoros_mode ? 2 : ptb->nbsubop +1;
	for(j=1;j<lg;j++) {
		i++;
		if(i >= inr_xargc) {
			res = -1;
			break;
		}
		if(inr_xargv[i] == NULL) {
			res = -1;
			break;
		}
	}
	if(res < 0) {
		add_erropt(ixarg,ptb->nbsubop);
		return (-lg);
	}
	return lg;
}
