#include <stdio.h>
/* lit des lignes de coord x, y et genere les ordres ##!draw
X,Y codes en flottant, comptees a partir de 0
ligne contenant - de 2 float : fin de contour
chg de plan par une ligne 
z n
placee AVANT les contours du plan.
n entier, >= 1
z n  => cmde ##!upleft(1,1,z)
Une ligne commenant par C donne la couleur : rr[/gg[/bb]]
*/

int flg_dble, xcol[3]= {255,255,255};
int black[3] = {0};
int flg_ed, flg_cp, flg_newz;
int flg_point;
#define NBMAX 16*1024
int tbx[NBMAX], tby[NBMAX];
int oldtbx[NBMAX], oldtby[NBMAX];
int nbpts, oldnbpts;
float base= .5;
char filename[256];
int nbfiles;
FILE *ifile;
int z0= 1;

static char Ucmd[]=
"[-ed] [-p] [-a] [-b1] [-c rr[/gg[/bb]]] [-z n] [file1 .. filen]";
static char Udetail[]= 
" Trace de lignes polygonales ou de points\n\
\t-p : trace en mode point\n\
\t-a : animation (on efface le trace precedent)\n\
\t-ed : utiliser le mode edit (incompatible avec -a)\n\
\t-c rr/gg/bb : couleur du trace, si rr<0 trace avec fonction XOR\n\
\t-z n : numero du plan (>= 1)\n\
\t-b1 : les coord. sont donnees a partir de 1 et non de 0\n\
";

struct ops {
	int (*init)();
	int (*end)();
	int (*setcol)();
	int (*setz)();
	int (*line)();
	int (*point)();
	int (*rect)();
	int (*polyline)();
};

struct ops *ptops;

extern int xved_init(), xved_end(), xved_setcol(), xved_setz(), xved_line();
extern int xved_point(), xved_rect(), xved_polyline();
extern int xvdraw_init(), xvdraw_end(), xvdraw_setcol(), xvdraw_setz(), xvdraw_line();
extern int xvdraw_point(), xvdraw_rect(), xvdraw_polyline();
int no_op();

struct ops op_ed= {
	xved_init, xved_end, xved_setcol, xved_setz, xved_line, xved_point,
	xved_rect, xved_polyline};
struct ops op_draw= {
	xvdraw_init, xvdraw_end, xvdraw_setcol, xvdraw_setz, xvdraw_line, xvdraw_point,
	no_op, xvdraw_polyline};

main(argc,argv)
int argc;
char **argv;
{
	register ist, first, i;
	register char **pf;
	char tmpbuf[255];
	initopts(argc,argv);
	flg_cp = flg_dble = 0;
	kdopts_();
	flg_point = igetopt0("-p");
	if (igetopt("-c","",0,"%s",tmpbuf,"",0)) {
	  i = sscanf(tmpbuf,"%d/%d/%d",&xcol[0],&xcol[1],&xcol[2]);
	  if(i < 2)
	    xcol[1] = xcol[0];
	  if(i < 3)
	    xcol[2] = xcol[1];
	}
	igetopt("-z","",0,"%d",&z0,"",0);
	z0--;
	if(z0 < 0)
		z0 = 0;
	if(!(flg_ed = igetopt("-ed","",0,"",0,"",0))) {
		if(flg_cp = igetopt("-a","",0,"",0,"",0))
			flg_dble = 1;
	}
	if(igetopt("-b1","",0,"",0,"",0)) 
		base = -.5;
	if(tstoptm())
		iusage_(Ucmd,Udetail);
	nbfiles = 0;
	nbfiles = igetopt("","%s",filename,"",0,"",0);
	if(!nbfiles)
		ifile = stdin;
	ptops = flg_ed ? &op_ed : &op_draw;
	ptops->init(flg_cp);
	ptops->setcol(xcol);
	ptops->setz(z0);
	first = 1;
	ist = 0;
	while(1) {
		if((nbfiles < 0) && !ist) {
			ptops->end();
			return 1 /* makes c99 happy */; 
		}
		if((nbfiles > 0) && !ist) {
			ifile = fopen(filename,"r");
			if(!igetopt("","%s",filename,"",0,"",0))
				nbfiles = -1;
		}
		ist = readdata();
		if(ist || (ist == 0 && nbfiles != 0)) {
			if(flg_dble && !first) {
				if(xcol[0] >= 0)
					ptops->setcol(black);
				redraw();
			} else 
				first = 0;
			ptops->init(flg_cp);
			ptops->setcol(xcol);
			ptops->setz(z0);
		}
		if(flg_newz) {
			printf("##!upleft(1,1,%d)\n",z0+1);
			fflush(stdout);
		}
		draw1(0);
		if(ist == 0) {
			if(nbfiles != 0)
				fclose(ifile);
			else
				break;
		}
		savetb();
	}
	if(flg_dble) {
		if(xcol[0] >= 0)
			ptops->setcol(black);
		draw1(1);
	}
	ptops->end();
}

static int norm_col(int x) {
  if(x < 0) 
    x = 0; 
  else 
    if (x > 255) 
      x = 255;
  return x;
}

readdata()
{
	float v1, v2;
	register x;
	char buf[80];
	register i, n, z;
	int val1, val2, val3;
	i = 0;
	flg_newz = 0;
	while (fgets(buf,80,ifile) != 0) {
		if((n = sscanf(buf,"%f %f",&v1,&v2)) != 2) {
			if(n < 0)
				continue;
			if(buf[0] == 'z' && i == 0) {
				if(sscanf(buf,"z %d",&val1) == 1) {
					z = val1 -1;
					if(z < 0)
						fprintf(stderr,"bad z value : %d\n",val1);
					else if(z != z0) {
						z0 = z;
						flg_newz = 1;
					}
					continue;
				}
			} else if(buf[0] == 'C' && i == 0) {
			  if((n = sscanf(buf,"C %d/%d/%d",&val1,&val2,&val3))> 0) {
			    if(n < 2)
			      val2 = val1;
			    if(n < 3)
			      val3 = val2;
			    xcol[0] = norm_col(val1);
			    xcol[1] = norm_col(val2);
			    xcol[2] = norm_col(val3);
			    ptops->setcol(xcol);
			  }
			  continue;
			}
			if(i == 0)
				continue;
			nbpts = i;
			return 1;
		}
		if(v1 < 0. || v2 < 0.) {
			fprintf(stderr,"negative value ignored\n");
			continue;
		}
		if((x = (int)(v1 + base)) < 0)
			x = 0;
		tbx[i] = x;
		if((x = (int)(v2 + base)) < 0)
			x = 0;
		tby[i] = x;
		i++;
		if(i >= NBMAX)
			imerror(8,"depassement taille buffer\n");
	}
	nbpts = i;
	return 0;
}


draw1(flg2)
register flg2;  /* 1 si redraw */
{
	register i;
	if(flg_point) {
		for(i=0;i< nbpts;i++) 
			ptops->point(tbx[i],tby[i]);
	} else {
		ptops->polyline(tbx,tby,nbpts);
	}
	if(flg_cp && !flg2) {
		printf("##!draw(s 1 1 %d -1 -1 1)\n",z0+1);
	}
	fflush(stdout);
}
redraw()
{
	register i;
	if(!flg_newz) {
		if(flg_point) {
			for(i=0;i< nbpts;i++) 
				ptops->point(tbx[i],tby[i]);
		} else {
			ptops->polyline(oldtbx,oldtby,oldnbpts);
		}
	}
	fflush(stdout);
}
savetb()
{
	register i;
	for(i=0;i<nbpts;i++) {
		oldtbx[i] = tbx[i];
		oldtby[i] = tby[i];
	}
	oldnbpts = nbpts;
}

int no_op()
{
}
