/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

/* Version pour Xvis */
/* programme qui parcourt les points d'une image en 2**n par un chemin
   qui passe par tous les points et 1 seule fois
(courbe de Peano)
H(d,c,n)  : n = ordre (carre de cote 2**n)
	d=direction, c=cote : 4 valeurs Haut, Bas, Droite, Gauche

H(d,c,n) =H(c,d,n-1);TRace(c);H(d,c,n-1);TR(d);H(d,c,n-1)
          TR(inv(c)); H(inv(c),inv(d),1)
avec inv(Haut)=Bas, etc
H(B,D,1) =>  	0-->-1   H(B,D,2) x    x----x----x
		     |		  |    |         |
		     |		  |    |         |
		3--<-2		  x----x    x----x
					    |
					    |
				  x----x    x----x
				  |    |         |
				  |    |         |
				  x    x----x----x
*/
#include <stdio.h>
#include <stdlib.h>
#include <inrimage/image.h>

#define UP 1
#define DOWN -1
#define RIGHT 2
#define LEFT -2
#define INV(x) (-x)
static int ix, iy;
int ordre, d_ordre;
static int f_zoom= 0;
static int incx[5] = {-1,0,0,0,1};
static int incy[5]= {0,1,0,-1,0};
extern errno;
static int (*itrmin)();
int Trmin(), Trmin0(), Trmin1(), Trmin2();
static unsigned char *bufi;
static unsigned long *bufo;
static unsigned char *cbufo;
static int som;
#define MAXS 255
struct incxyi {
	short icx, icy;
	int ici;
	int icix;
};
static struct incxyi *ltbl[5], *dtbl[5], *utbl[5], *rtbl[5];

static struct incxyi **dirtbl[5]= {
	ltbl, dtbl, 0, utbl, rtbl};
#define O_MIN 3
static int o_min;
static int sz_min, o_dim;
static struct incxyi *pt0;

static int dimxi, dimyi, dimxo, dimyo, xdimxo;


#define Tr(x) { ix += incx[x+2]; iy += incy[x+2];}
#define Tr0(x) { pt0->icx = incx[x+2]; pt0->icy = incy[x+2]; pt0++;}

#define MAX(x,y) (x < y ? y : x)

/* construit l'image de bits . buf = input buffer.
resultat dans bufo */
ipeano(buf)
register unsigned char *buf;
{
	bufi = buf;
	if((som = *buf) >= MAXS) {
		som -= MAXS;
		*cbufo = 0x7f;
	}
	ix = iy = 0;
	hilb(DOWN,RIGHT,ordre);
}

/*  initialise lfmto a partir de lfmt (input) et du facteur de zoom fz
alloue le buffer bitmap et renvoie son adresse
initialise les 8 tables d'ordre minimum */
static struct incxyi *pxy= 0;

init_peano(fz,lfmt,lfmto)
int fz;
Fort_int lfmt[9], lfmto[9];
{
	register n, i;
	register struct incxyi *p;
	f_zoom = fz;
	if(f_zoom == 0) f_zoom = 1;
	if(f_zoom < 0 || f_zoom > 8) xerr("zoom trop grand!");
	lfmto[0] = lfmt[0] * f_zoom;
	lfmto[1] = lfmt[1] * f_zoom;
	lfmto[4] = lfmt[4] * f_zoom;
	lfmto[5] = lfmt[5] * f_zoom;
	lfmto[6] = lfmt[6];
	lfmto[7] = lfmt[7];
	lfmto[2] = lfmto[3] = -1;
	dimxi = lfmt[0];
	dimyi = lfmt[5];
	dimxo = lfmto[0];
	dimyo = lfmto[5];
	xdimxo = (dimxo + 15) & ~15;
	ordre = getordre(MAX(dimxi,dimyi) * f_zoom);
	d_ordre = 1 << ordre;

	if(ordre >= O_MIN) o_min = O_MIN;
	else o_min = 1;
	sz_min = 1 << o_min;
	o_dim = sz_min * sz_min;
	n = o_dim * sizeof(struct incxyi);
	i_Free((char **)&pxy); 
	pxy = (struct incxyi *)i_malloc(8 * n);
	p = pxy;
	inittb1(p,UP,RIGHT);
	p += o_dim;
	inittb1(p,UP,LEFT);
	p += o_dim;
	inittb1(p,DOWN,RIGHT);
	p += o_dim;
	inittb1(p,DOWN,LEFT);
	p += o_dim;
	inittb1(p,RIGHT,UP);
	p += o_dim;
	inittb1(p,RIGHT,DOWN);
	p += o_dim;
	inittb1(p,LEFT,UP);
	p += o_dim;
	inittb1(p,LEFT,DOWN);
	switch(f_zoom) {
	case 1:
		if(dimxi == d_ordre && dimyi == d_ordre)
			itrmin = Trmin0;
		else
			itrmin = Trmin1;
		break;
	case 2:
		itrmin = Trmin2;
		break;
	default:
		itrmin = Trmin;
	}
}

zb_peano(buf)
unsigned long *buf;
{
	register n, i;
	n = ((xdimxo * dimyo) + 31) >> 5;
	bufo = (unsigned long *) buf;
	cbufo = (unsigned char *) bufo;
	for(i=0;i<n;i++)
		*(bufo + i) = 0xffffffff;
}

inittb1(p,d,c)
register struct incxyi *p;
register d, c;
{
	register struct incxyi **pp;
	register i, i0, i1;
	pp = dirtbl[d + 2];
	*(pp + (c + 2)) = p;
	pt0 = p;
	pt0->icx = 0;
	pt0->icy = 0;
	pt0->ici = 0;
	pt0->icix = 0;
	pt0++;
	hilb0(d,c,o_min);
	i = o_dim -1;
	i0= 0;
	i1 = 0;
	p->ici = 0;
	p++->icix = 0;
	while(i > 0) {
		i--;
		i0 += (p->icy * dimxo) + p->icx;
		i1 += (p->icy * xdimxo) + p->icx;
		p->ici = i0;
		p++->icix = i1;
	}
}

hilb0(d,c,n)
register d,c,n;
{
	if(n == 0) return 1 /* makes c99 happy */; 
	n--;
	hilb0(c,d,n);
	Tr0(c);
	hilb0(d,c,n);
	Tr0(d);
	hilb0(d,c,n);
	Tr0(INV(c));
	hilb0(INV(c),INV(d),n);
}

hilb(d,c,n)
register d,c,n;
{
	if(n <= o_min) {
		(*itrmin)(d,c);
		return 1 /* makes c99 happy */; 
	}
	n--;
	hilb(c,d,n);
	Tr(c);
	hilb(d,c,n);
	Tr(d);
	hilb(d,c,n);
	Tr(INV(c));
	hilb(INV(c),INV(d),n);
}

getordre(n)
register n;
{
	register i, x;
	x = n;
	i = 0;
	while ((x >>= 1) > 0) {
		i++;
	}
	if( (1 << i) < n) i++;
	return i;
}

int Trmin(d,c)
int d,c;
{
	register struct incxyi *p;
	register  s, ixx, iyy;
	register i;
	register i0;
	int j;
	p = *(dirtbl[d+2] + c + 2);
	j = o_dim;
	ixx = ix;
	iyy = iy;
	s = som;
	i0 = iyy * xdimxo + ixx;
	while(j > 0) {
		j--;
		ixx += p->icx;
		iyy += p->icy;
		if(ixx < dimxo && iyy < dimyo) {
			i = i0 + p->icix;
			if((int)(s += *(bufi + ((iyy / f_zoom) * dimxi + (ixx / f_zoom)))) >= MAXS) {
				s -= MAXS;
/*!!X10				*(cbufo + (i >> 3)) |= (1 << (i & 0x7)); */
				*(cbufo + (i >> 3)) &= ~((unsigned char)0x80 >> (i & 0x7));
			}
		}
		p++;
	}
	ix = ixx;
	iy = iyy;
	som = s;
	return 0;
}

int Trmin0(d,c)
int d,c;
{
	register struct incxyi *p;
	register  s, ixx, iyy;
	register i;
	register i0, i1;
	int j;
	p = *(dirtbl[d+2] + c + 2);
	j = o_dim;
	ixx = ix;
	iyy = iy;
	s = som;
	i0 = iyy * xdimxo + ixx;
	i1 = iyy * dimxo + ixx;
	while(j > 0) {
		j--;
		ixx += p->icx;
		iyy += p->icy;
		i = i0 + p->icix;
		if((int)(s += *(bufi + i1 + p->ici)) >= MAXS) {
			s -= MAXS;
/*!!X10				*(cbufo + (i >> 4)) |= (1 << (i & 0xf)); */
				*(cbufo + (i >> 3)) &= ~((unsigned char)0x80 >> (i & 0x7));
		}
		p++;
	}
	ix = ixx;
	iy = iyy;
	som = s;
	return 0;
}

int Trmin1(d,c)
int d,c;
{
	register struct incxyi *p;
	register  s, ixx, iyy;
	register i;
	register i0, i1;
	int j;
	p = *(dirtbl[d+2] + c + 2);
	j = o_dim;
	ixx = ix;
	iyy = iy;
	s = som;
	i0 = iyy * xdimxo + ixx;
	i1 = iyy * dimxo + ixx;
	while(j > 0) {
		j--;
		ixx += p->icx;
		iyy += p->icy;
		if(ixx < dimxo && iyy < dimyo) {
			i = i0 + p->icix;
			if((int)(s += *(bufi + i1 + p->ici)) >= MAXS) {
				s -= MAXS;
/*!!X10				*(cbufo + (i >> 4)) |= (1 << (i & 0xf)); */
				*(cbufo + (i >> 3)) &= ~((unsigned char)0x80 >> (i & 0x7));
			}
		}
		p++;
	}
	ix = ixx;
	iy = iyy;
	som = s;
	return 0;
}

int Trmin2(d,c)
int d,c;
{
	register struct incxyi *p;
	register  s, ixx, iyy;
	register i;
	register i0;
	int j;
	p = *(dirtbl[d+2] + c + 2);
	j = o_dim;
	ixx = ix;
	iyy = iy;
	s = som;
	i0 = iyy * xdimxo + ixx;
	while(j > 0) {
		j--;
		ixx += p->icx;
		iyy += p->icy;
		if(ixx < dimxo && iyy < dimyo) {
			i = i0 + p->icix;
			if((int)(s += *(bufi + ((iyy >> 1) * dimxi + (ixx >> 1)))) >= MAXS) {
				s -= MAXS;
/*!!X10				*(cbufo + (i >> 4)) |= (1 << (i & 0xf)); */
				*(cbufo + (i >> 3)) &= ~((unsigned char)0x80 >> (i & 0x7));
			}
		}
		p++;
	}
	ix = ixx;
	iy = iyy;
	som = s;
	return 0;
}


xerr(str)
register char *str;
{
	fprintf(stderr,"%s %d\n",str,errno);
	exit(1);
}

