/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/X.h>
#include <X11/Shell.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Dialog.h>
#include <inrimage/image.h>
#include "xvis.h"
#include "xvcolors.h"
#include "xvglobl.h"
#include "xvxglobl.h"



Widget cmap_actions, cmap_pts, cmap_actions, cmap_files, cmap_ifile, cmap_ofile;
Widget cmap_mire, cmapview_mire;
Widget cmap_opt_actions, cmap_opt_pts, cmap_pos_lab;
Widget cmap_btn_actions, cmap_btn_pts;
Widget cmap_bbox;
Widget cmap_shell= 0, cmap_child, cmap_box;
unsigned char tab_p1[8], tab_p2[8]= {255,255,255,255,255,255,255,255}, tab_delta[4];
Pixmap pix_mire= 0;
Window W_mire;

extern int XV_simul;
extern char tcfile[];
static char tcoutfile[80];
static void exp_mire(), coord_mire();

extern unsigned long blackpixel, whitepixel;
extern int ncolor;
extern int cmap_type;
extern int imin_tc, imax_tc;
extern unsigned char **pp_X_ct, **pp_cur_ct, **pp_mask_ct, **pp_sc_ct, **pp_cur_sc, *p_cts[];
extern short shft_val[];
unsigned char msk_x1[3]= {0,0,0}, msk_x2[3]= {0,0,0};
unsigned char msk_y[3]= {0,0,0}, msk_l[3]= {0,0,0};  /* destination orig and lgr */

extern int truecol_type;
extern struct image *nfcolor;
extern int loop_mode;
extern char **ptim;
extern unsigned char xtrans[];
extern struct trans_pix trans_pix[MAXTRANS];
extern int nb_trans_pix;


extern struct button *b_list[];

#define OP_INTERP 0
#define OP_POLY4 1
#define OP_SET1 2
#define OP_SET2 3

int scale_tc= 0;   /* scale ct RGB si + 1, 2, 4 */
static int flg_scale= B_RGB;  /* which table to scale */
static int flg_auto= 1, flg_on= 1, flg_pts= B_RGB, flg_actions= B_RGB;
static int flg_mask = 0;
static int last_op= OP_POLY4, last_shft= 0;
static int flg_autopt= 0; /* 2; */

extern int flg_c254;
extern int pixmin, pixmax;

int flg_cmap_pick = 0;
#define PICK_PIX 1
#define PICK_RGB 2
#define PICK_ALL (PICK_PIX | PICK_RGB)

static char *rgblab[]= {
	"R","G","B","Br","MASK","Brightness","pick","Auto-Set"};
#define I_MASK 4
#define I_PICK 6
#define I_SCALE 5
static Widget wbtn_actions[5], wbtn_pts[6], wbtn_scale[4];

int xvct_menu();
struct menu_item ct_menulist[]= {
	{"from image",CMAP_IMAGE},
	{"from file",CMAP_FILE},
	{"grey",CMAP_LIN},
	{"current",CMAP_CURR},
	{"previous",CMAP_PREV},
	{"table1",CMAP_TAB1},
	{"table2",CMAP_TAB2},
	{"random",CMAP_RAND},
	{"random+",CMAP_XRAND},
	{"editG",CMAP_ED},
	{"editR",CMAP_ED | CMAP_EDR},
};
struct xvmenu ct_menu= {
	"ctype","","",xvct_menu,sizeof(ct_menulist)/sizeof(struct menu_item),ct_menulist,NULL};

int xvct_order();
struct menu_item ct_orderlist[]= {
	{"RGB",0},
	{"RBG",1},
	{"GRB",2},
	{"GBR",3},
	{"BRG",4},
	{"BGR",5},
};
struct xvmenu ct_order= {
	"ctorder","","ordre: ",xvct_order,sizeof(ct_orderlist)/sizeof(struct menu_item),ct_orderlist,NULL};

int ix_ctorder;
static short tab_ctorder[6]= {0x012, 0x021, 0x102, 0x120, 0x201, 0x210};

int bct_cancel(), bct_apply(), bct_auto(), bct_pick(), bct_save(), bct_loop();
struct button cmapbtn[]= {
	{0,"quit",bct_cancel,NULL,0,0,0,0,0},
	{0,"apply",bct_apply,NULL,0,0,0,0,0},
	{0,"auto",bct_auto,NULL,0,0,0,0,(long *)-1},
	{0,NULL,NULL,NULL,0,0,0,0,(long *)&ct_menu},
	{0,NULL,NULL,NULL,0,0,0,0,(long *)&ct_order},
	{0,"save",bct_save,NULL,0,0,0,0,0},
};
#define NCMAPBTN 6
#define I_CTMENU 3
#define I_CTORDER 4
#define I_CTAPPLY 1
#define I_CTAUTO 2
struct button *l_cmapbtn[]= {cmapbtn,&cmapbtn[1],&cmapbtn[2],&cmapbtn[3],&cmapbtn[4],&cmapbtn[5]};

int bct_adjust();
struct button adjbtn= {0,"Adjust",bct_adjust,NULL,0,0,0,0,0};
struct button *l_adjbtn= &adjbtn;

static XColor colors[NCOLOR+2];


static Arg args[5];
static Arg bxargs[3];

#define LGVAL 32
char redtc_value[LGVAL]= {0};
char greentc_value[LGVAL]= {0};
char bluetc_value[LGVAL]= {0};


int bct_set1(),  bct_set2(), bct_interp(), bct_poly4(), bct_invert(), bct_reverse();
int bct_on();
int bct_scrgb(), bct_flpts(), bct_actions();
int bct_rshft(), bct_lshft(), bct_0shft(), bct_rrot(), bct_lrot();
/*!!int bct_pix1(), bct_pix2(), bct_rgb1(), bct_rgb2(), bct_delta(); */
/* boutons des tables */
struct proto_btn {
	char *lab;
	int (*but_evnt)();
	char **hlpmsg;      /* -1 => pas de mode help */
	int flg_txt;
} proto_tabbtn[]= {
	{"set 1",bct_set1,NULL,0},
	{"set 2",bct_set2,NULL,0},
	{"interp",bct_interp,NULL,0},
	{"interp3",bct_poly4,NULL,0},
	{"invert",bct_invert,NULL,0},
	{"reverse",bct_reverse,NULL,0},
	{"loop>>",bct_loop,NULL,-1},  /* toggle -1*/
	{"-->>",bct_rshft,NULL,0},
	{"<0>",bct_0shft,NULL,0},
	{"<<--",bct_lshft,NULL,0},
	{">-->",bct_rrot,NULL,0},
	{"<--<",bct_lrot,NULL,0},
};

#define NB_CTABBTN (sizeof(proto_tabbtn) / sizeof(struct proto_btn))

#define NCMAPBTN1 NB_CTABBTN

#if 0
struct button ctabbtn[NB_BTNS];
struct button *l_ctabbtn[NB_BTNS];
#endif
struct button cmapbtn1[NCMAPBTN1], *l_cmapbtn1[NCMAPBTN1];

struct proto_btn proto_tabbtn2[]= {
	{"pix1",NULL,NULL,1},
	{"col1",NULL,NULL,1},
	{"pix2",NULL,NULL,1},
	{"col2",NULL,NULL,1},
	{"delta",NULL,NULL,1},
	{"+/-",NULL,NULL,0},
};
#define NCMAPBTN2 (sizeof(proto_tabbtn2) / sizeof(struct proto_btn))
struct button cmapbtn2[NCMAPBTN2], *l_cmapbtn2[NCMAPBTN2];
#define I_PIX1 0
#define I_RGB1 1
#define I_PIX2 2
#define I_RGB2 3
#define I_DELTA 4
#define I_SCPIX2 5

#define NBTXTS (NCMAPBTN2 -1)
static unsigned char tab_txts[NBTXTS * TAB_TXT1];
static unsigned char pos_label[TAB_TXT1]= {0};

static char btntxtTrans[]= 
"~Shift <Btn1Down>: set()\n\
~Shift <Btn1Up>: txt_btn(0) unset()\n\
Shift <Btn1Down>: set()\n\
Shift <Btn1Up>: txt_btn(1) unset()\n\
~Shift <Btn2Down>: set()\n\
~Shift <Btn2Up>: txt_btn(2) unset()\n\
Shift <Btn2Down>: set()\n\
Shift <Btn2Up>: txt_btn(3) unset()\n\
~Shift <Btn3Down>: set()\n\
~Shift <Btn3Up>: txt_btn(4) unset()\n\
Shift <Btn3Down>: set()\n\
Shift <Btn3Up>: txt_btn(5) unset()";
static XtTranslations btnparsed_trans;

static char txttxtTrans[]= 
"~Shift <Btn1Up>: txt_btn(0)\n\
Shift <Btn1Up>: txt_btn(1)\n\
~Shift <Btn2Down>: select-start()\n\
~Shift <Btn2Up>: txt_btn(2)\n\
Shift <Btn2Down>:select-start()\n\
Shift <Btn2Up>: txt_btn(3)\n\
~Shift <Btn3Down>:select-start()\n\
~Shift <Btn3Up>: txt_btn(4)\n\
Shift <Btn3Down>:select-start()\n\
Shift <Btn3Up>: txt_btn(5)\n\
<Key>Return: txt_btn(6)";
static XtTranslations txtparsed_trans;

static char btnrgbTrans[]= 
"<Btn2Down>,<Btn2Up>: toggle() rgb_btn(2)\n\
<Btn3Down>,<Btn3Up>: toggle() rgb_btn(3)";
static XtTranslations rgbparsed_trans;

init_for_colors()
{
	register unsigned char *pc, *pc2;
	register struct button *pbt;
	register struct proto_btn *pr;
	register i, j, n, nbbt;
	/* init boutons de shift */
	pbt = cmapbtn1;
	pr = proto_tabbtn;
	for(i=0;i<NCMAPBTN1;i++) {
		l_cmapbtn1[i] = pbt;
		pbt->b_text = pr->lab;
		pbt->but_evnt = pr->but_evnt;
		pbt->hlpmsg = pr->hlpmsg;
		pbt->b_inv = 0;
		if(pr->flg_txt < 0) {
			pbt->b_menu = (long *)-1;  /* toggle */
		} else
			pbt->b_menu = 0;
		pr++;
		pbt++;
	}
	pc = tab_txts;
	pbt = cmapbtn2;
	pr = proto_tabbtn2;
	for(i=0;i<NCMAPBTN2;i++) {
		l_cmapbtn2[i] = pbt;
		pbt->b_text = pr->lab;
		pbt->but_evnt = pr->but_evnt;
		pbt->hlpmsg = pr->hlpmsg;
		pbt->b_cod = i;
		pbt->b_inv = 0;
		pbt->b_menu = 0;
		if(pr->flg_txt > 0) {
			pbt->menu_item = (long)pc;
			pc += TAB_TXT1;
		}
		pr++;
		pbt++;
	}
	strput4(cmapbtn2[I_PIX1].menu_item,0,0,0,0);
	strput4(cmapbtn2[I_PIX1+1].menu_item,0,0,0,0);
	strput4(cmapbtn2[I_PIX2].menu_item,255,255,255,255);
	strput4(cmapbtn2[I_PIX2+1].menu_item,255,255,255,255);
/*!!	strput4(cmapbtn2[I_DELTA].menu_item,8,12,250,6); */
	strput4(cmapbtn2[I_DELTA].menu_item,1,1,1,1);
	strput4(pos_label,0,0,0,0);
		
	/* init table de contraste */
	pc = *pp_sc_ct;
	pc2 = *(pp_sc_ct + 1);
	for(i=0;i<NCOLOR;i++) {
		*pc++ = i;
		*pc2++ = i;
	}

#if 0
	for(i=0;i<5;i++) {
		sprintf(btntxtTrans,btntxtfmt,i,i,i,i,i);
		cmparsed_trans[i] = XtParseTranslationTable(btntxtTrans);
	}
#else
		btnparsed_trans = XtParseTranslationTable(btntxtTrans);
		txtparsed_trans = XtParseTranslationTable(txttxtTrans);
		rgbparsed_trans = XtParseTranslationTable(btnrgbTrans);
#endif
}

initcmap()
{
	register i, k;
	register whiteval;
	register XColor *pxc;
	if(!XV_simul) {
		if(flg_Xtc)
			defcmap = DefaultColormapOfScreen(screen);
		else
			defcmap = XCreateColormap(dpy,RootWindowOfScreen(screen),mydefvisual,AllocAll);
	}
	if((scrdepth != 1) && !flg_Xtc) {  /* corriger la table */
		XtSetArg(args[0], XtNcolormap, defcmap);
		XtSetArg(args[1], XtNvisual, mydefvisual);
		XtSetValues(toplevel, args, 1);
		/* define a minimum cmap, in case of err on 1st image */
		pxc = &colors[NCOLOR];
		pxc->flags = DoRed | DoGreen | DoBlue;
		pxc->pixel = whitepixel;
		pxc->red = pxc->green = pxc->blue = 0xffff;
		(pxc+1)->pixel = blackpixel;
		(pxc+1)->flags = DoRed | DoGreen | DoBlue;
		XStoreColors(dpy,defcmap,pxc,2);
	}
	if(XV_simul) return 1 /* makes c99 happy */; 
#if 0
	XQueryColors(dpy,DefaultColormapOfScreen(screen),colors,NCOLOR);
	if(!(mydefvisual->class & 1)) {
		printf("visual pb %x\n",mydefvisual->class);
		return;
	}
#endif
}


static char prev_tc_mmx[6]= {0,0,0,255,255,255};  /* RGB min et max precedents */
static int Dmin_tc= 48; /* dist min entre min et max */

xvset_tc()
{
	register i, n;
	register XColor *pxc;
	register unsigned char *pR, *pV, *pB;
	if(scrdepth == 1) return 1 /* makes c99 happy */; 
	i = tab_ctorder[ix_ctorder];
	pR = *(pp_X_ct + ((i >> 8) & 7));
	pV = *(pp_X_ct + ((i >> 4) & 7));
	pB = *(pp_X_ct + (i & 7));
	if(! flg_Xtc) {
	  xvcorr_tc(imin_tc,imax_tc);  /* corriger la table couleur */
	  xvprot_tc();  /* s'assurer qu'on distingue encore min et max */
	  pxc = colors;

	  for(i=0;i<ncolor;i++) {
	    pxc->red = *pR++ << 8;
	    pxc->green = *pV++ << 8;
	    pxc->blue = *pB++ << 8;
	    pxc->flags = DoRed | DoGreen | DoBlue;
	    pxc++;
	  }
	}
	i = 0;
	n = flg_c254 ? (ncolor + 2) : ncolor;
	if(flg_Xtc) {
	  init_mire();
	  return 1 /* makes c99 happy */; 
	}
	if(!XV_simul)
		XStoreColors(dpy,defcmap,&colors[i],n);
}

/* corrige t.c. pour black et white pixels 
imin, imax = num pixels d'intensite min et max
*/
#define mk24(x) (x | (x << 8) | (x << 16))
xvcorr_tc(imin,imax)
register imin, imax;
{
	register white, black;
	register whiteval, blackval;
	register iminval, imaxval;
	register i, k;
	register XColor *pxc;
	pxc = colors;
	if(scrdepth == 8) {
		for(i=0;i<NCOLOR;i++) {
			pxc->pixel = i;
			pxc++;
		}
	} else {
		for(i=0;i<NCOLOR;i++) {
			pxc->pixel = mk24(i);
			pxc++;
		}
	}
	if(scrdepth == 24) {
		for(i=0;i<nb_trans_pix;i++) {
			k = trans_pix[i].pix_out;
			colors[(int)trans_pix[i].pix_in].pixel = mk24(k);
		}
	} else {
		for(i=0;i<nb_trans_pix;i++) {
			colors[(int)trans_pix[i].pix_in].pixel = trans_pix[i].pix_out;
		}
	}
}

xvprot_tc()
{
	register d0, i;
	int tabd[3];
	if(flg_c254)
		return 1 /* makes c99 happy */; 
	for(i=0;i<3;i++) {
		d0 = *(*(pp_X_ct + i) + imax_tc) - *(*(pp_X_ct + i) + imin_tc);
		if(d0 < 0)
			d0 = -d0;
		tabd[i] = d0;
	}
	/* calcul luminosite' */
	d0 = (RLUM * tabd[0] + GLUM *tabd[1] + BLUM * tabd[2]) >> 8;
	if(d0 < Dmin_tc) {
		fprintf(stderr,"Cannot set colors for %d %d\n",imin_tc,imax_tc);
		for(i=0;i<3;i++) {
			*(*(pp_X_ct + i) + imin_tc) = prev_tc_mmx[i];
			*(*(pp_X_ct + i) + imax_tc) = prev_tc_mmx[i +3];
		}
	} else {
		for(i=0;i<3;i++) {
			prev_tc_mmx[i] = *(*(pp_X_ct + i) + imin_tc);
			prev_tc_mmx[i +3] = *(*(pp_X_ct + i) + imax_tc);
		}
	}
}
static unsigned long tabmsk24[] = {0xff,0xff00,0xff0000,0xff000000};

static int prep_1col24(msk)
register unsigned long msk;
{
	register i;
	for(i=0;i<4;i++) {
		if((msk & tabmsk24[i]) == tabmsk24[i]) break;
	}
	if(i >= 4) return -1;
	if(Xbyte_order != MSB_first)
		return i;
	return  (3 - i);
}
static unsigned short tabmsk16[] = {0xf800,0x7e0,0x1f};

static int prep_1col16(msk)
register unsigned long msk;
{
  register i;
  for(i=0;i<3;i++) {
    if((msk & tabmsk16[i]) == tabmsk16[i]) break;
  }
  if(i >= 3) return -1;
#if 0
  if(Xbyte_order == MSB_first)
    return i;
  return  (2 - i);
#else
  return i;
#endif
}

/* prepare Xcol_order for 16 or 24 bits true color */
void prep_col_order(depth)
int depth;
{
	register i;
	Xbyte_order = ximage->byte_order == MSBFirst ? MSB_first : 0;
	if(depth == 16) {
	  Xcol_order[C_ROUGE] = prep_1col16(ximage->red_mask);
	  Xcol_order[C_VERT] = prep_1col16(ximage->green_mask);
	  Xcol_order[C_BLEU] = prep_1col16(ximage->blue_mask);
	} else {  /* 24 bits */
	  Xcol_order[C_ROUGE] = prep_1col24(ximage->red_mask);
	  Xcol_order[C_VERT] = prep_1col24(ximage->green_mask);
	  Xcol_order[C_BLEU] = prep_1col24(ximage->blue_mask);
	}
	for(i=0;i<3;i++) {  /* en cas de pb */
	  if(Xcol_order[i] > 3)
	    Xcol_order[i] = 0;
	}
}


pop_cmap()
{
	register nc, i;
	if(cmap_shell) {  /* deja actif : kill */
		bct_cancel();
		return 1 /* makes c99 happy */; 
	}
	flg_mask = 0;
	if(flg_on)
		scale_tc = flg_scale;
	XtSetArg(args[0], XtNvisual, mydefvisual);
	XtSetArg(args[1], XtNcolormap, defcmap);
	cmap_shell = XtCreatePopupShell("xvis-cmap",topLevelShellWidgetClass,toplevel,args,2);
	cmap_child = XtCreateManagedWidget("xvcmp",panedWidgetClass,cmap_shell,args,2);
	cmap_box = XtCreateManagedWidget("xvcmapbox",boxWidgetClass,cmap_child,args,0);
	/* set correct label for type menu */
	for(i=0;i<ct_menu.nb_items;i++) {
		if((cmap_type & ct_menulist[i].val) ==  ct_menulist[i].val) {
			cmapbtn[I_CTMENU].menu_item = i;
			break;
		}
	}
	createbuttons(cmap_box,l_cmapbtn,NCMAPBTN);
	xvmanagebuttons(l_cmapbtn,NCMAPBTN);
	/* auto button */
	if(flg_auto) {
		XtSetArg(args[0],XtNsensitive,False);
		XtSetValues(cmapbtn[I_CTAPPLY].b_win,args,1);
		XtSetArg(args[0],XtNstate,True);
		XtSetValues(cmapbtn[I_CTAUTO].b_win,args,1);
	} else {
		XtSetArg(args[0],XtNsensitive,True);
		XtSetValues(cmapbtn[I_CTAPPLY].b_win,args,1);
		XtSetArg(args[0],XtNstate,False);
		XtSetValues(cmapbtn[I_CTAUTO].b_win,args,1);
	}
	XtSetArg(bxargs[0], XtNorientation,XtorientHorizontal);
	XtSetArg(bxargs[1], XtNresizable,True);
	cmap_bbox = XtCreateManagedWidget("xvcmapbbox",boxWidgetClass,cmap_box,bxargs,2);
	cr_scale_box(cmap_bbox);

	cmap_files = XtCreateManagedWidget("xvcfiles",boxWidgetClass,cmap_child,bxargs,1);
	XtSetArg(args[2], XtNresizable,True);
	XtSetArg(args[0], XtNlabel,(XtArgVal)"in file");
	XtSetArg(args[1], XtNvalue,(XtArgVal)tcfile);
	cmap_ifile = XtCreateManagedWidget("xvicfile",dialogWidgetClass,cmap_files,args,2);
	XtSetArg(args[0], XtNlabel,(XtArgVal)"out file");
	XtSetArg(args[1], XtNvalue,(XtArgVal)tcoutfile);
	cmap_ofile = XtCreateManagedWidget("xvocfile",dialogWidgetClass,cmap_files,args,2);
	cmap_actions = XtCreateManagedWidget("xvcmapactions",panedWidgetClass,cmap_child,bxargs,0);
	cmap_opt_actions = XtCreateManagedWidget("cmapoptactions",boxWidgetClass,cmap_actions,bxargs,2);
	XtSetArg(bxargs[2], XtNfromVert,(XtArgVal)cmap_opt_actions);
	cmap_btn_actions = XtCreateManagedWidget("cmapbtnactions",boxWidgetClass,cmap_actions,bxargs,3);
	cr_toggle_buttons(cmap_opt_actions,rgblab,5,flg_actions,bct_actions,wbtn_actions);
	XtSetArg(args[0], XtNlabel,(XtArgVal)pos_label);
	cmap_pos_lab = XtCreateManagedWidget("position",labelWidgetClass,cmap_opt_actions,args,1);
#if 1
	createbuttons(cmap_btn_actions,l_cmapbtn1,NCMAPBTN1);
	xvmanagebuttons(l_cmapbtn1,NCMAPBTN1);
#endif
	cmap_pts = XtCreateManagedWidget("xvcmappts",panedWidgetClass,cmap_child,bxargs,0);
	cmap_opt_pts = XtCreateManagedWidget("cmapoptpts",boxWidgetClass,cmap_pts,bxargs,2);
	XtSetArg(bxargs[2], XtNfromVert,(XtArgVal)cmap_opt_pts);
	cmap_btn_pts = XtCreateManagedWidget("cmapbtnpts",boxWidgetClass,cmap_pts,bxargs,3);
	cr_toggle_buttons(cmap_opt_pts,rgblab,4,flg_pts,bct_flpts,wbtn_pts);
	cr_toggle_buttons(cmap_opt_pts,&rgblab[I_PICK],2,flg_cmap_pick | flg_autopt,bct_pick,&wbtn_pts[4]);
	cr_tab_buttons(cmap_btn_pts,l_cmapbtn2,NBTXTS);
	if(scrdepth > 1) {
		XtSetArg(args[0], XtNallowHoriz,(XtArgVal) TRUE);
		XtSetArg(args[1], XtNallowVert,(XtArgVal) TRUE);
		cmapview_mire = XtCreateManagedWidget ("cmapview", viewportWidgetClass,cmap_child,args,2);
		XtSetArg(args[0], XtNwidth,(XtArgVal)MIRE_WIDTH);
		XtSetArg(args[1], XtNheight,(XtArgVal)MIRE_HEIGHT);
		cmap_mire = XtCreateManagedWidget ("mire", simpleWidgetClass,cmapview_mire,args,2);
		XtAddEventHandler(cmap_mire,ExposureMask ,False,exp_mire,NULL);
		XtAddEventHandler(cmap_mire,ButtonPressMask ,False,coord_mire,NULL);
	}
	/* add translations for RGB buttons of actions and pts widget */
	for(i=0;i<4;i++) {
		XtOverrideTranslations(wbtn_actions[i],rgbparsed_trans);
		XtOverrideTranslations(wbtn_pts[i],rgbparsed_trans);
	}
	XtRealizeWidget(cmap_shell);
	XtPopup(cmap_shell,XtGrabNone);
	XFlush(dpy);
	if(scrdepth > 1) {
		W_mire = XtWindow(cmap_mire);
		init_mire();
	}
}

/* create RBG buttons */
cr_scale_box(parent)
Widget parent;
{
	register struct button *pbt;
	cr_toggle_buttons(parent,&rgblab[I_SCALE],1,flg_on,bct_on,&wbtn_scale[1]);
	cr_toggle_buttons(parent,rgblab,3,flg_scale,bct_scrgb,wbtn_scale);
	createbuttons(parent,&l_adjbtn,1);
	xvmanagebuttons(&l_adjbtn,1);
	pbt = &cmapbtn2[I_SCPIX2];
	XtSetArg (args[0], XtNlabel,pbt->b_text);
	pbt->b_win = (long *) XtCreateManagedWidget (pbt->b_text, commandWidgetClass, parent,args,1);
	XtOverrideTranslations(pbt->b_win,btnparsed_trans);
	pbt->b_cod = I_PIX2;
}


int bct_cancel()
{
	register struct button *pbt;
	pbt = b_list[B_CMAP];
	XtDestroyWidget(cmap_shell);
	cmap_shell = 0;
	flg_cmap_pick = 0;
	if(loop_mode & CTLOOP)
		loop_mode ^= CTLOOP;
	if(pbt->b_win == NULL) return 1 /* makes c99 happy */; 
	XtSetArg(args[0],XtNstate,False);
	XtSetValues(pbt->b_win,args,1);
	XFlush(dpy);
}

bct_apply()
{
	pp_cur_ct = &p_cts[3];
	init_tc(scrdepth);
	xvset_tc();
}

bct_adjust()
{
	register struct button *pbt;
	register unsigned char *pc;
	ct_get_pts(0,PICK_ALL);
	ct_get_pts(1,PICK_ALL);
	tab_p1[C_SCALE] = pixmin;
	tab_p2[C_SCALE] = pixmax;
	pbt = &cmapbtn2[I_PIX1];
	wr_ct_txt(pbt,tab_p1);
	pbt = &cmapbtn2[I_PIX2];
	wr_ct_txt(pbt,tab_p2);
	force_brightness();
}

force_brightness()
{
	struct rgb_pt p1, p2;
	last_op = OP_POLY4;
	p1.pix = tab_p1[C_SCALE];
	p1.col = tab_p1[C_SCALE + 4];
	p2.pix = tab_p2[C_SCALE];
	p2.col = tab_p2[C_SCALE + 4];
	mk_poly4(*pp_sc_ct,&p1,&p2);
	pp_cur_sc = pp_sc_ct;
	modif_ct(0);
}

bct_loop(w)
Widget w;
{
	toggle_loop(w,CTLOOP);
}

/* save in c.t file or in current image (if outfile == image file) */
static Fort_int lfmtc[9] = {256,3,1,0,256,3,1,1,200}, lfmtx[9];
bct_save()
{
	register unsigned char *s;

	s = (unsigned char *)XawDialogGetValueString(cmap_ofile);
	ct_save(s);
}

ct_save(s)
register unsigned char *s;
{
	if(*s == 0)
		return 1 /* makes c99 happy */; 
	if(nfcolor)
		fermnf_(&nfcolor);
	if(strcmp((char *)s,(char *)*ptim) == 0) {  /* ecrire dans en-tete image */
		nfcolor = image_((char *)s,"e","",(struct nf_fmt *)lfmtx);
		iwr_ctrgb(nfcolor,0,NCOLOR,(char *)*pp_X_ct,(char *)*(pp_X_ct + 1),(char *)*(pp_X_ct + 2));
		fermnf_(&nfcolor);
		return 1 /* makes c99 happy */; 
	}
	strcpy(tcoutfile,(char *)s);
	nfcolor = image_(tcoutfile,"s","a",(struct nf_fmt *)lfmtc);
	c_ecr(nfcolor,3,*pp_X_ct);
	fermnf_(&nfcolor);

}

bct_auto()
{
	Widget w;
	flg_auto ^= 1;
	if(flg_auto) {
		XtSetArg (args[0], XtNsensitive, False);
	} else {
		XtSetArg (args[0], XtNsensitive, True);
	}
	w = (Widget)cmapbtn[I_CTAPPLY].b_win;
	XtSetValues(w, args, 1);
}


int xvct_order(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register struct menu_item *pi;
	pi = (struct menu_item *)&ct_orderlist[(long)cl_data];
	set_menu_btn(l_cmapbtn[I_CTORDER],cl_data,0);
	ix_ctorder = pi->val;
	modif_ct(1);
}

int xvct_menu(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register struct menu_item *pi;
	register unsigned char *s;
	pi = (struct menu_item *)&ct_menulist[(long)cl_data];
	cmap_type = pi->val;
	if(cmap_type & CMAP_FILE) {
		s = (unsigned char *)XawDialogGetValueString(cmap_ifile);
		strcpy(tcfile,(char *)s);
	}
	set_menu_btn(l_cmapbtn[I_CTMENU],cl_data,0);
	set_initial_ct(0);
}


cr_tab_buttons(parent,blist,n)
Widget parent;
register struct button **blist;
register n;
{
	Widget w, w1;
	register i, narg;
	Widget bchild[10];
	register struct button *pbt;
	XtSetArg (args[0], XtNsensitive, True);
	w = NULL;
	w1 = NULL;
	for(i=0;i<n;i++) {
		narg = 2;
		pbt = *blist++;
		XtSetArg (args[1], XtNlabel, pbt->b_text);
/*!!!		XtSetArg (args[2], XtNfromHoriz, w); */
		if(pbt->menu_item) {  /* avec text widget associee */
			XtSetArg (args[2], XtNborderWidth, 0);
			narg = 3;
		}
		w = XtCreateWidget (pbt->b_text, commandWidgetClass, parent,args,narg);
		bchild[i] = w;
		pbt->b_win = (long *)w;
		if(pbt->but_evnt != NULL)
			XtAddCallback(pbt->b_win,XtNcallback,pbt->but_evnt,NULL);
		if(pbt->menu_item) {
			cr_tab_txt(parent,pbt,w1);
			w1 = (Widget)pbt->b_im_norm;
		}
		XtOverrideTranslations(pbt->b_win,btnparsed_trans);
	}
	XtManageChildren(bchild,n);
}

cr_toggle_buttons(parent,labels,n,flags,proc,bchild)
Widget parent;
register char **labels;
register n, flags;
int (*proc)();
Widget bchild[];
{
	Widget w;
	register narg, msk;
	register long i;
	XtSetArg (args[0], XtNsensitive, True);
	w = NULL;
	msk = 1;
	for(i=0;i<n;i++) {
		narg = 3;
		XtSetArg (args[1], XtNlabel, *labels);
		if(flags & msk)
			XtSetArg (args[2], XtNstate,True);
		else
			XtSetArg (args[2], XtNstate,False);
		bchild[i] = w = XtCreateWidget (*labels, toggleWidgetClass, parent,args,narg);
		XtAddCallback(w,XtNcallback,proc,(XtPointer)i);
		labels++;
		msk <<= 1;
	}
	XtManageChildren(bchild,n);
}

int bct_scrgb(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register msk;
	msk = 1 << (long)cl_data;
	flg_scale ^= msk;
	if(flg_on) {
		scale_tc = flg_scale;
		modif_ct(1);
	}
}

int bct_flpts(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register msk;
	msk = 1 << (long)cl_data;
	flg_pts ^= msk;
}

int bct_actions(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register long msk, i;
	if((i = (long)cl_data) == I_MASK) {
		flg_mask ^= 1;
		if(flg_mask) {
			last_op = OP_INTERP;
			interp_mask(1);
		} else
			modif_ct(0);
	} else {
		msk = 1 << i;
		flg_actions ^= msk;
		if(flg_mask)
			interp_mask(0);
	}
}

interp_mask(reset)
int reset;
{
	register msk;
	ct_get_pts(0,PICK_ALL);
	ct_get_pts(1,PICK_ALL);
	msk = x_interp(reset);
/*!!	if(msk) */
		modif_ct(0);
}

calc_mask(flg,reset)
register flg, reset;
{
	register i;
	if(flg) {
		ct_get_pts(0,PICK_PIX);
		ct_get_pts(1,PICK_PIX);
	}
	for(i=0;i<3;i++) {
		msk_x1[i] = tab_p1[i];
		msk_x2[i] = tab_p2[i];
		if(reset)
			msk_y[i] = msk_x1[i];
		msk_l[i] = msk_x2[i] - msk_x1[i] +1;
	}
}

int bct_on(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	flg_on ^= 1;
	if(flg_on)
		scale_tc = flg_scale;
	else
		scale_tc = 0;
	modif_ct(0);
}

#define RSHFT 1
#define RROT 2
#define LSHFT -1
#define LROT -2
#define NOSHFT 0


int bct_rshft(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	shft_rot(RSHFT);
}

int bct_lshft(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	shft_rot(LSHFT);
}

int bct_0shft(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register i;
	if(flg_mask) {
		calc_mask(1,1);
	} else {
		reset_shift();
	}
	shft_rot(NOSHFT);
}

reset_shift()
{
	register i;
	for(i=0;i<4;i++)
		shft_val[i] = 0;
}

int bct_rrot(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	shft_rot(RROT);
}

int bct_lrot(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	shft_rot(LROT);
}

shft_rot(flg)
int flg;
{
	register i;
	if(flg_mask) {
		if(xsr_mask(flg))  /* shift mask */
			modif_ct(0);
	} else {
		if(xshft_rot(flg))
			modif_ct(1);
	}
}

int xsr_mask(flg)
int flg;
{
	register v, i, nb, y1, y2;
	int vals[4];
	register unsigned char *pc, **pp;
	
	if((v = flg_actions & B_RGB) == 0) return 0;
	ct_get_pts(2,1);  /* get deltas */
	for(i=0;i<4;i++) {
		if(flg == 0) 
			vals[i] = 0;
		else if (flg < 0)
			vals[i] = -(int)tab_delta[i];
		else
			vals[i] = (int)tab_delta[i];
	}
	if(flg < 0)
		flg = -flg;
	nb = 0;
	for(i=0;i<3;i++) {
		if(v & (1 << i)) {
			nb++;
		}
		y1 = msk_y[i] + vals[i];
		y2 = y1 + msk_x2[i] - msk_x1[i];
		if(flg == RSHFT) {
			if(y1 < 0)
				y1 = 0;
			else if(y1 > 255)
				y1 = 255;
			if(y2 < 0)
				y2 = 0;
			else if(y2 > 255)
				y2 = 255;
		}
		msk_y[i] = y1;
		msk_l[i] = y2 - y1 + 1;
/*!!		} */
	}
	strput4(pos_label,msk_y[0],msk_y[1],msk_y[2],msk_y[3]);
	XtSetArg(args[0], XtNlabel,(XtArgVal)pos_label);
	XtSetValues(cmap_pos_lab, args, 1);
	return nb;
}

int xshft_rot(flg)
int flg;
{
	register v, i, nb;
	int vals[4];
	register unsigned char *pc, **pp;
	
	if((v = flg_actions & B_ALL) == 0) return 0;
	ct_get_pts(2,1);  /* get deltas */
	for(i=0;i<4;i++) {
		if(flg == 0) 
			vals[i] = 0;
		else if (flg < 0)
			vals[i] = -(int)tab_delta[i];
		else
			vals[i] = (int)tab_delta[i];
	}
	if(flg < 0)
		flg = -flg;
	last_shft = flg;
	nb = 0;
	pp = &p_cts[3];
	for(i=0;i<4;i++) {
		if(v & (1 << i)) {
			nb++;
			shft_val[i] += vals[i];
			shft_val[i] %= 256;
			if(i == 3) {
				pp_cur_sc = pp_sc_ct +1;
				do_srot1(*pp_sc_ct,*pp_cur_sc,shft_val[i],flg);
			} else
				do_srot1(p_cts[i],*(pp + i),shft_val[i],flg);
		}
	}
	strput4(pos_label,shft_val[0],shft_val[1],shft_val[2],shft_val[3]);
	XtSetArg(args[0], XtNlabel,(XtArgVal)pos_label);
	XtSetValues(cmap_pos_lab, args, 1);
	return nb;
}

do_srot1(in,out,s,flg)
register unsigned char *in, *out;
register s;
{
	register unsigned char *p1;
	register i;
	if(s < 0) {
		s = -s;
		p1 = in + s;
		for(i=0;i<256 -s;i++)
			*out++ = *p1++;
		if(flg == RSHFT) {
			for(i=0;i<s;i++)
				*out++ = 255;
		} else {
			for(i=0;i<s;i++)
			*out++ = *in++;
		}
		return 1 /* makes c99 happy */; 
	}

	p1 = out + s;
	for(i=0;i<256 -s;i++)
		*p1++ = *in++;
	if(flg == RSHFT) {
		for(i=0;i<s;i++)
			*out++ = 0;
	} else {
		for(i=0;i<s;i++)
			*out++ = *in++;
	}
}

/* retour : type = 0 si bouton, 1 si text */
struct button *find_btn(w,type)
Widget w;
int *type;
{
	register i;
	register struct button *pbt;
	pbt = cmapbtn2;
	for(i=0;i<NCMAPBTN2;i++) {
		if(w == (Widget)pbt->b_win) {
			if(i == I_SCPIX2)
				*type = -1;
			else
				*type = 0;
			return pbt;
		} else if(w == (Widget)pbt->b_im_norm) {
			*type = 1;
			return pbt;
		}
		pbt++;
	}
	imerror(9,"couldn't find txt button\n");
}

/* action Btn2 ou Btn3 sur R G B Br */
xvrgb_btn(w, event, params, num_params)
Widget w;
XEvent *event;
String *params;			
Cardinal *num_params;		
{
	register i, n, op, msk;
	register nb;
	register Widget *pw;
	register int *pfl;
	if(*num_params != 1) 
		imerror(9,"bad param nb in rgb_btn\n");
	for(n=0;n<4;n++) {
		if(w == wbtn_actions[n]) {
			pw = wbtn_actions;
			pfl = &flg_actions;
			break;
		} else if(w == wbtn_pts[n]) {
			pw = wbtn_pts;
			pfl = &flg_pts;
			break;
		}
	}
	if(n >= 4)
		imerror(9,"rgb_btn : bad widget\n");
	switch(**params) {
	case '2':
		op = 0;  /* rgb dans l'etat du boutont courant */
		break;
	case '3':
		op = 1; /* toggle rgb */
		break;
	default:
		imerror(9,"rgb_btn : bad arg\n");
	}
	if(op) { /* toggle */
		nb = n == 3 ? 4 : 3;
		msk = 1;
		for(i=0;i<nb;i++, msk <<= 1) {
			*pfl ^= msk;
			if(i == n) continue;
			if(*pfl & msk)
				XtSetArg(args[0],XtNstate,True);
			else
				XtSetArg(args[0],XtNstate,False);
			XtSetValues(*(pw+i),args,1);
		}
	} else {  /* all in same state */
		msk = 1 << n;
		if(n == 3) {
			*pfl ^= msk;
			if(*pfl & msk) {  /* Br to True, rgb to false */
				msk = 1;
			} else {
				msk = 0;
			}
		} else
			msk = *pfl & msk;
		if(msk) {  /* switch RGB to false */
			XtSetArg(args[0],XtNstate,False);
			*pfl &= ~7;
		} else { /* switch to true */
			XtSetArg(args[0],XtNstate,True);
			*pfl |= 7;
		}
		for(i=0;i<3;i++) {
			if(i != n)
				XtSetValues(*(pw+i),args,1);
		}
	}
	if(pfl == &flg_actions && flg_mask)
		interp_mask(0);
}

xvtxt_btn(w, event, params, num_params)
Widget w;
XEvent *event;
String *params;			
Cardinal *num_params;		
{
	register i;
	int typ;
	register struct button *pbt;
	if(*num_params != 1)
		imerror(9,"bad arg nb in xvtxt_btn\n");
	i = **params;
	if(i < '0' || i > '6')
		imerror(9,"bad arg in xvtxt_btn\n");
	i -= '0';
	pbt = find_btn(w,&typ);
	if(typ < 0) {
		bright_modif(i);
	} else {
		cmn_txt_btn(w,i,pbt->b_cod,typ);
	}
}


static short incrs[7]= { 1,10,-1,-10,0,255,0};
/* common proc for click on text button (pix1,... delta) */
/* type : 0 = +1, 1= +10, 2=-1, 3=-10 4= put 0, 5= put 255, 6= valid
*/
cmn_txt_btn(w,type,bnum,fromtxt)
Widget w;
register type, bnum;
int fromtxt;
{
	register struct button *pbt;
	register flag, i, msk, k;
	register unsigned char *pc;
	register incr, flgp;
	pbt = &cmapbtn2[bnum];
	if(!fromtxt && w != (Widget)pbt->b_win)
		imerror(9,"txt_btn : bad widget\n");
	flag = (bnum & 1) ? PICK_RGB : PICK_PIX;
	if(bnum == I_DELTA)
		pc = tab_delta;
	else if(bnum <= I_RGB1)
		pc = tab_p1;
	else
		pc = tab_p2;
	if(flag & PICK_RGB)
		pc += 4;
	ct_get_pts(bnum / 2,flag);
	msk = 1;
	k = 0;
	if(fromtxt > 0) {
		flgp = gtxt_pos(pbt);
	} else {
		flgp = flg_pts;
	}
	if(type == 6) {
		k = -1;
	} else {
		incr = incrs[type];
		for(i=0;i<4;i++) {
			if(flgp & msk) {
				if(type < 4)
					*(pc + i) += incr;
				else
					*(pc + i) = incr;
				k++;
			}
			msk <<= 1;
		}
	}
	if(k > 0) {
		wr_ct_txt(pbt,pc);
	}
	if(k) {
		if(bnum == I_DELTA)
			return 1 /* makes c99 happy */; 
		if(flg_mask) {
			interp_mask(0);
		} else if(flg_autopt){
			switch(last_op) {
			case OP_INTERP:
				bct_interp(0,0,0);
				break;
			case OP_POLY4:
				bct_poly4(0,0,0);
				break;
			case OP_SET1:
				if(bnum <= I_RGB1)
					bct_set1(0,0,0);
				break;
			case OP_SET2:
				if(bnum == I_RGB2 || bnum == I_PIX2)
					bct_set2(0,0,0);
				break;
			}
		}
	}
}

wr_ct_txt(pbt,pc)
register struct button *pbt;
register unsigned char *pc;
{
	XawTextPosition pos;
	pos = XawTextGetInsertionPoint(pbt->b_im_norm);
	strput4(pbt->menu_item,*pc,*(pc+1),*(pc+2),*(pc+3));
	XtSetArg(args[0],XtNstring,(XtArgVal)(pbt->menu_item));
	XtSetValues(pbt->b_im_norm,args,1);
	XawTextSetInsertionPoint(pbt->b_im_norm,pos);
}

/* modif brightness lors de click sur +/- */
bright_modif(type)
register type;
{
	register struct button *pbt;
	register i, msk, k;
	register unsigned char *pc;
	register incr;
	if(cmap_shell) {
		pbt = &cmapbtn2[I_PIX2];
		ct_get_pts(0,PICK_ALL);
		ct_get_pts(1,PICK_ALL);
	} else 	if(flg_on)
		scale_tc = flg_scale;
	incr = incrs[type];
	if(type < 4)
		tab_p2[C_SCALE] += incr;
	else
		tab_p2[C_SCALE] = incr;
	if(cmap_shell)
		wr_ct_txt(pbt,tab_p2);
	force_brightness();
}

gtxt_pos(pbt)
register struct button *pbt;
{
	register unsigned char *s;
	register i, j, n, c, prevc;
	i = XawTextGetInsertionPoint(pbt->b_im_norm);
	s = (unsigned char *)pbt->menu_item;
	n = 0;
	prevc = ' ';
	for(j=0;j<=i;j++) {
		if((c = *s++) == 0) {
			return 0;
		} else if(c == ' ') {
			if(prevc != ' ') {
				n++;
			}
		}
		prevc = c;
	}
	if(c == ' ')
		return 0;
	return (1 << n);
}

int bct_pick(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register long msk;
	msk = (long)cl_data;
	if(msk) {
		flg_autopt ^= 2;
	} else 
		flg_cmap_pick ^= 1;
}


int bct_set1(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	last_op = OP_SET1;
	ct_set_pt(0);
}

int bct_set2(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	last_op = OP_SET2;
	ct_set_pt(1);
}

/* set point in cmap ; n= 0 ou 1 */
ct_set_pt(n)
register n;
{
	register v, i, j;
	register unsigned char *pc;
	register unsigned char *pp, **ppc;
	if((v = flg_actions & B_ALL) == 0) return 1 /* makes c99 happy */; 
	ct_get_pts(n,PICK_ALL);
	pp = n == 0 ? tab_p1 : tab_p2;
	if(flg_mask) {
		ppc = pp_mask_ct;
		v &= B_RGB;
	} else {
		ppc = p_cts;
	}
	for(i=0;i<4;i++) {
		if(v & (1 << i)) {
			pc = *(ppc + i);
			*(pc + *(pp + i)) = *(pp +i + 4);
		}
	}
	if(flg_mask) {
		for(i=0;i<3;i++) {
			msk_x2[i] = msk_x1[i] = *(pc +i);
			msk_y[i] = msk_x1[i];
			msk_l[i] = 1;
		}
	}
	modif_ct(0);
}


/* recupere les infos de p1, p2 ou delta
flag: 1= get pix, 2 = get rgb, 3= all
*/
ct_get_pts(nump,flag)
register nump;
{
	register unsigned char *pp;
	register struct button *pbt;
	Widget wp, wv;
	if(nump == 0) {
		pp = tab_p1;
		pbt = &cmapbtn2[I_PIX1];
	} else if (nump== 1) {
		pp = tab_p2;
		pbt = &cmapbtn2[I_PIX2];
	} else {
		pp = tab_delta;
		pbt = &cmapbtn2[I_DELTA];
		flag = PICK_PIX;
	}
	if(flag & PICK_PIX)
		get_dial4(pbt,pp);
	if(flag & PICK_RGB)
		get_dial4(pbt+1,pp + 4);
}

get_dial4(pbt,pc)
register struct button *pbt;
register unsigned char *pc;
{
	int v[4];
	register i;
	register unsigned char *s;
	s = (unsigned char *)pbt->menu_item;
	for(i=0;i<4;i++)
		v[i] = 0;
	if(*s == 0)
		return 1 /* makes c99 happy */; 
	sscanf((char *)s,"%d %d %d %d",&v[0],&v[1],&v[2],&v[3]);
	for(i=0;i<4;i++)
		*pc++ = (unsigned char)v[i];
}

/* va chercher 1 point pour table tnum dans P1 ou P2 text widget ; n=0 ou 1 pour P1 P2 */
ct_get_1pt(tnum,n,pp)
register n, tnum;
register struct rgb_pt *pp;
{
	register unsigned char *pc;
	pc = n == 0 ? tab_p1 : tab_p2;
	pp->pix = *(pc + tnum);
	pp->col = *(pc + tnum + 4);
}

/* flg : 0 => recopier orig dans cur */
modif_ct(flg)
{
	if(flg_mask) {
		do_mask();
	} else if(!flg) {
		pp_cur_sc = pp_sc_ct + 1;
		pp_cur_ct = &p_cts[3];
		fastcpy(p_cts[0],*pp_cur_ct,3*NCOLOR);
		fastcpy(*pp_sc_ct,*pp_cur_sc,NCOLOR);
	}
	if(flg_auto)
		bct_apply();
}

int bct_interp(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	last_op = OP_INTERP;
	ct_get_pts(0,PICK_ALL);
	ct_get_pts(1,PICK_ALL);
	reset_shift();
	if(x_interp(1))
		modif_ct(0);
}
	   
int x_interp(reset_mask)
{
	struct rgb_pt p1, p2;
	register unsigned char **pp;
	register i, nb, flgp;
	nb = 0;
	if(flg_mask) {
		pp = pp_mask_ct;
		flgp = flg_actions & B_RGB;
	} else {
		pp = p_cts;
		flgp = flg_actions;
	}
	for(i=0;i<4;i++) {
		if(flgp & (1 << i)) {
			nb++;
			ct_get_1pt(i,0,&p1);
			ct_get_1pt(i,1,&p2);
			if(i == 3) {
				mk_lin(*pp_sc_ct,&p1,&p2);
				pp_cur_sc = pp_sc_ct;
			} else
				mk_lin(*(pp + i),&p1,&p2);
		}
	}
	if(flg_mask)
		calc_mask(0,reset_mask);
	return nb;
}


int bct_poly4(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	last_op = OP_POLY4;
	ct_get_pts(0,PICK_ALL);
	ct_get_pts(1,PICK_ALL);
	reset_shift();
	if(x_poly4(w,cl_data,data))
		modif_ct(0);
}

int x_poly4(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	struct rgb_pt p1, p2;
	register i, nb, flgp;
	register unsigned char **pp;
	nb = 0;
	if(flg_mask) {
		pp = pp_mask_ct;
		flgp = flg_actions & B_RGB;
	} else {
		pp = p_cts;
		flgp = flg_actions;
	}
	for(i=0;i<4;i++) {
		if(flgp & (1 << i)) {
			nb++;
			ct_get_1pt(i,0,&p1);
			ct_get_1pt(i,1,&p2);
			if(i == 3) {
				mk_poly4(*pp_sc_ct,&p1,&p2);
				pp_cur_sc = pp_sc_ct;
			} else
				mk_poly4(*(pp + i),&p1,&p2);
		}
	}
	if(flg_mask)
		calc_mask(0,1);
	return nb;
}
int do_invert(pc,n)
register unsigned char *pc;
register n;
{
	register j;
	for(j=0;j<n;j++)
		*pc++ ^= 0xff;
}

int do_reverse(pc,n)
register unsigned char *pc;
register n;
{
	register j, v;
	register unsigned char *p2;
	p2 = pc + n -1;
	for(j=0;j<n/2;j++) {
		v = *p2;
		*p2-- = *pc;
		*pc++ = v;
	}
}

/* inverse les bits des tables couleur */
int bct_invert(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	do_func(do_invert);
}

/* inverse l'ordre des valeurs des tables couleur */
int bct_reverse(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	do_func(do_reverse);
}

do_func(proc)
int (*proc)();
{

	register n, i;
	register i0, nb;
	register unsigned char **pp, *pc;
	if(flg_mask) {
		pp = pp_mask_ct;
		n = 3;
	} else {
		n = 4;
		pp = p_cts;
		nb = NCOLOR;
	}
	for(i=0;i<n;i++) {
		if(flg_actions & (1 << i)) {
			pc = *(pp + i);
			if(flg_mask) {
				pc += msk_x1[i];
				nb = msk_x2[i] - msk_x1[i] + 1;
			}
			proc(pc,nb);
		}
	}
	if(!flg_mask) {
		for(i=0;i<3;i++) {
			do_srot1(p_cts[i],p_cts[i+3],shft_val[i],last_shft);
		}
		modif_ct(1);
	} else
		modif_ct(0);
}

/* applique masque en fonction de flg_actions */
do_mask()
{
	register i;
	register unsigned char **pp;
	pp = &p_cts[3];
	for(i=0;i<3;i++) {
		if(flg_actions & (1 << i)) {
			do_mask1(p_cts[i],*(pp + i),i);
		} else {
			fastcpy(p_cts[i],*(pp+i),NCOLOR);
		}
	}
}

do_mask1(in,out,num)
register unsigned char *in, *out;
register num;
{
	register x1, y1, n, n1;
	register i;
	register unsigned char *p2, *msk;
	x1 = msk_x1[num];
	y1 = msk_y[num];
	n = msk_l[num];
	msk = *(pp_mask_ct + num) + x1;
	if((y1 + n) > NCOLOR) {
		n1 = NCOLOR - y1;
		p2 = out + y1;
		for(i=0;i<n1;i++)
			*p2++ = *msk++;
		in += (n -i);
		for(;i<n;i++)
			*out++ = *msk++;
		for(i=0;i<(NCOLOR -n);i++)
			*out++ = *in++;
		return 1 /* makes c99 happy */; 
	}
	n1 = y1 + n;
	for(i=0;i<y1;i++)
		*out++ = *in++;
	for(;i<n1;i++)
		*out++ = *msk++;
	in += n;
	for(;i<NCOLOR;i++)
		*out++ = *in++;
}

cr_tab_txt(parent,pbt,w1)
Widget parent;
register struct button *pbt;
Widget w1;
{
	Arg targs[8];
	char lab[80];
	sprintf(lab,"txt%s",pbt->b_text);
	XtSetArg(targs[0],XtNstring,(XtArgVal)(pbt->menu_item));
	XtSetArg(targs[1],XtNtype,XawAsciiString);
	XtSetArg (targs[2], XtNresizable,True);
	XtSetArg (targs[3], XtNfromVert,pbt->b_win);
	XtSetArg (targs[4], XtNfromHoriz,w1);
	XtSetArg (targs[5], XtNeditType,XawtextEdit);
	XtSetArg (targs[6], XtNuseStringInPlace,True);
	XtSetArg (targs[7], XtNlength,TAB_TXT1);
	pbt->b_im_norm = (long *)XtCreateManagedWidget (lab, asciiTextWidgetClass,parent,targs,8);
	XtOverrideTranslations(pbt->b_im_norm,txtparsed_trans);
}


mk_poly4(buf,p1,p2)
register unsigned char *buf;
struct rgb_pt *p1, *p2;
{
	struct rgb_pt tmp;
	register struct rgb_pt *p0;
	if(p1->pix > p2->pix) {
		p0 = p1;
		p1 = p2;
		p2 = p0;
	}
	mk_lin(buf,p1,p2);
	if(p1->pix != 0) {
		tmp.pix = 0;
		tmp.col = *buf;
		mk_lin(buf,&tmp,p1);
	}
	if(p2->pix != 255) {
		tmp.pix = 255;
		tmp.col = *(buf + 255);
		mk_lin(buf,p2,&tmp);
	}

}

mk_lin(buf,p1,p2)
register unsigned char *buf;
struct rgb_pt *p1, *p2;
{
	register struct rgb_pt *p0;
	register n;
	register float d, v;
	if(p1->pix > p2->pix) {
		p0 = p1;
		p1 = p2;
		p2 = p0;
	}
	n = p2->pix - p1->pix;
	*(buf + p2->pix) = p2->col;
	buf += p1->pix;
	*buf++ = p1->col;
	if(n <= 1) return 1 /* makes c99 happy */; 
	d = (float)(p2->col - p1->col) / (float) n;
	v = (float) p1->col;
	n--;
	while(n-- > 0) {
		v += d;
		*buf++ = (int)(v + .5);
	}

}

do_cmap_pick(pixel,but)
register pixel,but;
{
	register i, n;
	register k, flg, flgp;
	Widget w1, w2;
	register unsigned char *pc;
	register struct button *pbt;
	char tmp[80];
	int rgbp[3], rgbv[3];
	flgp = (but & 0x100) ? PICK_RGB : PICK_PIX;
	but &= 7;
	if(but == 1) {
		pc = tab_p1;
		pbt = &cmapbtn2[I_PIX1];
		ct_get_pts(0,PICK_ALL);
	} else if(but == 2) {
		pbt = &cmapbtn2[I_PIX2];
		pc = tab_p2;
		ct_get_pts(1,PICK_ALL);
	} else
		return 1 /* makes c99 happy */; 
	rgbp[2] = pixel & 0xff;
	if(scrdepth == 24 || truecol_type > 0) {
		rgbp[0] = (pixel >> 16) & 0xff;
		rgbp[1] = (pixel >> 8) & 0xff;
	} else {
		rgbp[0] = rgbp[2];
		rgbp[1] = rgbp[2];
	}
	for(i=0;i<3;i++) {
		rgbv[i] = *(*(pp_cur_ct + i) + rgbp[i]);
	}
	n = 4;
	flg = flg_pts;
	k = 0;
	for(i=0;i<n;i++) {
		if(flg & (1 << i)) {
			k++;
			if(flgp & PICK_PIX)
				*(pc + i) = rgbp[i];
			if(flgp & PICK_RGB)
				*(pc + i + 4) = rgbv[i];
		}
	}
	if(!k) return 1 /* makes c99 happy */; 
	if(flgp & PICK_PIX) {
		strput4(pbt->menu_item,*pc,*(pc+1),*(pc+2),*(pc+3));
		XtSetArg(args[0],XtNstring,(XtArgVal)pbt->menu_item);
		XtSetValues(pbt->b_im_norm,args,1);
	}
	if(flgp & PICK_RGB) {
		pbt++;
		strput4(pbt->menu_item,*(pc +4),*(pc+5),*(pc+6),*(pc+7));
		XtSetArg(args[0],XtNstring,(XtArgVal)pbt->menu_item);
		XtSetValues(pbt->b_im_norm,args,1);
	}

}

cmap_loop()
{
	shft_rot(RROT);
}

/* met 4 nbs dans string de text (lgr TAB_TXT1) */
strput4(s,v1,v2,v3,v4)
register char *s;
register v1,v2,v3,v4;
{
	register i;
	sprintf(s,"%03d %03d %03d %03d",v1,v2,v3,v4);
	i = strlen(s);
	s += i;
	for(;i<TAB_TXT1-1;i++)
		*s++ = 0;
	*s++ = 0;
}

static void exp_mire(w,data,event)
Window w;
register XExposeEvent *event;
{
	register x, y;
	x = event->x;
	y = event->y;
	XCopyArea(dpy,pix_mire,W_mire,defgc,x,y,event->width,event->height,x,y);
}

static void coord_mire(w,data,event)
Window w;
register XButtonPressedEvent *event;
{
	register x, y;
	register v;
	register but;
	but = event->button;
	x = event->x;
	y = event->y;
	if(event->state & ShiftMask)  /* shift */
		but |= 0x100;
	if(x < 0 || y < 0) return;
	if(x >= MIRE_WIDTH || y >= MIRE_HEIGHT) return;  /* hors limites */
	v = x;
	if(truecol_type > 0 || scrdepth == 24)
		v = x | (x << 8) | (x << 16);
	do_cmap_pick(v,but);
}


init_mire()
{
	XImage *xmire;
	unsigned char *buf;
	register unsigned char *pc;
	register unsigned short *ps;
	register u_int4 *pl, *p1;
	register i, j, n;
	if(cmap_shell == NULL || scrdepth == 1)
		return 1 /* makes c99 happy */; 
	n = (scrdepth == 24) ? 4 : (scrdepth == 16 ? 2 : 1);
	if(pix_mire == (Pixmap) 0)
		pix_mire = XCreatePixmap(dpy,W_mire,MIRE_WIDTH,MIRE_HEIGHT,scrdepth);
	buf = (unsigned char *)i_malloc(MIRE_WIDTH * MIRE_HEIGHT * n);
	xmire = XCreateImage(dpy,mydefvisual,scrdepth,ZPixmap,0,buf,MIRE_WIDTH,MIRE_HEIGHT,16,0);
	if(scrdepth == 24 ) {
	  pl = (u_int4 *)buf;
	  if(flg_Xtc) {
	    register unsigned char *pr, *pg, *pb;
	    pr = *pp_cur_ct;
	    pg = *(pp_cur_ct + 1);
	    pb = *(pp_cur_ct + 2);
	    for(j=0;j<MIRE_WIDTH;j++) {
	      i = xtrans[j];
	      *pl++ = *(pr+i) | (*(pg+i) << 8) | (*(pb+i) << 16);
	    }
	  } else {
	    for(j=0;j<MIRE_WIDTH;j++) {
	      i = xtrans[j];
	      *pl++ = i | (i << 8) | (i << 16);
	    }
	  }
	} else if(scrdepth == 16) {
	  ps = (unsigned short *)buf;
	  if(flg_Xtc) {
	    register unsigned char *pr, *pg, *pb;
	    pr = *pp_cur_ct;
	    pg = *(pp_cur_ct + 1);
	    pb = *(pp_cur_ct + 2);
	    for(j=0;j<MIRE_WIDTH;j++) {
	      i = xtrans[j];
	      *ps++ = ((*(pr+i) & 0xf8) << 8) | ((*(pg+i) & 0xfc) << 3) | ((*(pb+i) & 0xf8) >> 3);  /* mkpix16(i,i,i);*/
	    } 
	  }else {
	    for(j=0;j<MIRE_WIDTH;j++) {
	      i = xtrans[j];
	      *ps++ = ((i & 0xf8) << 8) | ((i & 0xfc) << 3) | ((i & 0xf8) >> 3);  /* mkpix16(i,i,i);*/
	    }
	  }
	  pl = (u_int4 *)ps;
	} else {
	  pc = buf;
	  for(j=0;j<MIRE_WIDTH;j++) 
	    *pc++ = xtrans[j];
	  pl = (u_int4 *)pc;
	}
	n = (n * MIRE_WIDTH)/4;
	p1 = (u_int4 *)buf;
	for(i=0;i<MIRE_HEIGHT-1;i++) {
		for(j=0;j<n;j++)
			*pl++ = *p1++;
	}
	XPutImage(dpy,pix_mire,defgc,xmire,0,0,0,0,MIRE_WIDTH,MIRE_HEIGHT);
	XDestroyImage(xmire);
	XCopyArea(dpy,pix_mire,W_mire,defgc,0,0,MIRE_WIDTH,MIRE_HEIGHT,0,0);

}

#define NPT1 8
static unsigned char tabx[NPT1]= {0,51,102,127,177,199,227,255};
static unsigned char tabrgb[3*NPT1] = {  /* 8 R, 8G , 8B */
	255,255,0,0,0,255,255,255,
	0,0,0,255,255,255,128,0,
	255,160,255,255,0,0,0,0
};
static short tabs[]= {191,82,234};
static int init_rand= 1;
/* init tables 1 ou 2 , ou random */
mk_deftables()
{
	register i, j;
	struct rgb_pt xp1, xp2;
	register struct rgb_pt *p1, *p2, *p0;
	register unsigned char *pc;
	if(cmap_type == CMAP_TAB1) {
		pc = tabrgb;
		for(j=0;j<3;j++) {
			p1 = &xp1;
			p2 = &xp2;
			p1->pix = tabx[0];
			p1->col = *pc++;
			for(i=1;i<NPT1;i++) {
				p2->pix = tabx[i];
				p2->col = *pc++;
				mk_lin(p_cts[j],p1,p2);
				p0 = p1;
				p1 = p2;
				p2 = p0;
			}
		}
		return 1 /* makes c99 happy */; 
	}
	if(cmap_type == CMAP_TAB2) {
		pc = p_cts[3];
		for(j=0;j<3;j++)
			for(i=0;i<NCOLOR;i++)
				*pc++ = i;
		for(i=0;i<3;i++)
			do_srot1(p_cts[i+3],p_cts[i],tabs[i],RROT);
		return 1 /* makes c99 happy */; 
	}
	if(cmap_type & (CMAP_RAND | CMAP_XRAND)) {
		if(cmap_type == CMAP_RAND)
			init_rand = 1;
#ifdef sun5
		srand(init_rand);
#else
		srandom(init_rand);
#endif
		pc = p_cts[0];
		for(j=0;j<3;j++) {
			for(i=0;i<NCOLOR;i++) {
#ifdef sun5
				*pc++ = rand() & 0xff;
#else
				*pc++ = random() & 0xff;
#endif
			}
		}
		init_rand = *(p_cts[0]) + *(p_cts[1]);
		return 1 /* makes c99 happy */; 
		
	}

}
