#include <inrimage/image.h>
#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include "xvis.h"
#include "xvglobl.h"

extern struct imagept shpts[];

extern Pixmap pix_im;
extern Display *dpy;
extern XImage *ximage;
extern Visual *mydefvisual;

extern unsigned char **pp_X_ct;
extern int byte_pixel;
extern unsigned char xtransi[];
extern unsigned char Xcol_order[];
extern int truecol_type;

extern int IM_nbmin_hdr;

static XImage *dump_ima= NULL;

xvdump(s)
register char *s;
{
	register struct imagept *pt;
	register i, j, k, nb, blksz;
	struct imbox ibox;
	Fort_int lfmtd[9];
	struct image *nf;
	register unsigned char *pc;
	unsigned char *buf, *outbuf;
	int ix0, iy0;
	if(s == NULL || *s == 0) return 1 /* makes c99 happy */; 
	shdef_args();
	lfmtd[I_EXP] = 200;
	if(scrdepth == 1) {
		lfmtd[I_BSIZE] = -1;
		lfmtd[I_TYPE] = PACKEE;
	} else {
		lfmtd[I_BSIZE] = 1;
		lfmtd[I_TYPE] = FIXE;
		if(scrdepth > 8) { /* 24 bits */
		  /*!!if(truecol_type > 0) */
				lfmtd[I_NDIMV] = 3;
		}
	}
	calc_imbox(shpts,&ibox);
	ix0 = ibox.x;
	iy0 = ibox.y;
	lfmtd[I_NDIMX] = ibox.dx;
	lfmtd[I_NDIMY] = ibox.dy;
	lfmtd[I_NDIMZ] = ibox.dz;
	if(ibox.dv != 1) lfmtd[I_NDIMV] = ibox.dv;

/* !!	if(truecol_type == I_VCOL)
   lfmtd[I_NDIMV] = 1; */
	if(flg_nopix) { /* arrondir dimx a mult. de 2 */
		lfmtd[I_NDIMX] &= ~1;
	}
	lfmtd[I_DIMX] = lfmtd[I_NDIMX] * lfmtd[I_NDIMV];
	lfmtd[I_DIMY] = lfmtd[I_NDIMY] * lfmtd[I_NDIMZ];;
	if(scrdepth > 1)
		IM_nbmin_hdr = 8;
	nf = image_(s,"c","a",(struct nf_fmt *)lfmtd);
	if(scrdepth > 1)
		iwr_ctrgb(nf,0,256,(char *)*(pp_X_ct + C_ROUGE),(char *)*(pp_X_ct + C_VERT),(char *)*(pp_X_ct + C_BLEU));
	if(scrdepth == 1) {
	  i = (lfmtd[I_NDIMX] + 7) / 8;
	} else if((scrdepth == 16) && (truecol_type > 0)) {
	  i = lfmtd[I_NDIMX] * 3;
	} else {
	  i = lfmtd[I_NDIMX] * byte_pixel;
	}
	nb = lfmtd[I_NDIMY] * i;
	if(dump_ima) {
		XDestroyImage(dump_ima);
		dump_ima = NULL;
	}

	if(!flg_nopix) {
		buf = (unsigned char *)i_malloc(nb);
		dump_ima = XCreateImage(dpy,mydefvisual,scrdepth,ZPixmap,
				   0,buf,lfmtd[I_NDIMX],lfmtd[I_NDIMY],8,i);
	}
	blksz = lfmtd[I_NDIMY]*lfmtd[I_NDIMX];
	if(lfmtd[I_NDIMV] > 1) 
	  outbuf = (unsigned char *)i_malloc(blksz * lfmtd[I_NDIMV]);
	else
	  outbuf = NULL;
	/* hide box */
	xvsh_boxdraw(shpts,1);
	for(i=0;i<lfmtd[I_NDIMZ];i++) {
	  for(k=0;k<ibox.dv;k++) {
	    if(flg_nopix) {
	      dump_ima = XSubImage(ximage,ix0,iy0,lfmtd[I_NDIMX],lfmtd[I_NDIMY]);
	    } else {
	      XGetSubImage(dpy,pix_im,ix0,iy0,lfmtd[I_NDIMX],lfmtd[I_NDIMY],AllPlanes,ZPixmap,dump_ima,0,0);
	    }
	    if(scrdepth == 8) {
	      pc = (unsigned char *)dump_ima->data;
	      for(j=0;j<nb;j++) {
		*pc = xtransi[*pc];
		pc++;
	      }
	    } else if(scrdepth == 24) {
	      dump24(dump_ima->data,nb);
	    } else if(scrdepth == 16) {
	      dump16(dump_ima->data,nb);
	    } else if(blackpixel != 0) {
	      pc = (unsigned char *)dump_ima->data;
	      for(j=0;j<nb;j++)
		*pc++ ^= 0xff;  /* inverser */
	    }
	    ix0 += im_w1v;
	    if(outbuf) {
	      merge_vect(dump_ima->data,outbuf+k,lfmtd[I_NDIMV],blksz);
	    }
	  }
	  if(k > 1)
	    c_xecr(nf,lfmtd[I_NDIMY],outbuf,1);
	  else
	    c_xecr(nf,lfmtd[I_NDIMY],dump_ima->data,1);
	  if(flg_z_horiz) {
	    ix0 -= im_w1v;
	    INCR_HZ(ix0,iy0);
	  } else {
	    ix0 = ibox.x;
	    iy0 += im_h1;
	  }
	  if(flg_nopix) {
	    XDestroyImage(dump_ima);
	    dump_ima = NULL;
	  }
	}
	if(!flg_nopix) {
	  XDestroyImage(dump_ima);
	  dump_ima = NULL;
	}
	xvsh_boxdraw(shpts,0);  /* redraw box */
	/* if stdout : close pipe */
	if(nf->fd == 1)
	  xvsh_wrclose();
	fermnf_(&nf);
	i_Free(&outbuf);
}

dump24(buf,nbytes)
register unsigned char *buf;
register nbytes;
{
	register i, jr, jg, jb;
	register vr, vg, vb;
	register unsigned char *pi, *po;
	pi = buf;
	po = buf;
#if 0
	if(truecol_type <= 0) {  /* monochrome */
		pi += Xcol_order[C_ROUGE];
		for(i=0;i<(nbytes/4);i++) {
			*po++ = xtransi[*pi];
			pi += 4;
		}
		return;
	}
#endif
	/* vraie couleur */
	jr = Xcol_order[C_ROUGE];
	jg = Xcol_order[C_VERT];
	jb = Xcol_order[C_BLEU];
	for(i=0;i<(nbytes/4);i++) {
		vr = xtransi[*(pi + jr)];
		vg = xtransi[*(pi + jg)];
		vb = xtransi[*(pi + jb)];
		*po++ = vr;
		*po++ = vg;
		*po++ = vb;
		pi += 4;
	}

}
#define red16(x) ((x & 0xf800) >> 8)
#define green16(x) ((x & 0x07e0) >> 3)
#define blue16(x) ((x & 0x1f) << 3)

dump16(buf,nbytes)
register unsigned char *buf;
register nbytes;
{
	register i, n;
	register vr, vg, vb, x;
	register unsigned char *po;
	register unsigned short *pi;
	if(truecol_type <= 0) {  /* monochrome */
	  pi = (unsigned short *)buf;
	  po = buf;
	  for(i=0;i<(nbytes/2);i++) {
	    *po++ = xtransi[green16(*pi)];
	    pi++;
	  }
	  return 1 /* makes c99 happy */; 
	}
	/* vraie couleur : On commence par la fin */
	n = nbytes / 3;  /* nb pixels */
	po = buf + nbytes;
	pi = (unsigned short *) buf;
	pi += n;
	po--;
	pi--;
	for(i=0;i<n;i++) {
	  x = *pi--;
	  vr = xtransi[red16(x)];
	  vg= xtransi[green16(x)];
	  vb = xtransi[blue16(x)];
	  *po-- = vb;
	  *po-- = vg;
	  *po-- = vr;
	}
}

merge_vect(in,out,dimv,nb)
unsigned char *in, *out;
int dimv, nb;
{
  while(nb-- > 0) {
    *out = *in++;
    out += dimv;
  }
}
