/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#ifndef X11R2
#ifndef X11R3
#define X11R4
#endif
#endif

#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#if defined X11R3 || defined X11R4
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/X.h>
#include <X11/Xproto.h>
#else
#include <X11/Atoms.h>
#endif
#ifdef X11R4
#define XAW_BC
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/AsciiText.h>
#else
#include <X11/Label.h>
#include <X11/Command.h>
#include <X11/Shell.h>
#include <X11/Box.h>
#include <X11/Dialog.h>
#include <X11/Form.h>
#include <X11/AsciiText.h>
#endif
#include <inrimage/image.h>
#include "xvis.h"
#include "xvglobl.h"
#include "xvxglobl.h"

extern int debug_, inr_dballoc;
extern int sh_state;

#define evreturn(n) {evt_retcode = n; return 1 /* makes c99 happy */;}
#define evreturnvoid(n) {evt_retcode = n; return;}

int evt_retcode;
static Arg args[7];
void coord_edit(), coord_edit1();

void exp_imag(w,data,event)
Window w;
register XExposeEvent *event;
{
	register x, y;
	x = event->x;
	y = event->y;
#if 0
	if(flg_nopix) {
#else
	if(pix_im == 0) {
#endif
		if(flg_fix < 0) {
			xzer_im(W_image,x,y,event->width,event->height);
		} else if(ximage->data != NULL) {
			XPutImage(dpy,W_image,defgc,ximage,x,y,x,y,event->width,event->height);
			/* redraw box */
			xvsh_draw(-1);
		}
	} else {
		XCopyArea(dpy,pix_im,W_image,defgc,x,y,event->width,event->height,x,y);
	}
	XFlush(dpy);
}

static int mouse_started= 0;
static struct screenpt ref_pt;  /* point de reference */


/* affichage coord d'un point */
coord_imag(w,data,event)
Window w;
register XButtonEvent *event;
{
	register x, y;
	register v;
	register but;
	register XMotionEvent *evm;
	if(event->type == MotionNotify) {  /* deplacement bouton 1 enfonce */
		evm = (XMotionEvent *) event;
		x = evm->x;
		y = evm->y;
		but = evm->state;
		if(but & Button1Mask)
			but = 1;
		else if(but & Button2Mask)
			but = 2;
		else if(but & Button3Mask)
			but = 3;
		else
			but = 0;
		if(curs_type) {
			reset_prev();
			draw_ptr(x,y);
		}
		if(flg_follow_mouse) {
			x = evm->x_root;
			y = evm->y_root;
			if(!mouse_started) {
				ref_pt.x = x;
				ref_pt.y = y;
				mouse_started = 1;
				xv_scr_orig(&cur_scr_top);
#if 0
				if(debug_)
					fprintf(stderr,"ref point %d,%d, top %d,%d\n",
						x,y,cur_scr_top.x,cur_scr_top.y);
#endif
				return 1 /* makes c99 happy */; 
			}
/*			xv_scr_orig(&cur_scr_top); */
			cur_scr_top.x += ref_pt.x - x;
			cur_scr_top.y += ref_pt.y - y;
			ref_pt.x = x;
			ref_pt.y = y;
			XtMoveWidget(image_widget,-cur_scr_top.x,-cur_scr_top.y);
			XFlush(dpy);
#if 0
			if(debug_) {
				fprintf(stderr,"(%d,%d), top %d,%d, del %d,%d\n",x,y,
					cur_scr_top.x,cur_scr_top.y,
					ref_pt.x -x,ref_pt.y -y);
			}
#endif
			return 1 /* makes c99 happy */; 
		}
	} else {
		mouse_started = 0;
		but = event->button;
		x = event->x;
		y = event->y;
		if(x < 0)  /* debordement (bug X) */
		  x = (int)(unsigned short)x;
		if(y < 0)  /* debordement (bug X) */
		  y = (int)(unsigned short)y;
		if(event->type == ButtonRelease) {
			if(curs_type)
				reset_prev();
			return 1 /* makes c99 happy */; 
		}
		if(curs_type)
			draw_ptr(x,y);
	}
	if(event->state & ShiftMask)  /* shift utilise pour shell */
		but |= 0x100;
	cmn_coord_image(x,y,but,1);
}


xv_start_edit()
{
	XtRemoveEventHandler(image_widget,ButtonPressMask| ButtonReleaseMask| Button1MotionMask ,False,coord_imag,NULL);
	XtAddEventHandler(image_widget,ButtonPressMask,False,coord_edit,NULL);
	XtAddEventHandler(image_widget,PointerMotionMask,False,coord_edit1,NULL);
	XDefineCursor(dpy,W_image,Cursed);
}

xv_end_edit()
{
	XtRemoveEventHandler(image_widget,ButtonPressMask,False,coord_edit,NULL);
	XtRemoveEventHandler(image_widget,PointerMotionMask,False,coord_edit1,NULL);
	XtAddEventHandler(image_widget,ButtonPressMask| ButtonReleaseMask | Button1MotionMask ,False,coord_imag,NULL);
	XDefineCursor(dpy,W_image,Cursim);
}

void coord_edit1(w,data,event)
Window w;
register XPointerMovedEvent *event;
{
	register x, y;
	register but, flg2;
	x = event->x;
	y = event->y;
	if(x < 0 || y < 0) return;
	if(x >= im_w || y >= im_h) return;  /* hors limites */
	but = event->state & (Button1Mask | Button3Mask);
	flg2 = Cursed == Cursed0 ? 0 : 1;
	if(but == 0)
		cmn_coord_image(x,y,0,flg2);
	else {
		but = but & Button1Mask ? 1 : 3;
		but = 2;
		cmn_edit_pt(x,y,but,0);
	}
	evreturnvoid(NOOP);
}

void coord_edit(w,data,event)
Window w;
register XButtonPressedEvent *event;
{
	register x, y;
	register but;
	but = event->button;
	x = event->x;
	y = event->y;
	if(x < 0 || y < 0) return;
	if(x >= im_w || y >= im_h) return;  /* hors limites */
	if(event->state & ShiftMask)
		but |= 0x100;
	cmn_edit_pt(x,y,but,1);
	evreturnvoid(NOOP);
}


par_valid(w, event, params, num_params)
Widget w;
XEvent *event;
String *params;			
Cardinal *num_params;
{
	char *s, *sr, *sg, *sb;
	s = XawDialogGetValueString(par_dial_widget);
	xvset_params(s);
	if(*num_params >= 1) {
		switch(**params) {
		case 'r':
			b_same();
			break;
		case 'n':
			chg_image(1);
			break;
		case 'p':
			chg_image(-1);
			break;
		}
	}
}

imag_prog(w, event, params, num_params)
Widget w;
XEvent *event;
String *params;			
Cardinal *num_params;
{
	register c, n;
	if(*num_params >= 1) {
		switch(c = **params) {
		case 'r':      /* reread */
			b_same();
			break;
		case 'n':   /* next */
			chg_image(1);
			break;
		case 'N':  /* CTRL n */
		  b_nextz();
		  break;
			
		case 'p':  /* previous */
			chg_image(-1);
			break;
		case 'P':  /* CTRL p */
		  b_prevz();
		  break;
		case 'q':  /* quit */
			b_exit();
			break;
		case 'l':
			start_loop();
			break;
		case 'L':   /* Ctrl L */
			scroll_image(0,0);
			break;
		case 'z':
			start_zloop();
			break;
		case 'e':
			if(flg_edit)
				b_edit();
			break;
		case 'X':
		case 'E':
		case 'A':
			if(!sh_state)
				break;
			if(c == 'X')
				sh_exec();
			else if(c == 'E')
				sh_repeat();
			else
				sh_abort();
			break;
		case 'H':
			b_help();
			break;
		case 'C':
			b_cmap();
			break;
		case 'S':
			b_shell();
			break;
		case 'F':	 /* Ctrl-f : new file list */
			xvf_create();
			break;
		case '0':	 /* Meta-c : copy */
			bd_copy();
			break;
		case '1':	 /* Meta-p : paste */
			bd_paste();
			break;
		case '2':	 /* Meta-t : paste text */
			bd_ptext();
			break;
		case '3':	 /* Meta-i : invert */
			bd_inv();
			break;
		case '4':	 /* Meta-u : undo */
			bd_undo();
			break;
		case '+':	 /* brightness + */
			n = 2;
			if(*(*params + 1) == '+')
				n++;
			bright_modif(n);
			break;
		case '-':	 /* brightness - */
			n = 0;
			if(*(*params + 1) == '-')
				n++;
			bright_modif(n);
			break;
		case '/':	 /* brightness reset */
			bright_modif(5);
			break;
		case '<':  /* CTRL < */
		  b_prevv();
		  break;
		case '>':  /* CTRL > */
		  b_nextv();
		  break;
			
		}
	}
}

bd_dump()
{
	char *s;
	s = XawDialogGetValueString(dump_dial_widget);
	xvdump(s);
}

/* set a point on the screen  : only if pix_im != 0 */
set_scr_pt(pt,but)
register struct screenpt *pt;
register but;
{
	register Pixmap px;
	if(debug_)
		fprintf(stderr,"set screen point (%d,%d)\n",pt->x,pt->y);
	if(pix_im == 0)
		return 1 /* makes c99 happy */; 
	XCopyArea(dpy,edvals.pmap[but-1],pix_im,defgc,0,0,edvals.nx,edvals.ny,pt->x,pt->y);
	XCopyArea(dpy,edvals.pmap[but-1],W_image,defgc,0,0,edvals.nx,edvals.ny,pt->x,pt->y);
}

xvbell()
{
	XBell(dpy,100);
}

xvimage_menu(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	if(debug_)
		fprintf(stderr,"menu image %s\n",tabim[(long)cl_data -1]);
	image_menu(cl_data);
}

#if 0
/* exit ou next/prev pour images sans boutons : SHIFT + bouton qque */
but_exit(w,data,event)
Window w;
register XButtonPressedEvent *event;
{
	register but;
	if(event->state & ShiftMask)
		exit(0);
	but = event->button;
	if(but == 1)
		chg_image(1);
	else chg_image(-1);
}
#else
/* fenetre sans boutons : btn 1 => next, autres idem mode normal */
but_exit(w,data,event)
Window w;
register XButtonPressedEvent *event;
{
	register but;
	but = event->button;
	if(!(event->state & ShiftMask) && (but == 1)) {
		if(event->type == ButtonPress)
			chg_image(1);
		return 1 /* makes c99 happy */; 
	}
	coord_imag(w,data,event);
}
#endif


int myXError(dp,evnt)
Display *dp;
XErrorEvent *evnt;
{
	register i;
	char errb[256], dflt[256], msg[12];
	i = I_XERR;
	if((evnt->request_code == X_CreatePixmap) && (evnt->error_code == BadAlloc) && (evnt->resourceid == pix_im)) {
		i = I_XERRPIX;  /* create pixmap err */
		pix_im = 0;
		imerror(i,"enable nopix mode\n");
	}
	XGetErrorText(dp,evnt->error_code,errb,256);
	sprintf(msg,"%d",evnt->request_code);
	XGetErrorDatabaseText(dpy,"XRequest",msg,dflt,dflt,256);
	imerror(i,"X error : %s in %s [0x%x]\n",errb,dflt,evnt->resourceid);
}

/* toggle loop */
start_loop()
{
	Widget w;
	XtArgVal code;
	w = (Widget)b_list[B_LOOP]->b_win;
	if(w) {
		code = True;
		if(loop_mode & LOOP)
			code = False;
		XtSetArg(args[0],XtNstate,code);
		XtSetValues(w,args,1);
	}
	b_loop(w);
}

b_loop(w)
Widget w;
{
	toggle_loop(w,LOOP);
	evreturn( NOOP);
}

/* toggle zloop */
start_zloop()
{
	Widget w;
	XtArgVal code;
	w = (Widget)b_list[B_ZLOOP]->b_win;
	if(w) {
		code = True;
		if(loop_mode & ZLOOP)
			code = False;
		XtSetArg(args[0],XtNstate,code);
		XtSetValues(w,args,1);
	}
	b_zloop(w);
}

b_zloop(w)
Widget w;
{
	register i;
	if((i = toggle_loop(w,ZLOOP)) > 0) {
		xv_scr_orig(&cur_scr_top);
		sc2im_coord(&cur_scr_top,&cur_ima_top);
		sc2im_coord(&cur_scr_top,&cur_ima);
	} else if(i < 0) {  /* put right plane at top */
		scroll_image(cur_scr.x,cur_scr.y);
	}
	evreturn( NOOP);
}

/* retourne 1 si loop activee, -1 si desactivee, 0 sinon */
toggle_loop(w,code)
Widget w;
int code;
{
	register i;
	if(loop_mode & code) {
		loop_mode ^= code;
		if((code == LOOP) || (code == ZLOOP))
			loop_widget = NULL;
		return -1;
	}
	/* LOOP & ZLOOP are exclusive */
	if((code == LOOP) || (code == ZLOOP)) {
		if(loop_widget) {
			XtSetArg(args[0],XtNstate,False);
			XtSetValues(loop_widget,args,1);
			if(code == LOOP)
				loop_mode &= ~ZLOOP;
			else
				loop_mode &= ~LOOP;
		}
		loop_widget = w;
	}
	loop_mode |= code;
	return 1;
}

xvopt_menu(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register struct menu_item *pi;
	register v, j, n;
	register m;
	n = (int)cl_data;
	pi = (struct menu_item *)&OPT_menulist[n];
	j = pi->val >> 16;
	v = pi->val & 0xffff;
	switch(j) {
	case OM_NBCOL:
		if(v == 0 && opt_c254) {
			opt_c254 = 0;
			set_option(n,1);
			set_option(n+1,0);
		} else if(v == 1 && !opt_c254) {
			opt_c254 = 1;
			set_option(n,1);
			set_option(n-1,0);
		}
		break;
	case OM_MMX:
		flg_mmx ^= 1;
		set_option(n,flg_mmx);
		break;
	case OM_PRINT:
		m = 1 << v;
		flg_print ^= m;
		set_option(n,flg_print & m);
		break;
	case OM_EDP:
		flg_pr_edit ^= 1;
		set_option(n,flg_pr_edit);
		break;
	case OM_HZ:
		opt_z_horiz ^= 1;
		set_option(n,opt_z_horiz);
		break;
	case OM_ZLREVERSE:
		flg_rv_zloop ^= 1;
		set_option(n,flg_rv_zloop);
		break;
	case OM_LREVERSE:
		flg_rv_loop ^= 1;
		set_option(n,flg_rv_loop);
		break;
	case OM_PIXF:
		if(v == 0)
		  flg_pix_fromfile = (flg_pix_fromfile & 1) ^ 1;
		else {
		  n--;
		  flg_pix_fromfile = (flg_pix_fromfile & 2) ^ 2;
		}
		set_option(n,flg_pix_fromfile & 1);
		set_option(n+1,flg_pix_fromfile & 2);
		clear_rdpix();
		break;
	case OM_TXTFOND:
		flg_txt_fond ^= 1;
		set_option(n,flg_txt_fond);
		break;
	case OM_DEBUG:
		if(debug_) {
			debug_ = 0;
			set_option(n,0);
		} else {
			debug_ = 1;
			inr_dballoc = 1;
			set_option(n,1);
		}
		break;
	case OM_FILES:
		xvf_create();
		break;
	case OM_CURSOR:
		m = 1 << v;
		if(m == CURS_OP_VAR) {
			def_curs_var(n);
			return 1 /* makes c99 happy */; 
		}
		curs_options ^= m;
		if(m == CURS_OP_ED) {
			if(curs_options & m) {
				set_option(n,1);
				Cursed = Cursvar ? Cursvar : Cursed0;
			} else {
				set_option(n,0);
				Cursed = Cursed0;
			}
			if(edit.active)
				XDefineCursor(dpy,W_image,Cursed);
			break;
		}
		if(!(curs_options & m)) {
			curs_new_type = CURS_NORMAL;
			set_option(n,0);
		} else {
			curs_new_type = CURS_DBLE_H;
			set_option(n,1);
			set_option(n+1,0);
			curs_options &= ~CURS_OP_VAR;
		}
		set_cursor();
		break;
	case OM_FOLLOW_M1:
		flg_follow_mouse ^= 1;
		set_option(n,flg_follow_mouse);
		break;
	}
}

draw_xline(oldima,ima)
register struct imagept *ima, *oldima;
{
	struct screenpt scr1, scr2;
	XGCValues gcv;
	gcv.function = GXcopy;
	init_gc(&fillgc,&gcv);
	im2sc_coord(oldima,&scr1);
	im2sc_coord(ima,&scr2);
	XDrawLine(dpy,W_image,fillgc,scr1.x,scr1.y,scr2.x,scr2.y);
	XDrawLine(dpy,pix_im,fillgc,scr1.x,scr1.y,scr2.x,scr2.y);
}


