/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <inrimage/image.h>
#include "xvis.h"
#include "xvglobl.h"


extern char *addbutton(), *addlabel();
extern char xv_label0[], xv_label[];


initwin(lfmti,lfmt,first,depth)
Fort_int lfmti[9], lfmt[9];
int first, depth;
{
	register i, w, h, k;
	register char *s;
	int nx, ny;
	nx = DIMX;
	ny = DIMY;
	im_h1 = NDIMY;
	im_nz = NDIMZ;
	im_nbv = NDIMV;
	if(nbim > 0)
		ptim = &tabim[numim-1];
	else
		ptim = tabim;
	im_h = ny;
	if(depth == 1) {
		im_wb = ((nx + 15) >> 4) << 1;
		im_w = im_wb << 3;
		im_size = im_wb * im_h1;
		im_w1b = im_wb;
		im_w1 = im_w;
	} else {
		flg_z_horiz = opt_z_horiz;
		if(flg_nopix)
			flg_z_horiz = 0;   /* silently ignore -hz */
		if(! (truecol_type & I_VCOL) && (NDIMV > 1))
		  flg_z_horiz = 0;   /* silently ignore -hz */
		if(flg_z_horiz) {
			if(nb_hz > im_nz)
				nb_hz = im_nz;
			if(nb_hz == 1)
				flg_z_horiz = 0;
		}
		im_w1 = nx;
		im_w1v = NDIMX;
		im_w1b = byte_pixel * im_w1;
		im_size = ((im_w1b + 1) & ~1) * im_h1;  /* lignes multiples de 16 bits pour affichage */
		if(flg_z_horiz) {
			im_ncolz = nb_hz;
			im_nrowz = (im_nz + nb_hz - 1) / nb_hz;
			if((im_last_ncolz = im_nz % nb_hz) == 0)
				im_last_ncolz = im_ncolz;
			im_h = im_h1 * im_nrowz;
			im_w = im_w1 * im_ncolz;
			im_wb = im_w1b * im_ncolz;
			im_lastw = im_last_ncolz * im_w1;
			im_lasth = (im_nrowz - 1) * im_h1;
		} else {
			im_w = im_w1;
			im_wb = im_w1b;
		}
	}

	/* prepare the image label and param label */
	prp_imlabel(ptim,lfmti);
	prp_params(paramslabel);
	initxwin(first,depth);
	old_im_w = im_w;
	old_im_h = im_h;
}

allocbufs()
{
	long ndim;
	register n, n1;
	int nx, ny;
	register nxi, nxo;
	register nlig;
	ny = NDIMY;
	nx = DIMX;
	n = BSIZE < 0 ? (-BSIZE +7) / 8 : BSIZE;
	nxi = n * DIMX;
	nxo = echan(DIMX);
	i_Free((char **)&aout_buffer);
	i_Free((char **)&ain_buffer);
	if(fl_peano) {
/*!!		nlig = echan(NDIMY); */
		nlig = lfmto[I_NDIMY];
		n = (nlig - 1) * nxo;
		/* il faut lire au moins 'pas' lignes */
		n1 = ((pas * nxi) <= nxo) ? nxo : (pas * nxi);
		n += n1 + 4;  /* !! pour etre toujours aligne */
		if(flg_fix < 0) {
		/*	ain_buffer = in_buffer = (unsigned char *)xvcalloc(n,1);*/
			ain_buffer = in_buffer = (unsigned char *)0;
		} else
			ain_buffer = in_buffer = (unsigned char *)xvmalloc(n);
		in_bufsize = n;
		flg_out_all = 1;
		nblig_out = nlig;
		aout_buffer = out_buffer = (unsigned char *)xvcalloc(im_size, 1);
		return 1 /* makes c99 happy */; 
	}
	n = koctet_ * 1024;
	flg_out_all = 0;
	if((nlig = calcnlig(n,lfmt,&ndim)) <= 0)
		imerror(8,"allocbufs: pas assez de memoire, utilisez option -k\n");
	nblig_out = echan(nlig);
	nblig_in = nlig;
	if(scrdepth == 1)
		nblig_out *= g_size;
	if((flg_edit <= 1) && (scrdepth > 1) &&
	   ((truecol_type == I_MONO) || (truecol_type == I_VCOL))) {
		n = nblig_out * im_w1b;
		ain_buffer = 0;
		if(ndim < n)
			ndim = n;
		aout_buffer = (unsigned char *)xvcalloc(ndim, 1);
		out_buffer = in_buffer = aout_buffer;
	} else {
		if(flg_fix < 0) {
		/*	ain_buffer = in_buffer = (unsigned char *) xvcalloc(ndim,1);*/
			ain_buffer = in_buffer = (unsigned char *)0;
		} else
			ain_buffer = in_buffer = (unsigned char *) xvmalloc(ndim);
		if(file_type == PIPE) {
			flg_out_all = 1;
			nblig_out = lfmto[I_NDIMY];
		}
		aout_buffer = out_buffer = (unsigned char *)xvcalloc(im_w1b * nblig_out, 1);
	}
	in_bufsize = ndim;
}
      

initblist(ptb)
register struct button *ptb;
{
	register i;
	for(i=0;i<Nboutons;i++) {
		b_list[ptb->b_cod] = ptb;
		ptb++;
	}
/*	b_list[B_STEP]->b_inv = 1; */
}

createbuttons(w,blist,n)
register long *w;
register struct button **blist;
register n;
{
register struct button *pbt;
register k;
	for(k=0;k<n;k++) {
		if((pbt = blist[k]) == 0) continue;
		pbt->b_win = (long *) addbutton(w,pbt);
	}
}

createlabels(w,blist,n)
register long *w;
register struct button **blist;
register n;
{
register struct button *pbt;
register k;
	for(k=0;k<n;k++) {
		if((pbt = blist[k]) == 0) continue;
		pbt->b_win = (long *) addlabel(w,pbt);
	}
}

/* prepare params label */
prp_params(label)
register char *label;
{
	if(fl_peano) {
		*label++ = '-';
		*label++ = 'P';
		*label++ = ' ';
	}
	sprintf(label,"-s %d",g_size);
	label += strlen(label);
	if(opt_pas != 1)
		sprintf(label," -p %d",opt_pas);
}
prp_mmx()
{
	sprintf(mmxlabel,"vmin= %3d, vmax= %3d",pixmin,pixmax);
}
/* prepare image label : name and format */
prp_imlabel(ptim,lfmt)
char **ptim;
Fort_int lfmt[9];
{
	char size1[256], msize[256];
	char fmt[32];
	char *label;
	register n;
	int i1, tabv[2];
	label = imagelabel;
	set_nom(ptim,label);
	sprintf(xv_label,"%s (%s)",xv_label0,label);
	strcpy(fmt,"-x %d -y %d");
	i1 = 0;
	if(NDIMV > 1) {
		strcat(fmt," -v %d");
		tabv[0] = NDIMV;
		i1 = 1;
	}
	if(NDIMZ > 1) {
		strcat(fmt," -z %d");
		tabv[i1] = NDIMZ;
	}
	sprintf(size1,fmt,NDIMX,NDIMY,tabv[0],tabv[1]);
	if(nbim != 1)
		sprintf(msize," <%2d> %s",numim,size1);
	else
		sprintf(msize," <  > %s",size1);
	strcat(label,msize);
}

/* copie dans nmi la partie principale du nom de fichier ptim */
set_nom(ptim,nmi)
register char **ptim;
char *nmi;
{
register k, i;
register char *s;
	if(ptim == 0) {
		nmi[0]= 0;
		return 1 /* makes c99 happy */; 
	}
	s = *ptim;
	if(*s != 0 && *s != '<') {
		i = strlen(s);
		s += i-1;
		while(i-- > 0) {
			if(*s == '/') break;
			s--;
		}
		s++;
		while(*nmi++ = *s++)
			;
	} else 
		nmi[0] = 0;
}

wrt_label(num,strg)
register num;
register char *strg;
{
	l_list[num]->b_text = strg;
	wrlabel(num);
}

/* inscrit les coord. du point image dans la fenetre
et ecrit sur stdout selon le numero de bouton :
3 nbs (x,y,z) si but == 2, -ix n -iy n -iz n si but==3
si but + 0x100 on n'ecrit rien sur stdout, mais on 
garde les extremite de la zone 
(extr 1 si but 2 dans zonept0, extr 2 si but 3 dans zonept1)
si but 1 + 0x100 : toggle validation/devalidation boite
(en utilisant zonept0.val (0 ou 1)
flg_2curs : 1 si on doit tester double curseur
*/
cmn_coord_image(x,y,but,flg_2curs)
register x, y, but, flg_2curs;
{
	struct screenpt scr, scr2;
	struct imagept ima, ima2, *p2;
	if(x < 0 || y < 0) return 1 /* makes c99 happy */; 
	if(x >= im_w || y >= im_h) return 1 /* makes c99 happy */;   /* hors limites */
	if(flg_z_horiz)
		if((y >= im_lasth) && (x >= im_lastw)) return 1 /* makes c99 happy */;   /* hors limites */
	scr.x = x;
	scr.y = y;
	sc2im_v_coord(&scr,&ima);
	p2 = (struct imagept *)0;
	if(flg_2curs && (curs_type & CURS_ORIENT)) {
		scr2.x = x + curs_offset.x;
		scr2.y = y + curs_offset.y;
		if((scr2.x < im_w) && (scr2.y < im_h)) {
			sc2im_v_coord(&scr2,&ima2);
			p2 = &ima2;
		}
	}
	affiche_coord(&ima,p2);
	if(flg_cmap_pick) {
		do_cmap_pick(ima.val,but);
		return 1 /* makes c99 happy */; 
	}
	if(but & 0x100) { /* memorise  zones */
		but &= ~0x100;
		if(but == 1) {
			zonept0.val ^= 1;
		}
		if(but == 2)
			xvcopybuf(&ima,&zonept0,sizeof(ima));
		if(but == 3) {
			xvcopybuf(&ima,&zonept1,sizeof(ima));
		}
		if(but != 1)
			zonept0.val = 1;  /* validation */
		xvsh_showbox();  /* afficher les valeurs */
	} else if(flg_print && (but == 2 || but == 3)) {
		print_coord(but,&ima);
		if(p2)
			print_coord(but,p2);
	}
}
affiche_coord(ima,ima2)
register struct imagept *ima, *ima2;
{
	register val, i;
	register char *pc;
	struct imagept *ims[2];
	register struct imagept *pi;
	ims[0] = ima;
	ims[1] = ima2;
	pc = coordlabel;
	memcpy(&cur_ima_pt,ima,sizeof(struct imagept));
	for(i=0;i<2;i++) {
		if((pi = ims[i]) == (struct imagept *)0)
			continue;
		if(i > 0) {
			sprintf(pc,"  \n");
			pc += 3;
		}
		sprintf(pc,"X %-4d Y %-4d",pi->vx +1,pi->zy +1);
		pc += strlen(pc);
		if(im_nz > 1) {
			sprintf(pc," Z %-4d",pi->z +1);
			pc += strlen(pc);
		}
		if(flg_sep_comp) {
			sprintf(pc," V %-4d",pi->v +1);
			pc += strlen(pc);
		}
		if((val = pi->val) >= 0) {
			if(truecol_type > 0)  /* couleur */
				sprintf(pc," : %4d %4d %4d",(val >> 16) & 0xff,
					(val >> 8) & 0xff, val & 0xff);
			else
				sprintf(pc," : %4d",val & 0xff);
			pc += strlen(pc);
		} else if((val = pi->val) == -2) {
			if(truecol_type > 0)  /* couleur */
				sprintf(pc," : %5f %5f %5f",pi->fval[0],pi->fval[1],pi->fval[2]);
			else
				sprintf(pc," : %5f",pi->fval[0]);
			pc += strlen(pc);
		}
	}
	wrt_label(L_XY,coordlabel);
}

print_coord(but,ima)
register but;
register struct imagept *ima;
{
  if(flg_print & 1) {
    if(but == 2)
      printf("%d %d %d %d",ima->vx+1,ima->zy+1,ima->z+1,ima->v+1);
    else 
      printf("-ix %d -iy %d -iz %d -iv %d",ima->vx+1,ima->zy+1,ima->z+1,ima->v+1);
  }
  if(flg_print & 2) {
    if(but == 3)
      printf(" -pix=");
    else
      printf(" ");
    if(ima->val == -2) {
      if(truecol_type > I_MONO) {
	printf("%f,%f,%f",ima->fval[0],ima->fval[1],ima->fval[2]);
      } else {
	printf("%f",ima->fval[0]);
      }
    } else {
      if(truecol_type > I_MONO) {
	printf("%d,%d,%d",(ima->val >> 16),(ima->val >> 8) & 0xff,ima->val & 0xff);
      } else {
	printf("%d",ima->val & 0xff);
      }
    }
  }
  printf("\n");
  fflush(stdout);
}
/* convertit coord ecran en coord image et donne la valeur pixel si 8 bits */
sc2im_v_coord(scr,ima)
register struct screenpt *scr;
register struct imagept *ima;
{
	sc2im_coord(scr,ima);
	if(scrdepth != 1 || flg_pix_fromfile) {
		if(scr->x > im_w || scr->y > im_h)
			ima->val = -1;
		else {
		  if(flg_pix_fromfile) {
		    if(flg_pix_fromfile & 1) {
		      ima->val = xv_rdpix(ima->x,ima->y);
		    } else {
		      ima->val = xv_rdpixv(ima->x,ima->y,&ima->fval);
		    }
		  }  else
		    ima->val = xvgetpixim(scr->x,scr->y);
		}
	}
}

sc2im_coord(scr,ima)
register struct screenpt *scr;
register struct imagept *ima;
{
	register n;
	int nx0 = im_w1 / im_nbv;
	if(flg_z_horiz) {
	  ima->vx = (((scr->x % nx0) / g_size) * pas) / zoom;
	  ima->v = iv0 + (scr->x / nx0) % im_nbv;
	  ima->x = ima->vx * im_nbv + ima->v;
	  ima->z = iz0 + (((scr->y / im_h1) * im_ncolz) + scr->x / im_w1) * zpas;
	  ima->zy = (((scr->y % im_h1) / g_size) * pas) / zoom;
	  ima->y = ima->zy + ima->z * NDIMY;
	} else {
	  ima->vx = (((scr->x % nx0) / g_size) * pas) / zoom;
	  ima->v = iv0 + ((scr->x / nx0) % im_nbv);
	  ima->x = ima->vx * im_nbv + ima->v;
	  ima->z = iz0 + (scr->y / im_h1) * zpas;
	  ima->zy = (((scr->y % im_h1) / g_size) * pas) / zoom;
	  ima->y = ima->zy + ima->z * NDIMY;
	}
	ima->val = -1;
}

im2sc_coord(ima,scr)
register struct screenpt *scr;
register struct imagept *ima;
{
	register z;
/*	z = ima->z - iz0; ?? */
	if(flg_z_horiz) {
		z = zechan(ima->z);
		scr->x = echan(ima->vx) * g_size + ima->v + (z % im_ncolz) * im_w1;
		scr->y = (z / im_ncolz) * im_h1 + g_size * (echan(ima->zy)) ;
	} else {
		scr->x = echan(ima->vx) * g_size + ((ima->v -iv0) * im_w1v);
		scr->y = g_size * (echan(ima->zy)) + zechan((ima->z - iz0)) * im_h1;
	}
}

/*
 * Error - Fatal error.
 */
Error(string)
	char *string;	/* Error description string. */
{
	fprintf(stderr, "%s: Error => %s\n", xargv[0], string);

	if (errno != 0) {
		perror(xargv[0]);
		fprintf(stderr, "\n");
	}

	exit(1);
}

int xvcmpbuf(a,b,n)
register unsigned char *a, *b;
register n;
{
	while(n-- > 0)
		if(*a++ != *b++) return 1;
	return 0;
}
xvcopybuf(a,b,n)
register unsigned char *a, *b;
register n;
{
	while(n-- > 0)
		*b++ = *a++;
	return 0;
}

/* initialisation des parametres */
init_params()
{
	if(new_params) {  /* modif demandee? */
		fl_peano = new_fl_peano;
		opt_pas = new_opt_pas;
		g_size = new_g_size;
		zpas = new_zpas;
		opt_nb_hz = new_nb_hz;
		deb_plan = new_deb_plan;
		nb_plan = new_nb_plan;
		deb_vcomp = new_deb_vcomp;
		nb_vcomp = new_nb_vcomp;
		vis_exp = new_vis_exp;
	}
	nb_hz = opt_nb_hz;
	if(nb_hz <= 0)
		nb_hz = 100000;
	if(fl_peano == 1 || (BSIZE == -1 && TYPE == -1 && scrdepth == 1)) {
		zoom = 1;
		if(opt_pas <= 0) {
			if(opt_pas < -1)
				g_size = -opt_pas;
			opt_pas = 1;
		}
		pas = opt_pas;
	} else {
		if(opt_pas == 0 || opt_pas == -1)
			opt_pas = 1;
		if(opt_pas < 0) {
			pas = 1;
			zoom = -opt_pas;
		} else {
			pas = opt_pas;
			zoom = 1;
		}
	}
	if(zpas <= 0) zpas = 1;
	new_params = 0;
}

/* flg_im 1 => on a change d'image : recalculer xtrans */
set_initial_ct(flg_im)
register flg_im;
{
	register flgcl;
	register unsigned char *pc;
	register unsigned char **pp_new_ct;
	int i0, nb;
	register i, j;

	pp_new_ct = p_cts;
	for(i=0;i<4;i++)
		shft_val[i] = 0;
	if(cmap_type & CMAP_IMAGE) {
		flgcl = 0;
		if(!xvnftab[0]) {
			flgcl = 1;
			g_open(xvnftab,ptim,"e","",lfmt,0);
		}
		ird_ctrgb(xvnftab[0],&i0,&nb,(char *)*(pp_new_ct + C_ROUGE),(char *)*(pp_new_ct + C_VERT),(char *)*(pp_new_ct + C_BLEU),NCOLOR);
		if(flgcl)
			g_close();
	} else if(cmap_type & CMAP_FILE) {
		pp_cur_ct = p_cts;
		read_colors();
	} else if(cmap_type & CMAP_LIN) {
		pc = *pp_new_ct;
		for(j=0;j<3;j++) {
			for(i=0;i<NCOLOR;i++) {
				*pc++ = i;
			}
		}
	} else if(cmap_type & CMAP_PREV) {
		fastcpy(*pp_prev_ct,*pp_new_ct,3*NCOLOR);
		fastcpy(*pp_prev_sc,*pp_sc_ct,NCOLOR);
	} else if(cmap_type == CMAP_CURR) {
		fastcpy(*pp_cur_ct,*pp_new_ct,3*NCOLOR);
		if(pp_cur_sc != pp_sc_ct)
			fastcpy(*pp_cur_sc,*pp_sc_ct,NCOLOR);
	} else if(cmap_type & (CMAP_TAB1 | CMAP_TAB2 | CMAP_RAND | CMAP_XRAND))
		mk_deftables();
	pp_cur_ct = pp_new_ct;
	pp_X_ct = pp_cur_ct;
	pp_cur_sc = pp_sc_ct;
	if(flg_im && (((truecol_type > I_MONO) && (scrdepth == 8)) || (scrdepth == 16)))
		init_rvb_tb(scrdepth);
	init_tc(scrdepth);
	if(!(cmap_type & CMAP_PREV)) {
		fastcpy(*pp_cur_ct,*pp_prev_ct,3*NCOLOR);
		fastcpy(*pp_sc_ct,*pp_prev_sc,NCOLOR);
	}
	/* init table de transcodage des pixels */
	if(flg_im)
		xvinit_trans();
	else
		xvset_tc();
}

/* init table couleur */
init_tc(depth)
int depth;
{
	register i, cmax;
	register m, j;
	register unsigned char *ptc, *psc, *pti;
	cmax = depth == 1 ? 1 : 3;
	ncolor = NCOLOR;
	m = 1;
	psc = *pp_cur_sc;
	for(j=0;j<3;j++) {
		pti = *(pp_cur_ct + j);
		ptc = *(pp_cur_ct + 3 + j);
		if(scale_tc & m) {
			for(i=0;i<NCOLOR;i++)
				*ptc++ = *(psc + *pti++);
		} else
			fastcpy(pti,ptc,NCOLOR);
		m <<= 1;
	}
	pp_cur_ct += 3;
	ptc = *pp_cur_ct;
	if(depth != 1) {
		if(cmap_type & CMAP_ED) {
			if(cmap_type & CMAP_EDR) {
				*(ptc + C_ROUGE * NCOLOR + EDCOLOR) = 200;
				*(ptc + C_VERT * NCOLOR + EDCOLOR) = 0;
				*(ptc + C_BLEU * NCOLOR + EDCOLOR) = 64;
			} else {
				*(ptc + C_ROUGE * NCOLOR + EDCOLOR) = 0;
				*(ptc + C_VERT * NCOLOR + EDCOLOR) = 200;
				*(ptc + C_BLEU * NCOLOR + EDCOLOR) = 128;
			}
		}
	}
	pp_X_ct = pp_cur_ct;
	if(truecol_type > 0) {
	  if (scrdepth == 8) {
		for(i=0;i<cmax;i++)
		  setrvbtc8(i);
	  } else if(scrdepth == 16) {
		for(i=0;i<cmax;i++)
		  setrvbtc16(i);
	  }
	}
}

/* initialise rvb_shft, rvb_msk et rvb_rshft */
init_rvb_tb(depth)
int depth;
{
  register i, n, s;
  if(depth == 8) {
    n = ncol_2bits;
    if(n < 0)
      n = 0;
    else if(n > 2)
      n = 2;
    rvb_msk[0] = 0xe0;
    rvb_msk[1] = 0xe0;
    rvb_msk[2] = 0xe0;
    rvb_msk[n] = 0xc0;
    s = 0;
    for(i=0;i<3;i++) {
      rvb_shft[i] = s;
      s += i == n ? 2 : 3;
    }
    rvb_rshft[2] = 0;
    rvb_rshft[1] = 8 - rvb_shft[2];
    rvb_rshft[0] = 8 - rvb_shft[1];
    return 1 /* makes c99 happy */; 
  }
  /* 16 bits */
  rvb_msk[0] = 0xf8;
  rvb_msk[1] = 0xfc;
  rvb_msk[2] = 0xf8;
  rvb_shft[Xcol_order[C_ROUGE]] = 11;
  rvb_rshft[Xcol_order[C_ROUGE]] = 3;
  rvb_shft[Xcol_order[C_VERT]] = 5;
  rvb_rshft[Xcol_order[C_VERT]] = 2;
  rvb_shft[Xcol_order[C_BLEU]] = 0;
  rvb_rshft[Xcol_order[C_BLEU]] = 3;
}

/* calcule table couleur pour composante ntc, dans le cas dpy 8bits
calcule table inverse (8bits -> 3 ou 2 bits)
*/
setrvbtc8(ntc)
int ntc;
{
	register i, s, msk, n;
	register cmax;
	register c2;
	register n2;
	register unsigned char *pi;
	register unsigned char *po;
	register unsigned char *pt;
	unsigned char rvb_vals[8];
	pp_X_ct = pp_cur_ct + 3;
	pi = *(pp_cur_ct + ntc);
	po = *(pp_X_ct + ntc);
	s = rvb_shft[ntc];
	msk = rvb_msk[ntc] >> s;
	s = rvb_rshft[ntc];
	cmax = msk >> s;  /* indice max  dans la couleur */
	pt = cmax == 3 ? rvb_tc2b : rvb_tc3b;
	for(i=0;i<=cmax;i++)
		rvb_vals[i] = *(pi + *(pt + i));
	for(i=0;i<NCOLOR;i++) {
		c2 = (i & msk) >> s;
		*po++ = rvb_vals[c2];
	}
	/* calcul des tables de codage pixels */
	po = ptabc24_8[ntc];
	if(cmax == 7) {
		pt = rvb_lg3b;
		n2 = 32;
	} else {
		pt = rvb_lg2b;
		n2 = 64;
	}

	for(i=0;i<=cmax;i++) {
		c2 = *(pt + i);
		for(n=0;n<c2;n++)
			*po++ = i << s;
		for(;n<n2;n++)
			*po++ = (i+1) << s;
	}
}

/* calcule table couleur pour composante ntc, dans le cas dpy 16bits
calcule table inverse (16bits -> 5 ou 6 bits) 
*/
setrvbtc16(ntc)
int ntc;
{
	register i, s, msk, n;
	register cmax;
	register c2;
	register n2;
	register unsigned char *pi;
	register unsigned short *po;
	register unsigned char *pt;
	unsigned char rvb_vals[64];
	float v;
	pp_X_ct = pp_cur_ct + 3;
	pi = *(pp_cur_ct + ntc);
	po = (unsigned short *) *(pp_X_ct + ntc);
	msk = rvb_msk[ntc];
	s = rvb_rshft[ntc];
	cmax = msk >> s;  /* indice max  dans la couleur */
	pt = cmax == 3 ? rvb_tc2b : rvb_tc3b;
	rvb_vals[0] = 0;
	rvb_vals[cmax] = 255;
	v = 255 / cmax;
	for(i=1;i<cmax;i++)
	  rvb_vals[i] = *(pi + (int)(i * v + .5));

	for(i=0;i<NCOLOR;i++) {
		c2 = (i & msk) >> s;
		*po++ = rvb_vals[c2];
	}
	/* calcul des tables de codage pixels */
	po = ptabc24_16[ntc];
	c2 = 256 / (cmax+1);
	s = rvb_shft[ntc];
	for(i=0;i<=cmax;i++) {
	  for(n=0;n<c2;n++)
	    *po++ = i << s;
	}
}

/* initialisation table de transcodage pour conserver blackpixel et whitepixel */
xvinit_trans()
{
	register i;
	register black, white;
	register v;
	register n;
	register unsigned char *pt;
	register imin, imax, min, max;
	if(scrdepth == 1) return 1 /* makes c99 happy */; 
	pt = *pp_X_ct;
	for(i=0;i<NCOLOR;i++) {
		xtrans[i] = i;
	}
	flg_c254 = opt_c254;
	if(flg_c254) {
		i = 0;
		trans_pix[i].pix_in = 0;
		trans_pix[i++].pix_out = 3;
		trans_pix[i].pix_in = 1;
		trans_pix[i++].pix_out = 2;
		trans_pix[i].pix_in = 3;
		trans_pix[i++].pix_out = 4;
		trans_pix[i].pix_in = 255;
		trans_pix[i++].pix_out = 253;
		trans_pix[i].pix_in = 253;
		trans_pix[i++].pix_out = 255;
		nb_trans_pix = i;
		for(i=0;i<NCOLOR;i++)  /* init table inverse */
			xtransi[i] = i;
	} else if(!flg_Xtc) {
		min = RLUM * *pt + GLUM * *(pt + NCOLOR) + BLUM * *(pt + 2 * NCOLOR);
		max = min;
		imin = imax = 0;
		for(i=1;i<NCOLOR;i++) {
			v = RLUM * *(pt + i) + GLUM * *(pt + i + NCOLOR) + BLUM * *(pt + i + 2 * NCOLOR);
			if(v < min) {
				imin = i; min = v;
			} else if (v >= max) {  /* on prend le dernier max */
				imax = i; max = v;
			}
		}
		imin_tc = imin; imax_tc = imax;
		black = blackpixel & 0xff;
		white = whitepixel & 0xff;
		trans_pix[0].pix_in = imin;
		trans_pix[0].pix_out = black;
		trans_pix[1].pix_in = imax;
		trans_pix[1].pix_out = white;
		i = 2;
		if((black != imin) && (black != imax)) {
			trans_pix[i].pix_in = black;
			trans_pix[i++].pix_out = white != imin ? imin : imax;
		}
		if((white != imin) && (white != imax)) {
			trans_pix[i].pix_in = white;
			trans_pix[i++].pix_out = black != imax ? imax : imin;
		}
		nb_trans_pix = i;
	} else {
		nb_trans_pix = 0;
	}
	for(i=0;i<nb_trans_pix;i++) 
		xtrans[(int)trans_pix[i].pix_in] = trans_pix[i].pix_out;
	/* table inverse */
	for(i=0;i<NCOLOR;i++)
		xtransi[xtrans[i]] = i;
	return 1 /* makes c99 happy */; 
}

/* applique une table de transcodage sur un buffer de pixels sur 1 octet 
*/
applic_tbl(buf,n,tc)
register unsigned char *tc, *buf;
register n;
{
	register v;
	while(n-- > 0) {
		v = *buf;
		*buf++ = *(tc + v);
	}
}

/* applique une table couleur sur un buffer de pixels sur 1 octet 
et calcule le min et max
*/
applic_tc(buf,n,tc)
register unsigned char *tc, *buf;
register n;
{
	register v;
	while(n-- > 0) {
		v = *buf;
		if(v < pixmin)
			pixmin = v;
		if(v > pixmax)
			pixmax = v;
		*buf++ = *(tc + v);
	}
}

/*    et calcule min et max */
xvismmx(buf,n)
register unsigned char *buf;
register n;
{
	register v;
	register vmin, vmax;
	if(!flg_mmx) return 1 /* makes c99 happy */; 
	if(pixmin < 0) {
		vmin = vmax = *buf++;
		n--;
	} else {
		vmin = pixmin;
		vmax = pixmax;
	}
	while(n-- > 0) {
		if((v = *buf++) < vmin)
			vmin = v;
		else if(v > vmax)
			vmax = v;
	}
	pixmin = vmin;
	pixmax = vmax;
}

char *xvmalloc(n)
register n;
{
	return ((char *)i_malloc(n));
}

char *xvcalloc(n1,n2)
register n1, n2;
{
	return ((char *)i_calloc(n1,n2));
}

static struct tstalign {
	long l1;
	char c;
	long l2;
} tstalign;
#define AL_MASK (sizeof(long) -1)
fastcpy(in,out,nbytes)
register char *in, *out;
register nbytes;
{
	register long *pi, *po;
	if((char *)&tstalign.l2 != ((char *)&tstalign.c) + 1) {  /* pb align */
		if((long)in & AL_MASK || (long)out & AL_MASK) {  /* byte copy */
			while(nbytes-- > 0)
				*out++ = *in++;
			return 1 /* makes c99 happy */; 
		}
	}
	pi = (long *)in;
	po = (long *)out;
	while(nbytes >= sizeof(long)) {
		*po++ = *pi++;
		nbytes -= sizeof(long);
	}
	in = (char *)pi;
	out = (char *)po;
	while(nbytes-- > 0)
		*out++ = *in++;
	return 1 /* makes c99 happy */; 
}
