/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#ifndef X11R2
#ifndef X11R3
#define X11R4
#endif
#endif
#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <sys/time.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include <X11/Xresource.h>
/*#include <X11/ResourceI.h> */
#if defined X11R3 || defined X11R4
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/X.h>
#include <X11/Xproto.h>
#else
#include <X11/Atoms.h>
#endif
#ifdef X11R4
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Viewport.h>
#else
#include <X11/VPaned.h>
#include <X11/Label.h>
#include <X11/Command.h>
#include <X11/Box.h>
#include <X11/Dialog.h>
#include <X11/AsciiText.h>
#include <X11/Viewport.h>
#endif
#if defined X11R3 
#include <X11/MenuBox.h>
#include <X11/MenuShell.h>
#include <X11/Menu.h>
#endif
#ifdef X11R4
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#endif
#include <inrimage/image.h>
#include <inrimage/error.h>
#include "xvis.h"
#include "xvglobl.h"
#include "xvxglobl.h"
#define FAILURE 0
extern int XV_simul;
extern char xv_version[];
char xv_label0[32], xv_label[80];

int exp_main(), exp_imag(), exp_head(), ev_noop(), exp_msg();
int but_main(), but_imag(), but_head(), but_msg();
int coord_imag(), but_exit();

int myXError();

extern int errno;
extern int evt_retcode;

#if DBPIX
int DB_pix= 1;  /* simul err pixmap */
#endif

char Win_name[]= "image";

int Badh;
/*#define hashcod(x) ((x + (x >> 16)) & 0x1f) */
#define hashcod(x) (x  & 0x1f)




String fallback_resources[] = { 
/* old ressources */
#if 0
	"*sh.Translations:	#override\n <Btn1Down>,<Btn1Up>:set()notify()",
	"*parbox*height:	100",
	"*parbox*width:		100",
	"*hlpbox.height: 140",
	"*xvshdial.label.borderWidth: 0",
#endif
	"*xvcmp.internalBorderWidth: 3",
	"*pdialog.value.width : 190",
#if 0
	"*pdialog.label.width : 200",
#endif
	"*.xvis-shell.width: 450",
	"*.xvis-shell.height: 500",
	"*.xvis-shell.xvsh.internalBorderWidth: 3",
	"*.xvis-shell.xvsh.xvshdial*Text.resizable: true",
	"*.xvis-shell.xvsh.xvshdial*Text.width: 400",
	"*.xvis-shell.xvsh.xvshdial.label.height: 80",
	"*.xvis-shell.xvsh.xvshdial.value.height: 80",
	"*.xvis-shell.xvsh.textbox.height: 200",
	"*.xvis-shell.xvsh.txtbox.height: 200",
	"*.xvis-shell.xvsh.textbox.file.height: 500",
	"*.xvis-shell.*sh*Translations:  #override <Btn1Down>,<Btn1Up>:set() notify()",
/* following resource must be specified */
	"*.frame.width: 490",
	"*.frame.height: 550 ",
	"*.xvis-help.width: 500",
	"*.xvis-help.height: 500",
	"*.xvis-help*xvhlplist.width: 500",
	"*.xvis-help*xvhlplist.height: 150",
	"*.xvis-cmap.width: 350",
	"*.xvis-cmap.height: 375",
	"*.xvis-cmap*xvcmapactions.width: 320",
	"*.xvis-cmap*xvcmapactions.height: 90",
	"*.xvis-cmap*xvcmappts.width: 320",
	"*.xvis-cmap*xvcmappts.height: 110",
	"*xvis-cmap*cmapbtnpts*Text.width: 120",
/* new file list popup widget */
	"*.xvfshell.width: 500",
	"*.xvfshell.height: 80",
	"*.xvfshell.xvff.width: 400",
	"*.xvfshell.xvff.height: 80",
	"*.xvfshell*select*Translations:  #override <Btn1Down>,<Btn1Up>:set() notify()",
	"*.xvfshell*modif*Translations:  #override <Btn1Down>,<Btn1Up>:set() notify()",
	"*.xvfshell*xvftext*Translations:  #override <Btn1Up>(2) : select-word() file_select() ",
	NULL,
};


static Arg args[5];
static int flg_limitpix;

static String menuTrans = "<BtnDown>:MenuPopup(Images)";

static XVisualInfo vTemplate, *visualist;


xvinit(argc,argv)
int *argc;
char **argv;
{
	register i, k;
	Arg tmp_arg[2];
	sprintf(xv_label0,"%s %s",inr_basename(xargv[0]),xv_version);
#ifdef X11R4
	toplevel = XtAppInitialize (&xvapp_con,"Xvis",NULL, 0, argc,argv,
				    fallback_resources,NULL,0);
#else
	toplevel = XtInitialize ("xvis", "Xvis", 0, 0, argc,argv);
#endif
	XtSetArg(tmp_arg[0], XtNtitle, xv_label0);
	XtSetValues(toplevel, tmp_arg, 1);
	dpy = XtDisplay(toplevel);
	screen = XtScreen(toplevel);
	scr_width = screen->width;
	scr_height = screen->height;
	screen_num = XDefaultScreen(dpy);
/*!!	defgc = XDefaultGC(dpy,screen_num); */
	if(Req_depth)
		scrdepth = Req_depth;
	else
		scrdepth = XDefaultDepth(dpy,screen_num);
/*!!	defvisual = DefaultVisualOfScreen(screen); */
/*!!	Curstd = XCreateFontCursor(dpy,XC_crosshair); */
#if 0
	Curstd = XCreateFontCursor(dpy,XC_top_left_arrow);
#endif
	Cursed0 = XCreateFontCursor(dpy,XC_hand2);
	Cursed = Cursed0;
	if(scrdepth != 8 && scrdepth != 1 && scrdepth != 24 && scrdepth != 16)
		imerror(9,"unsupported screen depth : %d\n",scrdepth);
	if((scrdepth != 0) && ! flg_Xtc) {
		int nvisual;
		vTemplate.screen = screen_num;
		vTemplate.depth = scrdepth;
		vTemplate.class = scrdepth == 1 ? StaticGray : (scrdepth == 8 ? PseudoColor : DirectColor);
		visualist = XGetVisualInfo(dpy,VisualScreenMask|VisualClassMask | VisualDepthMask ,&vTemplate,&nvisual);
		if(nvisual > 0) {
			mydefvisual = visualist->visual;
			XtSetArg(tmp_arg[0], XtNvisual, mydefvisual);
			XtSetArg(tmp_arg[1], XtNdepth, scrdepth);
			XtSetValues(toplevel, tmp_arg, 2);
		} else if(scrdepth > 8) {
			fprintf(stderr," no visual found, using option -Xtc\n");
			flg_Xtc = 1;
		} else
			imerror(9,"no acceptable visual, try -Xtc\n");
	}
	if((scrdepth != 0) && flg_Xtc) {
		mydefvisual = DefaultVisualOfScreen(screen);
		XtSetArg(tmp_arg[0], XtNvisual, mydefvisual);
		XtSetValues(toplevel, tmp_arg, 1);
	}
	if(scrdepth == 8)
		byte_pixel = 1;
	else if(scrdepth == 16)
		byte_pixel = 2;
	else if(scrdepth == 24)
		byte_pixel = 4;
	
	if(scrdepth == 8) {
		XV_simul = 0;
/*		blackpixel = 0;
		whitepixel = 255; */
		blackpixel = (unsigned long) XBlackPixel (dpy, screen_num) & 0xff;
		whitepixel = (unsigned long) XWhitePixel (dpy, screen_num) & 0xff; 
	} else {
		blackpixel = (unsigned long) XBlackPixel (dpy, screen_num);
		whitepixel = (unsigned long) XWhitePixel (dpy, screen_num); 
		if(XV_simul)
			scrdepth = 8;
	}
#if 0
	gc_val.foreground = blackpixel;
	gc_val.background = whitepixel;
	gc_val.plane_mask = scrdepth == 8 ? 0xff : AllPlanes;
	XChangeGC (dpy, defgc, GCForeground|GCBackground | GCPlaneMask, &gc_val);
#endif
	XSetErrorHandler(myXError);
	return scrdepth;
}


static Arg viewArgs[]= {
	{XtNwidth,0},
	{XtNheight,0},
	{XtNbackground,0},
	{XtNforeground,0},
	{XtNforceBars,(XtArgVal) TRUE},
	{XtNallowHoriz,(XtArgVal) TRUE},
	{XtNallowVert,(XtArgVal) TRUE},
};
static Arg imagArgs[]= {
	{XtNwidth,0},
	{XtNheight,0},
	{XtNbackground,0},
	{XtNforeground,0},
};

extern void xvtxt_select(), par_valid(), xvtxt_btn(), xvtxt_hlp();
extern void xvrgb_btn(), xvtxt_fill(), imag_prog(), file_select();
static XtActionsRec myactionTable[]= {
	{"txt_select", xvtxt_select},
	{"file_select", file_select},
	{"par_valid", par_valid},
	{"imag_prog", imag_prog},
	{"txt_btn", xvtxt_btn},
	{"txt_hlp", xvtxt_hlp},
	{"txt_fill", xvtxt_fill},
	{"rgb_btn", xvrgb_btn},
	{NULL, NULL},
};
#define NB_ACTIONS ((sizeof(myactionTable) / sizeof(XtActionsRec)) - 1)

#define LGVAL 48
char size_value[LGVAL]= {0};

static char imagTrans[]=
"<Key>r: imag_prog(r)\n\
~Ctrl<Key>n: imag_prog(n)\n\
~Ctrl <Key> space: imag_prog(n)\n\
~Ctrl <Key> Return: imag_prog(n)\n\
~Ctrl~Meta<Key>p: imag_prog(p)\n\
<Key>q: imag_prog(q)\n\
~Meta Ctrl<Key>c: imag_prog(q)\n\
~Ctrl<Key>l: imag_prog(l)\n\
Ctrl<Key>l: imag_prog(L)\n\
<Key>z: imag_prog(z)\n\
~Ctrl~Shift<Key>e: imag_prog(e)\n\
~Ctrl<Key>h: imag_prog(H)\n\
~Ctrl<Key>?: imag_prog(H)\n\
Shift~Ctrl<Key>c: imag_prog(C)\n\
Shift<Key>s: imag_prog(S)\n\
~Meta Ctrl<Key>p:  imag_prog(P)\n\
~Meta Ctrl<Key>n:  imag_prog(N)\n\
~Meta Ctrl<Key><:  imag_prog(<)\n\
~Meta Ctrl<Key>>:  imag_prog(>)\n\
~Meta Ctrl<Key>f:  imag_prog(F)\n\
Meta~Ctrl<Key>c: imag_prog(0)\n\
Meta~Ctrl<Key>p: imag_prog(1)\n\
Meta~Ctrl<Key>t: imag_prog(2)\n\
Meta~Ctrl<Key>i: imag_prog(3)\n\
Meta~Ctrl<Key>u: imag_prog(4)\n\
Shift~Meta~Ctrl<Key>x: imag_prog(X)\n\
Shift~Meta~Ctrl<Key>e: imag_prog(E)\n\
Shift~Meta~Ctrl<Key>a: imag_prog(A)\n\
~Shift~Meta~Ctrl<Key>Up: imag_prog(+)\n\
Shift~Meta~Ctrl<Key>Up: imag_prog(++)\n\
~Shift~Meta~Ctrl<Key>Down: imag_prog(-)\n\
Shift~Meta~Ctrl<Key>Down: imag_prog(--)\n\
~Shift~Meta~Ctrl<Key>=: imag_prog(/)\n\
";

static char dialTrans[]=
"<Key>Return: par_valid()\n\
Meta<Key>r: par_valid(r)\n\
Meta<Key>p: par_valid(p)\n\
Meta<Key>n: par_valid(n)\n\
<Key>r: par_valid(r)\n\
<Key>p: par_valid(p)\n\
<Key>n: par_valid(n)";

static char fillTrans[]=
"~Shift <Btn1Up>: txt_fill(0)\n\
Shift <Btn1Up>: txt_fill(1)\n\
~Shift <Btn2Down>: select-start()\n\
~Shift <Btn2Up>: txt_fill(2)\n\
Shift <Btn2Down>:select-start()\n\
Shift <Btn2Up>: txt_fill(3)\n\
~Shift <Btn3Down>:select-start()\n\
~Shift <Btn3Up>: txt_fill(4)\n\
Shift <Btn3Down>:select-start()\n\
Shift <Btn3Up>: txt_fill(5)\n\
<Key>Return: txt_fill(6)";

static Arg commandArgs[4];
initxwin(first,depth)
int first, depth;  /* first ignored */
{
	register n, i;
	int def_w, def_h, max_w, max_h;
	Window win;
	XGCValues gc_val;
	Dimension verif_dim;
	int chg;
	int ier;
	char *size_msg;
	XtTranslations parsed_trans;
	Widget w;
	if(flg_initw) {  /* init windows, no image */
		chg = 0;
		def_w = MIN_W;
		def_h = MIN_H;
	} else {
		if(im_w == old_im_w && im_h == old_im_h)
			chg = 0;
		else
			chg = 1;
		if(flg_nu) {
			def_w = im_w;
			def_h = im_h;
		} else {
			def_w = MAX(MIN_W,im_w);
			def_h = MAX(MIN_H,im_h);
		}
		def_w = MIN(MAX_W,def_w);
		def_h = MIN(MAX_H,def_h);
	}
	if(!flg_nu) {
		def_w += SCROL_W;
		def_h += SCROL_W;
	}
	max_w = MIN(MAX_W,def_w);
	max_h = MIN(MAX_H,def_h);
	/*
	 * Open the display.
	 */
	imagArgs[0].value = (XtArgVal)max_w;
	imagArgs[1].value = (XtArgVal)max_h;
	imagArgs[2].value = (XtArgVal)whitepixel;  /* background */
	imagArgs[3].value = (XtArgVal)blackpixel;

	viewArgs[0].value = (XtArgVal) def_w;
	viewArgs[1].value = (XtArgVal) def_h;
	viewArgs[2].value = (XtArgVal) whitepixel;
	viewArgs[3].value = (XtArgVal) blackpixel;
	if(flg_nu) {
		viewArgs[4].value = (XtArgVal) FALSE;
		if(!flg_geom || flg_zloop) {
			viewArgs[5].value = (XtArgVal) FALSE;
			viewArgs[6].value = (XtArgVal) FALSE;
		}
	} else {
		viewArgs[4].value = (XtArgVal) TRUE;
	}
	if(chg) {
	/* teste de taille : on ne doit pas depasser les valeurs
	   admises pour width et height (short ?) */
	  verif_dim = (Dimension) im_w;
	  if(im_w != (int)verif_dim) imerror(9,"Depassement largeur fenetre autorisee par X\n");
	  verif_dim = (Dimension) im_h;
	  if(im_h != (int)verif_dim) imerror(9,"Depassement hauteur fenetre autorisee par X\n");
	}
	
/*	XtSetArg(viewArgs[0],XtNwidth,(XtArgVal)def_w );
	XtSetArg(viewArgs[1],XtNheight,(XtArgVal)def_h);
	XtSetArg (viewArgs[2], XtNbackground, whitepixel);
	XtSetArg (viewArgs[3], XtNforeground, blackpixel);
*/
	if(flg_initw) {
		/* Create the containing_widget.  */

		XtSetArg (args[0], XtNbackground, whitepixel);
		XtSetArg (args[1], XtNforeground, blackpixel);
#ifdef X11R4
		containing_widget = XtCreateManagedWidget ("frame", panedWidgetClass, toplevel,args,2);
#else
		containing_widget = XtCreateManagedWidget ("frame", vPanedWidgetClass, toplevel,args,2);
#endif
		initblist(buttons);
		init_sh();
		init_for_colors();
		if(!flg_nu) {
			label_box_widget = XtCreateManagedWidget ("imagelabels", boxWidgetClass, containing_widget,args,2);
			/* Create window full of buttons.  */
			button_box_widget = XtCreateManagedWidget ("Buttons", boxWidgetClass,
				      containing_widget,args,2);
			XtSetArg(args[3],XtNwidth,(XtArgVal)def_w);
			XtSetArg(args[2],XtNheight,(XtArgVal)120);
			cutp_box_widget = XtCreateManagedWidget ("cutbox", boxWidgetClass,
				      containing_widget,args,0);
			createbuttons(cutp_box_widget,l_bcutp,nbt_cutp);
			xvmanagebuttons(l_bcutp,nbt_cutp);
			
			par_box_widget = XtCreateManagedWidget ("parbox", boxWidgetClass, containing_widget,args,0);
			if(scrdepth == 1)
				size_msg = "peano size pas zpas iz nz iv  nv zloop exp";
			else
				size_msg = "pas zpas iz nz iv  nv zloop exp nbhz    ";
			new_g_size = g_size;
			new_opt_pas = opt_pas;
			new_fl_peano = fl_peano;
			new_nb_hz = opt_nb_hz;
			new_params = 0;
			for(i=0;i<LGVAL-1;i++)
				size_value[i] = '.';
			XtSetArg(args[0],XtNlabel,(XtArgVal)size_msg);
			XtSetArg(args[1],XtNvalue,(XtArgVal)size_value);
			XtSetArg(args[2],XtNresizable,True);
			XtSetArg(args[3],XtNwidth,(XtArgVal)260);
			XtSetArg(args[4],XtNheight,(XtArgVal)46);   /* hauteur */
			par_dial_widget = XtCreateManagedWidget("pdialog",dialogWidgetClass,par_box_widget,args,3);
			w = XtNameToWidget(par_dial_widget,"value");
			parsed_trans = XtParseTranslationTable(dialTrans);
			XtOverrideTranslations(w,parsed_trans);
			XtSetArg(args[2],XtNlabel,(XtArgVal)"fill value:");
			XtSetArg(args[3],XtNvalue,(XtArgVal)"000");
			fill_dial_widget = XtCreateManagedWidget("filldialog",dialogWidgetClass,par_box_widget,&args[2],3);
			w = XtNameToWidget(fill_dial_widget,"value");
			parsed_trans = XtParseTranslationTable(fillTrans);
			XtOverrideTranslations(w,parsed_trans);
			XtSetArg(args[2],XtNlabel,(XtArgVal)"dump file:");
			XtSetArg(args[3],XtNvalue,(XtArgVal)"   ");
			dump_dial_widget = XtCreateManagedWidget("ddialog",dialogWidgetClass,par_box_widget,&args[2],3);
			createbuttons(dump_dial_widget,l_dump,1);
			xvmanagebuttons(l_dump,1);
		}
 		imageview_widget = XtCreateManagedWidget ("imageview", viewportWidgetClass,
									  containing_widget, viewArgs,XtNumber(viewArgs));
		b_list[B_NOM]->but_evnt = NULL;
		if(!flg_nu) {
			createbuttons(button_box_widget,b_list,Nboutons);
			xvmanagebuttons(b_list,Nboutons);
			createlabels(label_box_widget,l_list,LBOUTONS);
			xvmanagebuttons(l_list,LBOUTONS);
			configbuttons();
		} else if(flg_nu > 0) {
			XtSetArg(args[0],XtNlabel,"");
			im_label = XtCreateManagedWidget("label",labelWidgetClass, containing_widget,args,1);
		}
		image_vscroll = XtNameToWidget(imageview_widget,"vertical");
		image_hscroll = XtNameToWidget(imageview_widget,"horizontal");
#if 1
		{
			Widget image_clip;
			/* hack to correct a pb with viewport X11R5 */
			image_clip = XtNameToWidget(imageview_widget,"clip");
			XtSetArg(args[0],XtNbackgroundPixmap,XtUnspecifiedPixmap);
			XtSetValues(image_clip,args,1);
			/* end of hack */
		}
#endif
		image_widget = XtCreateManagedWidget ("image", simpleWidgetClass,
								  imageview_widget, imagArgs,XtNumber(imagArgs));
		XtAddEventHandler(image_widget,ExposureMask ,False,exp_imag,NULL);
		if(!flg_nu)
			XtAddEventHandler(image_widget,ButtonPressMask| ButtonReleaseMask| Button1MotionMask ,False,coord_imag,NULL);
		else {
#if 0
			XtAddEventHandler(image_widget,ButtonPressMask ,False,but_exit,NULL);
#else
			XtAddEventHandler(image_widget,ButtonPressMask| ButtonReleaseMask| Button1MotionMask ,False,but_exit,NULL);
#endif
		}
		parsed_trans = XtParseTranslationTable(imagTrans);
		XtOverrideTranslations(imageview_widget,parsed_trans);
/*!!		if(nbim > im_nbfiles+1)  */
			init_im_menu();

		XtAppAddActions(xvapp_con,myactionTable,NB_ACTIONS);
		XtRealizeWidget(toplevel);
		XFlush(dpy);
		gc_val.foreground = blackpixel;
		gc_val.background = whitepixel;
		gc_val.plane_mask = scrdepth == 8 ? 0xff : AllPlanes;
		gc_val.function = GXcopy;
		gc_val.line_width = 1;
		defgc = XCreateGC(dpy,XtWindow(toplevel),GCFunction | GCLineWidth | GCPlaneMask | GCForeground | GCBackground,&gc_val);
		/* prepare XImage struct */
		ximage = XCreateImage(dpy,mydefvisual,scrdepth,ZPixmap,0,NULL,def_w,def_h,16,0);
		if(scrdepth == 24 || scrdepth == 16)
			prep_col_order(scrdepth);
		byte_pixel = (ximage->bits_per_pixel + 7) / 8;
		W_image = XtWindow(image_widget);
		mk_stdcursor(); /* make std cursor */
		if(!flg_nu) {
			init_options();
		}
	} else {  /* not first */
		if(curs_new_type && !(curs_new_type & CURS_VAR))
			set_cursor();
		XDefineCursor(dpy,W_image,Cursim);
		if(!flg_nu) {
			if(scrdepth == 1)
				sprintf(size_value,"%d %d %d %d %d %d %d %d %d %d",fl_peano,g_size,opt_pas,zpas,deb_plan,nb_plan,deb_vcomp,nb_vcomp,zloop_int,vis_exp);
			else
				sprintf(size_value,"%-4d%-4d%-4d%-4d%-4d%-4d%-4d %-3d% -4d",opt_pas,zpas,deb_plan,nb_plan,deb_vcomp,nb_vcomp,zloop_int,vis_exp,opt_nb_hz);
			XtSetArg(args[0],XtNvalue,(XtArgVal)size_value);
			XtSetValues(par_dial_widget,args,1);
		}
		if(chg) {
			if(!flg_nu) {
				XtResizeWidget(image_widget,im_w,im_h,0);
			} else {
				force_size();
			}
		}
	}
	if(im_nz <= 1)
		b_list[B_ZLOOP]->b_inv = -1;
	else
		b_list[B_ZLOOP]->b_inv = 0;
	XFlush(dpy);
	if(flg_initw && !gflg_nopix) {
		/* check if pixmap limits */
		flg_limitpix = 0;
		silent_err();
		c_erreur(ier);
		if(ier != 0) {
			g_close();
			pix_im = 0;
			if(ier == I_XERRPIX) {
				if(debug_)
					fprintf(stderr,"set pixmap limit\n");
				flg_limitpix = 1;
			}
		} else {
#if DBPIX
			if(DB_pix)
				pix_im = XCreatePixmap(dpy,W_image,100000,100000,depth);
			else
#endif
				pix_im = XCreatePixmap(dpy,W_image,16,scr_height + 1,depth);
			XSync(dpy,False);
			XFreePixmap(dpy,pix_im);
			pix_im = 0;
		}
	}
	if(pix_im != 0) {
		XFreePixmap(dpy,pix_im);
		pix_im = 0;
	}
	if(pix_undo != 0) {
		XFreePixmap(dpy,pix_undo);
		pix_undo = 0;
	}
	if(!flg_initw) {
	  if(! flg_nopix) {
	    if(flg_limitpix) {  /* check if screen size limit  exceeded */
	      if((im_h > scr_height) || (im_w > scr_width)) {
		flg_nopix = 1;
		if(debug_)
		  fprintf(stderr,"Force nopix\n");
	      }
	    } else if((im_h > 0x7fff) || (im_w > 0x7fff)) { 
	      /* les parametres de XCopyArea sont limites a 16 bits */
	      flg_nopix = 1;
	      if(debug_)
		fprintf(stderr,"Force nopix\n");
	    }
	  }
		if(flg_nopix) {  /* create image buffer */
			i_Free(&buf_im);  /* realloc buffer */
			buf_im = (char *)i_malloc(im_wb * im_h);
			ximage->data = buf_im;
		} else {
			pix_im = XCreatePixmap(dpy,W_image,im_w,im_h,depth);
			XSync(dpy,False);  /* get create pixmap err */
		}
	}
	flg_initw = 0;
	XFlush(dpy);
}

Widget addbutton (parent,pbt)
Widget parent;
register struct button *pbt;
{
	Widget w;
	XtSetArg (commandArgs[0], XtNlabel, pbt->b_text);
	XtSetArg (commandArgs[1], XtNsensitive, True);
	XtSetArg (commandArgs[2], XtNbackground, whitepixel);
	XtSetArg (commandArgs[3], XtNforeground, blackpixel);
#ifdef X11R4
	if(pbt->b_menu == (long *)-1) {  /* Toggle */
		XtSetArg (commandArgs[0], XtNstate,False);
		w = XtCreateWidget (pbt->b_text, toggleWidgetClass, parent,commandArgs,1);
		
	} else if(pbt->b_menu != NULL) {
		if(pbt->menu_item >= 0 && pbt->b_menu != (long *)1) {
			set_menu_btn(pbt,pbt->menu_item,1);
		}
		w = XtCreateWidget (pbt->b_text, menuButtonWidgetClass, parent,NULL,0);
		if(pbt->b_menu != (long *)1)
			create_menu(pbt,w);
	} else
		w = XtCreateWidget (pbt->b_text, commandWidgetClass, parent,NULL,0);
#else
  w = XtCreateWidget (pbt->b_text, commandWidgetClass, parent,NULL,0);
#endif
	if(pbt->but_evnt != NULL)
		XtAddCallback(w,XtNcallback,pbt->but_evnt,NULL);
	return w;
}

/* change label of menu button to current menu item */
static char tmps[80];
set_menu_btn(pbt,n,flg_set)
register struct button *pbt;
register n;
int flg_set;
{
	register struct menu_item *pi;
	register struct xvmenu *pm;
	pm = (struct xvmenu *)pbt->b_menu;
	pi = pm->items + n;
	pbt->menu_item = n;
	sprintf(tmps,"%s%s ->",pm->m_prefix,pi->label);
	if(flg_set) {
		pbt->b_text = tmps;
	} else {
		XtSetArg(args[0],XtNlabel,tmps);
		XtSetValues(pbt->b_win,args,1);
		XFlush(dpy);
	}
}

xvmanagebuttons(blist,n)
register struct button **blist;
register n;
{
	register struct button *pbt;
	register k, i;
	Widget bchild[32];
	i = 0;
	for(k=0;k<n;k++) {
		if((pbt = blist[k]) == 0) continue;
		bchild[i++] = (Widget)pbt->b_win;
	}
	XtManageChildren(bchild,i);
}

Widget addlabel (parent,pbt)
Widget parent;
register struct button *pbt;
{
	Widget w;
  XtSetArg (commandArgs[0], XtNlabel, pbt->b_text);
  XtSetArg (commandArgs[1], XtNsensitive, True);
  XtSetArg (commandArgs[2], XtNbackground, whitepixel);
  XtSetArg (commandArgs[3], XtNforeground, blackpixel);
	w = XtCreateWidget (pbt->b_text, labelWidgetClass, parent,
		  commandArgs, XtNumber (commandArgs));
	return w;
}

xput_im(buff,y,ny)
register unsigned char *buff;
register y, ny;
{
	register n, i;
	register iz, ixo, iyo;
	register izx, izy;
	register unsigned char *pc, *pt;
	if(scrdepth != 1 ) { /* remplacer black et white pixel */
		applic_tbl(buff,im_w1b * ny,xtrans);
	}
	ximage->width = im_w1;
	ximage->bytes_per_line = im_w1b;
	if(flg_nopix) {
		ximage->height = im_h;
		pt = (unsigned char *)buf_im + (y * im_wb);
		pc = buff;
		n = ny * im_wb;
		while(n-- > 0)
			*pt++ = *pc++;
	} else {
		ximage->height = ny;
		ximage->data = (char *)buff;
		if(flg_z_horiz) {
			iz = y / im_h1;
			izx = iz % im_ncolz;
			izy = iz / im_ncolz;
			iyo = (im_h1 * izy) + (y % im_h1);
			ixo = izx * im_w1;
		} else {
			ixo = 0;
			iyo = y;
		}
		XPutImage(dpy,pix_im,defgc,ximage,0,0,ixo,iyo,im_w1,ny);
	}
}

/* met toute l'image a 0 */
xzer_pixim()
{
	XGCValues gcv;
	register msk;
	if(flg_nopix) return 1 /* makes c99 happy */; 
	xzer_im(pix_im,0,0,im_w,im_h);
}
xzer_im(drawable,x,y,w,h)
register x, y, w, h;
Window drawable;
{
	XGCValues gcv;
	register msk;
	msk = xtrans[(fill_value & 0xff)];
	if(scrdepth == 24)
		msk |= (msk << 8) | (msk << 16);
	else if (scrdepth == 16)
		msk = mkpix16(msk,msk,msk);
	gcv.function = GXcopy;
	init_gc(&fillgc,&gcv);
	gcv.foreground = msk;
	gcv.fill_style = FillSolid;
	XChangeGC(dpy,fillgc,GCFunction | GCForeground | GCFillStyle ,&gcv);
	XFillRectangle(dpy,drawable,fillgc,x,y,w,h);

}

termine_pixmap()
{
	XGCValues gcv;
	register x0, y0, nx;
	if(!flg_z_horiz)
		return 1 /* makes c99 happy */; 
	if(im_last_ncolz == im_ncolz)
		return 1 /* makes c99 happy */; 
	if(flg_nopix) return 1 /* makes c99 happy */; 
	y0 = im_lasth;
	x0 = im_lastw;
	nx = (im_ncolz - im_last_ncolz) * im_w1;
	gcv.function = GXclear;
	init_gc(&fillgc,&gcv);
	XCopyArea(dpy,pix_im,pix_im,fillgc,x0,y0,nx,im_h1,x0,y0);
}

xvisim()
{
	struct screenpt scr, scrsz;
	if(!flg_nopix) {
		XCopyArea(dpy,pix_im,W_image,defgc,0,0,im_w,im_h,0,0);
	} else {
		xv_scr_orig(&scr);
		xv_scr_size(&scrsz);
		if(flg_fix < 0) {
			xzer_im(W_image,scr.x,scr.y,scrsz.x,scrsz.y);
		} else {
			XPutImage(dpy,W_image,defgc,ximage,scr.x,scr.y,scr.x,scr.y,scrsz.x,scrsz.y);
		}
	}
	init_mire();  /* mise a jour mire couleur si necessaire */
	XFlush(dpy);
	i_Free((char **)&aout_buffer);
	/* set the image label */
	wrt_imlabel();
	wrt_label(L_PARAM, paramslabel);
	/* draw the 'mark region box' if necessary */
	xvsh_newim();
	XFlush(dpy);
	return NOOP;
}

wrt_imlabel()
{
	XtSetArg(args[0], XtNtitle, xv_label);
	XtSetArg(args[1], XtNiconName, xv_label);
	XtSetValues(toplevel, args, 2);
	l_list[L_NOM]->b_text = imagelabel;
	wrlabel(L_NOM);
}

static int flg1;
static fd_set xv_rdfd, xv_wrfd= {0}, xv_spfd= {0};
static struct timeval timeout= {0};
xvis_loop()
{
	register Window win;
	register ier;
	register i;
	register dpyfd;
	int flg_errpx;
	flg1= 1;
	flg_errpx = 0;
	if(!debug_) {
		silent_err();
	}
	while(1) {
		c_erreur(ier);
		if(ier != 0) {
			if(ier == I_XERRPIX) {
				fflg_nopix = 1;
				flg1 = 1;
			} else
				xvbell();
			continue;
		}
		sig_lock = 0;
		if(flg1) {
			flg1 = 0;
			sig_lock = 1;
			trt_image();
			if(flg_zloop) 
				start_zloop();
			sig_lock = 0;
		}
		if(loop_mode) {
#ifdef ConnectionNumber
			dpyfd = ConnectionNumber(dpy);
#else
			dpyfd = dpy->fd;
#endif
			sig_lock = 1;
			XSync(dpy,0);
			if(XPending(dpy) <= 0) {
				if(loop_mode & SHLOOP) {
#if 1
					/* wait if pipe buffer empty */
					if(sh_rdpipe >= 0 && rdpipe_nb <= 0) {
						FD_ZERO(&xv_rdfd);
						FD_SET(dpyfd,&xv_rdfd);
						FD_SET(sh_rdpipe,&xv_rdfd);
						if((i = select(32,&xv_rdfd,&xv_wrfd,&xv_spfd,0)) < 0) {
							fprintf(stderr,"select err %d\n",errno);
							continue;
						}
						if(i == 0) {
							fprintf(stderr,"waiting\n");
							continue;
						}
						if(FD_ISSET(dpyfd,&xv_rdfd))
							continue;
					}
#endif
					xvsh_nextcmd();
				}
				if(loop_mode & ZLOOP) {
					if(flg_rv_zloop && sens_zloop < 0)
						put_prevz(1);
					else
						put_nextz(1);
				}
				if(loop_mode & CTLOOP) {
					cmap_loop();
				}
				if(loop_mode & LOOP) {/* image loop */
					if(loop_int > 0)
						sleep(loop_int);
					if(nbim > im_opfiles && flg_edit == 0) {
						if(flg_rv_loop && sens_loop < 0)
							b_prev();
						else
							b_next();
					} else {
						b_same();
					}
				} else
					continue;
			}
		}
		evt_retcode = NOOP;
		sig_lock = 0;
#ifdef X11R4
		XtAppNextEvent(xvapp_con,&event);
#else
		XtNextEvent(&event);
#endif
		sig_lock = 1;
		XtDispatchEvent(&event);
		if(evt_retcode == QUIT) return evt_retcode;
		sig_lock = 0;
	}
}

/* affiche plan suivant
si flag != 0 on tient compte du facteur de ralentissement zloop_int */
put_nextz(flag)
register flag;
{
	z_scroll(1,flag);
}

/* affiche plan precedent
si flag != 0 on tient compte du facteur de ralentissement zloop_int */
put_prevz(flag)
register flag;
{
	z_scroll(-1,flag);
}

/* affiche plan a la distance incz * zpas du plan courant 
si flag != 0 on tient compte du facteur de ralentissement zloop_int*/
z_scroll(incz,flag)
register flag, incz;
{
	register ny;
	float pos;
	struct screenpt scrsz;
	struct imagept ima;
	int maxz;
	xv_scr_orig(&cur_scr_top);
	sc2im_coord(&cur_scr_top,&ima);
	cur_ima.x = ima.x;
	cur_ima.zy = ima.zy;
	incz *= zpas;
	if(incz >= nbz)
		incz %= nbz;
	if(flag && (zloop_int > 1)) {
		if(cpt_zloop-- <= 0) {
			cpt_zloop = zloop_int;
			cur_ima.z += incz;
		}
	} else {
		cur_ima.z += incz;
	}
	maxz = im_nz * zpas;
	if(cur_ima.z >= maxz) {
		if(flg_rv_zloop && sens_zloop >= 0) {
			sens_zloop = -1;
			cur_ima.z -= incz;
		} else
			cur_ima.z -= maxz;
		cur_ima.zy = cur_ima_top.zy;
	}
	if(cur_ima.z < iz0) {
		if(flg_rv_zloop && sens_zloop < 0) {
			sens_zloop = 1;
			cur_ima.z -= incz;
		} else
			cur_ima.z += maxz;
		cur_ima.zy = cur_ima_top.zy;
	}

	cur_ima.y = cur_ima.zy + cur_ima.z * NDIMY;
	im2sc_coord(&cur_ima,&cur_scr);
	xv_scr_size(&scrsz);
	if(!flg_nopix) {
		XCopyArea(dpy,pix_im,W_image,defgc,cur_scr.x,cur_scr.y,scrsz.x,scrsz.y,
			  cur_scr_top.x,cur_scr_top.y);
	} else if(flg_fix >= 0) {
		XPutImage(dpy,W_image,defgc,ximage,cur_scr.x,cur_scr.y,
			  cur_scr_top.x,cur_scr_top.y,scrsz.x,scrsz.y);
	}

	XFlush(dpy);
/*	XtMoveWidget(image_widget,x,ny); */
	XFlush(dpy);
}

/* renvoie les coordonnees du point haut gauche d'affichage de l'image */
xv_scr_orig(scr)
struct screenpt *scr;
{
	Position x, y;
	Arg args[2];
	XtSetArg(args[0],XtNx,(XtArgVal)&x);
	XtSetArg(args[1],XtNy,(XtArgVal)&y);
	XtGetValues(image_widget,args,2);
	scr->x = -x;
	scr->y = -y;
}

/* renvoie les dimensions courantes d'affichage de l'image */
xv_scr_size(scr)
struct screenpt *scr;
{
	Dimension x, y;
	Arg args[2];
	XtSetArg(args[0],XtNwidth,(XtArgVal)&x);
	XtSetArg(args[1],XtNheight,(XtArgVal)&y);
	XtGetValues(imageview_widget,args,2);
	scr->x = x;
	scr->y = y;
}

do_exit(code)
register code;
{
	cod_exit = code;
	b_list[code]->b_inv = 1;
	wrbutton(code);
	XFlush(dpy);
	return 1 /* makes c99 happy */; 
}

wrbutton(k)
register k;
{
	register struct button *ptb;
	if(flg_nu) return 1 /* makes c99 happy */; 
	if((ptb = b_list[k]) == 0) return 1 /* makes c99 happy */; 
	modifbutton(ptb);
}

modifbutton(ptb)
register struct button *ptb;
{
	register Widget w;
	w = (Widget)ptb->b_win;
	if(ptb->b_inv < 0) {
		XtSetArg (args[2], XtNsensitive, False);
		XtSetArg(args[3],XtNlabel,"");
	} else {
		XtSetArg (args[2], XtNsensitive, True);
		XtSetArg(args[3],XtNlabel,ptb->b_text);
	}
	if(ptb->b_inv > 0) {
		XtSetArg(args[0],XtNbackground,(XtArgVal)blackpixel);
		XtSetArg(args[1],XtNforeground,(XtArgVal)whitepixel);
	} else {
		XtSetArg(args[0],XtNbackground,(XtArgVal)whitepixel);
		XtSetArg(args[1],XtNforeground,(XtArgVal)blackpixel);
	}
	XtSetValues(w,args,3);
}

wrlabel(k)
register k;
{
	register struct button *ptb;
	register Widget w;
	if(flg_nu < 0) return 1 /* makes c99 happy */; 
	if((ptb = l_list[k]) == 0) return 1 /* makes c99 happy */; 
	if(flg_nu > 0) { 
		if(k == L_NOM) {
			XtSetArg(args[0],XtNlabel,ptb->b_text);
			XtSetValues(im_label,args,1);
		}
		return 1 /* makes c99 happy */; 
	}
		
	w = (Widget)ptb->b_win;
	if(ptb->b_inv) {
		XtSetArg(args[0],XtNbackground,(XtArgVal)blackpixel);
		XtSetArg(args[1],XtNforeground,(XtArgVal)whitepixel);
	} else {
		XtSetArg(args[0],XtNbackground,(XtArgVal)whitepixel);
		XtSetArg(args[1],XtNforeground,(XtArgVal)blackpixel);
	}
	XtSetArg(args[2],XtNlabel,ptb->b_text);
	XtManageChild(w);
	XtSetValues(w,args,3);
}
xtermine()
{
    /*
     * Destroy the image window.
     */
	if(pix_im != 0) {
		XFreePixmap(dpy,pix_im);
		pix_im = 0;
	}
	XtDestroyWidget(toplevel);
    
}


/* force window size */
force_size()
{
	Dimension ih, iw, gh, gw, iwn, ihn;
	int dx, dy, nx, ny, v;
	int imin;
	Arg args[2];
	XtSetArg(args[0],XtNwidth,(XtArgVal)&iw);
	XtSetArg(args[1],XtNheight,(XtArgVal)&ih);
	XtGetValues(image_widget,args,2);
	XtSetArg(args[0],XtNwidth,(XtArgVal)&gw);
	XtSetArg(args[1],XtNheight,(XtArgVal)&gh);
	XtGetValues(toplevel,args,2);
/*!!	fprintf(stderr,"image= %dx%d, top %dx%d\n",iw,ih,gw,gh); */
	if(flg_geom) {
		nx = MIN((int)gw,im_w);
		ny = MIN((int)gh,im_h);
	} else {
		nx = MIN(MAX_W,im_w);
		ny = MIN(MAX_H,im_h);
	}
	dx = nx - iw;
	if((dx < 0) && (iw > gw)) dx += iw - gw;
	dy = ny - ih;
	if((dy < 0) && (ih > gh)) dy += ih - gh;
	iw = nx;
	ih = ny;
	if(!flg_geom) {
		v = (int)gw + dx;
		if(v >= iw)
			gw = (Dimension)v;
		v = (int)gh + dy;
		if(v >= ih)
			gh = (Dimension)v;
	}
	imin = ih;
	if(flg_nu > 0) {
		if(!flg_geom)
			gh = ih + 50;
		else
			ih = gh - 50;
	} else 
		gh = ih;
#if 1
	if((int)iw < im_w) {
		XtSetArg (args[0],XtNallowHoriz,(XtArgVal) TRUE);
		XtSetValues(imageview_widget,args,1);
		gh += 16;
		ih += 16;
	}
	if(((int)ih < im_h) && !flg_zloop) {
		XtSetArg (args[0],XtNallowVert,(XtArgVal) TRUE);
		XtSetValues(imageview_widget,args,1);
		gw += 16;  /* scrollbar thickness */
		iw += 16;  /* scrollbar thickness */
	}
#else
	if((iw < im_w) || (ih < im_h)) {
		XtSetArg (args[0],XtNallowVert,(XtArgVal) TRUE);
		XtSetArg (args[1],XtNallowHoriz,(XtArgVal) TRUE);
		XtSetValues(imageview_widget,args,2);
	}
#endif

	if(flg_nu > 0) /* avec label */
		XawPanedSetMinMax(imageview_widget,imin,imin);
	
	XtResizeWidget(image_widget,im_w,im_h,0);
	XtResizeWidget(imageview_widget,iw,ih,0);
	/* don't force size if option -geometry was given */
	if(!flg_geom) {
		/*XtSetArg(args[0],XtNwidth,(XtArgVal)gw);
		XtSetArg(args[1],XtNheight,(XtArgVal)gh);
		XtSetValues(toplevel,args,2); */
		XtResizeWidget(containing_widget,gw,gh,0);
		XtResizeWidget(toplevel,gw,gh,0);
	}
	XFlush(dpy);
#if 0
	fprintf(stderr,"top %dx%d, image= %dx%d, \n",gw,gh,iw,ih);
	test_size();
#endif
}
#if 0
test_size()
{
	Dimension ih, iw, gh, gw, iwn, ihn;
	Widget image_clip;
	image_clip = XtNameToWidget(imageview_widget,"clip");
	XtSetArg(args[0],XtNwidth,(XtArgVal)&iw);
	XtSetArg(args[1],XtNheight,(XtArgVal)&ih);
	XtGetValues(image_widget,args,2);
	XtSetArg(args[0],XtNwidth,(XtArgVal)&iwn);
	XtSetArg(args[1],XtNheight,(XtArgVal)&ihn);
	XtGetValues(image_clip,args,2);
	XtSetArg(args[0],XtNwidth,(XtArgVal)&gw);
	XtSetArg(args[1],XtNheight,(XtArgVal)&gh);
	XtGetValues(imageview_widget,args,2);
	fprintf(stderr,"clip %dx%d, image= %dx%d, view %dx%d\n",iwn,ihn,iw,ih,gw,gh);
}
#endif
/* retourne pixel : char monochrome (depth 8 ou 24)
int si color  r = val >> 16, G=val >> 8 ... */
xvgetpixim(x,y)
register x,y;
{
	register v;
	register unsigned char *pc;
	register XImage *ima;
	ima = XGetImage(dpy,W_image,x,y,1,1,AllPlanes,ZPixmap);
	pc = (unsigned char *)ima->data;
	if(scrdepth == 8) {
		v = xtransi[*pc];
		if(truecol_type > 0) {
			v = (((v << rvb_shft[0]) & rvb_msk[0]) << 16) |
				(((v << rvb_shft[1]) & rvb_msk[1]) << 8) |
				((v << rvb_shft[2]) & rvb_msk[2]);
		}
	} else if(scrdepth == 16) {
	  v = *(unsigned short *)ima->data;
	  v = ((int)xtransi[(((v >> rvb_shft[0]) << rvb_rshft[0]) & rvb_msk[0])] << 16) |
	    ((int)xtransi[(((v >> rvb_shft[1]) << rvb_rshft[1]) & rvb_msk[1])] << 8) |
	    (int)xtransi[(((v >> rvb_shft[0]) << rvb_rshft[0]) & rvb_msk[0])];
	} else { /* 24 bits couleur ou mono */
		
		v = ((int)xtransi[*(pc + Xcol_order[0])] << 16) |
			(xtransi[*(pc + Xcol_order[1])] << 8) |
				(xtransi[*(pc + Xcol_order[2])]);
	}
	return v;
}

/* fill rect with black or white according to but */
xvfillrect(x,y,w,h,pm)
Pixmap pm;
register x,y,w,h;
{
	XGCValues gcv;
	gcv.function = GXcopy;
	init_gc(&fillgc,&gcv);
	gcv.plane_mask = AllPlanes;
	gcv.fill_style = FillTiled;
	gcv.tile = pm;
	gcv.clip_mask = None;
	XChangeGC(dpy,fillgc,GCFunction | GCPlaneMask | GCFillStyle | GCTile | GCClipMask,&gcv);
	XFillRectangle(dpy,W_image,fillgc,x,y,w,h);
	if(!flg_nopix)
		XFillRectangle(dpy,pix_im,fillgc,x,y,w,h);
}

/* initialise gc (fillgc or drawgc) */
init_gc(pgc,gcv)
XGCValues *gcv;
GC *pgc;
{
	if(*pgc == (GC) 0) {
		*pgc = XCreateGC(dpy,W_image,GCFunction,gcv);
		XCopyGC(dpy,defgc,0xffffffff,*pgc);
	} 
#if 0
else {
#endif
		gcv->line_width = 1;
		gcv->plane_mask = AllPlanes;
		gcv->foreground = blackpixel;
		gcv->background = whitepixel;
		XChangeGC(dpy,*pgc,GCFunction | GCLineWidth | GCPlaneMask | GCForeground | GCBackground,gcv);
#if 0
	}
#endif
}

init_options()
{
	register  i, j, v, narg;
	register struct menu_item *pi;
	register Widget *pw;
	char *pbuf;
	v = 2 * ((MAX_W * MAX_H + 15) / 16);
	pbuf = (char *)i_malloc(v);
	for(i=0;i<v;i++)
		*(pbuf+i) = 0xff;
	pix_mark = XCreateBitmapFromData(dpy,W_image,pbuf,MARK_W,MARK_H);
	i_Free(&pbuf);

	pi = OPT_menulist;
	pw = (Widget *)OPT_wlist;
	XtSetArg(args[0], XtNleftMargin,MARK_W + 4);
	XtSetArg(args[1], XtNleftBitmap,pix_mark);
	for(i=0;i<nb_opts;i++,pi++,pw++) {
		if(pi->label == NULL)
			continue;
		v = pi->val;
		j = v >> 16;
		v &= 0xffff;
		narg = 1;
		switch (j) {
		case OM_NBCOL:
			if((v == 0 && !opt_c254) || (v == 1 && opt_c254)) {
				narg = 2;
			}
			break;
		case OM_MMX:
			if(flg_mmx) {
				narg = 2;
			}
			break;
		case OM_PRINT:
			if(((v == 0) && (flg_print & 1)) || ((v == 1) && flg_print & 2))
				narg = 2;
			break;
		case OM_HZ:
			if(((v == 0) && opt_z_horiz) || ((v == 1) && !opt_z_horiz))
				narg = 2;
			break;
		case OM_ZLREVERSE:
			if(((v == 0) && flg_rv_zloop) || ((v == 1) && !flg_rv_zloop))
				narg = 2;
			break;
		case OM_LREVERSE:
			if(((v == 0) && flg_rv_loop) || ((v == 1) && !flg_rv_loop))
				narg = 2;
			break;
		case OM_EDP:
			if(flg_pr_edit)
				narg = 2;
			break;
		case OM_TXTFOND:
			if(flg_txt_fond)
				narg = 2;
			break;
		case OM_DEBUG:
			if(debug_)
				narg = 2;
			break;
		case OM_CURSOR:
			if((v == 0 && (curs_new_type && !(curs_new_type & CURS_VAR))) || (v == 1 && (curs_new_type & CURS_VAR))) {
				narg = 2;
			}
			break;
		case OM_FOLLOW_M1:
			if(flg_follow_mouse)
				narg = 2;
			break;
		}
		XtSetValues(*pw,args,narg);
	}
}

set_option(num,flg_set)
register num, flg_set;
{
	if(flg_set)
		XtSetArg(args[0], XtNleftBitmap,pix_mark);
	else
		XtSetArg(args[0], XtNleftBitmap,NULL);
	XtSetValues(OPT_wlist[num],args,1);
}

/* met off les boutons inutiles */
configbuttons()
{
	register n;
	n = im_opfiles;
	if(flg_edit) n++;
	cod_exit = B_NEXT;
	if(nbim <= n) {
		valid_button(b_list[B_PREV], 0);
		valid_button(b_list[B_NOM], 0);
		cod_exit = B_SAME;
		valid_button(b_list[B_NEXT], 0);
	} else {
		valid_button(b_list[B_PREV], 1);
		valid_button(b_list[B_NOM], 1);
		valid_button(b_list[B_NEXT], 1);
	}
	if(flg_edit) {
		valid_button(b_list[B_EDIT], 1);
	} else {
		valid_button(b_list[B_EDIT], 0);
	}
}

valid_button(pbt,valid)
register struct button *pbt;
register valid;
{
	if(valid)
		XtSetArg(args[0], XtNsensitive,True);
	else
		XtSetArg(args[0], XtNsensitive,False);
	XtSetValues((Widget)pbt->b_win,args, 1);
}
