/* prepare et execute shell cmde */
#include "xvis.h"
#include "xvglobl.h"

#include "xvshell.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <errno.h>

extern int errno, debug_;

static struct exec_buf xbuf_p= {0};

static int sh_pid= 0;
extern int sh_oldfd0, sh_oldfd1;
extern int sh_rdpipe, sh_wrpipe;
extern char rdpipe_tmp[];
extern int rdpipe_ix, rdpipe_nb;
extern int sh_xmode;

extern struct xvcmdtab xvsh_builtin[];
extern struct pcmdtab xvsh_pbuilt;

static struct exp_buf bfexe= {0};

static int script_argc= 0;
static char **script_argv;

/* use /bin/sh or /bin/csh or /bin/perl if flg_shell ==0 or == 1 or == 2
flg_pipe : bits 0x1 , 0x2  pour pipe in et out
(pipe vers programme appelant => supp wait)
 */
static char cshfile[]= "/tmp/tmpcshXXXXXX";
xvexec_cmd(s,args,flg_wait,flg_shell,flg_pipe)
char *s, *args;
int flg_wait, flg_shell,flg_pipe;
{
	int status, w;
	register n;
	register fd;
	int narg0, narg;
	char **nargv;
	int pipe0[2], pipe1[2];
/*	register int (*istat)(), (*qstat)(); */
	if(s == NULL) return 0;
	if(*s == 0) return 0;
	narg0 = 0;
	if(*args != 0) 
	  narg0 = make_arglist(args);
	waitchild(0);
	if(debug_)
		fprintf(stderr,"exec shell %s\n",s);
	sh_rdpipe = -1;
	sh_wrpipe = -1;
	pipe0[0] = -1;
	pipe0[1] = -1;
	pipe1[0] = -1;
	pipe1[1] = -1;
	if(flg_pipe & S_INPIPE) {  /* input for xvis */
		pipe(pipe0);
	}
	if(flg_pipe & S_OUTPIPE) {
		pipe(pipe1);
	}
	if(flg_pipe)
		flg_wait = 0;
#if 0   /* un peu obsolete */
	if ((sh_pid = vfork()) == 0) {  /* fils */
#else
	if ((sh_pid = fork()) == 0) {  /* fils */
#endif
		setpgrp(0,0);
		if(flg_pipe & S_INPIPE) {  /* write to father */
			close(pipe0[0]);
			close(1);
			dup(pipe0[1]);
			close(pipe0[1]);
		}
		if(flg_pipe & S_OUTPIPE) {  /* read from father */
			close(0);
			close(pipe1[1]);
			dup(pipe1[0]);
			close(pipe1[0]);
		} 
#if 0
		else {
			open("/dev/null",0);  /* stdin is now /dev/null */
		} 
#endif
		mktemp(cshfile);
		if((fd = creat(cshfile,0700)) > 0) {
		  if((flg_shell == SH_CSH) || (flg_shell == SH_SH))
		    write(fd,"/bin/rm \"",9);
		  else
		    write(fd,"unlink \"",8);
		  write(fd,cshfile,strlen(cshfile));
		  write(fd,"\";\n",3);
		  write(fd,s,strlen(s));
		  write(fd,"\n",1);  /* add a newline */
		  close(fd);
		  if(flg_shell == SH_CSH) narg = narg0 + 4;
		  else narg = narg0 + 3;
		  nargv = (char **)i_calloc(sizeof(char *),narg +1);
		  narg= 0;
                  if(flg_shell == SH_BASH) {
		    nargv[narg++] = "/bin/bash";
		    nargv[narg++] = "bash";
		    nargv[narg++] = cshfile;
		  } 
		  else if(flg_shell == SH_PERL) {
		    nargv[narg++] = "perl";
		    nargv[narg++] = "perl";
		    nargv[narg++] = cshfile;
		  } else if(flg_shell == SH_SH) {
		    nargv[narg++] = "/bin/sh";
		    nargv[narg++] = "sh";
		    nargv[narg++] = cshfile;
		  } else {  /* csh */
		    nargv[narg++] = "/bin/csh";
		    nargv[narg++] = "sh";
		    nargv[narg++] = "-f";
		    nargv[narg++] = cshfile;
		  }
		  for(n=0;n<narg0;n++) 
		    nargv[narg++] = script_argv[n];
		  execvp(*nargv,nargv+1);
		}
		exit(127);
	}
	/* father */
	if(sh_pid < 0) {
		close(pipe0[0]);
		close(pipe0[1]);
		close(pipe1[0]);
		close(pipe1[1]);
		imerror(9,"fork err %d\n",errno);
	}
	if(flg_pipe & S_OUTPIPE) {
		close(1);
		close(pipe1[0]);
		dup(pipe1[1]);
		close(pipe1[1]);
		sh_wrpipe = 1;
	}
	if(flg_pipe & S_INPIPE) {
		close(pipe0[1]);
		sh_rdpipe = pipe0[0];
		xbuf_p.ix0 = 0;
#if 0
		fcntl(sh_rdpipe,F_SETFL,FNDELAY);
#endif
	}
	if(flg_wait) {
		while ((w = wait(&status)) != sh_pid && w != -1)
			;
		if (w == -1)
			status = -1;
		xvexec_end(0);
		return(status);
	}
	return 0;
}

/* called on end of child */
xvexec_end(abort)
int abort;
{
	if(sh_pid) {
		if(!abort)
			shread_pipe();
		xvsh_rdclose();
		xvsh_wrclose();
		sh_pid = 0;
	}
}

xvsh_rdclose()
{
	if(sh_rdpipe >= 0) {
		close(sh_rdpipe);
		sh_rdpipe = -1;
		rdpipe_ix = 0;
		rdpipe_nb = 0;
	}
}

xvsh_wrclose()
{
	if(sh_wrpipe >= 0) {
		close(sh_wrpipe);
		sh_wrpipe = -1;
		dup(sh_oldfd1);
	}
}

/* wait for previous child
if flg : don't wait; return 0 if process dead, else 1
 */
waitchild(flg)
register flg;
{
	register n, w;
	int status;
	if(sh_pid) { /* wait for previous child */
		n = 1;
#ifdef sun5
		while ((w = waitpid((pid_t)-1,&status,WNOHANG)) != sh_pid) {
#else
		while ((w = wait3(&status,WNOHANG,NULL)) != sh_pid) {
#endif
			if(w == -1) break;
			if(w == 0) {
				if(n && debug_ && !flg)
					fprintf(stderr,"waiting for process %d\n",sh_pid);
				n = 0;
				if(flg) return 1;
			}
		}		
		xvexec_end(0);
		return 0;
	}
	return 0;
}

#define INCR_EXE 512

/* pout = adr du ptr vers buffer resultat,
alloue ou realloue si necessaire
retourne la lgr resultat
S'il reste des lignes a traiter pout->next_input sera non nul
pout->status indique le type (builtin ou shell) et la presence de pipes
##!aaaa  : builtin
<| (ou |): pipe sortant de xvis
>| : pipe entrant dans xvis
*/
xvprp_cmd(in,pout,pptb)
register char *in;
register struct exp_buf *pout;
register struct pargtab *pptb;
{
	register struct exec_buf *px;
	register bslsh;  /* 1 if prev char is '\' */
	register c;
	register char *out;
	char tmp[512];
	int lg1, lg2;
	register lgin, lgout;
	int stp;
	register stopchar;
	bslsh = 0;
	lgin = strlen(in);
	px = pout->pexec;
	if(pout->bufexe == NULL) {
		lgout = INCR_EXE * (((lgin + INCR_EXE -1) / INCR_EXE) + 1);
		pout->bufexe = (char *)i_malloc(lgout);
		pout->maxsize = lgout;
	}
	lgout = px->ix0;
	out = pout->bufexe + lgout;
	px->next_input = NULL;
	while((c = *in++)) {
		if(bslsh) {
			bslsh = 0;
		} else {
			if(c == '\\')
				bslsh = 1;
			else if(c == '$') {
				if(xvchk_var(in,tmp,&lg1,&lg2,pptb) >= 0) {
					in += lg1;
					if((lgout + lg2) >= pout->maxsize) {
						bufexe_reall(pout,lgout+lg2);
						out = pout->bufexe + lgout;
					}
					strcpy(out,tmp);
					out += lg2;
					lgout += lg2;
					continue;
				}
			}
		}
		if((lgout +1) >= pout->maxsize) {
			bufexe_reall(pout,lgout +1);
			out = pout->bufexe + lgout;
		}
		*out++ = c;
		lgout++;
	}
	*out++ = 0;
	lgout++;
	if(*(in -1) != 0 && *in != 0)
		px->next_input = in;
	px->lgr = lgout - px->ix0;
	return (px->lgr);
}

xvprp_chk(in,px,stop)
register char *in;
register struct exec_buf *px;
int *stop;
{
	register flg, n, c;
	px->status = 0;
	*stop = 0;
	flg = 1;
	n = 0;
	while(flg) {
		c = *in;
		switch (c) {  /* test 1st char */
		case '#':
			flg = 0;
			if(*(in+1) == '#' && *(in+2) == '!') {
				*stop = '\n';
				px->status = S_BUILTIN;
			}
			return 0;
			break;
		case '<':
			if(*(in+1) != '|') 
				return n;
			n++;
			in++;
		case '|':
			n++;
			in++;
			px->status |= S_OUTPIPE;
			break;
		case '>':
			if(*(in+1) != '|') 
				return n;
			n += 2;
			in += 2;
			px->status |= S_INPIPE;
			break;
		default:
			flg = 0;
		}
	}
	return n;
}

/* idem xvprp_cmd sans remplacement variables 
entree: ->ix0 = debut buffer
sortie:
pout->pexec->ix0 : indice 1e car. utile de la cmde (on met 0 en fin de cmde)
->lgr et code retour = lgr totale cmde
->next_input : debut cmde suivante
*/
xvprp_exec(in,pout)
register char *in;
register struct exp_buf *pout;
{
	register struct exec_buf *px;
	register bslsh;  /* 1 if prev char is '\' */
	register c;
	int lg1;
	register lgout;
	register stopchar;
	int stp;
	bslsh = 0;
	px = pout->pexec;
	lgout = px->ix0;
	px->next_input = NULL;
	lg1 = xvprp_chk(in,px,&stp);
	stopchar = stp;
	in += lg1;
	lgout += lg1;
	px->ix0 += lg1;
	while((c = *in++) != stopchar) {
		if(c == 0) break;
		if(bslsh) {
			bslsh = 0;
		} else {
			if(c == '\\')
				bslsh = 1;
			else if(c == '\n' && *in == '#'
				  && *(in+1) == '#' && *(in+2) == '!') {
				break;
			}
		}
		lgout++;
	}
	if(*(in -1) != 0 && *in != 0) {
		px->next_input = in;
	}
	*(in -1) = 0;
	lgout++;
	px->lgr = lgout - px->ix0;
	return (px->lgr);
}

struct xvcmdtab *d_searchcmd (ptab,name)
register char *name;
register struct pcmdtab *ptab;
{
	register struct xvcmdtab **ppl;
	register j, j1, v;
	register n;
	j1 = 0;
	n = ptab->nbcmd;
	ppl = ptab->clist;
	while(j1 < (n-1)) {
		j = (j1 + n) / 2;
		if((v = strcmp(name,(*(ppl+j))->name)) == 0)
			return *(ppl + j);
		if(v > 0) {
			j1 = j;
		} else {
			n = j;
		}
	}
	if(strcmp(name,(*(ppl+j1))->name) == 0)
		return *(ppl+j1);
	else
		return NULL;
}

struct argtab *d_searchvar (ptab,name)
register char *name;
register struct pargtab *ptab;
{
	register struct argtab **ppl;
	register j, j1, v;
	register n;
	j1 = 0;
	n = ptab->nbvar;
	ppl = ptab->vlist;
	while(j1 < (n-1)) {
		j = (j1 + n) / 2;
		if((v = strcmp(name,(*(ppl+j))->name)) == 0)
			return *(ppl + j);
		if(v > 0) {
			j1 = j;
		} else {
			n = j;
		}
	}
	if(strcmp(name,(*(ppl+j1))->name) == 0)
		return *(ppl+j1);
	else
		return NULL;
}

/* lg1 = lgr input, lg2= lgr out 
retourne 0 si on trouve des variables, -1 sinon
substitue les variables
*/
xvchk_var(in,out,lg1,lg2,pptb)
register char *in, *out;
int *lg1, *lg2;
register struct pargtab *pptb;
{
	register struct argtab *ptb;
	char tmp[256];
	register n, c;
	register char *pc;
	if(*in == '{') {
		n = 1;
		in++;
		pc = in;
		while((c = *in++) != 0) {
			n++;
			if(c == '}')
				break;
		}
		*lg1 = n;
		if(c == 0) return -1;
		n -= 2;
	} else {
		pc = in;
		n = 0;
		while((c = *in++)) {
			if(isalnum(c)) {
				n++;
			} else
				break;
				
		}
		*lg1 = n;
	}
	/* comparer au tableau */
	strncpy(tmp,pc,n);
	tmp[n] = 0;  /* rajouter le null */
	if(ptb = d_searchvar(pptb,tmp)) {
		n = xvput_val(out,ptb);
		*lg2 = n;
		return 0;
	} else
		return -1;
}

xvput_val(out,ptb)
register char *out;
register struct argtab *ptb;
{
	register n;
	register i, n1;
	register char **pc;
	n = 0;
	if(ptb->value == NULL) {
		if(ptb->type == T_PSTRG || ptb->type == T_STRG) {
			*out++ = '"';
			*out++ = '"';
			n = 2;
		}
		*out = 0;
		return n;
	}
	switch(ptb->type) {
	case T_STRG:
		strcpy(out,ptb->value);
		break;
	case T_PSTRG:
		n = ptb->nbval;
		pc = (char **)ptb->value;
		n1 = 0;
		while(n-- > 0) {
			i = strlen(*pc);
			strcpy(out,*pc++);
			out += i;
			*out++ = ' ';
			n1 += i + 1;
		}
		*(out -1) = 0;
		return (n1 -1);
		break;
	case T_INT:
		sprintf(out,"%d",*(int *)ptb->value);
		break;
	case T_FORTINT:
		sprintf(out,"%ld",*(Fort_int *)ptb->value);
		break;
	case T_HEXA:
		sprintf(out,"0x%x",*(int *)ptb->value);
		break;
	case T_FLOAT:
		sprintf(out,"%.1f",*(float *)ptb->value);
		break;
	default:
		return 0;
	}
	return strlen(out);
}

int bufexe_reall(pout,n)
register struct exp_buf *pout;
register n;
{
	register char *pc;
	register i;
	if(pout->maxsize == 0) {
		i = INCR_EXE * (((n + INCR_EXE -1) / INCR_EXE) + 1);
		pc = (char *)i_malloc(i);
		pout->maxsize = i;
		pout->bufexe = pc;
		return 1 /* makes c99 happy */; 
	}
	n = INCR_EXE * ((n + INCR_EXE -1) / INCR_EXE);
	if(n == 0) n = INCR_EXE;
	pout->maxsize = n;
	pc = pout->bufexe;
	pout->bufexe = NULL;  /* en cas d'erreur */
	pc = (char *)i_realloc(pc,n);
	pout->bufexe = pc;
}

/* if flg_wait : wait for child to terminate */
xvsh_call(cmd,ptable,flg_wait)
register unsigned char *cmd;
register struct pcmdtab *ptable;
int flg_wait;
{
	char *str;
	int lgr;
	register n, i;
	register struct xvcmdtab *table;
	if(strncmp(cmd,"##!",3) != 0)
		return -1;
	if(flg_wait)
		waitchild(0);   /* wait for child */
	cmd += 3;
	if(*cmd == '#')  /* comment */
		return 0;
	n = sh_prpstr(cmd,&str,&lgr);
	i = 0;
	if(n == 0)
		return 0;  /* empty command : ignore */
	if(strncmp(cmd,"BEGIN",5) == 0) {
		if(sh_xmode) return 0;  /* ignorer le chg de shell en mode pipe */
		if(debug_)
			fprintf(stderr,"exec builtin ##!%s\n",cmd);
		/* effectuer chg de shell si necessaire */
		if(*(cmd+5) != '-') return 0;
		do_chgsh(cmd+6);
		return 0;
	}
	if(table = d_searchcmd(ptable,cmd)) {
		if(debug_)
			fprintf(stderr,"exec builtin ##!%s\n",table->name);
		table->func(table->value,str,lgr);
		return 0;
	}
	return -1;
#if 0
	while(table->name != NULL) {
		if(strncmp(cmd,table->name,n) == 0) {
			table->func(table->value,str,lgr);
			return 0;
		}
		table++;
		i++;
	}
	return -1;
#endif
}

/* prepare une commande interne
met 0 a la fin de la commande et renvoie la lgr du mot de commande
parg= debut args, lgarg lgr arg (sans espaces )
*/
sh_prpstr(cmd,parg,lgarg)
register char *cmd;
register char **parg;
register *lgarg;
{
	register i, n, c;
	register char *s;
	int i1;
	n = 0;
	*lgarg = 0;
	*parg = 0;
	while((c = *cmd++)) {
		if(isspace(c))
			break;
		else if(c == '(') {
			break;
		}
		n++;
	}
	if(c == 0)
		return n;
	*(cmd - 1) = 0;
	if(c != '(')
		return n;
	/* chercher ')' */
	s = cmd;
	while((c = *s)) {
		if((c == ')') && (*(s -1) != '\\')) {
			*s = 0;
			break;
		}
		s++;
	}
	i = min_string(cmd,&i1);
	cmd += i1;
	*parg = cmd;
	*(cmd+i) = 0;
	*lgarg = i;
	return n;
}

/* kill current process */
xvsh_kill()
{
	register n;
	if(!sh_pid) return 1 /* makes c99 happy */; 
#ifdef sun5
	if((n = sigsend(P_PGID,sh_pid,9)) != 0) {
#else
	if((n = killpg(sh_pid,9)) != 0) {
#endif
		if(debug_)
			fprintf(stderr,"kill status %d for pid %d\n",errno,sh_pid);
		waitchild(0);
	}
	xvexec_end(1);
}

xvsh_lstcmd(ptab)
register struct pcmdtab *ptab;
{
	register struct xvcmdtab *table;
	register struct xvcmdtab **pt;
	register n;
	fprintf(stderr,"builtin commands list :\n");
	n = ptab->nbcmd;
	pt = ptab->clist;
	while(n-- > 0) {
		table = *pt++;
		fprintf(stderr,"##!%s%s\n",table->name,table->syntax);
	}
}

xvsh_lstvar(pptb)
register struct pargtab *pptb;
{
	register struct argtab *ptb;
	register n;
	char tmp[256];
	fprintf(stderr,"variables list :\n");
	n = pptb->nbvar;
	ptb = pptb->stdlist;
	while(n-- > 0) {
		xvput_val(tmp,ptb);
		fprintf(stderr,"# $%s = %s\n",ptb->name,tmp);
		ptb++;
	}
}


shread_pipe()
{
	register n, i, j, eol;
	register char *s;
	if(sh_rdpipe < 0) return -1;  /* stop if aborted */
	if((n = rdpipe_nb) <= 0) {
		errno = 0;
		n = read(sh_rdpipe,rdpipe_tmp,256);
		if(n < 0 && (errno == EWOULDBLOCK || errno == EAGAIN))
			return 0;
		if(n <= 0) {
			if(debug_) 
				fprintf(stderr,"code %d on pipe (err %d)\n",n,errno);
			xvsh_rdclose();
			return -1;
		}
		if(debug_) 
			fprintf(stderr,"read %d on pipe\n",n);
		rdpipe_nb = n;
		rdpipe_ix = 0;
	}
	i = rdpipe_ix;
	s = &rdpipe_tmp[i];
	eol = 0;
	for(j=0;j<n;j++) {
		if(rdpipe_tmp[i++] == '\n') {
			eol = 1;
			j++;
			break;
		}
	}
	rdpipe_ix = i;
	n -= j;
	rdpipe_nb -= j;
	shadd_pipe(s,j,&bfexe,&xbuf_p,eol);
	if(debug_)
		fprintf(stderr,"%d remaining in pipe input buffer\n",rdpipe_nb);
	return 1;
}

shadd_pipe(buf,n,pout,px,eol)
register n;
int eol;
register char *buf;
register struct exp_buf *pout;
register struct exec_buf *px;
{
	register i, j, ix, c;
	register char *out;
	i = px->ix0 + n + 1;
	if(i > pout->maxsize) {
		bufexe_reall(pout,i);
	}
	out = pout->bufexe + px->ix0;
	strncpy(out,buf,n);
	out += n;
	if(eol) {
		*out = 0;
		sh_xmode = 1;  /* in pipe */
		if(xvsh_call(pout->bufexe,&xvsh_pbuilt,0) < 0) {
			fprintf(stderr,"xvshell builtin call err for %s\n",pout->bufexe);
		}
		px->ix0 = 0;
	} else {
		px->ix0 += n;
	}
}

/* renvoie dans i1 l'indice du 1er caract non espace de s 
retourne la nouvelle longueur (jusqu'au dernier caract non espace
*/
min_string(s,i1)
register char *s;
register int *i1;
{
	register i, n, c;
	n = 0;
	while((c = *s)) {  /* skip leading spaces */
		if(!isspace(c))
			break;
		s++;
		n++;
	}
	*i1 = n;
	if(!c)
		return 0;
	n = strlen(s);
	s += n -1;
	while(n > 0) {
		c = *s;
		if(!isspace(c))
			break;
		n--;
		s--;
	}
	return n;
}

/* copie le  1e mot qui suit dans out sur maxlg bytes et le termine par 0 
maxlg = nb varis char
renvoie lgr mot
*/
nextword(pc,out,maxlg)
register char *pc, *out;
register maxlg;
{
	register c, n;
	*out = 0;
	while(c = *pc++) {
		if(isspace(c))
			break;
	}
	if(c == 0 || c == '\n')
		return 0;
	while(c = *pc) {
		if(!isspace(c)) break;
		pc++;
	}
	if(!c) return 0;
	n = 0;
	while(maxlg-- > 0) {
		if(!(c = *pc++)) break;
		if(isspace(c)) break;
		*out++ = c;
		n++;
	}
	*out = 0;
	return n;
}

#define NB_ARGS 10
int make_arglist(s)
char *s;
{
  register nb, c, firstc;
  nb = 0;
  firstc = 1;
  if(script_argc == 0) {
    script_argv = (char **)i_calloc(sizeof(char *),NB_ARGS);
    script_argc = NB_ARGS;
  }
  while(c = *s++) {
    if(isspace(c)) {
      *(s-1) = 0;
      firstc = 1;
      continue;
    }
    if(firstc) {
      if(nb >= script_argc) {
	script_argc += NB_ARGS;
	script_argv = (char **)i_realloc(script_argv,script_argc * sizeof(char *));
      }
      script_argv[nb++] = s - 1;
      firstc = 0;
    }
  }
  return nb;
}
