/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Shell.h>

#include <inrimage/inrlocal.h>
#include <inrimage/image.h>
#include "xvshell.h"
#include "xvis.h"
#include "xvglobl.h"
#include "xvxglobl.h"

static Widget xvpop_shell= 0;
static Widget xvpop_child;
static Widget xvpop_box, xvpop_dial;


extern Widget toplevel;
extern Colormap defcmap;
extern Visual *mydefvisual;

extern Display *dpy;
extern XtAppContext xvapp_con;
extern GC fillgc, defgc;
int xvp_ok(), xvp_cancel(), xvp_btnprog();

struct button xvpbtn[]= {
  {0,"CANCEL",xvp_cancel,0,0,0,0,0,0},
  {0,"OK",xvp_ok,0,0,0,0,0,0},
};
#define MAXBTNS 16
struct button xvpbtnx[MAXBTNS];
struct button *l_xvpbtn[MAXBTNS+2];

static Arg args[10];

static Dimension cur_x = 0, cur_y = 0;

xvpop_destroy()
{
  if(xvpop_shell == NULL) return 1 /* makes c99 happy */;
  XtSetArg (args[0], XtNx,(XtArgVal)&cur_x);
  XtSetArg (args[1], XtNy,(XtArgVal)&cur_y);
  XtGetValues(xvpop_shell,args,2);
  XtDestroyWidget(xvpop_shell);
  xvpop_shell = NULL;
}


xvpop_create(s,indx,nb)
char *s;
int *indx, nb;
{
	Widget w;
	char *lab, *val;
	int nbtns, i;
	if(xvpop_shell)
		xvpop_destroy();
	XtSetArg(args[0], XtNvisual, mydefvisual);
	XtSetArg(args[1], XtNcolormap, defcmap);
	XtSetArg (args[2], XtNx,(XtArgVal)cur_x);
	XtSetArg (args[3], XtNy,(XtArgVal)cur_y);
	xvpop_shell = XtCreatePopupShell("xvpopdial",topLevelShellWidgetClass,toplevel,args,4);
	xvpop_child = XtCreateManagedWidget("xvpp",panedWidgetClass,xvpop_shell,args,2);
	
	if(nb >= 1) lab = s +indx[0];
	else lab = "";
	if(nb >= 2) val = s +indx[1];
	else val = "";
	XtSetArg(args[0], XtNlabel,(XtArgVal)lab);
	XtSetArg(args[1], XtNvalue,(XtArgVal)val);
	if(nb >= 1 && *lab != '\0') {
	  xvpop_dial = XtCreateManagedWidget("popdial",dialogWidgetClass,xvpop_child,args,2);
	} else {
	  xvpop_dial = (Widget) 0;
	}
	xvpop_box = XtCreateManagedWidget("xvpbox",boxWidgetClass,xvpop_child,args,0);
	nbtns = 2;
	l_xvpbtn[0] = &xvpbtn[0];
	nb -= 2;
	if(nb > 0) {
	  if(nb > MAXBTNS) nb = MAXBTNS;
	  nbtns += nb;
	  for(i=0;i<nb;i++) {
	    xvpbtnx[i].b_win = NULL;
	    xvpbtnx[i].b_text = s + indx[i+2];
	    xvpbtnx[i].but_evnt = xvp_btnprog;
	    xvpbtnx[i].b_cod = 0;
	    xvpbtnx[i].b_inv = 0;
	    xvpbtnx[i].b_im_norm = NULL;
	    xvpbtnx[i].menu_item = 0;
	    xvpbtnx[i].b_menu = NULL;
	    l_xvpbtn[i+2] = &xvpbtnx[i];
	  }
	} else {
	  l_xvpbtn[1] = &xvpbtn[1];
	}
	createbuttons(xvpop_box,l_xvpbtn,nbtns);
	xvmanagebuttons(l_xvpbtn,nbtns);

	XtRealizeWidget(xvpop_shell);
	XtPopup(xvpop_shell,XtGrabNone);
	XFlush(dpy);
}

int xvp_ok()
{
  return xvp_presult("OK");
}

int xvp_cancel()
{
  return xvp_presult("CANCEL");
}

int xvp_btnprog(w)
Widget w;
{
  char *nom;
  XtSetArg (args[0], XtNlabel, (XtArgVal)&nom);
  XtGetValues(w,args,1);
  xvp_presult(nom);
}

int xvp_presult(msg)
char *msg;
{
  char *s;
  if(xvpop_dial == (Widget) 0) {
    s = "";
  } else {
    s = XawDialogGetValueString(xvpop_dial);
  }
  printf("%s: %s\n",msg,s);
  fflush(stdout);
  if(strcmp("CANCEL",msg) == 0)
    xvpop_destroy();
  return 0;
}
