/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Shell.h>

#include <inrimage/inrlocal.h>
#include <inrimage/image.h>
#include "xvshell.h"
#include "xvis.h"
#include "xvglobl.h"
#include "xvxglobl.h"

static int txtargs();
static Widget make_txtwidget();
#define MAXTMP 8192
static char *filetmp= NULL;
static int filetmp_size = 0;
static char *tmpbuf = NULL;
static int tmpbuf_size = 0;
extern char opt_shargs[];  /* les args du shell donnes en arg */

int xvtxt_select();
extern double sqrt();
extern char *nextword();

extern char *get_inr_home();
extern int debug_;

extern Widget image_vscroll, image_hscroll, image_widget;
static Widget sh_shell;
static Widget sh_child;
static Widget sh_box, sh_box2, sh_dial, sh_dialf, sh_args, sh_dlabel, sh_dvalue, sh_file;
static Widget sh_txt_box, sh_txt_res, sh_textf;
FILE *F_text= NULL;
int sh_state= 0;   /* 1 when shell window is opened */
int sh_xmode= 0;  /* 1 if xvsh_call called in pipe mode */
#define DEFAULT_SCRIPT "etc/xvis.sh"
char sh_filename[128]= {0};

int shflg_wait;  /* 1 = wait, 0 = nowait */
static Widget bsh_widgets[4];

int sh_oldfd0, sh_oldfd1;
int sh_rdpipe, sh_wrpipe;  /* pipe for read or write if >= 0 */
extern int flg_xsh;

extern Widget toplevel;
extern Window W_image;
extern Colormap defcmap;
extern Visual *mydefvisual;

extern Display *dpy;
extern XtAppContext xvapp_con;
extern GC fillgc, defgc;
extern XImage *ximage;
extern int flg_nopix, flg_nu;
extern Pixmap pix_im;
extern int opt_pas, pas, zoom, zpas;
extern int truecol_type, im_nbfiles, flg_edit;
extern unsigned char col_order[];

char bufcmde[]= "##!$\n##!!";
struct exp_buf bufexe= {0}, bufexx= {0};
struct exec_buf execbuf= {0};
struct exec_buf *pxbuf= &execbuf;
static int shloop_on= 0;
char rdpipe_tmp[256];
int rdpipe_ix= 0, rdpipe_nb = 0;

struct imagept shpts[3];  /* current box : p0, p1, dims */
struct imagept oldshpts[3];  /* orevious box : p0, p1, dims */

extern struct imagept zonept0, zonept1;
static char im_name[]= "bidon";

extern int loop_mode;

extern char **ptim;
static float lgdiag2d, lgdiag3d;  /* taille diagonales 2d et 3d boite*/
#define IM_R 1
#define IM_ED 4
#define IM_S 5
struct argtab argtab[]= {
	{"im",im_name,T_PSTRG,1},
	{"imr",im_name,T_STRG,1},
	{"img",im_name,T_STRG,1},
	{"imb",im_name,T_STRG,1},
	{"im2",im_name,T_STRG,1},
	{"ims",im_name,T_PSTRG,1},
	{"x0",(char *)&shpts[0].vx,T_INT,1},
	{"y0",(char *)&shpts[0].zy,T_INT,1},
	{"z0",(char *)&shpts[0].z,T_INT,1},
	{"v0",(char *)&shpts[0].v,T_INT,1},
	{"x1",(char *)&shpts[1].vx,T_INT,1},
	{"y1",(char *)&shpts[1].zy,T_INT,1},
	{"z1",(char *)&shpts[1].z,T_INT,1},
	{"v1",(char *)&shpts[1].v,T_INT,1},
	{"dx",(char *)&shpts[2].vx,T_INT,1},
	{"dy",(char *)&shpts[2].zy,T_INT,1},
	{"dz",(char *)&shpts[2].z,T_INT,1},
	{"dv",(char *)&shpts[2].v,T_INT,1},
	{"l2d",(char *)&lgdiag2d,T_FLOAT,1},
	{"l3d",(char *)&lgdiag3d,T_FLOAT,1},
	{"dimx",(char *)&DIMX,T_FORTINT,1},
	{"ndimx",(char *)&NDIMX,T_FORTINT,1},
	{"dimy",(char *)&DIMY,T_FORTINT,1},
	{"ndimy",(char *)&NDIMY,T_FORTINT,1},
	{"ndimz",(char *)&NDIMZ,T_FORTINT,1},
	{"ndimv",(char *)&NDIMV,T_FORTINT,1},
	{"cmap",(char *)&defcmap,T_HEXA,1},
	//	{"box", (char*)&shpts[2].y, T_INT, 1}, (un test de dominique, pour voir comment ca marche
};
struct pargtab pargtab = {
	sizeof(argtab) / sizeof(struct argtab),
	NULL,
	argtab
};

extern struct xvcmdtab xvsh_builtin[];
extern struct pcmdtab xvsh_pbuilt;

extern int ev_noop();
int sh_cancel(), sh_expand(), sh_aexpand(), sh_exec(), sh_repeat(), sh_load();
int shd_opts(), sh_kill(), sh_abort(), sh_close(), sh_all();
extern char *msh_cancel[], *msh_expand[], *msh_aexpand[], *msh_exec[], *msh_repeat[];
extern int evt_retcode;
#define evreturn(n) {evt_retcode = n; return;}

#define SH_NB 8
struct button shell_b[]= {
	{0,"quit",sh_cancel,msh_cancel,0,0,0,0,0},
	{0,"expand",sh_expand,msh_expand,1,0,0,0,0},
	{0,"expand+",sh_aexpand,msh_aexpand,1,0,0,0,0},
	{0,"exec",sh_repeat,msh_repeat,3,0,0,0,0},
	{0,"exp&exec",sh_exec,msh_exec,2,0,0,0,0},
	{0,"kill",sh_kill,NULL,4,0,0,0,0},
	{0,"abort",sh_abort,NULL,4,0,0,0,0},
	{0,"close pipe",sh_close,NULL,4,0,0,0,0},
};

struct button *l_shell[]= {shell_b,&shell_b[1],&shell_b[2],&shell_b[3],&shell_b[4],&shell_b[5],&shell_b[6],&shell_b[7]};

struct button sh_btnpaused= {0,"paused",NULL,NULL,0,0,0,0,0};
struct button sh_btnfile[]= {
	{0,"load",sh_load,NULL,0,0,0,0,0},
	{0,"select_all",sh_all,NULL,1,0,0,0,0},
};
struct button *l_btnfile[]= {&sh_btnfile[0],&sh_btnfile[1]};

extern struct button labels[];

static Arg dialArgs[]= {
	{XtNlabel,0},
	{XtNvalue,0},
	{XtNresizable,(XtArgVal)True},
	{XtNwidth,0},
	{XtNheight,0},
/*	{XtNmaximumLength,LGVAL},*/
};

static Arg args[10];

static char *txtTrans= "~Shift ~Meta ~Ctrl <Btn1Up>: extend-end(PRIMARY, CUT_BUFFER0) txt_select(1)\n\
~Shift ~Meta ~Ctrl <Btn2Up>: extend-end(PRIMARY, CUT_BUFFER0) txt_select(1)\n\
Shift ~Meta ~Ctrl <Btn1Up>: extend-end(PRIMARY, CUT_BUFFER0) txt_select(2)";
static XtTranslations parsed_trans;

static int cmd_cmp(p1,p2)
register struct xvcmdtab **p1, **p2;
{
	return strcmp((*p1)->name,(*p2)->name);
}
static int var_cmp(p1,p2)
register struct argtab **p1, **p2;
{
	return strcmp((*p1)->name,(*p2)->name);
}

static int sh_def_w= 300, sh_def_h= 200;
init_sh()
{
	register i;
	register struct xvcmdtab **pcl;
	register struct argtab **pvl;
	register char *pc;
	sh_textf = 0;
	F_text = NULL;
	shflg_wait = 0;
/*!!	shflg_shell = 0; */
	zonept1.y = zonept0.y = -1;  /* no initial box */
	zonept0.val = 0;
	shdef_args();
	xvcopybuf(shpts,oldshpts,sizeof(shpts));
	parsed_trans = XtParseTranslationTable(txtTrans);
	for(i=0;i<64;i++)
		boxlabel[i] = ' ';
	boxlabel[i] = 0;
	sh_oldfd0 = dup(0);
	sh_oldfd1 = dup(1);
	xvsh_pbuilt.clist = pcl = (struct xvcmdtab **)i_malloc(xvsh_pbuilt.nbcmd * sizeof(struct xvcmdtab *));
	for(i=0;i<xvsh_pbuilt.nbcmd;i++) 
		*pcl++ = &xvsh_builtin[i];
	qsort(xvsh_pbuilt.clist,xvsh_pbuilt.nbcmd,sizeof(struct xvcmdtab *),cmd_cmp);
	pargtab.vlist = pvl = (struct argtab **)i_malloc(pargtab.nbvar * sizeof(struct argtab *));
	for(i=0;i<pargtab.nbvar;i++) 
		*pvl++ = &argtab[i];
	qsort(pargtab.vlist,pargtab.nbvar,sizeof(struct argtab *),var_cmp);
	/* init path for default script file */
	if(sh_filename[0]) return 1 /* makes c99 happy */;
	if((pc = get_inr_home()) == NULL) return 1 /* makes c99 happy */;
	sprintf(sh_filename,"%s/%s",pc,DEFAULT_SCRIPT);
}
xvsh_create()
{
  Widget bw0, bw1, bw2, bsh1, bsh2, bsh3, bsh4;
	if(sh_state) return 1 /* makes c99 happy */;
	sh_textf = 0;
	bufexe.pexec = pxbuf;
	pxbuf->ix0 = 0;
	XtSetArg (args[0], XtNheight,(XtArgVal)400);
	XtSetArg (args[1], XtNwidth,(XtArgVal)370);
	shdef_args();
	if(F_text != NULL) {
		fclose(F_text);
		F_text = NULL;
	}
	//	xvprp_cmd(bufcmde,&bufexe,&pargtab);
	xvprp_cmd("",&bufexe,&pargtab);
	XtSetArg(args[0], XtNvisual, mydefvisual);
	XtSetArg(args[1], XtNcolormap, defcmap);
	sh_shell = XtCreatePopupShell("xvis-shell",topLevelShellWidgetClass,toplevel,args,2);
	sh_child = XtCreateManagedWidget("xvsh",panedWidgetClass,sh_shell,args,2);
	sh_box = XtCreateManagedWidget("xvshbox",boxWidgetClass,sh_child,args,0);
	/* widget for commands : 2 text widgets */
	sh_dial = XtCreateManagedWidget("xvshdial",panedWidgetClass,
					sh_child,dialArgs,0);

#if 0
	XtSetArg(args[0],XtNstring,(XtArgVal)bufexe.bufexe);
	XtSetArg(args[1],XtNtype,XawAsciiString);
	txtargs(sh_dial);
	XtSetArg (args[3], XtNheight,60);
	XtSetArg (args[7], XtNeditType,XawtextEdit);
	XtSetArg(args[8],XtNfromVert,NULL);
	sh_dlabel = XtCreateManagedWidget ("label", asciiTextWidgetClass, sh_dial,args,9);
#endif
	sh_dlabel = make_txtwidget(sh_dial,"label",bufexe.bufexe);
#if 0
	XtSetArg(args[8],XtNfromVert,(XtArgVal)sh_dlabel);
	XtSetArg(args[0],XtNstring,(XtArgVal)bufcmde);
	XtSetArg (args[7], XtNeditType,XawtextEdit);
	sh_dvalue = XtCreateManagedWidget ("value", asciiTextWidgetClass, sh_dial,args,9);
#endif
	sh_dvalue = make_txtwidget(sh_dial,"value",bufcmde);

	sh_box2 = XtCreateManagedWidget("shbox2",boxWidgetClass,sh_dial,args,0);
	XtSetArg(args[0], XtNlabel,(XtArgVal)"args");
	XtSetArg(args[1], XtNvalue,(XtArgVal)opt_shargs);
	sh_args = XtCreateManagedWidget("xvshargs",dialogWidgetClass,sh_dial,args,2);
	XtSetArg (args[0], XtNlabel,sh_btnpaused.b_text);
	XtSetArg(args[1],XtNfromVert,(XtArgVal)sh_dvalue);
	bw0 = XtCreateManagedWidget (sh_btnpaused.b_text, labelWidgetClass, sh_box2,args,2);
	sh_btnpaused.b_win = (long *) bw0;
	sh_btnpaused.b_inv = 0;

	XtSetArg (args[0], XtNstate,False);
	bw1 = XtCreateManagedWidget ("wait", toggleWidgetClass, sh_box2,args,1);
	XtAddCallback(bw1,XtNcallback,shd_opts,(XtPointer)1);

	XtSetArg (args[0], XtNstate,(shflg_shell == SH_CSH ? True : False));
	XtSetArg (args[1], XtNlabel,"csh");
	bsh1 = XtCreateManagedWidget ("sh", toggleWidgetClass, sh_box2,args,2);
	bsh_widgets[SH_CSH] = bsh1;
	XtAddCallback(bsh1,XtNcallback,shd_opts,(XtPointer)3);

	XtSetArg (args[0], XtNstate,(shflg_shell == SH_SH ? True : False));
	XtSetArg (args[1], XtNradioGroup,bsh1);
	XtSetArg (args[2], XtNlabel,"sh");
	bsh2 = XtCreateManagedWidget ("sh", toggleWidgetClass, sh_box2,args,3);
	bsh_widgets[SH_SH] = bsh2;
	XtAddCallback(bsh2,XtNcallback,shd_opts,(XtPointer)2);

	XtSetArg (args[0], XtNstate,(shflg_shell == SH_PERL ? True : False));
	XtSetArg (args[2], XtNlabel,"perl");
	bsh3 = XtCreateManagedWidget ("sh", toggleWidgetClass, sh_box2,args,3);
	bsh_widgets[SH_PERL] = bsh3;
	XtAddCallback(bsh3,XtNcallback,shd_opts,(XtPointer)4);

	XtSetArg (args[0], XtNstate,(shflg_shell == SH_BASH ? True : False));
	XtSetArg (args[2], XtNlabel,"bash");
	bsh4 = XtCreateManagedWidget ("sh", toggleWidgetClass, sh_box2,args,3);
	bsh_widgets[SH_BASH] = bsh4;
	XtAddCallback(bsh4,XtNcallback,shd_opts,(XtPointer)5);

/*	sh_file = XtCreateManagedWidget("xvshfile",formWidgetClass,
					sh_child,dialArgs,0); */
	dialArgs[0].value = (XtArgVal)"text file :";
	dialArgs[1].value = (XtArgVal)sh_filename;
	sh_dialf = XtCreateManagedWidget("xvshfile",dialogWidgetClass,
					sh_child,dialArgs,2);
	createbuttons(sh_box,l_shell,SH_NB);
	xvmanagebuttons(l_shell,SH_NB);
	createbuttons(sh_dialf,l_btnfile,1);
	xvmanagebuttons(l_btnfile,1);
	createbuttons(sh_dialf,&l_btnfile[1],1);
	xvmanagebuttons(&l_btnfile[1],1);
	XtSetArg (args[0], XtNwidth,(XtArgVal)sh_def_w);
	XtSetArg (args[1], XtNheight,(XtArgVal)sh_def_h);
	sh_txt_box = XtCreateManagedWidget ("textbox", formWidgetClass, sh_child,args,2);
	sh_txt_res = XtCreateManagedWidget ("txtbox", simpleWidgetClass, sh_txt_box,args,2);

	XtRealizeWidget(sh_shell);
	XtPopup(sh_shell,XtGrabNone);
	XFlush(dpy);
	sh_state = 1;
	xvsh_prtbox();
	if(sh_filename[0]) {
#if 0
		sh_load();
#else
		if(!sh_load())
			auto_xsh();
#endif
	}
}

/* get all lines starting at n, 
end on line containing point n2
*/
static int get_file_lines(n,n2,pout,size)
int n, n2;
int *size;
char **pout;
{
  int c;
  int i;
  char *out;
  int ix = 0;
  if(! *size) {
    out = i_malloc(MAXTMP);
    *pout = out;
    *size = MAXTMP;
  } else
    out = *pout;
  fseek(F_text,n,0);
  while((c = getc(F_text)) != EOF) {
    if((c == '\n') && (n >= n2))
      break;
    if(ix >= *size - 1) {
      *size += MAXTMP;
      *pout = i_realloc(*pout,*size);
      out = *pout + ix;
    }
    *out++ = c;
    ix++;
    n++;
  }
  *out++ = 0;
  return i;
}

/* auto-exec shell */
auto_xsh()
{
#if 0
	if(flg_xsh > 0) {
#else
	if(flg_xsh) {
#endif
		if(!sh_filename[0]) return 1 /* makes c99 happy */;
		if(sh_load()) return 1 /* makes c99 happy */;
		flg_xsh = 0;
		sh_all();
		sh_exec();
	}
	if(flg_xsh < 0) {
		flg_xsh = 1;
	}
}

int sh_cancel()
{
	XtDestroyWidget(sh_shell);
	sh_state = 0;
	i_Free(&tmpbuf);
	tmpbuf_size = 0;
	if(F_text != NULL) {
		fclose(F_text);
		F_text = NULL;
	}
}

int sh_expand()
{
	if(shloop_on) {
		xvbell();
		return 1 /* makes c99 happy */;
	}
	sh_expand1();
	if(!sh_state) return 1 /* makes c99 happy */;
	/* show in text widget */
	XtSetArg(args[0],XtNstring,bufexe.bufexe);
	XtSetValues(sh_dlabel,args,1);
	XFlush(dpy);
}

/* retourne lgr totale */
sh_expand1()
{
	char *pc, *pargs;
	register struct exec_buf *px;
	shdef_args();
	if(sh_state) { /* there is a shell window */
		XtSetArg(args[0],XtNstring,(XtArgVal)&pc);
		XtGetValues(sh_dvalue,args,1);
		pargs = XawDialogGetValueString(sh_args);
		/* 	pc = XawDialogGetValueString(sh_dial); */
	} else {
	  if(!filetmp_size) {
	    fprintf(stderr,"Empty buffer!\n");
	    return -1;
	  }
	  pc = filetmp;
	  pargs = opt_shargs;
	}
	px = pxbuf;
	px->ix0 = 0;
	bufexe.pexec = px;
	bufexe.args = pargs;
	xvprp_cmd(pc,&bufexe,&pargtab);
	return px->lgr;
}

/* expand and append to execution text */
int sh_aexpand()
{
	char *pc, *p2;
	register n1, n2;
	register struct exec_buf *px;
	if(shloop_on) {
		xvbell();
		return 1 /* makes c99 happy */;
	}
	n2 = sh_expand1();
	XtSetArg(args[0],XtNstring,(XtArgVal)&pc);
	XtGetValues(sh_dvalue,args,1);
	n1 = strlen(pc);
	p2 = (char *)i_malloc(n1 + n2 + 1);
	strcpy(p2,pc);
	*(p2 + n1) = '\n';
	strcpy(p2 + n1 +1,bufexe.bufexe);
	XtSetArg(args[0],XtNstring,p2);
	XtSetValues(sh_dlabel,args,1);
	XFlush(dpy);
	i_Free(&p2);
}

int sh_exec()
{
	if(shloop_on) {
		xvbell();
		return 1 /* makes c99 happy */;
	}
	sh_expand();
	bufexx.bufexe = bufexe.bufexe;
	bufexx.args = bufexe.args;
	xvsh_exec(bufexe.bufexe,bufexe.args);
}

int sh_repeat()
{
	char *pc, *pargs;
	if(shloop_on > 0) {
		xvbell();
		return 1 /* makes c99 happy */;
	}
	if(shloop_on == 0) {
		XtSetArg(args[0],XtNstring,(XtArgVal)&pc);
		XtGetValues(sh_dlabel,args,1);
		bufexx.bufexe = pc;
		pargs = XawDialogGetValueString(sh_args);
		bufexx.args = pargs;
	} else {
		sh_btnpaused.b_inv = 0;
		modifbutton(&sh_btnpaused);
		if(sh_xmode) {  /* paused in pipe */
			shloop_on = 1;
			toggle_loop(0,SHLOOP);
			return 1 /* makes c99 happy */;
		} else {  /* normal pause */
			pc = bufexx.pexec->next_input;
		}
	}
	xvsh_exec(pc,pargs);

}

xvxexec_term()
{
	/* return to editable mode */
	if(shloop_on || !sh_state) 
		return 1 /* makes c99 happy */;
	XtSetArg (args[0], XtNeditType,XawtextEdit);
	XtSetValues(sh_dlabel,args,1);
	XawTextSetInsertionPoint(sh_dlabel,(XawTextPosition) 0);
	XawTextUnsetSelection(sh_dlabel);
}

/* pause execution */
shx_pause(num,s,lgr)
register num, lgr;
register char *s;
{
	register n;
	if(s) {
		n = atoi(s);
		sleep(n);
		return 1 /* makes c99 happy */;
	}
	if(shloop_on)
		shloop_on = -1;
	if(loop_mode & SHLOOP)
		loop_mode ^= SHLOOP;
	sh_btnpaused.b_inv = 1;
	if(sh_state)
		modifbutton(&sh_btnpaused);
}

/* effectuer changement de shell si necessaire */
do_chgsh(pc)
register char *pc;
{
	register flg;
	flg = -1;
	if(strncmp(pc,"sh",2) == 0)
		flg = SH_SH;
	else if(strncmp(pc,"csh",3) == 0)
		flg = SH_CSH;
	else if(strncmp(pc,"perl",4) == 0)
		flg = SH_PERL;
        else if(strncmp(pc,"bash",4) == 0 )
	        flg = SH_BASH;
	if((flg >= 0) && (flg != shflg_shell)) {
		if(sh_state) {
/*			XtSetArg (args[0], XtNstate, False);
			XtSetValues(bsh_widgets[shflg_shell],args,1); */
			XtSetArg (args[0], XtNstate, True);
			XtSetValues(bsh_widgets[flg],args,1);
		}
		shflg_shell = flg;
	}
}

/* exec cmd buffer */
xvsh_exec(pc,pargs)
register char *pc, *pargs;
{
	register char *p2;
	register n;
	register struct exec_buf *px;

	sh_rdpipe = -1;
	sh_wrpipe = -1;
	rdpipe_ix = 0;
	rdpipe_nb = 0;
	px = pxbuf;
	px->ix0 = 0;
	bufexx.pexec = px;
	px->next_input = pc;
	if(sh_state) {
		/* set non editable mode */
		XtSetArg (args[0], XtNeditType,XawtextRead);
		XtSetValues(sh_dlabel,args,1);
	}
	shloop_on = 1;
	toggle_loop(0,SHLOOP);
}

/* called from xvis_loop*/
xvsh_nextcmd()
{
	register char *pc;
	register struct exec_buf *px;
	register i;
	register XawTextPosition t1, t2;
	px = pxbuf;
	if(shread_pipe() > 0) return 1 /* makes c99 happy */;  /* read everything from pipe */
	if(waitchild(1))
		return 1 /* makes c99 happy */;  /* loop until child termination */
	if((pc = px->next_input) == NULL) {
		if(loop_mode & SHLOOP) {
			loop_mode ^= SHLOOP;
		} 
		shloop_on = 0;
		xvxexec_term();
		return 1 /* makes c99 happy */;
	}
	if(debug_)
		fprintf(stderr,"xvshell try next cmde\n");
/*!!	shread_pipe();  /* read everything present on pipe */
	if(sh_state)
		XawTextUnsetSelection(sh_dlabel);
	px->ix0 = 0;
	xvprp_exec(pc,&bufexx);
	pc += px->ix0;
	if(debug_)
		fprintf(stderr,"xvshell : exec : %s\n",pc);
	if(*pc == 0) return 1 /* makes c99 happy */;
	t1 = (unsigned long)pc - (unsigned long)bufexx.bufexe;
	t2 = t1 + px->lgr;
	if(sh_state) {
		XawTextSetSelection(sh_dlabel,t1,t2);
		XawTextSetInsertionPoint(sh_dlabel,t1);
	}
	if(px->status == S_BUILTIN) {
		sh_xmode = 0;
		if(xvsh_call(pc,&xvsh_pbuilt,shflg_wait) < 0)
			fprintf(stderr,"xvshell builtin call err\n");
	} else {
		if((i = xvexec_cmd(pc,bufexx.args,shflg_wait,shflg_shell,px->status)) != 0)
			fprintf(stderr,"xvshell shellcmd status %d\n",i);
	}
}

/* definition des arguments */
shdef_args()
{
	register char *s;
	register i;
	register double fx, fy;
	/* nom de l'image */
	for(i=0;i<= IM_S;i++)
		argtab[i].value = NULL;
	if(ptim != 0) {
		s = *ptim;
		if(s != 0 && *s != '<') {
			argtab[0].value = (char *)ptim;
			argtab[0].nbval = im_opfiles;
			if(truecol_type == I_3COL) {
				for(i=0;i<3;i++) {
					argtab[col_order[i] + IM_R].value = *(ptim +i);
				}
			}
			if(flg_edit)
				argtab[IM_ED].value = *(ptim + im_nbfiles + 1);
			argtab[IM_S].value = (char *)ptim;
			argtab[IM_S].nbval = flg_edit > 1 ? im_nbfiles + 2 : im_opfiles;
		}
	}
	if(zonept0.y < 0 || zonept1.y < 0 || !zonept0.val) {  /* boite non defini ou non valide */
		shpts[2].y = -1;
		return 1 /* makes c99 happy */;
	}
		
	if(zonept0.vx < zonept1.vx) {
		shpts[0].vx = zonept0.vx +1;
		shpts[1].vx = zonept1.vx +1;
	} else {
		shpts[0].vx = zonept1.vx +1;
		shpts[1].vx = zonept0.vx +1;
	}
	if(zonept0.zy < zonept1.zy) {
		shpts[0].zy = zonept0.zy +1;
		shpts[1].zy = zonept1.zy +1;
	} else {
		shpts[0].zy = zonept1.zy +1;
		shpts[1].zy = zonept0.zy +1;
	}
	if(zonept0.z < zonept1.z) {
		shpts[0].z = zonept0.z +1;
		shpts[1].z = zonept1.z +1;
	} else {
		shpts[0].z = zonept1.z +1;
		shpts[1].z = zonept0.z +1;
	}
	if(zonept0.v < zonept1.v) {
		shpts[0].v = zonept0.v +1;
		shpts[1].v = zonept1.v +1;
	} else {
		shpts[0].v = zonept1.v +1;
		shpts[1].v = zonept0.v +1;
	}
	shpts[2].vx = shpts[1].vx - shpts[0].vx + 1;
	shpts[2].zy = shpts[1].zy - shpts[0].zy + 1;
	shpts[2].z = truecol_type == I_ZCOL ? 3 : shpts[1].z - shpts[0].z + 1;
	shpts[2].v = truecol_type == I_VCOL ? 3 : shpts[1].v - shpts[0].v + 1;
	if((shpts[2].vx == 1) && (shpts[2].zy == 1)) {
		lgdiag2d = 1;
		lgdiag3d = 1;
		shpts[2].y = -1;
		zonept0.y = zonept1.y = -1;
	} else {
		shpts[2].y = 0;
		fx = (double)shpts[2].vx;
		fy = (double)shpts[2].zy;
		lgdiag2d = (float)sqrt(fx * fx + fy * fy);
		fy = (double)shpts[2].z;
		lgdiag3d = (float)sqrt(lgdiag2d * lgdiag2d + fy * fy);
	}
}

xvsh_showbox()
{
	shdef_args();
	xvsh_draw(1);  /* undraw old box, draw new box , copy new to old */
	if(shpts[2].y < 0)
		return 1 /* makes c99 happy */;
	xvsh_prtbox();
}

xvsh_prtbox()
{
	if(flg_nu) return 1 /* makes c99 happy */;
	sprintf(boxlabel,"box {%d,%d,%d,%d} - {+%d,+%d,+%d,+%d}, l2d %.1f, l3d %.1f",
		shpts[0].vx,shpts[0].zy,shpts[0].z,shpts[0].v,shpts[2].vx,shpts[2].zy,shpts[2].z,shpts[2].v,lgdiag2d,lgdiag3d);
	XtSetArg(args[0],XtNlabel,boxlabel);
/*!!	XtSetValues(shell_lab[0].b_win,args,1); */
	XtSetValues(labels[L_BOX].b_win,args,1);
}

xvsh_newim()
{
	if(zonept0.vx >= NDIMX)
		zonept0.vx = NDIMX -1;
	if(zonept0.zy >= NDIMY)
		zonept0.zy = NDIMY -1;
	if(zonept0.z >= NDIMZ)
		zonept0.z = NDIMZ -1;
	if(zonept0.v >= NDIMV)
		zonept0.v = NDIMV -1;
	if(zonept1.vx >= NDIMX)
		zonept1.vx = NDIMX -1;
	if(zonept1.zy >= NDIMY)
		zonept1.zy = NDIMY -1;
	if(zonept1.z >= NDIMZ)
		zonept1.z = NDIMZ -1;
	if(zonept1.z >= NDIMZ)
		zonept1.z = NDIMZ -1;
	if(zonept1.v >= NDIMV)
		zonept1.v = NDIMV -1;
	shdef_args();
	xvsh_draw(0);
	xvsh_prtbox();
}
/* flag == 0 : draw
flag > 0 : erase old, draw new
flag < 0 : erase and draw new
*/
xvsh_draw(flag)
int flag;
{
	if(flag > 0)
		xvsh_boxdraw(oldshpts,1);
	else if(flag < 0)
		xvsh_boxdraw(shpts,1);
	xvsh_boxdraw(shpts,0);
	if(flag >= 0)
		xvcopybuf(shpts,oldshpts,sizeof(shpts));
}

/* erase >0 pour erase */
unsigned long DB_mask = AllPlanes;
xvsh_boxdraw(pts,erase)
register struct imagept *pts;
int erase;
{
  struct screenpt scr, scrsz;
  struct imbox ibox;
  register struct imagept *pt;
  int nz, nv, x, y, dx, dy;
  int ymin, ymax, ep, ep2;
  XGCValues gcv;
  pt = pts + 2;
  if(pt->y < 0)
    return 1 /* makes c99 happy */;
  calc_imbox(pts,&ibox);
  ep2 = (ibox.ep + 1) / 2;
  nz = ibox.dz;
  x = ibox.x;
  y = ibox.y;
  dx = ibox.dx;
  dy = ibox.dy;
  ep = ibox.ep;
  gcv.function = GXinvert;
  init_gc(&fillgc,&gcv);
  gcv.function = GXinvert;
  gcv.line_width = ep;
  gcv.plane_mask = DB_mask;
  XChangeGC(dpy,fillgc,GCFunction | GCLineWidth | GCPlaneMask,&gcv);
  if(flg_nopix) {
    xv_scr_orig(&scr);
    xv_scr_size(&scrsz);
    ymin = scr.y;
    ymax = ymin + scrsz.y;
  }
  ep = 2 * ep2;
  while(nz-- > 0) {
    nv = ibox.dv;
    while(nv-- > 0) {
      if(!flg_nopix)
	XDrawRectangle(dpy,pix_im,fillgc,x,y,dx,dy);
      if(!flg_nopix)
	XDrawRectangle(dpy,W_image,fillgc,x,y,dx,dy);
      else if((y <= ymax) && ((y + dy) >= ymin)) {
	if(!erase) {
	  XDrawRectangle(dpy,W_image,fillgc,x,y,dx,dy);
	} else {
				/* barres verticales */
	  XPutImage(dpy,W_image,defgc,ximage,x -ep2,y-ep2,x - ep2,y-ep2,ep,dy + ep);
	  XPutImage(dpy,W_image,defgc,ximage,x - ep2 + dx,y-ep2,x - ep2 + dx,y-ep2,ep,dy +ep);
	  if(y >= ymin)
	    XPutImage(dpy,W_image,defgc,ximage,x,y -ep2,x,y-ep2,dx,ep);
	  if((y + dy) <= ymax)
	    XPutImage(dpy,W_image,defgc,ximage,x,y-ep2+dy,x,y-ep2+dy,dx,ep);
	}
      }
      x += im_w1v;
    }
    if(flg_z_horiz) {
      x -= im_w1v;
      INCR_HZ(x,y);
    } else {
      x = ibox.x;
      y += im_h1;
    }
  }
  XFlush(dpy);
}
/* calcule la boite en coordonnees ecran */
calc_imbox(pts,ibox)
register struct imagept *pts;
register struct imbox *ibox;
{
	register struct imagept *pt;
	register z;
	ibox->ep = zoom * g_size;
	pt = pts + 2;
	if(pt->y < 0) {
		ibox->x = 0;
		ibox->y = 0;
		ibox->dx = lfmto[I_NDIMX];
		ibox->dy = lfmto[I_NDIMY];
		ibox->dz = truecol_type == I_ZCOL ? 1 : lfmto[I_NDIMZ];
		ibox->dv = truecol_type == I_VCOL ? 1 : lfmto[I_NDIMV];
		return 1 /* makes c99 happy */;
	}
	/* convert origin */
	ibox->x =  echan((pts->vx -1)) * g_size;
	ibox->y = g_size * (echan((pts->zy -1)));
	if(flg_z_horiz)  {
		z = zechan((pts->z -iz0 -1));
		ibox->x +=  (z % im_ncolz) * im_w1;
		ibox->y +=  (z / im_ncolz) * im_h1;
	} else {
	  ibox->x += (pts->v - iv0 - 1) * im_w1v;
	  ibox->y += zechan((pts->z -iz0 -1)) * im_h1;
	}
	/* convert width and height */
	ibox->dx = echan(pt->vx) * g_size;
	ibox->dy = echan(pt->zy) * g_size;
	if(truecol_type == I_ZCOL)
		ibox->dz = 1;
	else
	  ibox->dz = zechan((pts + 2)->z);
	
	if(truecol_type == I_VCOL)
		ibox->dv = 1;
	else
	  ibox->dv = (pts+2)->v;
	
}

/* load a text file */
sh_load()
{
	register char *fname;
	int i1;
	register i;
	Widget wsrc;
	if(sh_textf) {
		XtDestroyWidget(sh_textf);
		sh_textf = 0;
	}
	if(F_text)
		fclose(F_text);
	if(sh_state)
		fname = XawDialogGetValueString(sh_dialf);
	else 
		fname = sh_filename;
	i = min_string(fname,&i1);
	fname += i1;
	*(fname + i) = 0;
	if(i == 0) return -1;
	if((F_text = fopen(fname,"r")) == NULL) {
		fprintf(stderr,"text file %s open error\n",fname);
		xvbell();
		return -1;
	}
	if(!sh_state) return 0;
	XtSetArg(args[0],XtNstring,(XtArgVal)fname);
	XtSetArg(args[1],XtNtype,XawAsciiFile);
	txtargs(sh_txt_box);
	XtSetArg (args[7], XtNeditType,XawtextRead);
	sh_textf = XtCreateManagedWidget ("file", asciiTextWidgetClass, sh_txt_box,args,8);
	XtOverrideTranslations(sh_textf, parsed_trans);
	XtRealizeWidget(sh_textf);
	XFlush(dpy);
	return 0;
}

/* select entire file */
sh_all()
{
	if(F_text == NULL) return 1 /* makes c99 happy */;
	get_file_lines(0,100000,&filetmp,&filetmp_size);
	if(!sh_state) return 1 /* makes c99 happy */;
	XtSetArg(args[0], XtNstring,filetmp);
	XtSetValues(sh_dvalue,args,1);
	XFlush(dpy);
}

/* show text widget */
#define HMARGE 10
#define WMARGE 10
static int txtargs(wid)
Widget wid;
{
	Arg xargs[2];
	Dimension w, h;
	XtSetArg(xargs[0],XtNwidth,(XtArgVal)&w);
	XtSetArg(xargs[1],XtNheight,(XtArgVal)&h);
	XtGetValues(wid,xargs,2);
	XtSetArg (args[2], XtNresizable,True);
	XtSetArg (args[3], XtNheight,(XtArgVal)(h - HMARGE));
	XtSetArg (args[4], XtNwidth,(XtArgVal)(w - WMARGE));
	/*	XtSetArg (args[5], XtNscrollVertical,XawtextScrollWhenNeeded); */
	XtSetArg (args[5], XtNscrollVertical,XawtextScrollAlways);
	XtSetArg (args[6], XtNscrollHorizontal,XawtextScrollWhenNeeded);
}
static Widget make_txtwidget(parent,label,str)
Widget parent;
char *label, *str;
{
	Widget w;
	XtSetArg(args[0],XtNstring,(XtArgVal)str);
	XtSetArg(args[1],XtNtype,XawAsciiString);
	XtSetArg (args[2], XtNresizable,True);
	/*	XtSetArg (args[3], XtNscrollVertical,XawtextScrollWhenNeeded);*/
	XtSetArg (args[3], XtNscrollVertical,XawtextScrollAlways);
	XtSetArg (args[4], XtNscrollHorizontal,XawtextScrollWhenNeeded);
	XtSetArg (args[5], XtNeditType,XawtextEdit);
	w = XtCreateManagedWidget (label, asciiTextWidgetClass,parent,args,6);
	return w;
}

static XawTextBlock blk= {0,1,"\n",(Atom)0};
static XawTextBlock blkend= {0,7,"\n##!END",(Atom)0};
static XawTextBlock blkbeg= {0,9,"\n##!BEGIN",(Atom)0};

int xvtxt_select(w, event, params, num_params)
Widget w;
XEvent *event;			/* must be XMotionEvent */
String *params;			
Cardinal *num_params;		
{
	char *s;
	char blkname[32], blkname2[32];
	XawTextPosition start, finish;
	register n, lg, flg_sel;
	register char *pc, *str;
	char *buf;
	int lgr;
	blk.format = FMT8BIT;
	XawTextGetSelectionPos (sh_textf, &start, &finish);
	XawTextSetInsertionPoint(sh_textf,start);
	n = XawTextSearch(sh_textf,XawsdLeft,&blk);
	if(n == XawTextSearchError)
		n = 0;
	else n++;
	lg = get_file_lines(n,finish,&tmpbuf,&tmpbuf_size);
	s = *params;
	buf = NULL;
	if(*s == '1') { /* button 1 */
		flg_sel = 0;
		pc = tmpbuf;
		if((tmpbuf[0] == '#') && (tmpbuf[1] == '#') && (tmpbuf[2] == '!')) {
			if(strncmp(tmpbuf+3,"SELECT",6) == 0) {
				if(!nextword(tmpbuf + 7,blkname,31)) return 1 /* makes c99 happy */;
				while(1) {
					finish = XawTextSearch(sh_textf,XawsdRight,&blkbeg);
					if(finish == XawTextSearchError)
						return 1 /* makes c99 happy */;
					finish += 2;
					lg = get_file_lines(finish,finish,&tmpbuf,&tmpbuf_size);
					XawTextSetInsertionPoint(sh_textf,(XawTextPosition) finish + 5);
					if(nextword(tmpbuf + 7,blkname2,31) &&
					   (strcmp(blkname,blkname2) == 0)) {
						flg_sel = 1;
						n = finish - 1;
						break;
					}
				}
			} else if(strncmp(tmpbuf +3,"BEGIN",5) == 0) {
				flg_sel = 1;
			}
		}
		if(flg_sel) {  /* search for end of block */
			finish = XawTextSearch(sh_textf,XawsdRight,&blkend);
			start = XawTextSearch(sh_textf,XawsdRight,&blkbeg);
			if(finish == XawTextSearchError)
				finish = tmpbuf_size;
#if 0
			else 
				finish += 2;
#endif
			if(start == XawTextSearchError)
				start = tmpbuf_size;
			if(start < finish)
				finish = start;
			lg = get_file_lines(n,finish,&tmpbuf,&tmpbuf_size);
		}
	} else {
		XtSetArg(args[0],XtNstring,(XtArgVal)&s);
		XtGetValues(sh_dvalue,args,1);
/*		s = XawDialogGetValueString(sh_dial); */
		n = strlen(s);
		buf = (char *)i_malloc(n + lg + 2);
		pc = buf;
		strcpy(pc,s);
		*(pc + n) = '\n';
		strcpy(pc+n+1,tmpbuf);
	}
suite:	XtSetArg(args[0], XtNstring, pc);
	XtSetValues(sh_dvalue,args,1);
	XFlush(dpy);
	i_Free(&buf);
}


/* toggle wait / nowait(cl_data==1) et sh/csh/perl (cl_data== 3,2,4 )*/
int shd_opts(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	switch ((long) cl_data) {
	case 0 :
	case 1:
		shflg_wait ^= 1;
		break;
	case 2:
		shflg_shell = SH_SH;
		break;
	case 3:
		shflg_shell = SH_CSH;
		break;
	case 4:
		shflg_shell = SH_PERL;
		break;
	case 5:
		shflg_shell = SH_BASH;
		break;
	}
}

/* pour le help */
/* switch to help mode */
sh_show_msg()
{
	if(!sh_state) return 1 /* makes c99 happy */;
}

/* exit from help mode */
sh_hide_msg()
{
	if(!sh_state) return 1 /* makes c99 happy */;
}

sh_kill()
{
	xvsh_kill();
}

sh_abort()
{
	xvsh_kill();
	if(loop_mode & SHLOOP) {
		loop_mode ^= SHLOOP;
	} 
	if(shloop_on < 0) {
		sh_btnpaused.b_inv = 0;
		modifbutton(&sh_btnpaused);
	}
	shloop_on = 0;
	xvxexec_term();
	xvpop_destroy();
}

sh_close()
{
	xvsh_wrclose();
}

/* scroll image : put x, y at upper left corner */
scroll_image(x,y)
{
	float pos;
	XtMoveWidget(image_widget,-x,-y);
	if(!image_vscroll || !image_hscroll)
		return 1 /* makes c99 happy */;
	pos = (float)y / (float)im_h;
	XawScrollbarSetThumb(image_vscroll,pos,-1.);
	pos = (float)x / (float)im_w;
	XawScrollbarSetThumb(image_hscroll,pos,-1.);
}
