#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <inrimage/image.h>
#include "xvis.h"
#include "xvshell.h"
#include "xvglobl.h"
#include "xvxglobl.h"
#include "xvcolors.h"

extern int cmap_type;
extern char tcfile[];
extern int b_prevz(), b_nextz(), b_prevv(), b_nextv();

extern struct imagept zonept0, zonept1;
extern struct argtab argtab[];
extern struct pargtab pargtab;
int shx_hlp(), shx_prtvar();


struct shx_param {
	char *name;
	int *val;
} shx_tabpar[]= {
	{"pas",&new_opt_pas},
	{"zpas",&new_zpas},
	{"nz",&new_nb_plan},
	{"iz",&new_deb_plan},
	{"nv",&new_nb_vcomp},
	{"iv",&new_deb_vcomp},
	{"zloop",&zloop_int},
	{"nbhz",&new_nb_hz},
	{"exp",&new_vis_exp},
};
#define NB_SHPARAMS (sizeof(shx_tabpar) / sizeof(struct shx_param))

shx_noop()
{
}

shx_imlist(num,s,lgr)
register num, lgr;
register char *s;
{
  if(s == NULL) return 1 /* makes c99 happy */;
  xvf_set_imlist(s,lgr);
}


shx_reread(num,s,lgr)
register num, lgr;
register char *s;
{
	register i;
	if(s == NULL)
		chg_image(0);
	else {
		for(i=0;i<nbim;i++) {
			if(strcmp(tabim[i],s) == 0)
				break;
		}
		if(i >= nbim)
			return 1 /* makes c99 happy */;
		numim = i +1;
		b_same();
	}
}


shx_next(num,s,lgr)
register num, lgr;
register char *s;
{
	chg_image(1);
}

shx_prev(num,s,lgr)
register num, lgr;
register char *s;
{
	chg_image(-1);
}

shx_box(num,s,lgr)
register num, lgr;
register char *s;
{
	int tmp[8];
	register n, i;
	if(num == 1) {
		zonept0.val = 0;
		xvsh_showbox();
		return 1 /* makes c99 happy */;
	}
	if(s != NULL) {
		n = sscanf(s,"%d,%d,%d,%d,%d,%d,%d,%d",&tmp[0],&tmp[1],&tmp[2],&tmp[3],&tmp[4],&tmp[5],&tmp[6],&tmp[7]);
		for(i=0;i<8;i++)
			if(tmp[i] > 0)
				tmp[i]--;
		if(n >= 3) {
			zonept0.vx = tmp[0];
			zonept0.zy = tmp[1];
			zonept0.z = tmp[2];
			zonept0.v = tmp[3];
			zonept0.y = 0;
		}
		if(n >= 7) {
			zonept1.vx = tmp[4];
			zonept1.zy = tmp[5];
			zonept1.z = tmp[6];
			zonept1.v = tmp[7];
			zonept1.y = 0;
		}
	}
	zonept0.val = 1;
	xvsh_showbox();
}

static struct lst_map {
	char *name;
	int val;
} lst_map[]= {
	{"fromfile",CMAP_FILE},
	{"fromimage",CMAP_IMAGE},
	{"grey",CMAP_LIN},
	{"table1",CMAP_TAB1},
	{"table2",CMAP_TAB2},
	{"random",CMAP_RAND},
	{"random+",CMAP_XRAND},
};
#define NBMAPS (sizeof(lst_map) / sizeof(struct lst_map))

/* set initial cmap */
shx_ct(num,s,lgr)
register num, lgr;
register char *s;
{
	int indx[2];
	register n, i;
	register char *pc;
	if(s == NULL)
		return 1 /* makes c99 happy */;
	n = strgcut(s,indx,3);
	pc = s + indx[0];
	num = -1;
	for(i=0;i<NBMAPS;i++) {
		if(strcmp(pc,lst_map[i].name) == 0) {
			num = lst_map[i].val;
			break;
		}
	}
	if(num < 0) return 1 /* makes c99 happy */;
	if(num == CMAP_FILE){
		if(n > 1) {
			pc = s + indx[1];
			if(pc != NULL)
				strcpy(tcfile,pc);
		}
	}
	cmap_type = num;
	set_initial_ct(0);
}

/* save color table */
shx_ctsave(num,s,lgr)
register num, lgr;
register unsigned char *s;
{
	ct_save(s);
}

/* set a color */
shx_ctset(num,s,lgr)
register num, lgr;
register unsigned char *s;
{
	register msk, i, n, c;
	int pix[3], col[3];
	int indx[3];
	register unsigned char **ppc;
	register unsigned char *pc;
	for(i=0;i<3;i++) {
		pix[i] = 0;
		col[i] = 0;
	}
	msk = B_RGB;
	if(s) {
		n = strgcut(s,indx,3);
		if(n >= 1) {
			pc = s + indx[0];
			msk = shx_getrgb(pc);
		}
		if(n >= 2) {
			sscanf((char *)s + indx[1],"%d %d %d",&pix[0],&pix[1],&pix[2]);
		}
		if(n >= 3) {
			sscanf((char *)s + indx[2],"%d %d %d",&col[0],&col[1],&col[2]);
		}
	}
	if(!msk) return 1 /* makes c99 happy */;
	ppc = p_cts;
	for(i=0;i<3;i++) {
		if(msk & (1 << i)) {
			pc = *(ppc + i);
			*(pc + pix[i]) = col[i];
		}
	}
	modif_ct(0);
}

/* interpolate color tables : interp3 if num == 1*/
shx_ctinter(num,s,lgr)
register num, lgr;
register unsigned char *s;
{
	register msk, i, c;
	struct rgb_pt p1[3], p2[3];
	int indx[5];
	register unsigned char **ppc;
	register unsigned char *pc;
	for(i=0;i<3;i++) {
		p1[i].pix = 0;
		p1[i].col = 0;
		p2[i].pix = 0;
		p2[i].col = 0;
	}
	msk = B_RGB;
	if(s == NULL) return 1 /* makes c99 happy */;
	if(strgcut(s,indx,5) != 5) return 1 /* makes c99 happy */;
	msk = shx_getrgb(s + indx[0]);
	if(!msk) return 1 /* makes c99 happy */;
	sscanf((char *)s + indx[1],"%d %d %d",&(p1[0].pix),&(p1[1].pix),&(p1[2].pix));
	sscanf((char *)s + indx[2],"%d %d %d",&(p1[0].col),&(p1[1].col),&(p1[2].col));
	sscanf((char *)s + indx[3],"%d %d %d",&(p2[0].pix),&(p2[1].pix),&(p2[2].pix));
	sscanf((char *)s + indx[4],"%d %d %d",&(p2[0].col),&(p2[1].col),&(p2[2].col));
	ppc = p_cts;
	for(i=0;i<3;i++) {
		if(msk & (1 << i)) {
			pc = *(ppc + i);
			if(num == 1) {
				mk_poly4(pc,&p1[i],&p2[i]);
			} else {
				mk_lin(pc,&p1[i],&p2[i]);
			}
		}
	}
	modif_ct(0);
	
}

shx_getrgb(pc)
register char *pc;
{
	register msk, c;
	msk = 0;
	while((c = *pc++)) {
		c |= 0x20;
		switch(c) {
		case 'r':
			msk |= B_ROUGE;
			break;
		case 'g':
		case 'v':
			msk |= B_VERT;
			break;
		case 'b':
			msk |= B_BLEU;
			break;
		}
	}
	return msk;
}

shx_cutp(num,s,lgr)
register num, lgr;
register char *s;
{
	struct screenpt scr;
	switch(num) {
	case 0:
		bd_clear();
		break;
	case 1:
		bd_set();
		break;
	case 2:
		bd_inv();
		break;
	case 3:
		bd_copy();
		break;
	case 4:
		if(s != NULL) {
			shrd_xyzv(s,&scr,0);
			do_paste(scr.x,scr.y,im_w1,im_h1,im_nz);
		} else {
			bd_paste();
		}
		break;
	}
}

shx_dump(num,s,lgr)
register num, lgr;
register char *s;
{
	if(s == NULL)
		return 1 /* makes c99 happy */;
	xvdump(s);
}

shx_upleft(num,s,lgr)
register num, lgr;
register char *s;
{
	struct screenpt scr;
	shrd_xyzv(s,&scr,0);
	scroll_image(scr.x,scr.y);
}

shx_center(num,s,lgr)
register num, lgr;
register char *s;
{
	struct screenpt scr;
	shrd_xyzv(s,&scr,0);
	center_display(scr.x,scr.y);
}

shrd_xyzv(s,scr,novirg)
register char *s;
register struct screenpt *scr;
register novirg;
{
	struct imagept ima;
	int i1, i2, i3, i4;
	i1 = i2 = i3 = i4 = 1;
	if(s != NULL) {
		if(novirg)
			sscanf(s,"%d %d %d %d",&i1,&i2,&i3,&i4);
		else
			sscanf(s,"%d,%d,%d,%d",&i1,&i2,&i3,&i4);
	}
	ima.vx = i1 <= 0 ? 1 : i1 -1;
	ima.zy = i2 <= 0 ? 1 : i2 -1;
	ima.z = i3 <= 0 ? 1 : i3 -1;
	ima.v = i4 <= 0 ? 1 : i4 -1;
	im2sc_coord(&ima,scr);
	if(scr->x >= im_w)
		scr->x = im_w -1;
	if(scr->y >= im_h)
		scr->y = im_h -1;
}

shx_params(num,s,lgr)
register num, lgr;
register char *s;
{
	int indx[16];
	char buf1[20];
	int val;
	register n, i, j;
	register char *pc;
	if(!s) return 1 /* makes c99 happy */;
	if((n = strgcut(s,indx,16)) == 0)
		return 1 /* makes c99 happy */;
	for(i=0;i<n;i++) {
		pc = s + indx[i];
		buf1[0] = 0;
		if(sscanf(pc,"%s %d",buf1,&val) != 2)
			continue;
		for(j=0;j<NB_SHPARAMS;j++) {
			if(strcmp(buf1,shx_tabpar[j].name) == 0) {
				*(shx_tabpar[j].val) = val;
				new_params = 1;
				break;
			}
		}
	}
}

/* decoupe string sur les ','
met 0 a la fin des parties utiles
retourne le nb de chaines, les indices dans indx
*/
int strgcut(s,indx,nmax)
register char *s;
int *indx;
register nmax;
{
	register n, i, j, i0, c;
	register char *s0;
	int in_quote;
	int i1;
	n = 0;
	i = 0;
	s0 = s;
	i0 = 0;
	in_quote= 0;
	while(1) {
		c = *s++;
		i++;
		if(c == '"') {
		  in_quote ^= 1;
		  continue;
		}
		if(in_quote) {
		  if(c == 0) return n;
		  continue;
		}
		if(c == 0 || c == ',') {
			*(s-1) = 0;
			j = min_string(s0,&i1);
			*(indx + n++) = i0 + i1;
			*(s0+i1+j) = 0;
			if(n >= nmax || c == 0)
				return n;
			s0 = s;
			i0 = i;
		}
	}
}

shx_fill(num,s,lgr)
register num, lgr;
register char *s;
{
	int i;
	if(s == NULL) {
		bd_fill();
	} else {
		sscanf(s,"%d",&i);
		do_fill(i);
	}
}

/* set font for text paste */
shx_font(num,s,lgr)
register num, lgr;
register char *s;
{
	int val, indx;
	register i;
	register char *pc;
	if(s == NULL)
		return 1 /* makes c99 happy */;
	strncpy(fontname,s,FONT_LGR);
	txtfont = XLoadFont(dpy,fontname);
}

shx_texte(num,s,lgr)
register num, lgr;
register char *s;
{
	int val, indx, backgr;
	register i;
	register char *pc;
	if(s == NULL)
		return 1 /* makes c99 happy */;
	if(strgcut(s,&indx,1) != 1)
		return 1 /* makes c99 happy */;
	val = 0;
	pc = s + indx;
	backgr = -1;
	if(sscanf(pc,"%d/%d",&val,&backgr) <= 0)
		val = get_fillval();
	pc += strlen(pc) + 1;
	i = verif_text(pc);  /* supp les \ */
	do_ptext(val,backgr,pc,i);
}

/* ecrit un texte a une position donnee */
shx_postexte(num,s,lgr)
register num, lgr;
register char *s;
{
	struct screenpt scr;
	int val, indx[2], backgr;
	register i;
	register char *pc;
	if(s == NULL)
		return 1 /* makes c99 happy */;
	if(strgcut(s,indx,2) != 2)
		return 1 /* makes c99 happy */;
	val = 0;
	shrd_xyzv(s,&scr,1);
	pc = s + indx[1];
	backgr = -1;
	if(sscanf(pc,"%d/%d",&val,&backgr) <= 0)
		val = get_fillval();
	pc += strlen(pc) + 1;
	i = verif_text(pc);  /* supp les \ */
	do_puttext(val,backgr,pc,i,scr.x,scr.y);
}

/* start zloop */
shx_zloop(num,s,lgr)
register num, lgr;
register char *s;
{
	start_zloop();
}

/* scroll en z. 
1e arg= incr (+- n* zpas)
2e arg= nb de reaffichages
*/
shx_zscroll(num,s,lgr)
register num, lgr;
register char *s;
{
	int incz, flag;
	incz = 1;
	flag = 0;
	if(s != NULL) {
		if(sscanf(s,"%d,%d",&incz,&flag) < 1)
			incz = 1;
	}
	z_scroll(incz,flag);
}

shx_echo(num,s,lgr)
register num, lgr;
register char *s;
{
	if(s != NULL)
		write(1,s,lgr);
	write(1,"\n",1);
}

/* echo current selection (X buffer 0)*/
shx_echosel(num,s,lgr)
register num, lgr;
register char *s;
{
	int nbytes;
	s = (char *)XFetchBuffer(dpy,&nbytes,0);
	if(s != NULL)
		write(1,s,nbytes);
	write(1,"\n",1);
}

static int cur_ed_but= 1, cur_ed_z= 0, cur_ed_v = 0;
static struct screenpt ed_scr;
#define MAXEDC 200
shx_edit(num,s,lgr)
register num, lgr;
register char *s;
{
	int nb;
	int indx[MAXEDC], val1, val2, val3;
	register i, c, c1;
	register char *pc;
	int nbcval;
	if(s == NULL || !flg_edit)
		return 1 /* makes c99 happy */;
	if((nb = strgcut(s,indx,MAXEDC)) <= 0)
		return 1 /* makes c99 happy */;
	for(i=0;i<nb;i++) {
		pc = s + indx[i];
		if((c = *pc) == 'o') {
			if(strcmp(pc,"on") == 0) {
				if(edit.active) continue;
				b_edit();
			} else if(strcmp(pc,"off") == 0) {
				if(!edit.active) continue;
				b_edit();
			}
			continue;
		}
		if(!edit.active)
			continue;
		c1 = *(pc + 1);
		pc += 2;
		if(c1 != ' ' && c1 != '\t')
			continue;
		switch(c) {
		case 'C':
		  if((nbcval = sscanf(pc,"%d/%d/%d",&val1,&val2,&val3)) <= 0) 
		     break;
		  if(val1 > 0) {
		    cur_ed_but = 3;
		    if(scrdepth >= 8) {
		      if(nbcval == 1)
			val2 = val1;
		      if(nbcval == 2)
			val3 = val2;
		      ed_curcolor = (unsigned long)((val1 & 0xff) << 16) | ((val2 & 0xff) << 8) | (val3 & 0xff);
		      change_edcolor();
		    }
		  } else
		    cur_ed_but = 1;
		  break;
		case 'z':
			sscanf(pc,"%d",&val1);
			if(val1 < 1) break;
			cur_ed_z = val1 -1;
			break;
		case 'p':
			if(shget_edxy(pc))
				break;
			cmn_edit_pt(ed_scr.x,ed_scr.y,cur_ed_but,1); /* avec affichage */
			break;
		case 'l':
			if(shget_edxy(pc))
				break;
			cmn_edit_pt(ed_scr.x,ed_scr.y,2,1); /* avec affichage */
			break;
		case 'r':
			if(shget_edxy(pc))
				break;
			cmn_edit_pt(ed_scr.x,ed_scr.y,0x102,1); /* avec affichage */
			break;
		}
	}
}
shget_edxy(pc)
register char *pc;
{
	register v1, v2;
	char *pc1;
	struct imagept ima;
	if((v1 = strtol(pc,&pc1,0) -1) < 0)
		return 1;
	if((v2 = atol(pc1,0,0) -1) < 0)
		return 1;
	ima.z = cur_ed_z;
	ima.v = cur_ed_v;
	ima.vx = v1;
	ima.zy = v2;
	im2sc_coord(&ima,&ed_scr);
/*!!	if(ed_scr.x < 0 || ed_scr.y < 0) return 1; */
	if(ed_scr.x >= im_w || ed_scr.y >= im_h) return 1;
	return 0;
}

static int cur_draw_col[]= {255,255,255}, cur_draw_z= 0, ixscpt= 0;
static int cur_draw_ep;
static char cur_draw_mode= -1;
static int effect_draw= 1;  /* draw in pix_im and W_image */

init_drawgc(ep)
register ep;
{
	XGCValues gcv;
	int val1, msk;
	cur_draw_ep = ep;
	gcv.function = GXset;
	init_gc(&drawgc,&gcv);
	gcv.line_width = ep;
	gcv.plane_mask = AllPlanes;
	val1 = cur_draw_col[0];
	if (val1 < 0) {
	  gcv.function = GXxor;
	  msk = -val1;
	} else {
	  gcv.function = GXcopy;
	  msk = xtrans[(val1 & 0xff)];
	}
	if(scrdepth == 24)
		msk = msk << 16 | (xtrans[cur_draw_col[1] & 0xff] << 8) | xtrans[cur_draw_col[2] & 0xff];
	gcv.foreground = msk;
	XChangeGC(dpy,drawgc,GCFunction | GCLineWidth | GCPlaneMask | GCForeground,&gcv);
}

/* C color; p x y ;l x y; L x1 y1 ... xn yn; a x1 y1 w h ang1 ang2;
z numz; v numv (??)
a: arc, coin ht gche en x1 y1, tailles w h, ang1= debut de trace (degrs)
	ang2: amplitude de trac en degrs
m 0/1 : mode 0 => trace dans pix_im seulement
s x0 y0 z0 v0 dx dy dz dv  : copie de la fenetre donnee de pix_im dans W_image
si x1, y1 <0 => DIMX, NDIMY
*/
static XPoint points[MAXEDC];
shx_draw(num,s,lgr)
register num, lgr;
register char *s;
{
	int nb;
	int indx[MAXEDC];
	int tmp[6];
	register val1;
	register i, c, j;
	int ep;
	struct imagept ima;
	struct screenpt scr1, scr2;
	char *pc;
	register prev, npts;
	if(s == NULL || edit.active)
		return 1 /* makes c99 happy */;
	if((nb = strgcut(s,indx,MAXEDC)) <= 0)
		return 1 /* makes c99 happy */;
	ep = zoom * g_size;
	if(cur_draw_mode < 0 || ep != cur_draw_ep) {
		cur_draw_mode = 0;
		init_drawgc(ep);
	}
	prev = 0;
	npts = 0;
	for(i=0;i<nb;i++) {
		pc = s + indx[i];
		c = *pc++;
		switch(c) {
		case 'm':
			draw_flush(points,npts);
			npts = 0;
			val1 = atoi(pc);
			if(val1 < 0 || val1 > 1)
				break;
			effect_draw = val1;
			break;
		case 's':
			val1 = sscanf(pc,"%d %d %d %d %d %d %d %d",&tmp[0],&tmp[1],&tmp[2],&tmp[3],&tmp[4],&tmp[5],&tmp[6],&tmp[7]);
			if(val1 != 4 && val1 != 7)
				break;
			tmp[0]--;
			tmp[1]--;
			tmp[2]--;
			tmp[3]--;
			if(tmp[0] < 0)
				tmp[0] = 0;
			if(tmp[1] < 0)
				tmp[1] = 0;
			if(tmp[2] < 0)
				tmp[2] = 0;
			if(tmp[3] < 0)
				tmp[3] = 0;
			ima.vx = tmp[0];
			ima.zy = tmp[1];
			ima.z = tmp[2];
			ima.v = tmp[3];
			im2sc_coord(&ima,&scr1);
			if(val1 == 4) {
				ima.vx = DIMX;
				ima.zy = DIMY;
				ima.z = 1;
				ima.v = 1;
			} else {
				if(tmp[4] < 0)
					tmp[4] = NDIMX;
				if(tmp[5] < 0)
					tmp[5] = NDIMY;
				if(tmp[6] < 0)
					tmp[6] = NDIMZ;
				if(tmp[7] < 0)
					tmp[7] = NDIMV;
				ima.vx = tmp[4];
				ima.zy = tmp[5];
				ima.z = tmp[6];
				ima.v = tmp[7];
			}
			im2sc_coord(&ima,&scr2);
			XCopyArea(dpy,pix_im,W_image,defgc,scr1.x,scr1.y,scr2.x,scr2.y,scr1.x,scr1.y);
			break;
		case 'C':
			draw_flush(points,npts);
			npts = 0;
			val1 = sscanf(pc,"%d %d %d",&cur_draw_col[0],&cur_draw_col[1],&cur_draw_col[2]);
			if(val1 == 1) 
			  cur_draw_col[1] = cur_draw_col[0];
			if(val1 == 2) 
			  cur_draw_col[2] = cur_draw_col[1];
			init_drawgc(ep);
			ixscpt = 0;
			break;
		case 'z':
			draw_flush(points,npts);
			npts = 0;
			if((val1 = atoi(pc) -1) < 0) break;;
			cur_draw_z = val1;
			ixscpt = 0;
			break;
		case 'p':
		case 'l':
		case 'r':
			if(c != prev || npts >= MAXEDC) {
				draw_flush(points,npts);
				if(c != 'p') {
					ixscpt = 1;
					npts = 1;
				} else
					npts = 0;
				cur_draw_mode = c;
			}
			if((val1 = strtol(pc,&pc,0) -1) < 0)
				continue;
			points[npts].x = val1;
			if((val1 = strtol(pc,&pc,0) -1) < 0)
				continue;
			points[npts++].y = val1;
			break;
		case 'L':  /* polyline */
			draw_flush(points,npts);
			npts = 0;
			ixscpt = 0;
			cur_draw_mode = c;
			while(1) {
				if((val1 = strtol(pc,&pc,0) -1) < 0)
					break;
				points[npts].x = val1;
				if((val1 = strtol(pc,&pc,0) -1) < 0)
					break;
				points[npts++].y = val1;
				if(npts >= MAXEDC) {
					draw_flush(points,npts);
					ixscpt = 1;
					npts = 1;
				}
			}
			if(npts > 1) {
				draw_flush(points,npts);
				npts = 0;
			}
		case 'a':  /* Arc : x y width [height [angle1 angle2] */
			/* angle1 = position initiale, angle2= amplitude de trace */
			draw_flush(points,npts);
			npts = 0;
			ixscpt = 0;
			cur_draw_mode = c;
			while(npts < 3) {
				points[npts].x = strtol(pc,&pc,0);
				points[npts].y = strtol(pc,&pc,0);
				if(npts == 0) {
					points[npts].x -= 1;
					points[npts].y -= 1;
				}
				npts++;
			}
			draw_flush(points,npts);
			npts = 0;
		}
		prev = c;
	}
	draw_flush(points,npts);
}


/* flush buffer de trace */
draw_flush(pts0,n)
register XPoint *pts0;
register n;
{
	register XPoint *pts;
	register coef, cxz, cyz, n2, i, n1;
	register xp, yp;
	int w, h;
	coef = g_size;
	if(n <= 0) return 1 /* makes c99 happy */;
	if(opt_pas != 1 || cur_draw_z) {
		if(cur_draw_mode != 'p') {
			pts = pts0 + ixscpt;
		} else {
			pts = pts0;
		}
		if(flg_z_horiz) {
			cxz = (cur_draw_z / zpas) * im_w1;
			cyz = 0;
		} else {
			cyz = (cur_draw_z / zpas) * im_h1;
			cxz = 0;
		}
		n1 = n;
		if(cur_draw_mode == 'a')
			n1 = 1;
		if(opt_pas <= 1) {
			n2 = zoom * g_size;
			for(i=ixscpt;i<n1;i++) { /* convert to screen points */
				xp = n2 * pts->x + cxz;
				yp = n2 * pts->y + cyz;
				if(xp >= im_w) xp = im_w - 1;
				if(yp >= im_h) xp = im_h - 1;
				pts->x = xp;
				pts++->y = yp;
			}
			if((cur_draw_mode == 'a') && (n >= 2)) {
				pts->x = n2 * pts->x;
				pts->y = n2 * pts->y;
			}
		} else {
			n2 = pas;
			for(i=ixscpt;i<n1;i++) { /* convert to screen points */
				xp = coef * (pts->x / n2) + cxz;
				yp = coef * (pts->y / n2) + cyz;
				if(xp >= im_w) xp = im_w - 1;
				if(yp >= im_h) xp = im_h - 1;
				pts->x = xp;
				pts++->y = yp;
			}
			if((cur_draw_mode == 'a') && (n >= 2)) {
				pts->x = coef * (pts->x / n2);
				pts->y = coef * (pts->y / n2);
			}
		}
	}
	switch(cur_draw_mode) {
	case 'p':
		if(debug_)
			fprintf(stderr,"draw %d points\n",n);
		if(effect_draw)
			XDrawPoints(dpy,W_image,drawgc,pts0,n,CoordModeOrigin);
		if(!flg_nopix)
			XDrawPoints(dpy,pix_im,drawgc,pts0,n,CoordModeOrigin);
		break;
	case 'r':
		if(n != 2) return 1 /* makes c99 happy */;
		xp = pts0->x;
		w = (pts0+1)->x;
		if(w < xp) {
			xp = w;
			w = pts0->x;
		}
		yp = pts0->y;
		h = (pts0+1)->y;
		if(h < yp) {
			yp = h;
			h = pts0->y;
		}
		if(opt_pas < -1) {
			if((w += n2 - 1) >= im_w) w = im_w - 1;
			if((h += n2 - 1) >= im_h) h = im_h - 1;
		}
		w = w - xp + 1;
		h = h - yp + 1;
		if(debug_)
			fprintf(stderr,"draw rectangle\n");
		if(effect_draw)
			XFillRectangle(dpy,W_image,drawgc,xp,yp,w,h);
		if(!flg_nopix)
			XFillRectangle(dpy,pix_im,drawgc,xp,yp,w,h);
		break;
	case 'l':
	case 'L':
		if(debug_)
			fprintf(stderr,"draw %d lines\n",n);
		if(effect_draw)
			XDrawLines(dpy,W_image,drawgc,pts0,n,CoordModeOrigin);
		if(!flg_nopix)
			XDrawLines(dpy,pix_im,drawgc,pts0,n,CoordModeOrigin);
		break;
	case 'a': {
		register w, h, a1, a2;
		a1 = 0;a2 = 0;
		w = 1;h = 0;
		if(n > 1) {
			w = (pts0+1)->x;
			h = (pts0 +1)->y;
		}
		if(h <= 0) h = w;
		if(n > 2) {
			a1 = (pts0 + 2)->x;
			a2 = (pts0 + 2)->y;
		}
		if(a2 == 0)
			a2 = 360 - a1;
		a1 *= 64;
		a2 *= 64;
		if(debug_)
			fprintf(stderr,"draw arc\n",n);
		if(effect_draw)
			XDrawArc(dpy,W_image,drawgc,pts0->x,pts0->y,w,h,a1,a2);
		if(!flg_nopix)
			XDrawArc(dpy,pix_im,drawgc,pts0->x,pts0->y,w,h,a1,a2);
		break;
	}
	}
	ixscpt = 0;
	if(n > 1) {
		pts0->x = (pts0 + n-1)->x;
		pts0->y = (pts0 + n-1)->y;
	}
	XFlush(dpy);
}

shx_dialog(num,s,lgr)
register num, lgr;
register char *s;
{
  int nb;
  int indx[MAXEDC];
  if(s == NULL) nb = 0;
  else
    nb = strgcut(s,indx,MAXEDC);
  xvpop_create(s,indx,nb);
}

extern int shx_pause(), sh_abort(), pop_cmap(), show_msg(), b_exit();
struct xvcmdtab xvsh_builtin[]= {
	{"!",shx_hlp,0,""},
	{"$",shx_hlp,1,""},
	{"EXIT",b_exit,0,""},
	{"END",shx_noop,0,""},
	{"SELECT",shx_noop,0,""},
	{"abort",sh_abort,0,""},
	{"box",shx_box,0,"[(x0,y0,z0,v0[,x1,y1,z1,v1])]"},
	{"center",shx_center,0,"([x],[y],[z].[v])"},
	{"clear",shx_cutp,0,""},
	{"colors",pop_cmap,0,""},
	{"copy",shx_cutp,3,""},
	{"ct_interp",shx_ctinter,0,"[(rgb,Rpix1 Gpix1 Bpix1,Rcol1 Gcol1 Bcol1,Rpix2 Gpix2 Bpix2,Rcol2 Gcol2 Bcol2)]"},
	{"ct_interp3",shx_ctinter,1,"[(rgb,Rpix1 Gpix1 Bpix1,Rcol1 Gcol1 Bcol1,Rpix2 Gpix2 Bpix2,Rcol2 Gcol2 Bcol2)]"},
	{"ct_map",shx_ct,0,"(type[,file]) : fromfile, table1,..."},
	{"ct_save",shx_ctsave,0,"(filename)"},
	{"ct_set",shx_ctset,0,"[(rgb,Rpix Gpix Bpix,Rcol Gcol Bcol)] : (rg,0 0 0,255 0 0)"},
	{"dialog",shx_dialog,0,"[([label],[value][,btn,...,btn])]"},
	{"draw",shx_draw,0,"[(cmde,..,cmde)]"},
	{"dump",shx_dump,0,"[(filename)]"},
	{"echo",shx_echo,0,"[(string)]"},
	{"echosel",shx_echosel,0,": echo X selection"},
	{"edit",shx_edit,0,"[(cmde,..,cmde)]"},
	{"fill",shx_fill,0,"[(value)]"},
	{"help",show_msg,0,""},
	{"imlist",shx_imlist,0,"(filename[ filename  ...])"},
	{"invert",shx_cutp,2,""},
	{"next",shx_next,0,""},
	{"nextv",b_nextv,0,""},
	{"nextz",b_nextz,0,""},
	{"nobox",shx_box,1,""},
	{"params",shx_params,0,"(type val, ...)  Ex: (pas 1,zpas 1,zloop 2)"},
	{"paste",shx_cutp,4,"([dstx],[dsty],[dstz],[dstv])"},
	{"pause",shx_pause,0,"[(nb_sec)]"},
	{"prev",shx_prev,0,""},
	{"prevv",b_prevv,0,""},
	{"prevz",b_prevz,0,""},
	{"prtvar",shx_prtvar,0,"(varname[,varname, ..., varname])"},
	{"re-read",shx_reread,0,"[(filename)]"},
	{"set",shx_cutp,1,""},
	{"texte",shx_texte,0,"([value[/background]],string)"},
	{"ptexte",shx_postexte,0,"([x [y [z [v]]]],[value[/background]],string)"},
	{"font",shx_font,0,"(font_name)"},
	{"upleft",shx_upleft,0,"([x],[y],[z],[v])"},
	{"zloop",shx_zloop,0,""},
	{"zscroll",shx_zscroll,0,"([incr],[use-zloop-count])"},
};
struct pcmdtab xvsh_pbuilt = {
	sizeof(xvsh_builtin) / sizeof(struct xvcmdtab),
	NULL
};


int shx_hlp(num,s,lgr)
register num, lgr;
register char *s;
{
	if(num == 0)
		xvsh_lstcmd(&xvsh_pbuilt);
	else if(num == 1)
		xvsh_lstvar(&pargtab);
	return 0;
}

shx_prtvar(num,s,lgr)
register num, lgr;
register char *s;
{
	char tmp[256];
	int lg1, lg2;
	register char c;
	lg1 = 0;
	while(lgr > 0) {
		c = *s;
		if(isspace(c) || c == ',') {
			s++;
			lgr--;
			continue;
		}
		if(c == ')') break;
		if(xvchk_var(s,tmp,&lg1,&lg2,&pargtab) >= 0) {
			tmp[lg2++] = ' ';
			write(1,tmp,lg2);
		}
		lgr -= lg1;
		s += lg1;
	}
	write(1,"\n",1);
}
